/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.application;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.ui.views.JasmineNodeExplorerView;

/**
 * @generated
 */
public class DiagramEditorPerspective implements IPerspectiveFactory {

	/**
	 * @generated NOT
	 */
	public void createInitialLayout(IPageLayout layout) {

		layout.setEditorAreaVisible(true);

		layout
				.addPerspectiveShortcut(DiagramEditorWorkbenchAdvisor.PERSPECTIVE_ID);

		/*
		 * top left : JasmineNode explorer
		 */
		IFolderLayout topLeft = layout.createFolder(
				"topLeft", IPageLayout.LEFT, 0.3f, layout.getEditorArea()); //$NON-NLS-1$
		topLeft.addView(JasmineNodeExplorerView.ID);
		//		topLeft.addView(BundleRepositoriesView.VIEW_ID);

		/*
		 * bottom left : outline
		 */
		IFolderLayout bottomLeft = layout.createFolder(
				"bottomLeft", IPageLayout.BOTTOM, 0.5f, "topLeft"); //$NON-NLS-1$
		bottomLeft.addView(IPageLayout.ID_OUTLINE);

		/*
		 * bottom right : properties
		 */
		IFolderLayout bottomRight = layout
				.createFolder(
						"bottomRight", IPageLayout.BOTTOM, 0.65f, layout.getEditorArea()); //$NON-NLS-1$
		bottomRight.addView(IPageLayout.ID_PROP_SHEET);
	}
}
