/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry;

/**
 * @generated
 */
public class JasmineEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (JasmineVisualIDRegistry.getVisualID(view)) {

			case DomainEditPart.VISUAL_ID:
				return new DomainEditPart(view);

			case JOnASEditPart.VISUAL_ID:
				return new JOnASEditPart(view);

			case JOnASNameEditPart.VISUAL_ID:
				return new JOnASNameEditPart(view);

			case JOnASInstanceNameDomainEditPart.VISUAL_ID:
				return new JOnASInstanceNameDomainEditPart(view);

			case Apache_HTTPdEditPart.VISUAL_ID:
				return new Apache_HTTPdEditPart(view);

			case Apache_HTTPdNameEditPart.VISUAL_ID:
				return new Apache_HTTPdNameEditPart(view);

			case CmiGroupEditPart.VISUAL_ID:
				return new CmiGroupEditPart(view);

			case CmiGroupNameEditPart.VISUAL_ID:
				return new CmiGroupNameEditPart(view);

			case HaGroupEditPart.VISUAL_ID:
				return new HaGroupEditPart(view);

			case HaGroupNameEditPart.VISUAL_ID:
				return new HaGroupNameEditPart(view);

			case HTTP_RepGroupEditPart.VISUAL_ID:
				return new HTTP_RepGroupEditPart(view);

			case HTTP_RepGroupNameEditPart.VISUAL_ID:
				return new HTTP_RepGroupNameEditPart(view);

			case RMIGroupEditPart.VISUAL_ID:
				return new RMIGroupEditPart(view);

			case RMIGroupNameEditPart.VISUAL_ID:
				return new RMIGroupNameEditPart(view);

			case ClusterContainerEditPart.VISUAL_ID:
				return new ClusterContainerEditPart(view);

			case DBEditPart.VISUAL_ID:
				return new DBEditPart(view);

			case JBossASEditPart.VISUAL_ID:
				return new JBossASEditPart(view);

			case JBossASNameEditPart.VISUAL_ID:
				return new JBossASNameEditPart(view);

			case JBossTryTryEditPart.VISUAL_ID:
				return new JBossTryTryEditPart(view);

			case JBossHAGroupNameEditPart.VISUAL_ID:
				return new JBossHAGroupNameEditPart(view);

			case WebContainerEditPart.VISUAL_ID:
				return new WebContainerEditPart(view);

			case EJBContainerEditPart.VISUAL_ID:
				return new EJBContainerEditPart(view);

			case DiscoveryServiceEditPart.VISUAL_ID:
				return new DiscoveryServiceEditPart(view);

			case JmsServiceEditPart.VISUAL_ID:
				return new JmsServiceEditPart(view);

			case IIOPEditPart.VISUAL_ID:
				return new IIOPEditPart(view);

			case IRMIEditPart.VISUAL_ID:
				return new IRMIEditPart(view);

			case JRMPEditPart.VISUAL_ID:
				return new JRMPEditPart(view);

			case CMIEditPart.VISUAL_ID:
				return new CMIEditPart(view);

			case AJPEditPart.VISUAL_ID:
				return new AJPEditPart(view);

			case HTTPEditPart.VISUAL_ID:
				return new HTTPEditPart(view);

			case HTTPSEditPart.VISUAL_ID:
				return new HTTPSEditPart(view);

			case ModJKModuleEditPart.VISUAL_ID:
				return new ModJKModuleEditPart(view);

			case ClusterEditPart.VISUAL_ID:
				return new ClusterEditPart(view);

			case JBossBindingEditPart.VISUAL_ID:
				return new JBossBindingEditPart(view);

			case WebContainer2EditPart.VISUAL_ID:
				return new WebContainer2EditPart(view);

			case HTTPS2EditPart.VISUAL_ID:
				return new HTTPS2EditPart(view);

			case HTTP2EditPart.VISUAL_ID:
				return new HTTP2EditPart(view);

			case AJP2EditPart.VISUAL_ID:
				return new AJP2EditPart(view);

			case JOnASServicesEditPart.VISUAL_ID:
				return new JOnASServicesEditPart(view);

			case JOnASProtocolsEditPart.VISUAL_ID:
				return new JOnASProtocolsEditPart(view);

			case JOnASWeb_ConnectorsEditPart.VISUAL_ID:
				return new JOnASWeb_ConnectorsEditPart(view);

			case Apache_HTTPdModulesEditPart.VISUAL_ID:
				return new Apache_HTTPdModulesEditPart(view);

			case ClusterContainerClusterSetEditPart.VISUAL_ID:
				return new ClusterContainerClusterSetEditPart(view);

			case JBossASServicesEditPart.VISUAL_ID:
				return new JBossASServicesEditPart(view);

			case JBossASWeb_ConnectorsEditPart.VISUAL_ID:
				return new JBossASWeb_ConnectorsEditPart(view);

			case CMIConnectorEditPart.VISUAL_ID:
				return new CMIConnectorEditPart(view);

			case ModjkConnectorEditPart.VISUAL_ID:
				return new ModjkConnectorEditPart(view);

			case RepHTTPConnectorEditPart.VISUAL_ID:
				return new RepHTTPConnectorEditPart(view);

			case HAConnectorEditPart.VISUAL_ID:
				return new HAConnectorEditPart(view);

			case DbLinkEditPart.VISUAL_ID:
				return new DbLinkEditPart(view);

			case RmiConnectorEditPart.VISUAL_ID:
				return new RmiConnectorEditPart(view);

			case JBossHAConnectorEditPart.VISUAL_ID:
				return new JBossHAConnectorEditPart(view);

			case DbLink2EditPart.VISUAL_ID:
				return new DbLink2EditPart(view);

			case RmiConnector2EditPart.VISUAL_ID:
				return new RmiConnector2EditPart(view);
			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrapLabel)
			return new TextCellEditorLocator((WrapLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrapLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrapLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrapLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (getWrapLabel().isTextWrapped()
					&& getWrapLabel().getText().length() > 0) {
				rect.setSize(new Dimension(text.computeSize(rect.width,
						SWT.DEFAULT)));
			} else {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}

	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			int avr = FigureUtilities.getFontMetrics(text.getFont())
					.getAverageCharWidth();
			rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
					SWT.DEFAULT)).expand(avr * 2, 0));
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
