/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.Apache_HTTPdCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.ClusterContainerCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.CmiGroupCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.DBCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.HTTP_RepGroupCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.HaGroupCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.JBossASCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.JBossTryTryCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.JOnASCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.RMIGroupCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.providers.JasmineElementTypes;

/**
 * @generated
 */
public class DomainItemSemanticEditPolicy extends
		JasmineBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (JasmineElementTypes.JOnAS_1001 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_MiddlewareComponents());
			}
			return getGEFWrapper(new JOnASCreateCommand(req));
		}
		if (JasmineElementTypes.Apache_HTTPd_1002 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_MiddlewareComponents());
			}
			return getGEFWrapper(new Apache_HTTPdCreateCommand(req));
		}
		if (JasmineElementTypes.CmiGroup_1003 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_ConfigurationNodes());
			}
			return getGEFWrapper(new CmiGroupCreateCommand(req));
		}
		if (JasmineElementTypes.HaGroup_1004 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_ConfigurationNodes());
			}
			return getGEFWrapper(new HaGroupCreateCommand(req));
		}
		if (JasmineElementTypes.HTTP_RepGroup_1005 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_ConfigurationNodes());
			}
			return getGEFWrapper(new HTTP_RepGroupCreateCommand(req));
		}
		if (JasmineElementTypes.RMIGroup_1006 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_ConfigurationNodes());
			}
			return getGEFWrapper(new RMIGroupCreateCommand(req));
		}
		if (JasmineElementTypes.ClusterContainer_1007 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_ClusterContainers());
			}
			return getGEFWrapper(new ClusterContainerCreateCommand(req));
		}
		if (JasmineElementTypes.DB_1008 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_Db());
			}
			return getGEFWrapper(new DBCreateCommand(req));
		}
		if (JasmineElementTypes.JBossAS_1009 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_MiddlewareComponents());
			}
			return getGEFWrapper(new JBossASCreateCommand(req));
		}
		if (JasmineElementTypes.JBossHAGroup_1010 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getDomain_ConfigurationNodes());
			}
			return getGEFWrapper(new JBossTryTryCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
