/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.edit.policies;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CanonicalEditPolicy;
import org.eclipse.gmf.runtime.notation.View;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.AJP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPS2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineDiagramUpdater;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineNodeDescriptor;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry;

/**
 * @generated
 */
public class JBossASWeb_ConnectorsCanonicalEditPolicy extends
		CanonicalEditPolicy {

	/**
	 * @generated
	 */
	Set myFeaturesToSynchronize;

	/**
	 * @generated
	 */
	protected List getSemanticChildrenList() {
		View viewObject = (View) getHost().getModel();
		List result = new LinkedList();
		for (Iterator it = JasmineDiagramUpdater
				.getJBossASWeb_Connectors_5007SemanticChildren(viewObject)
				.iterator(); it.hasNext();) {
			result.add(((JasmineNodeDescriptor) it.next()).getModelElement());
		}
		return result;
	}

	/**
	 * @generated
	 */
	protected boolean isOrphaned(Collection semanticChildren, final View view) {
		int visualID = JasmineVisualIDRegistry.getVisualID(view);
		switch (visualID) {
		case HTTPS2EditPart.VISUAL_ID:
		case HTTP2EditPart.VISUAL_ID:
		case AJP2EditPart.VISUAL_ID:
			return !semanticChildren.contains(view.getElement())
					|| visualID != JasmineVisualIDRegistry.getNodeVisualID(
							(View) getHost().getModel(), view.getElement());
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected String getDefaultFactoryHint() {
		return null;
	}

	/**
	 * @generated
	 */
	protected Set getFeaturesToSynchronize() {
		if (myFeaturesToSynchronize == null) {
			myFeaturesToSynchronize = new HashSet();
			myFeaturesToSynchronize.add(JasminemodelPackage.eINSTANCE
					.getJBossAS_Webconnectors());
		}
		return myFeaturesToSynchronize;
	}

}
