/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.CMICreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.IIOPCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.IRMICreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.commands.JRMPCreateCommand;
import org.objectweb.jasmine.ui.jasminemodel.diagram.providers.JasmineElementTypes;

/**
 * @generated
 */
public class JOnASProtocolsItemSemanticEditPolicy extends
		JasmineBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (JasmineElementTypes.IIOP_2005 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getIJavaEEServer_RmiRegistries());
			}
			return getGEFWrapper(new IIOPCreateCommand(req));
		}
		if (JasmineElementTypes.IRMI_2006 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getIJavaEEServer_RmiRegistries());
			}
			return getGEFWrapper(new IRMICreateCommand(req));
		}
		if (JasmineElementTypes.JRMP_2007 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getIJavaEEServer_RmiRegistries());
			}
			return getGEFWrapper(new JRMPCreateCommand(req));
		}
		if (JasmineElementTypes.CMI_2008 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(JasminemodelPackage.eINSTANCE
						.getIJavaEEServer_RmiRegistries());
			}
			return getGEFWrapper(new CMICreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

}
