/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.ext.domain;

import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.transaction.TransactionalCommandStack;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.WorkspaceEditingDomainFactory;

public class ExtJasmineEditingDomainFactory implements TransactionalEditingDomain.Factory {
	   public TransactionalEditingDomain createEditingDomain() {
		      // create an editing domain with a default resource set implementation
		      //    and delegating command execution to the default (workbench)
		      //    operation history
		      TransactionalEditingDomain result = WorkspaceEditingDomainFactory.INSTANCE.createEditingDomain();

		      // add an exception handler to the editing domain's command stack
		      ((TransactionalCommandStack) result.getCommandStack()).setExceptionHandler(
		            new CommandStackExceptionHandler());

		      return result;
		   }

		   public TransactionalEditingDomain createEditingDomain(ResourceSet rset) {
		      // not used when initializing editing domain from extension point
		      return null;
		   }

		   public TransactionalEditingDomain getEditingDomain(ResourceSet rset) {
		      // not used when initializing editing domain from extension point
		      return null;
		   }
		}

