/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.part;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.command.BasicCommandStack;
import org.eclipse.emf.common.ui.URIEditorInput;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gmf.runtime.diagram.core.preferences.PreferencesHint;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.document.IDiagramDocument;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.document.IDocument;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.document.IDocumentProvider;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.parts.DiagramDocumentEditor;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.WorkspaceModifyOperation;
import org.objectweb.jasmine.ui.jasminemodel.diagram.ui.views.JasmineNodeExplorerView;
import org.objectweb.jasmine.ui.jasminemodel.provider.JasmineEditPlugin;
import org.objectweb.jasmine.ui.loginAdressPort.ConnectionManager;

/**
 * @generated Not
 */
public class JasmineDiagramEditor extends DiagramDocumentEditor {

	/**
	 * @generated
	 */
	public static final String ID = "org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineDiagramEditorID"; //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final String CONTEXT_ID = "org.objectweb.jasmine.ui.jasminemodel.diagram.ui.diagramContext"; //$NON-NLS-1$

	/**
	 * @generated Not
	 */
	protected Resource theResource;

	/**
	 * Synchronizes workspace changes with the editing domain.
	 *
	 * @generated Not
	 */
	protected WorkspaceSynchronizer workspaceSynchronizer;

	/**
	 * @generated
	 */
	public JasmineDiagramEditor() {
		super(true);
	}

	/**
	 * @generated
	 */
	protected String getContextID() {
		return CONTEXT_ID;
	}

	/**
	 * @generated
	 */
	protected PaletteRoot createPaletteRoot(PaletteRoot existingPaletteRoot) {
		PaletteRoot root = super.createPaletteRoot(existingPaletteRoot);
		new JasminePaletteFactory().fillPalette(root);
		return root;
	}

	/**
	 * @generated
	 */
	protected PreferencesHint getPreferencesHint() {
		return JasmineDiagramEditorPlugin.DIAGRAM_PREFERENCES_HINT;
	}

	/**
	 * @generated
	 */
	public String getContributorId() {
		return JasmineDiagramEditorPlugin.ID;
	}

	/**
	 * @generated
	 */
	protected IDocumentProvider getDocumentProvider(IEditorInput input) {
		if (input instanceof URIEditorInput) {
			return JasmineDiagramEditorPlugin.getInstance()
					.getDocumentProvider();
		}
		return super.getDocumentProvider(input);
	}

	/**
	 * @generated Not
	 */
	@Override
	public void init(IEditorSite site, IEditorInput input) {
		try {
			super.init(site, input);
		} catch (PartInitException e) {
			e.printStackTrace();
		}

		// TODO : Implement
		// workspaceSynchronizer = new WorkspaceSynchronizer(
		// (TransactionalEditingDomain) getEditingDomain(),
		// createSynchronizationDelegate());

		getSite().getShell().getDisplay().asyncExec(new Runnable() {
			public void run() {

				try {
					if (!ConnectionManager.isConnected()) {
						ConnectionManager.initConnections(getSite().getShell());
					}
				} catch (RuntimeException e) {
					e.printStackTrace();

				}
			}
		});
	}

	/**
	 * @generated Not
	 */
	public static String domainID = "jasmine.model.diagram.EditingDomain"; //$NON-NLS-1$

	/**
	 * @generated Not
	 */
	@Override
	public String getEditingDomainID() {
		return TransactionalEditingDomain.Registry.INSTANCE.getEditingDomain(
				"org.ow2.jasmine.model.diagram.JasmineEditingDomain")
				.toString();
	}

	/**
	 * @generated Not
	 */
	protected TransactionalEditingDomain createEditingDomain() {
		return JasmineDiagramEditorPlugin.getInstance().getEditingDomain();
	}

	/**
	 * @generated Not
	 */
	public TransactionalEditingDomain getEditingDomain() {
		IDocument document = getEditorInput() != null ? getDocumentProvider()
				.getDocument(getEditorInput()) : null;
		if (document instanceof IDiagramDocument) {
			return ((IDiagramDocument) document).getEditingDomain();
		}
		return TransactionalEditingDomain.Registry.INSTANCE
				.getEditingDomain("org.ow2.jasmine.model.diagram.JasmineEditingDomain");
	}

	/**
	 * @generated Not
	 */
	protected void setDocumentProvider(IEditorInput input) {
		if (input instanceof URIEditorInput) {

			URIEditorInput uriEditorInput = (URIEditorInput) input;

			JasmineNodeExplorerView.RESOURCE_URI = uriEditorInput.getURI()
					.devicePath();

			URI uri = URI.createFileURI(uriEditorInput.getURI().devicePath());
			theResource = getEditingDomain().getResourceSet().getResource(uri,
					true);

			setDocumentProvider(JasmineDiagramEditorPlugin.getInstance()
					.getDocumentProvider());
		} else {
			super.setDocumentProvider(input);
		}
	}

	/**
	 * @generated Not
	 */
	@Override
	public void dispose() {

		doSave();
		super.dispose();
		JasmineNodeExplorerView.RESOURCE_URI = null;
		getEditingDomain().getResourceSet().getResources().remove(theResource);
	}

	/**
	 * This is for implementing {@link IEditorPart} and simply saves the model
	 * file. <!-- begin-user-doc --> <!-- end-user-doc -->
	 *
	 * @generated Not
	 */
	public void doSave() {

		if (!isDirty()
				&& ((BasicCommandStack) getEditingDomain().getCommandStack())
						.isSaveNeeded()) {

			// Save only resources that have actually changed.
			//
			final Map<Object, Object> saveOptions = new HashMap<Object, Object>();
			saveOptions.put(Resource.OPTION_SAVE_ONLY_IF_CHANGED,
					Resource.OPTION_SAVE_ONLY_IF_CHANGED_MEMORY_BUFFER);

			// Do the work within an operation because this is a long running
			// activity that modifies the workbench.
			//
			WorkspaceModifyOperation operation = new WorkspaceModifyOperation() {
				// This is the method that gets invoked when the operation runs.
				//
				@Override
				public void execute(IProgressMonitor monitor) {
					// Save the resources to the file system.
					//
					boolean first = true;
					for (Resource resource : getEditingDomain()
							.getResourceSet().getResources()) {
						// if ((first || !resource.getContents().isEmpty() ||
						// isPersisted(resource)) &&
						// !getEditingDomain().isReadOnly(resource))
						if ((first || !resource.getContents().isEmpty())
								&& !getEditingDomain().isReadOnly(resource)) {
							try {
								System.out.println("add resource "
										+ resource.getURI());

								// savedResources.add(resource);
								// resource.save(saveOptions);
								resource.save(Collections.EMPTY_MAP);
							} catch (Exception exception) {
								JasmineEditPlugin.getPlugin().log(exception);
								exception.printStackTrace();
							}
							first = false;
						}
					}
				}
			};

			try {
				// This runs the options, and shows progress.
				new ProgressMonitorDialog(getSite().getShell()).run(true,
						false, operation);

				// Refresh the necessary state.
				((BasicCommandStack) getEditingDomain().getCommandStack())
						.saveIsDone();
				firePropertyChange(IEditorPart.PROP_DIRTY);

			} catch (Exception exception) {
				// Something went wrong that shouldn't.
				JasmineEditPlugin.getPlugin().log(exception);
				exception.printStackTrace();
			}
		}
	}
}
