/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.part;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.objectweb.jasmine.ui.jasminemodel.diagram.providers.JasmineElementTypes;

/**
 * @generated
 */
public class JasminePaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createMiddlewares1Group());
		paletteRoot.add(createComponents2Group());
		paletteRoot.add(createGroupConnector3Group());
		paletteRoot.add(createClusters4Group());
		paletteRoot.add(createConnectors5Group());
	}

	/**
	 * Creates "Middlewares" palette tool group
	 * @generated
	 */
	private PaletteContainer createMiddlewares1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Middlewares1Group_title);
		paletteContainer.setDescription(Messages.Middlewares1Group_desc);
		paletteContainer.add(createJOnAS1CreationTool());
		paletteContainer.add(createApache2CreationTool());
		paletteContainer.add(createJBossAS3CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Components" palette tool group
	 * @generated
	 */
	private PaletteContainer createComponents2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Components2Group_title);
		paletteContainer.add(createWebContainer1CreationTool());
		paletteContainer.add(createEJBContainer2CreationTool());
		paletteContainer.add(createDiscovery3CreationTool());
		paletteContainer.add(createJMS4CreationTool());
		paletteContainer.add(createProtocols5CreationTool());
		paletteContainer.add(createWeb_connectors6CreationTool());
		paletteContainer.add(createModules7CreationTool());
		paletteContainer.add(createDB8CreationTool());
		paletteContainer.add(createJBossBinding9CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Group Connector" palette tool group
	 * @generated
	 */
	private PaletteContainer createGroupConnector3Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.GroupConnector3Group_title);
		paletteContainer.setDescription(Messages.GroupConnector3Group_desc);
		paletteContainer.add(createCMI_Groups1CreationTool());
		paletteContainer.add(createHA_Groups2CreationTool());
		paletteContainer.add(createRMI_Groups3CreationTool());
		paletteContainer.add(createHTTP_Rep_Groups4CreationTool());
		paletteContainer.add(createJBossHAGroup5CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Clusters" palette tool group
	 * @generated
	 */
	private PaletteContainer createClusters4Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Clusters4Group_title);
		paletteContainer.setDescription(Messages.Clusters4Group_desc);
		paletteContainer.add(createCluster_containers1CreationTool());
		paletteContainer.add(createClusters2CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Connectors" palette tool group
	 * @generated
	 */
	private PaletteContainer createConnectors5Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Connectors5Group_title);
		paletteContainer.setDescription(Messages.Connectors5Group_desc);
		paletteContainer.add(createModjk_link1CreationTool());
		paletteContainer.add(createCMI_link2CreationTool());
		paletteContainer.add(createHTTP_Rep_link3CreationTool());
		paletteContainer.add(createHA_link4CreationTool());
		paletteContainer.add(createRMI_link5CreationTool());
		paletteContainer.add(createDB_link6CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createJOnAS1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.JOnAS_1001);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.JOnAS1CreationTool_title,
				Messages.JOnAS1CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.JOnAS_1001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createApache2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.Apache_HTTPd_1002);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Apache2CreationTool_title,
				Messages.Apache2CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.Apache_HTTPd_1002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createJBossAS3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.JBossAS_1009);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.JBossAS3CreationTool_title,
				Messages.JBossAS3CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.JBossAS_1009));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createWebContainer1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(JasmineElementTypes.WebContainer_2001);
		types.add(JasmineElementTypes.WebContainer_2015);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.WebContainer1CreationTool_title,
				Messages.WebContainer1CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.WebContainer_2001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createEJBContainer2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.EJBContainer_2002);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.EJBContainer2CreationTool_title,
				Messages.EJBContainer2CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.EJBContainer_2002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDiscovery3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.DiscoveryService_2003);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Discovery3CreationTool_title,
				Messages.Discovery3CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.DiscoveryService_2003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createJMS4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.JmsService_2004);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.JMS4CreationTool_title,
				Messages.JMS4CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.JmsService_2004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createProtocols5CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(4);
		types.add(JasmineElementTypes.IIOP_2005);
		types.add(JasmineElementTypes.IRMI_2006);
		types.add(JasmineElementTypes.JRMP_2007);
		types.add(JasmineElementTypes.CMI_2008);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Protocols5CreationTool_title,
				Messages.Protocols5CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.IIOP_2005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createWeb_connectors6CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(6);
		types.add(JasmineElementTypes.AJP_2009);
		types.add(JasmineElementTypes.HTTP_2010);
		types.add(JasmineElementTypes.HTTPS_2011);
		types.add(JasmineElementTypes.HTTPS_2016);
		types.add(JasmineElementTypes.HTTP_2017);
		types.add(JasmineElementTypes.AJP_2018);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Web_connectors6CreationTool_title,
				Messages.Web_connectors6CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.AJP_2009));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModules7CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.ModJKModule_2012);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Modules7CreationTool_title,
				Messages.Modules7CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.ModJKModule_2012));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDB8CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.DB_1008);
		NodeToolEntry entry = new NodeToolEntry(Messages.DB8CreationTool_title,
				Messages.DB8CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.DB_1008));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createJBossBinding9CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.JBossBinding_2014);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.JBossBinding9CreationTool_title,
				Messages.JBossBinding9CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.JBossBinding_2014));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCMI_Groups1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.CmiGroup_1003);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.CMI_Groups1CreationTool_title,
				Messages.CMI_Groups1CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.CmiGroup_1003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createHA_Groups2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.HaGroup_1004);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.HA_Groups2CreationTool_title,
				Messages.HA_Groups2CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.HaGroup_1004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRMI_Groups3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.RMIGroup_1006);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.RMI_Groups3CreationTool_title,
				Messages.RMI_Groups3CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.RMIGroup_1006));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createHTTP_Rep_Groups4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.HTTP_RepGroup_1005);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.HTTP_Rep_Groups4CreationTool_title,
				Messages.HTTP_Rep_Groups4CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.HTTP_RepGroup_1005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createJBossHAGroup5CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.JBossHAGroup_1010);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.JBossHAGroup5CreationTool_title,
				Messages.JBossHAGroup5CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.JBossHAGroup_1010));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCluster_containers1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.ClusterContainer_1007);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Cluster_containers1CreationTool_title,
				Messages.Cluster_containers1CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.ClusterContainer_1007));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createClusters2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.Cluster_2013);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Clusters2CreationTool_title,
				Messages.Clusters2CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.Cluster_2013));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModjk_link1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(JasmineElementTypes.IHTTPServerJavaeeServers_3002);
		types.add(JasmineElementTypes.JBossModJKConnector_3003);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Modjk_link1CreationTool_title,
				Messages.Modjk_link1CreationTool_desc, types);
		entry.setSmallIcon(JasmineDiagramEditorPlugin
				.findImageDescriptor("icons/eview16/ModjkConnector.gif")); //$NON-NLS-1$
		entry.setLargeIcon(JasmineDiagramEditorPlugin
				.findImageDescriptor("icons/eview16/ModjkConnector.gif")); //$NON-NLS-1$
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCMI_link2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.JOnASCmigroup_3001);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.CMI_link2CreationTool_title,
				Messages.CMI_link2CreationTool_desc, types);
		entry.setSmallIcon(JasmineDiagramEditorPlugin
				.findImageDescriptor("icons/eview16/CMIConnector.gif")); //$NON-NLS-1$
		entry.setLargeIcon(JasmineDiagramEditorPlugin
				.findImageDescriptor("icons/eview16/CMIConnector.gif")); //$NON-NLS-1$
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createHTTP_Rep_link3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(JasmineElementTypes.RepHTTPConnector_3004);
		types.add(JasmineElementTypes.JBossHTTPRepConnector_3005);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.HTTP_Rep_link3CreationTool_title,
				Messages.HTTP_Rep_link3CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.RepHTTPConnector_3004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createHA_link4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(JasmineElementTypes.HAConnector_3006);
		types.add(JasmineElementTypes.JBossHAConnector_3007);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.HA_link4CreationTool_title,
				Messages.HA_link4CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.HAConnector_3006));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRMI_link5CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.RmiConnector_3009);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.RMI_link5CreationTool_title,
				Messages.RMI_link5CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.RmiConnector_3009));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDB_link6CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(JasmineElementTypes.DbLink_3008);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.DB_link6CreationTool_title,
				Messages.DB_link6CreationTool_desc, types);
		entry.setSmallIcon(JasmineElementTypes
				.getImageDescriptor(JasmineElementTypes.DbLink_3008));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
