/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.AJP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.AJPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdModulesEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CMIConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CMIEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterContainerClusterSetEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CmiGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CmiGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DBEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DbLink2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DbLinkEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DiscoveryServiceEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DomainEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.EJBContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HAConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPS2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPSEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP_RepGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP_RepGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HaGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HaGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.IIOPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.IRMIEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASServicesEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASWeb_ConnectorsEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossBindingEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossHAConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossHAGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossTryTryEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossTryTryTrytryEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASInstanceNameDomainEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASProtocolsEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASServicesEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASWeb_ConnectorsEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JRMPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JmsServiceEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ModJKModuleEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ModjkConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RMIGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RMIGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RepHTTPConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RmiConnector2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RmiConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.WebContainer2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.WebContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.expressions.JasmineAbstractExpression;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class JasmineVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = JasmineDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (DomainEditPart.MODEL_ID.equals(view.getType())) {
				return DomainEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				JasmineDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (JasminemodelPackage.eINSTANCE.getDomain().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((Domain) domainElement)) {
			return DomainEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null
				|| !DomainEditPart.MODEL_ID
						.equals(org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry
								.getModelID(containerView))) {
			return -1;
		}
		switch (org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry
				.getVisualID(containerView)) {
		case JOnASServicesEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getWebContainer().isSuperTypeOf(
					domainElement.eClass())) {
				return WebContainerEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getEJBContainer().isSuperTypeOf(
					domainElement.eClass())) {
				return EJBContainerEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getDiscoveryService()
					.isSuperTypeOf(domainElement.eClass())) {
				return DiscoveryServiceEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getJmsService().isSuperTypeOf(
					domainElement.eClass())) {
				return JmsServiceEditPart.VISUAL_ID;
			}
			break;
		case JOnASProtocolsEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getIIOP().isSuperTypeOf(
					domainElement.eClass())) {
				return IIOPEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getIRMI().isSuperTypeOf(
					domainElement.eClass())) {
				return IRMIEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getJRMP().isSuperTypeOf(
					domainElement.eClass())) {
				return JRMPEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getCMI().isSuperTypeOf(
					domainElement.eClass())) {
				return CMIEditPart.VISUAL_ID;
			}
			break;
		case JOnASWeb_ConnectorsEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getAJP().isSuperTypeOf(
					domainElement.eClass())) {
				return AJPEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getHTTP().isSuperTypeOf(
					domainElement.eClass())) {
				return HTTPEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getHTTPS().isSuperTypeOf(
					domainElement.eClass())) {
				return HTTPSEditPart.VISUAL_ID;
			}
			break;
		case Apache_HTTPdModulesEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getModJKModule().isSuperTypeOf(
					domainElement.eClass())) {
				return ModJKModuleEditPart.VISUAL_ID;
			}
			break;
		case ClusterContainerClusterSetEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getCluster().isSuperTypeOf(
					domainElement.eClass())) {
				return ClusterEditPart.VISUAL_ID;
			}
			break;
		case JBossASServicesEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getJBossBinding().isSuperTypeOf(
					domainElement.eClass())) {
				return JBossBindingEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getWebContainer().isSuperTypeOf(
					domainElement.eClass())) {
				return WebContainer2EditPart.VISUAL_ID;
			}
			break;
		case JBossASWeb_ConnectorsEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getHTTPS().isSuperTypeOf(
					domainElement.eClass())) {
				return HTTPS2EditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getHTTP().isSuperTypeOf(
					domainElement.eClass())) {
				return HTTP2EditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getAJP().isSuperTypeOf(
					domainElement.eClass())) {
				return AJP2EditPart.VISUAL_ID;
			}
			break;
		case DomainEditPart.VISUAL_ID:
			if (JasminemodelPackage.eINSTANCE.getJOnAS().isSuperTypeOf(
					domainElement.eClass())) {
				return JOnASEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getApache_HTTPd().isSuperTypeOf(
					domainElement.eClass())) {
				return Apache_HTTPdEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getCmiGroup().isSuperTypeOf(
					domainElement.eClass())) {
				return CmiGroupEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getHaGroup().isSuperTypeOf(
					domainElement.eClass())) {
				return HaGroupEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getHTTP_RepGroup().isSuperTypeOf(
					domainElement.eClass())) {
				return HTTP_RepGroupEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getRMIGroup().isSuperTypeOf(
					domainElement.eClass())) {
				return RMIGroupEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getClusterContainer()
					.isSuperTypeOf(domainElement.eClass())) {
				return ClusterContainerEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getDB().isSuperTypeOf(
					domainElement.eClass())) {
				return DBEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getJBossAS().isSuperTypeOf(
					domainElement.eClass())) {
				return JBossASEditPart.VISUAL_ID;
			}
			if (JasminemodelPackage.eINSTANCE.getJBossHAGroup().isSuperTypeOf(
					domainElement.eClass())) {
				return JBossTryTryEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry
				.getModelID(containerView);
		if (!DomainEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (DomainEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = DomainEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case JOnASEditPart.VISUAL_ID:
			if (JOnASNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JOnASInstanceNameDomainEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JOnASServicesEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JOnASProtocolsEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JOnASWeb_ConnectorsEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Apache_HTTPdEditPart.VISUAL_ID:
			if (Apache_HTTPdNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Apache_HTTPdModulesEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CmiGroupEditPart.VISUAL_ID:
			if (CmiGroupNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case HaGroupEditPart.VISUAL_ID:
			if (HaGroupNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case HTTP_RepGroupEditPart.VISUAL_ID:
			if (HTTP_RepGroupNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RMIGroupEditPart.VISUAL_ID:
			if (RMIGroupNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ClusterContainerEditPart.VISUAL_ID:
			if (ClusterContainerClusterSetEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case JBossASEditPart.VISUAL_ID:
			if (JBossASNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JBossASServicesEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JBossASWeb_ConnectorsEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case JBossTryTryEditPart.VISUAL_ID:
			if (JBossHAGroupNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case JOnASServicesEditPart.VISUAL_ID:
			if (WebContainerEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (EJBContainerEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (DiscoveryServiceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JmsServiceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case JOnASProtocolsEditPart.VISUAL_ID:
			if (IIOPEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (IRMIEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JRMPEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CMIEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case JOnASWeb_ConnectorsEditPart.VISUAL_ID:
			if (AJPEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (HTTPEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (HTTPSEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Apache_HTTPdModulesEditPart.VISUAL_ID:
			if (ModJKModuleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ClusterContainerClusterSetEditPart.VISUAL_ID:
			if (ClusterEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case JBossASServicesEditPart.VISUAL_ID:
			if (JBossBindingEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WebContainer2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case JBossASWeb_ConnectorsEditPart.VISUAL_ID:
			if (HTTPS2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (HTTP2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AJP2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case DomainEditPart.VISUAL_ID:
			if (JOnASEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Apache_HTTPdEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CmiGroupEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (HaGroupEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (HTTP_RepGroupEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (RMIGroupEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ClusterContainerEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (DBEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JBossASEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (JBossTryTryEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (JasminemodelPackage.eINSTANCE.getJBossModJKConnector()
				.isSuperTypeOf(domainElement.eClass())) {
			return RepHTTPConnectorEditPart.VISUAL_ID;
		}
		if (JasminemodelPackage.eINSTANCE.getRepHTTPConnector().isSuperTypeOf(
				domainElement.eClass())) {
			return HAConnectorEditPart.VISUAL_ID;
		}
		if (JasminemodelPackage.eINSTANCE.getJBossHTTPRepConnector()
				.isSuperTypeOf(domainElement.eClass())) {
			return DbLinkEditPart.VISUAL_ID;
		}
		if (JasminemodelPackage.eINSTANCE.getHAConnector().isSuperTypeOf(
				domainElement.eClass())) {
			return RmiConnectorEditPart.VISUAL_ID;
		}
		if (JasminemodelPackage.eINSTANCE.getJBossHAConnector().isSuperTypeOf(
				domainElement.eClass())) {
			return JBossHAConnectorEditPart.VISUAL_ID;
		}
		if (JasminemodelPackage.eINSTANCE.getDbLink().isSuperTypeOf(
				domainElement.eClass())) {
			return DbLink2EditPart.VISUAL_ID;
		}
		if (JasminemodelPackage.eINSTANCE.getRmiConnector().isSuperTypeOf(
				domainElement.eClass())) {
			return RmiConnector2EditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Domain element) {
		return true;
	}

	/**
	 * @generated
	 */
	private static boolean evaluate(JasmineAbstractExpression expression,
			Object element) {
		Object result = expression.evaluate(element);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

}
