/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.part;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.eclipse.gef.EditPartViewer;

/**
 * @generated
 */
public class ValidationMarker {

	/**
	 * @generated
	 */
	private static final String KEY = "validation_marker"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final ValidationMarker[] EMPTY_ARRAY = new ValidationMarker[0];

	/**
	 * @generated
	 */
	private final String location;

	/**
	 * @generated
	 */
	private final String message;

	/**
	 * @generated
	 */
	private final int statusSeverity;

	/**
	 * @generated
	 */
	public ValidationMarker(String location, String message, int statusSeverity) {
		this.location = location;
		this.message = message;
		this.statusSeverity = statusSeverity;
	}

	/**
	 * @generated
	 */
	public String getLocation() {
		return location;
	}

	/**
	 * @generated
	 */
	public String getMessage() {
		return message;
	}

	/**
	 * @generated
	 */
	public int getStatusSeverity() {
		return statusSeverity;
	}

	/**
	 * @generated
	 */
	private static Map getMarkers(EditPartViewer viewer) {
		Map markers = (Map) viewer.getProperty(KEY);
		if (markers == null) {
			markers = new HashMap();
			viewer.setProperty(KEY, markers);
		}
		return markers;
	}

	/**
	 * @generated
	 */
	private static Set getMarkers(EditPartViewer viewer, String viewId,
			boolean create) {
		Set markers = (Set) getMarkers(viewer).get(viewId);
		if (markers == null) {
			if (!create) {
				return Collections.EMPTY_SET;
			}
			markers = new HashSet();
			getMarkers(viewer).put(viewId, markers);
		}
		return markers;
	}

	/**
	 * @generated
	 */
	public static ValidationMarker[] getMarkers(EditPartViewer viewer,
			String viewId) {
		Set markers = getMarkers(viewer, viewId, false);
		if (markers.isEmpty()) {
			return EMPTY_ARRAY;
		}
		return (ValidationMarker[]) markers
				.toArray(new ValidationMarker[markers.size()]);
	}

	/**
	 * @generated
	 */
	public static void removeAllMarkers(EditPartViewer viewer) {
		getMarkers(viewer).clear();
	}

	/**
	 * @generated
	 */
	public void add(EditPartViewer viewer, String viewId) {
		getMarkers(viewer, viewId, true).add(this);
	}
}
