/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.diagram.expressions.JasmineAbstractExpression;
import org.objectweb.jasmine.ui.jasminemodel.diagram.expressions.JasmineOCLFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineDiagramEditorPlugin;

/**
 * @generated
 */
public class ElementInitializers {

	/**
	 * @generated
	 */
	public static class Initializers {
		/**
		 * @generated
		 */
		public static final IObjectInitializer JOnAS_1001 = new ObjectInitializer(
				JasminemodelPackage.eINSTANCE.getJOnAS()) {
			protected void init() {
				add(createNewElementFeatureInitializer(
						JasminemodelPackage.eINSTANCE
								.getIJavaEEServer_WebContainers(),
						new ObjectInitializer[] { webContainers(), }));
				add(createNewElementFeatureInitializer(
						JasminemodelPackage.eINSTANCE
								.getIJavaEEServer_DiscoveryServices(),
						new ObjectInitializer[] { discoveryServices(), }));
				add(createNewElementFeatureInitializer(
						JasminemodelPackage.eINSTANCE
								.getIJavaEEServer_JmsServices(),
						new ObjectInitializer[] { jmsServices(), }));
				add(createNewElementFeatureInitializer(
						JasminemodelPackage.eINSTANCE
								.getIJavaEEServer_RmiRegistries(),
						new ObjectInitializer[] { rmiRegistries(), }));
			}

			ObjectInitializer webContainers() {
				return new ObjectInitializer(JasminemodelPackage.eINSTANCE
						.getWebContainer()) {
					protected void init() {
						add(createExpressionFeatureInitializer(
								JasminemodelPackage.eINSTANCE
										.getIContainer_Description(),
								JasmineOCLFactory.getExpression(
										"\'Web Container\'", //$NON-NLS-1$
										JasminemodelPackage.eINSTANCE
												.getWebContainer())));
					}
				}; // webContainers ObjectInitializer
			}

			ObjectInitializer discoveryServices() {
				return new ObjectInitializer(JasminemodelPackage.eINSTANCE
						.getDiscoveryService()) {
					protected void init() {
						add(createExpressionFeatureInitializer(
								JasminemodelPackage.eINSTANCE
										.getDiscoveryService_Name(),
								JasmineOCLFactory.getExpression(
										"\'Discovery Service\'", //$NON-NLS-1$
										JasminemodelPackage.eINSTANCE
												.getDiscoveryService())));
					}
				}; // discoveryServices ObjectInitializer
			}

			ObjectInitializer jmsServices() {
				return new ObjectInitializer(JasminemodelPackage.eINSTANCE
						.getJmsService()) {
					protected void init() {
						add(createExpressionFeatureInitializer(
								JasminemodelPackage.eINSTANCE
										.getJmsService_JmsTopics(),
								JasmineOCLFactory.getExpression(
										"\'SampleTopic\'", //$NON-NLS-1$
										JasminemodelPackage.eINSTANCE
												.getJmsService())));
					}
				}; // jmsServices ObjectInitializer
			}

			ObjectInitializer rmiRegistries() {
				return new ObjectInitializer(JasminemodelPackage.eINSTANCE
						.getJRMP()) {
					protected void init() {
						add(createExpressionFeatureInitializer(
								JasminemodelPackage.eINSTANCE
										.getIRMIRegistry_Name(),
								JasmineOCLFactory
										.getExpression("\'JRMP\'", //$NON-NLS-1$
												JasminemodelPackage.eINSTANCE
														.getJRMP())));
					}
				}; // rmiRegistries ObjectInitializer
			}
		}; // JOnAS_1001 ObjectInitializer		
		/**
		 * @generated
		 */
		public static final IObjectInitializer Apache_HTTPd_1002 = new ObjectInitializer(
				JasminemodelPackage.eINSTANCE.getApache_HTTPd()) {
			protected void init() {
				add(createNewElementFeatureInitializer(
						JasminemodelPackage.eINSTANCE.getApache_HTTPd_Modules(),
						new ObjectInitializer[] { modules(), }));
			}

			ObjectInitializer modules() {
				return new ObjectInitializer(JasminemodelPackage.eINSTANCE
						.getModJKModule()) {
					protected void init() {
						add(createExpressionFeatureInitializer(
								JasminemodelPackage.eINSTANCE
										.getModJKModule_Description(),
								JasmineOCLFactory.getExpression(
										"\'Mod Jk module\'", //$NON-NLS-1$
										JasminemodelPackage.eINSTANCE
												.getModJKModule())));
					}
				}; // modules ObjectInitializer
			}
		}; // Apache_HTTPd_1002 ObjectInitializer

		/**
		 * @generated
		 */
		public static final IObjectInitializer JBossAS_1009 = new ObjectInitializer(
				JasminemodelPackage.eINSTANCE.getJBossAS()) {
			protected void init() {
				add(createNewElementFeatureInitializer(
						JasminemodelPackage.eINSTANCE
								.getIJavaEEServer_WebContainers(),
						new ObjectInitializer[] { webContainers(), }));
			}

			ObjectInitializer webContainers() {
				return new ObjectInitializer(JasminemodelPackage.eINSTANCE
						.getWebContainer()) {
					protected void init() {
						add(createExpressionFeatureInitializer(
								JasminemodelPackage.eINSTANCE
										.getIContainer_Description(),
								JasmineOCLFactory.getExpression(
										"\'Web Container\'", //$NON-NLS-1$
										JasminemodelPackage.eINSTANCE
												.getWebContainer())));
					}
				}; // webContainers ObjectInitializer
			}
		}; // JBossAS_1009 ObjectInitializer

		/** 
		 * @generated
		 */
		private Initializers() {
		}

		/** 
		 * @generated
		 */
		public static interface IObjectInitializer {
			/** 
			 * @generated
			 */
			public void init(EObject instance);
		}

		/** 
		 * @generated
		 */
		public static abstract class ObjectInitializer implements
				IObjectInitializer {
			/** 
			 * @generated
			 */
			final EClass element;
			/** 
			 * @generated
			 */
			private List featureInitializers = new ArrayList();

			/** 
			 * @generated
			 */
			ObjectInitializer(EClass element) {
				this.element = element;
				init();
			}

			/**
			 * @generated
			 */
			protected abstract void init();

			/** 
			 * @generated
			 */
			protected final IFeatureInitializer add(
					IFeatureInitializer initializer) {
				featureInitializers.add(initializer);
				return initializer;
			}

			/** 
			 * @generated
			 */
			public void init(EObject instance) {
				for (Iterator it = featureInitializers.iterator(); it.hasNext();) {
					IFeatureInitializer nextExpr = (IFeatureInitializer) it
							.next();
					try {
						nextExpr.init(instance);
					} catch (RuntimeException e) {
						JasmineDiagramEditorPlugin.getInstance().logError(
								"Feature initialization failed", e); //$NON-NLS-1$						
					}
				}
			}
		} // end of ObjectInitializer

		/** 
		 * @generated
		 */
		interface IFeatureInitializer {
			/**
			 * @generated
			 */
			void init(EObject contextInstance);
		}

		/**
		 * @generated
		 */
		static IFeatureInitializer createNewElementFeatureInitializer(
				EStructuralFeature initFeature,
				ObjectInitializer[] newObjectInitializers) {
			final EStructuralFeature feature = initFeature;
			final ObjectInitializer[] initializers = newObjectInitializers;
			return new IFeatureInitializer() {
				public void init(EObject contextInstance) {
					for (int i = 0; i < initializers.length; i++) {
						EObject newInstance = initializers[i].element
								.getEPackage().getEFactoryInstance().create(
										initializers[i].element);
						if (feature.isMany()) {
							((Collection) contextInstance.eGet(feature))
									.add(newInstance);
						} else {
							contextInstance.eSet(feature, newInstance);
						}
						initializers[i].init(newInstance);
					}
				}
			};
		}

		/**
		 * @generated
		 */
		static IFeatureInitializer createExpressionFeatureInitializer(
				EStructuralFeature initFeature,
				JasmineAbstractExpression valueExpression) {
			final EStructuralFeature feature = initFeature;
			final JasmineAbstractExpression expression = valueExpression;
			return new IFeatureInitializer() {
				public void init(EObject contextInstance) {
					expression.assignTo(feature, contextInstance);
				}
			};
		}
	} // end of Initializers
}
