/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineDiagramEditorPlugin;

/**
 * @generated
 */
public class JasmineElementTypes extends ElementInitializers {

	/**
	 * @generated
	 */
	private JasmineElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType Domain_79 = getElementType("org.ow2.jasmine.model.diagram.Domain_79"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType JOnAS_1001 = getElementType("org.ow2.jasmine.model.diagram.JOnAS_1001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Apache_HTTPd_1002 = getElementType("org.ow2.jasmine.model.diagram.Apache_HTTPd_1002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType CmiGroup_1003 = getElementType("org.ow2.jasmine.model.diagram.CmiGroup_1003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType HaGroup_1004 = getElementType("org.ow2.jasmine.model.diagram.HaGroup_1004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType HTTP_RepGroup_1005 = getElementType("org.ow2.jasmine.model.diagram.HTTP_RepGroup_1005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RMIGroup_1006 = getElementType("org.ow2.jasmine.model.diagram.RMIGroup_1006"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ClusterContainer_1007 = getElementType("org.ow2.jasmine.model.diagram.ClusterContainer_1007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType DB_1008 = getElementType("org.ow2.jasmine.model.diagram.DB_1008"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType JBossAS_1009 = getElementType("org.ow2.jasmine.model.diagram.JBossAS_1009"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType JBossHAGroup_1010 = getElementType("org.ow2.jasmine.model.diagram.JBossHAGroup_1010"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType WebContainer_2001 = getElementType("org.ow2.jasmine.model.diagram.WebContainer_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType EJBContainer_2002 = getElementType("org.ow2.jasmine.model.diagram.EJBContainer_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType DiscoveryService_2003 = getElementType("org.ow2.jasmine.model.diagram.DiscoveryService_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType JmsService_2004 = getElementType("org.ow2.jasmine.model.diagram.JmsService_2004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType IIOP_2005 = getElementType("org.ow2.jasmine.model.diagram.IIOP_2005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType IRMI_2006 = getElementType("org.ow2.jasmine.model.diagram.IRMI_2006"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType JRMP_2007 = getElementType("org.ow2.jasmine.model.diagram.JRMP_2007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType CMI_2008 = getElementType("org.ow2.jasmine.model.diagram.CMI_2008"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType AJP_2009 = getElementType("org.ow2.jasmine.model.diagram.AJP_2009"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType HTTP_2010 = getElementType("org.ow2.jasmine.model.diagram.HTTP_2010"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType HTTPS_2011 = getElementType("org.ow2.jasmine.model.diagram.HTTPS_2011"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ModJKModule_2012 = getElementType("org.ow2.jasmine.model.diagram.ModJKModule_2012"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Cluster_2013 = getElementType("org.ow2.jasmine.model.diagram.Cluster_2013"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType JBossBinding_2014 = getElementType("org.ow2.jasmine.model.diagram.JBossBinding_2014"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType WebContainer_2015 = getElementType("org.ow2.jasmine.model.diagram.WebContainer_2015"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType HTTPS_2016 = getElementType("org.ow2.jasmine.model.diagram.HTTPS_2016"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType HTTP_2017 = getElementType("org.ow2.jasmine.model.diagram.HTTP_2017"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType AJP_2018 = getElementType("org.ow2.jasmine.model.diagram.AJP_2018"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType JOnASCmigroup_3001 = getElementType("org.ow2.jasmine.model.diagram.JOnASCmigroup_3001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType IHTTPServerJavaeeServers_3002 = getElementType("org.ow2.jasmine.model.diagram.IHTTPServerJavaeeServers_3002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType JBossModJKConnector_3003 = getElementType("org.ow2.jasmine.model.diagram.JBossModJKConnector_3003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType RepHTTPConnector_3004 = getElementType("org.ow2.jasmine.model.diagram.RepHTTPConnector_3004"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType JBossHTTPRepConnector_3005 = getElementType("org.ow2.jasmine.model.diagram.JBossHTTPRepConnector_3005"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType HAConnector_3006 = getElementType("org.ow2.jasmine.model.diagram.HAConnector_3006"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType JBossHAConnector_3007 = getElementType("org.ow2.jasmine.model.diagram.JBossHAConnector_3007"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType DbLink_3008 = getElementType("org.ow2.jasmine.model.diagram.DbLink_3008"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType RmiConnector_3009 = getElementType("org.ow2.jasmine.model.diagram.RmiConnector_3009"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return JasmineDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap();

			elements.put(Domain_79, JasminemodelPackage.eINSTANCE.getDomain());

			elements.put(JOnAS_1001, JasminemodelPackage.eINSTANCE.getJOnAS());

			elements.put(Apache_HTTPd_1002, JasminemodelPackage.eINSTANCE
					.getApache_HTTPd());

			elements.put(CmiGroup_1003, JasminemodelPackage.eINSTANCE
					.getCmiGroup());

			elements.put(HaGroup_1004, JasminemodelPackage.eINSTANCE
					.getHaGroup());

			elements.put(HTTP_RepGroup_1005, JasminemodelPackage.eINSTANCE
					.getHTTP_RepGroup());

			elements.put(RMIGroup_1006, JasminemodelPackage.eINSTANCE
					.getRMIGroup());

			elements.put(ClusterContainer_1007, JasminemodelPackage.eINSTANCE
					.getClusterContainer());

			elements.put(DB_1008, JasminemodelPackage.eINSTANCE.getDB());

			elements.put(JBossAS_1009, JasminemodelPackage.eINSTANCE
					.getJBossAS());

			elements.put(JBossHAGroup_1010, JasminemodelPackage.eINSTANCE
					.getJBossHAGroup());

			elements.put(WebContainer_2001, JasminemodelPackage.eINSTANCE
					.getWebContainer());

			elements.put(EJBContainer_2002, JasminemodelPackage.eINSTANCE
					.getEJBContainer());

			elements.put(DiscoveryService_2003, JasminemodelPackage.eINSTANCE
					.getDiscoveryService());

			elements.put(JmsService_2004, JasminemodelPackage.eINSTANCE
					.getJmsService());

			elements.put(IIOP_2005, JasminemodelPackage.eINSTANCE.getIIOP());

			elements.put(IRMI_2006, JasminemodelPackage.eINSTANCE.getIRMI());

			elements.put(JRMP_2007, JasminemodelPackage.eINSTANCE.getJRMP());

			elements.put(CMI_2008, JasminemodelPackage.eINSTANCE.getCMI());

			elements.put(AJP_2009, JasminemodelPackage.eINSTANCE.getAJP());

			elements.put(HTTP_2010, JasminemodelPackage.eINSTANCE.getHTTP());

			elements.put(HTTPS_2011, JasminemodelPackage.eINSTANCE.getHTTPS());

			elements.put(ModJKModule_2012, JasminemodelPackage.eINSTANCE
					.getModJKModule());

			elements.put(Cluster_2013, JasminemodelPackage.eINSTANCE
					.getCluster());

			elements.put(JBossBinding_2014, JasminemodelPackage.eINSTANCE
					.getJBossBinding());

			elements.put(WebContainer_2015, JasminemodelPackage.eINSTANCE
					.getWebContainer());

			elements.put(HTTPS_2016, JasminemodelPackage.eINSTANCE.getHTTPS());

			elements.put(HTTP_2017, JasminemodelPackage.eINSTANCE.getHTTP());

			elements.put(AJP_2018, JasminemodelPackage.eINSTANCE.getAJP());

			elements.put(JOnASCmigroup_3001, JasminemodelPackage.eINSTANCE
					.getJOnAS_Cmigroup());

			elements.put(IHTTPServerJavaeeServers_3002,
					JasminemodelPackage.eINSTANCE
							.getIHTTPServer_JavaeeServers());

			elements.put(JBossModJKConnector_3003,
					JasminemodelPackage.eINSTANCE.getJBossModJKConnector());

			elements.put(RepHTTPConnector_3004, JasminemodelPackage.eINSTANCE
					.getRepHTTPConnector());

			elements.put(JBossHTTPRepConnector_3005,
					JasminemodelPackage.eINSTANCE.getJBossHTTPRepConnector());

			elements.put(HAConnector_3006, JasminemodelPackage.eINSTANCE
					.getHAConnector());

			elements.put(JBossHAConnector_3007, JasminemodelPackage.eINSTANCE
					.getJBossHAConnector());

			elements
					.put(DbLink_3008, JasminemodelPackage.eINSTANCE.getDbLink());

			elements.put(RmiConnector_3009, JasminemodelPackage.eINSTANCE
					.getRmiConnector());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet();
			KNOWN_ELEMENT_TYPES.add(Domain_79);
			KNOWN_ELEMENT_TYPES.add(JOnAS_1001);
			KNOWN_ELEMENT_TYPES.add(Apache_HTTPd_1002);
			KNOWN_ELEMENT_TYPES.add(CmiGroup_1003);
			KNOWN_ELEMENT_TYPES.add(HaGroup_1004);
			KNOWN_ELEMENT_TYPES.add(HTTP_RepGroup_1005);
			KNOWN_ELEMENT_TYPES.add(RMIGroup_1006);
			KNOWN_ELEMENT_TYPES.add(ClusterContainer_1007);
			KNOWN_ELEMENT_TYPES.add(DB_1008);
			KNOWN_ELEMENT_TYPES.add(JBossAS_1009);
			KNOWN_ELEMENT_TYPES.add(JBossHAGroup_1010);
			KNOWN_ELEMENT_TYPES.add(WebContainer_2001);
			KNOWN_ELEMENT_TYPES.add(EJBContainer_2002);
			KNOWN_ELEMENT_TYPES.add(DiscoveryService_2003);
			KNOWN_ELEMENT_TYPES.add(JmsService_2004);
			KNOWN_ELEMENT_TYPES.add(IIOP_2005);
			KNOWN_ELEMENT_TYPES.add(IRMI_2006);
			KNOWN_ELEMENT_TYPES.add(JRMP_2007);
			KNOWN_ELEMENT_TYPES.add(CMI_2008);
			KNOWN_ELEMENT_TYPES.add(AJP_2009);
			KNOWN_ELEMENT_TYPES.add(HTTP_2010);
			KNOWN_ELEMENT_TYPES.add(HTTPS_2011);
			KNOWN_ELEMENT_TYPES.add(ModJKModule_2012);
			KNOWN_ELEMENT_TYPES.add(Cluster_2013);
			KNOWN_ELEMENT_TYPES.add(JBossBinding_2014);
			KNOWN_ELEMENT_TYPES.add(WebContainer_2015);
			KNOWN_ELEMENT_TYPES.add(HTTPS_2016);
			KNOWN_ELEMENT_TYPES.add(HTTP_2017);
			KNOWN_ELEMENT_TYPES.add(AJP_2018);
			KNOWN_ELEMENT_TYPES.add(JOnASCmigroup_3001);
			KNOWN_ELEMENT_TYPES.add(IHTTPServerJavaeeServers_3002);
			KNOWN_ELEMENT_TYPES.add(JBossModJKConnector_3003);
			KNOWN_ELEMENT_TYPES.add(RepHTTPConnector_3004);
			KNOWN_ELEMENT_TYPES.add(JBossHTTPRepConnector_3005);
			KNOWN_ELEMENT_TYPES.add(HAConnector_3006);
			KNOWN_ELEMENT_TYPES.add(JBossHAConnector_3007);
			KNOWN_ELEMENT_TYPES.add(DbLink_3008);
			KNOWN_ELEMENT_TYPES.add(RmiConnector_3009);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

}
