/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CmiGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DBEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DomainEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP_RepGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HaGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossTryTryEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RMIGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineDiagramEditorPlugin;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.Messages;

/**
 * @generated
 */
public class JasmineModelingAssistantProvider extends ModelingAssistantProvider {

	/**
	 * @generated
	 */
	public List getTypesForPopupBar(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof JOnASEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.WebContainer_2001);
			types.add(JasmineElementTypes.EJBContainer_2002);
			types.add(JasmineElementTypes.DiscoveryService_2003);
			types.add(JasmineElementTypes.JmsService_2004);
			types.add(JasmineElementTypes.IIOP_2005);
			types.add(JasmineElementTypes.IRMI_2006);
			types.add(JasmineElementTypes.JRMP_2007);
			types.add(JasmineElementTypes.CMI_2008);
			types.add(JasmineElementTypes.AJP_2009);
			types.add(JasmineElementTypes.HTTP_2010);
			types.add(JasmineElementTypes.HTTPS_2011);
			return types;
		}
		if (editPart instanceof Apache_HTTPdEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.ModJKModule_2012);
			return types;
		}
		if (editPart instanceof ClusterContainerEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.Cluster_2013);
			return types;
		}
		if (editPart instanceof JBossASEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JBossBinding_2014);
			types.add(JasmineElementTypes.WebContainer_2015);
			types.add(JasmineElementTypes.HTTPS_2016);
			types.add(JasmineElementTypes.HTTP_2017);
			types.add(JasmineElementTypes.AJP_2018);
			return types;
		}
		if (editPart instanceof DomainEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JOnAS_1001);
			types.add(JasmineElementTypes.Apache_HTTPd_1002);
			types.add(JasmineElementTypes.CmiGroup_1003);
			types.add(JasmineElementTypes.HaGroup_1004);
			types.add(JasmineElementTypes.HTTP_RepGroup_1005);
			types.add(JasmineElementTypes.RMIGroup_1006);
			types.add(JasmineElementTypes.ClusterContainer_1007);
			types.add(JasmineElementTypes.DB_1008);
			types.add(JasmineElementTypes.JBossAS_1009);
			types.add(JasmineElementTypes.JBossHAGroup_1010);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSource(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof JOnASEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JOnASCmigroup_3001);
			types.add(JasmineElementTypes.RepHTTPConnector_3004);
			types.add(JasmineElementTypes.HAConnector_3006);
			types.add(JasmineElementTypes.RmiConnector_3009);
			return types;
		}
		if (sourceEditPart instanceof Apache_HTTPdEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JBossModJKConnector_3003);
			return types;
		}
		if (sourceEditPart instanceof DBEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.DbLink_3008);
			return types;
		}
		if (sourceEditPart instanceof JBossASEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JBossHTTPRepConnector_3005);
			types.add(JasmineElementTypes.JBossHAConnector_3007);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof CmiGroupEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JOnASCmigroup_3001);
			return types;
		}
		if (targetEditPart instanceof HaGroupEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.HAConnector_3006);
			return types;
		}
		if (targetEditPart instanceof HTTP_RepGroupEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.RepHTTPConnector_3004);
			types.add(JasmineElementTypes.JBossHTTPRepConnector_3005);
			return types;
		}
		if (targetEditPart instanceof RMIGroupEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.RmiConnector_3009);
			return types;
		}
		if (targetEditPart instanceof JBossASEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JBossModJKConnector_3003);
			return types;
		}
		if (targetEditPart instanceof JBossTryTryEditPart) {
			List types = new ArrayList();
			types.add(JasmineElementTypes.JBossHAConnector_3007);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source,
			IAdaptable target) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof JOnASEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof CmiGroupEditPart) {
				types.add(JasmineElementTypes.JOnASCmigroup_3001);
			}
			if (targetEditPart instanceof HTTP_RepGroupEditPart) {
				types.add(JasmineElementTypes.RepHTTPConnector_3004);
			}
			if (targetEditPart instanceof HaGroupEditPart) {
				types.add(JasmineElementTypes.HAConnector_3006);
			}
			if (targetEditPart instanceof RMIGroupEditPart) {
				types.add(JasmineElementTypes.RmiConnector_3009);
			}
			return types;
		}
		if (sourceEditPart instanceof Apache_HTTPdEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof JBossASEditPart) {
				types.add(JasmineElementTypes.JBossModJKConnector_3003);
			}
			return types;
		}
		if (sourceEditPart instanceof DBEditPart) {
			List types = new ArrayList();
			return types;
		}
		if (sourceEditPart instanceof JBossASEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof HTTP_RepGroupEditPart) {
				types.add(JasmineElementTypes.JBossHTTPRepConnector_3005);
			}
			if (targetEditPart instanceof JBossTryTryEditPart) {
				types.add(JasmineElementTypes.JBossHAConnector_3007);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForSource(IAdaptable target,
			IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof CmiGroupEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.JOnASCmigroup_3001) {
				types.add(JasmineElementTypes.JOnAS_1001);
			}
			return types;
		}
		if (targetEditPart instanceof HaGroupEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.HAConnector_3006) {
				types.add(JasmineElementTypes.JOnAS_1001);
			}
			return types;
		}
		if (targetEditPart instanceof HTTP_RepGroupEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.RepHTTPConnector_3004) {
				types.add(JasmineElementTypes.JOnAS_1001);
			}
			if (relationshipType == JasmineElementTypes.JBossHTTPRepConnector_3005) {
				types.add(JasmineElementTypes.JBossAS_1009);
			}
			return types;
		}
		if (targetEditPart instanceof RMIGroupEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.RmiConnector_3009) {
				types.add(JasmineElementTypes.JOnAS_1001);
			}
			return types;
		}
		if (targetEditPart instanceof JBossASEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.JBossModJKConnector_3003) {
				types.add(JasmineElementTypes.Apache_HTTPd_1002);
			}
			return types;
		}
		if (targetEditPart instanceof JBossTryTryEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.JBossHAConnector_3007) {
				types.add(JasmineElementTypes.JBossAS_1009);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForTarget(IAdaptable source,
			IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof JOnASEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.JOnASCmigroup_3001) {
				types.add(JasmineElementTypes.CmiGroup_1003);
			}
			if (relationshipType == JasmineElementTypes.RepHTTPConnector_3004) {
				types.add(JasmineElementTypes.HTTP_RepGroup_1005);
			}
			if (relationshipType == JasmineElementTypes.HAConnector_3006) {
				types.add(JasmineElementTypes.HaGroup_1004);
			}
			if (relationshipType == JasmineElementTypes.RmiConnector_3009) {
				types.add(JasmineElementTypes.RMIGroup_1006);
			}
			return types;
		}
		if (sourceEditPart instanceof Apache_HTTPdEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.JBossModJKConnector_3003) {
				types.add(JasmineElementTypes.JBossAS_1009);
			}
			return types;
		}
		if (sourceEditPart instanceof DBEditPart) {
			List types = new ArrayList();
			return types;
		}
		if (sourceEditPart instanceof JBossASEditPart) {
			List types = new ArrayList();
			if (relationshipType == JasmineElementTypes.JBossHTTPRepConnector_3005) {
				types.add(JasmineElementTypes.HTTP_RepGroup_1005);
			}
			if (relationshipType == JasmineElementTypes.JBossHAConnector_3007) {
				types.add(JasmineElementTypes.JBossHAGroup_1010);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target,
			IElementType relationshipType) {
		return selectExistingElement(target, getTypesForSource(target,
				relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source,
			IElementType relationshipType) {
		return selectExistingElement(source, getTypesForTarget(source,
				relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types) {
		if (types.isEmpty()) {
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart == null) {
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		Collection elements = new HashSet();
		for (Iterator it = diagram.getElement().eAllContents(); it.hasNext();) {
			EObject element = (EObject) it.next();
			if (isApplicableElement(element, types)) {
				elements.add(element);
			}
		}
		if (elements.isEmpty()) {
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements
				.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types) {
		IElementType type = ElementTypeRegistry.getInstance().getElementType(
				element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements) {
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(
				JasmineDiagramEditorPlugin.getInstance()
						.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(
				shell, labelProvider);
		dialog.setMessage(Messages.JasmineModelingAssistantProviderMessage);
		dialog.setTitle(Messages.JasmineModelingAssistantProviderTitle);
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK) {
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
