/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.AJP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.AJPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CMIEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CmiGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DiscoveryServiceEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.EJBContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPS2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPSEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP_RepGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HaGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.IIOPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.IRMIEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossBindingEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossHAGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossTryTryTrytryEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASInstanceNameDomainEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JRMPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JmsServiceEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ModJKModuleEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RMIGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.WebContainer2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.WebContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.parsers.CompositeParser;
import org.objectweb.jasmine.ui.jasminemodel.diagram.parsers.MessageFormatParser;
import org.objectweb.jasmine.ui.jasminemodel.diagram.parsers.PrintfParser;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry;

/**
 * @generated
 */
public class JasmineParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser jOnASName_4001Parser;

	/**
	 * @generated
	 */
	private IParser getJOnASName_4001Parser() {
		if (jOnASName_4001Parser == null) {
			jOnASName_4001Parser = createJOnASName_4001Parser();
		}
		return jOnASName_4001Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createJOnASName_4001Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getJOnAS_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser jOnASInstanceNameDomain_4002Parser;

	/**
	 * @generated
	 */
	private IParser getJOnASInstanceNameDomain_4002Parser() {
		if (jOnASInstanceNameDomain_4002Parser == null) {
			jOnASInstanceNameDomain_4002Parser = createJOnASInstanceNameDomain_4002Parser();
		}
		return jOnASInstanceNameDomain_4002Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createJOnASInstanceNameDomain_4002Parser() {
		EAttribute[] features = new EAttribute[] {
				JasminemodelPackage.eINSTANCE.getJOnAS_InstanceName(),
				JasminemodelPackage.eINSTANCE.getJOnAS_Domain(), };
		PrintfParser reader = new PrintfParser(features);
		reader.setViewPattern("<%s,%s>");
		reader.setEditorPattern("<%s,%s>");
		MessageFormatParser writer = new MessageFormatParser(features);
		writer.setEditPattern("<%s,%s>");
		return new CompositeParser(reader, writer);
	}

	/**
	 * @generated
	 */
	private IParser apache_HTTPdName_4003Parser;

	/**
	 * @generated
	 */
	private IParser getApache_HTTPdName_4003Parser() {
		if (apache_HTTPdName_4003Parser == null) {
			apache_HTTPdName_4003Parser = createApache_HTTPdName_4003Parser();
		}
		return apache_HTTPdName_4003Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createApache_HTTPdName_4003Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getApache_HTTPd_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser cmiGroupName_4004Parser;

	/**
	 * @generated
	 */
	private IParser getCmiGroupName_4004Parser() {
		if (cmiGroupName_4004Parser == null) {
			cmiGroupName_4004Parser = createCmiGroupName_4004Parser();
		}
		return cmiGroupName_4004Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createCmiGroupName_4004Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getConfigurationNode_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser haGroupName_4005Parser;

	/**
	 * @generated
	 */
	private IParser getHaGroupName_4005Parser() {
		if (haGroupName_4005Parser == null) {
			haGroupName_4005Parser = createHaGroupName_4005Parser();
		}
		return haGroupName_4005Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createHaGroupName_4005Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getConfigurationNode_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser hTTP_RepGroupName_4006Parser;

	/**
	 * @generated
	 */
	private IParser getHTTP_RepGroupName_4006Parser() {
		if (hTTP_RepGroupName_4006Parser == null) {
			hTTP_RepGroupName_4006Parser = createHTTP_RepGroupName_4006Parser();
		}
		return hTTP_RepGroupName_4006Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createHTTP_RepGroupName_4006Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getConfigurationNode_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser rMIGroupName_4007Parser;

	/**
	 * @generated
	 */
	private IParser getRMIGroupName_4007Parser() {
		if (rMIGroupName_4007Parser == null) {
			rMIGroupName_4007Parser = createRMIGroupName_4007Parser();
		}
		return rMIGroupName_4007Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createRMIGroupName_4007Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getConfigurationNode_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser jBossASName_4008Parser;

	/**
	 * @generated
	 */
	private IParser getJBossASName_4008Parser() {
		if (jBossASName_4008Parser == null) {
			jBossASName_4008Parser = createJBossASName_4008Parser();
		}
		return jBossASName_4008Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createJBossASName_4008Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getJBossAS_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser jBossHAGroupName_4009Parser;

	/**
	 * @generated
	 */
	private IParser getJBossHAGroupName_4009Parser() {
		if (jBossHAGroupName_4009Parser == null) {
			jBossHAGroupName_4009Parser = createJBossHAGroupName_4009Parser();
		}
		return jBossHAGroupName_4009Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createJBossHAGroupName_4009Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getConfigurationNode_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser webContainer_2001Parser;

	/**
	 * @generated
	 */
	private IParser getWebContainer_2001Parser() {
		if (webContainer_2001Parser == null) {
			webContainer_2001Parser = createWebContainer_2001Parser();
		}
		return webContainer_2001Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createWebContainer_2001Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getIContainer_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser eJBContainer_2002Parser;

	/**
	 * @generated
	 */
	private IParser getEJBContainer_2002Parser() {
		if (eJBContainer_2002Parser == null) {
			eJBContainer_2002Parser = createEJBContainer_2002Parser();
		}
		return eJBContainer_2002Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createEJBContainer_2002Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getIContainer_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser discoveryService_2003Parser;

	/**
	 * @generated
	 */
	private IParser getDiscoveryService_2003Parser() {
		if (discoveryService_2003Parser == null) {
			discoveryService_2003Parser = createDiscoveryService_2003Parser();
		}
		return discoveryService_2003Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createDiscoveryService_2003Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getDiscoveryService_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser jmsService_2004Parser;

	/**
	 * @generated
	 */
	private IParser getJmsService_2004Parser() {
		if (jmsService_2004Parser == null) {
			jmsService_2004Parser = createJmsService_2004Parser();
		}
		return jmsService_2004Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createJmsService_2004Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getJmsService_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser iIOP_2005Parser;

	/**
	 * @generated
	 */
	private IParser getIIOP_2005Parser() {
		if (iIOP_2005Parser == null) {
			iIOP_2005Parser = createIIOP_2005Parser();
		}
		return iIOP_2005Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createIIOP_2005Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getIRMIRegistry_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser iRMI_2006Parser;

	/**
	 * @generated
	 */
	private IParser getIRMI_2006Parser() {
		if (iRMI_2006Parser == null) {
			iRMI_2006Parser = createIRMI_2006Parser();
		}
		return iRMI_2006Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createIRMI_2006Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getIRMIRegistry_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser jRMP_2007Parser;

	/**
	 * @generated
	 */
	private IParser getJRMP_2007Parser() {
		if (jRMP_2007Parser == null) {
			jRMP_2007Parser = createJRMP_2007Parser();
		}
		return jRMP_2007Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createJRMP_2007Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getIRMIRegistry_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser cMI_2008Parser;

	/**
	 * @generated
	 */
	private IParser getCMI_2008Parser() {
		if (cMI_2008Parser == null) {
			cMI_2008Parser = createCMI_2008Parser();
		}
		return cMI_2008Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createCMI_2008Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getIRMIRegistry_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser aJP_2009Parser;

	/**
	 * @generated
	 */
	private IParser getAJP_2009Parser() {
		if (aJP_2009Parser == null) {
			aJP_2009Parser = createAJP_2009Parser();
		}
		return aJP_2009Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createAJP_2009Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getWebConnector_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser hTTP_2010Parser;

	/**
	 * @generated
	 */
	private IParser getHTTP_2010Parser() {
		if (hTTP_2010Parser == null) {
			hTTP_2010Parser = createHTTP_2010Parser();
		}
		return hTTP_2010Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createHTTP_2010Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getWebConnector_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser hTTPS_2011Parser;

	/**
	 * @generated
	 */
	private IParser getHTTPS_2011Parser() {
		if (hTTPS_2011Parser == null) {
			hTTPS_2011Parser = createHTTPS_2011Parser();
		}
		return hTTPS_2011Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createHTTPS_2011Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getWebConnector_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser modJKModule_2012Parser;

	/**
	 * @generated
	 */
	private IParser getModJKModule_2012Parser() {
		if (modJKModule_2012Parser == null) {
			modJKModule_2012Parser = createModJKModule_2012Parser();
		}
		return modJKModule_2012Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createModJKModule_2012Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getModJKModule_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser cluster_2013Parser;

	/**
	 * @generated
	 */
	private IParser getCluster_2013Parser() {
		if (cluster_2013Parser == null) {
			cluster_2013Parser = createCluster_2013Parser();
		}
		return cluster_2013Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createCluster_2013Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getCluster_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser jBossBinding_2014Parser;

	/**
	 * @generated
	 */
	private IParser getJBossBinding_2014Parser() {
		if (jBossBinding_2014Parser == null) {
			jBossBinding_2014Parser = createJBossBinding_2014Parser();
		}
		return jBossBinding_2014Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createJBossBinding_2014Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getJBossBinding_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser webContainer_2015Parser;

	/**
	 * @generated
	 */
	private IParser getWebContainer_2015Parser() {
		if (webContainer_2015Parser == null) {
			webContainer_2015Parser = createWebContainer_2015Parser();
		}
		return webContainer_2015Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createWebContainer_2015Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getIContainer_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser hTTPS_2016Parser;

	/**
	 * @generated
	 */
	private IParser getHTTPS_2016Parser() {
		if (hTTPS_2016Parser == null) {
			hTTPS_2016Parser = createHTTPS_2016Parser();
		}
		return hTTPS_2016Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createHTTPS_2016Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getWebConnector_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser hTTP_2017Parser;

	/**
	 * @generated
	 */
	private IParser getHTTP_2017Parser() {
		if (hTTP_2017Parser == null) {
			hTTP_2017Parser = createHTTP_2017Parser();
		}
		return hTTP_2017Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createHTTP_2017Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getWebConnector_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser aJP_2018Parser;

	/**
	 * @generated
	 */
	private IParser getAJP_2018Parser() {
		if (aJP_2018Parser == null) {
			aJP_2018Parser = createAJP_2018Parser();
		}
		return aJP_2018Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createAJP_2018Parser() {
		EAttribute[] features = new EAttribute[] { JasminemodelPackage.eINSTANCE
				.getWebConnector_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case JOnASNameEditPart.VISUAL_ID:
			return getJOnASName_4001Parser();
		case JOnASInstanceNameDomainEditPart.VISUAL_ID:
			return getJOnASInstanceNameDomain_4002Parser();
		case Apache_HTTPdNameEditPart.VISUAL_ID:
			return getApache_HTTPdName_4003Parser();
		case CmiGroupNameEditPart.VISUAL_ID:
			return getCmiGroupName_4004Parser();
		case HaGroupNameEditPart.VISUAL_ID:
			return getHaGroupName_4005Parser();
		case HTTP_RepGroupNameEditPart.VISUAL_ID:
			return getHTTP_RepGroupName_4006Parser();
		case RMIGroupNameEditPart.VISUAL_ID:
			return getRMIGroupName_4007Parser();
		case JBossASNameEditPart.VISUAL_ID:
			return getJBossASName_4008Parser();
		case JBossHAGroupNameEditPart.VISUAL_ID:
			return getJBossHAGroupName_4009Parser();
		case WebContainerEditPart.VISUAL_ID:
			return getWebContainer_2001Parser();
		case EJBContainerEditPart.VISUAL_ID:
			return getEJBContainer_2002Parser();
		case DiscoveryServiceEditPart.VISUAL_ID:
			return getDiscoveryService_2003Parser();
		case JmsServiceEditPart.VISUAL_ID:
			return getJmsService_2004Parser();
		case IIOPEditPart.VISUAL_ID:
			return getIIOP_2005Parser();
		case IRMIEditPart.VISUAL_ID:
			return getIRMI_2006Parser();
		case JRMPEditPart.VISUAL_ID:
			return getJRMP_2007Parser();
		case CMIEditPart.VISUAL_ID:
			return getCMI_2008Parser();
		case AJPEditPart.VISUAL_ID:
			return getAJP_2009Parser();
		case HTTPEditPart.VISUAL_ID:
			return getHTTP_2010Parser();
		case HTTPSEditPart.VISUAL_ID:
			return getHTTPS_2011Parser();
		case ModJKModuleEditPart.VISUAL_ID:
			return getModJKModule_2012Parser();
		case ClusterEditPart.VISUAL_ID:
			return getCluster_2013Parser();
		case JBossBindingEditPart.VISUAL_ID:
			return getJBossBinding_2014Parser();
		case WebContainer2EditPart.VISUAL_ID:
			return getWebContainer_2015Parser();
		case HTTPS2EditPart.VISUAL_ID:
			return getHTTPS_2016Parser();
		case HTTP2EditPart.VISUAL_ID:
			return getHTTP_2017Parser();
		case AJP2EditPart.VISUAL_ID:
			return getAJP_2018Parser();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(JasmineVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(JasmineVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (JasmineElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
