/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.notation.View;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.AJP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.AJPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdModulesEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.Apache_HTTPdNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CMIConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CMIEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterContainerClusterSetEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ClusterEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CmiGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.CmiGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DBEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DbLink2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DbLinkEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DiscoveryServiceEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.DomainEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.EJBContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HAConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPS2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTPSEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP_RepGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HTTP_RepGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HaGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.HaGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.IIOPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.IRMIEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASServicesEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossASWeb_ConnectorsEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossBindingEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossHAConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossHAGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossTryTryEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JBossTryTryTrytryEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASInstanceNameDomainEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASProtocolsEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASServicesEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JOnASWeb_ConnectorsEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JRMPEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.JmsServiceEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ModJKModuleEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.ModjkConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RMIGroupEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RMIGroupNameEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RepHTTPConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RmiConnector2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.RmiConnectorEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.WebContainer2EditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.edit.parts.WebContainerEditPart;
import org.objectweb.jasmine.ui.jasminemodel.diagram.part.JasmineVisualIDRegistry;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.AJP2ViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.AJPViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.Apache_HTTPdModulesViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.Apache_HTTPdNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.Apache_HTTPdViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.CMIConnectorViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.CMIViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.ClusterContainerClusterSetViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.ClusterContainerViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.ClusterViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.CmiGroupNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.CmiGroupViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.DBViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.DbLink2ViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.DbLinkViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.DiscoveryServiceViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.DomainViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.EJBContainerViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HAConnectorViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HTTP2ViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HTTPS2ViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HTTPSViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HTTPViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HTTP_RepGroupNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HTTP_RepGroupViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HaGroupNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.HaGroupViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.IIOPViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.IRMIViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossASNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossASServicesViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossASViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossASWeb_ConnectorsViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossBindingViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossHAConnectorViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossHAGroupNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossTryTryTrytryViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JBossTryTryViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JOnASInstanceNameDomainViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JOnASNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JOnASProtocolsViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JOnASServicesViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JOnASViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JOnASWeb_ConnectorsViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JRMPViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.JmsServiceViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.ModJKModuleViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.ModjkConnectorViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.RMIGroupNameViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.RMIGroupViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.RepHTTPConnectorViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.RmiConnector2ViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.RmiConnectorViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.WebContainer2ViewFactory;
import org.objectweb.jasmine.ui.jasminemodel.diagram.view.factories.WebContainerViewFactory;

/**
 * @generated
 */
public class JasmineViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (DomainEditPart.MODEL_ID.equals(diagramKind)
				&& JasmineVisualIDRegistry.getDiagramVisualID(semanticElement) != -1) {
			return DomainViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		EObject domainElement = getSemanticElement(semanticAdapter);
		int visualID;
		if (semanticHint == null) {
			// Semantic hint is not specified. Can be a result of call from CanonicalEditPolicy.
			// In this situation there should be NO elementType, visualID will be determined
			// by VisualIDRegistry.getNodeVisualID() for domainElement.
			if (elementType != null || domainElement == null) {
				return null;
			}
			visualID = JasmineVisualIDRegistry.getNodeVisualID(containerView,
					domainElement);
		} else {
			visualID = JasmineVisualIDRegistry.getVisualID(semanticHint);
			if (elementType != null) {
				// Semantic hint is specified together with element type.
				// Both parameters should describe exactly the same diagram element.
				// In addition we check that visualID returned by VisualIDRegistry.getNodeVisualID() for
				// domainElement (if specified) is the same as in element type.
				if (!JasmineElementTypes.isKnownElementType(elementType)
						|| (!(elementType instanceof IHintedType))) {
					return null; // foreign element type
				}
				String elementTypeHint = ((IHintedType) elementType)
						.getSemanticHint();
				if (!semanticHint.equals(elementTypeHint)) {
					return null; // if semantic hint is specified it should be the same as in element type
				}
				if (domainElement != null
						&& visualID != JasmineVisualIDRegistry.getNodeVisualID(
								containerView, domainElement)) {
					return null; // visual id for node EClass should match visual id from element type
				}
			} else {
				// Element type is not specified. Domain element should be present (except pure design elements).
				// This method is called with EObjectAdapter as parameter from:
				//   - ViewService.createNode(View container, EObject eObject, String type, PreferencesHint preferencesHint) 
				//   - generated ViewFactory.decorateView() for parent element
				if (!DomainEditPart.MODEL_ID.equals(JasmineVisualIDRegistry
						.getModelID(containerView))) {
					return null; // foreign diagram
				}
				switch (visualID) {
				case JOnASEditPart.VISUAL_ID:
				case Apache_HTTPdEditPart.VISUAL_ID:
				case CmiGroupEditPart.VISUAL_ID:
				case HaGroupEditPart.VISUAL_ID:
				case HTTP_RepGroupEditPart.VISUAL_ID:
				case RMIGroupEditPart.VISUAL_ID:
				case ClusterContainerEditPart.VISUAL_ID:
				case DBEditPart.VISUAL_ID:
				case JBossASEditPart.VISUAL_ID:
				case JBossTryTryEditPart.VISUAL_ID:
				case WebContainerEditPart.VISUAL_ID:
				case EJBContainerEditPart.VISUAL_ID:
				case DiscoveryServiceEditPart.VISUAL_ID:
				case JmsServiceEditPart.VISUAL_ID:
				case IIOPEditPart.VISUAL_ID:
				case IRMIEditPart.VISUAL_ID:
				case JRMPEditPart.VISUAL_ID:
				case CMIEditPart.VISUAL_ID:
				case AJPEditPart.VISUAL_ID:
				case HTTPEditPart.VISUAL_ID:
				case HTTPSEditPart.VISUAL_ID:
				case ModJKModuleEditPart.VISUAL_ID:
				case ClusterEditPart.VISUAL_ID:
				case JBossBindingEditPart.VISUAL_ID:
				case WebContainer2EditPart.VISUAL_ID:
				case HTTPS2EditPart.VISUAL_ID:
				case HTTP2EditPart.VISUAL_ID:
				case AJP2EditPart.VISUAL_ID:
					if (domainElement == null
							|| visualID != JasmineVisualIDRegistry
									.getNodeVisualID(containerView,
											domainElement)) {
						return null; // visual id in semantic hint should match visual id for domain element
					}
					break;
				case JOnASNameEditPart.VISUAL_ID:
				case JOnASInstanceNameDomainEditPart.VISUAL_ID:
				case JOnASServicesEditPart.VISUAL_ID:
				case JOnASProtocolsEditPart.VISUAL_ID:
				case JOnASWeb_ConnectorsEditPart.VISUAL_ID:
					if (JOnASEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case Apache_HTTPdNameEditPart.VISUAL_ID:
				case Apache_HTTPdModulesEditPart.VISUAL_ID:
					if (Apache_HTTPdEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case CmiGroupNameEditPart.VISUAL_ID:
					if (CmiGroupEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case HaGroupNameEditPart.VISUAL_ID:
					if (HaGroupEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case HTTP_RepGroupNameEditPart.VISUAL_ID:
					if (HTTP_RepGroupEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case RMIGroupNameEditPart.VISUAL_ID:
					if (RMIGroupEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case ClusterContainerClusterSetEditPart.VISUAL_ID:
					if (ClusterContainerEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case JBossASNameEditPart.VISUAL_ID:
				case JBossASServicesEditPart.VISUAL_ID:
				case JBossASWeb_ConnectorsEditPart.VISUAL_ID:
					if (JBossASEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case JBossHAGroupNameEditPart.VISUAL_ID:
					if (JBossTryTryEditPart.VISUAL_ID != JasmineVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				default:
					return null;
				}
			}
		}
		return getNodeViewClass(containerView, visualID);
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(View containerView, int visualID) {
		if (containerView == null
				|| !JasmineVisualIDRegistry.canCreateNode(containerView,
						visualID)) {
			return null;
		}
		switch (visualID) {
		case JOnASEditPart.VISUAL_ID:
			return JOnASViewFactory.class;
		case JOnASNameEditPart.VISUAL_ID:
			return JOnASNameViewFactory.class;
		case JOnASInstanceNameDomainEditPart.VISUAL_ID:
			return JOnASInstanceNameDomainViewFactory.class;
		case Apache_HTTPdEditPart.VISUAL_ID:
			return Apache_HTTPdViewFactory.class;
		case Apache_HTTPdNameEditPart.VISUAL_ID:
			return Apache_HTTPdNameViewFactory.class;
		case CmiGroupEditPart.VISUAL_ID:
			return CmiGroupViewFactory.class;
		case CmiGroupNameEditPart.VISUAL_ID:
			return CmiGroupNameViewFactory.class;
		case HaGroupEditPart.VISUAL_ID:
			return HaGroupViewFactory.class;
		case HaGroupNameEditPart.VISUAL_ID:
			return HaGroupNameViewFactory.class;
		case HTTP_RepGroupEditPart.VISUAL_ID:
			return HTTP_RepGroupViewFactory.class;
		case HTTP_RepGroupNameEditPart.VISUAL_ID:
			return HTTP_RepGroupNameViewFactory.class;
		case RMIGroupEditPart.VISUAL_ID:
			return RMIGroupViewFactory.class;
		case RMIGroupNameEditPart.VISUAL_ID:
			return RMIGroupNameViewFactory.class;
		case ClusterContainerEditPart.VISUAL_ID:
			return ClusterContainerViewFactory.class;
		case DBEditPart.VISUAL_ID:
			return DBViewFactory.class;
		case JBossASEditPart.VISUAL_ID:
			return JBossASViewFactory.class;
		case JBossASNameEditPart.VISUAL_ID:
			return JBossASNameViewFactory.class;
		case JBossTryTryEditPart.VISUAL_ID:
			return JBossTryTryViewFactory.class;
		case JBossHAGroupNameEditPart.VISUAL_ID:
			return JBossHAGroupNameViewFactory.class;
		case WebContainerEditPart.VISUAL_ID:
			return WebContainerViewFactory.class;
		case EJBContainerEditPart.VISUAL_ID:
			return EJBContainerViewFactory.class;
		case DiscoveryServiceEditPart.VISUAL_ID:
			return DiscoveryServiceViewFactory.class;
		case JmsServiceEditPart.VISUAL_ID:
			return JmsServiceViewFactory.class;
		case IIOPEditPart.VISUAL_ID:
			return IIOPViewFactory.class;
		case IRMIEditPart.VISUAL_ID:
			return IRMIViewFactory.class;
		case JRMPEditPart.VISUAL_ID:
			return JRMPViewFactory.class;
		case CMIEditPart.VISUAL_ID:
			return CMIViewFactory.class;
		case AJPEditPart.VISUAL_ID:
			return AJPViewFactory.class;
		case HTTPEditPart.VISUAL_ID:
			return HTTPViewFactory.class;
		case HTTPSEditPart.VISUAL_ID:
			return HTTPSViewFactory.class;
		case ModJKModuleEditPart.VISUAL_ID:
			return ModJKModuleViewFactory.class;
		case ClusterEditPart.VISUAL_ID:
			return ClusterViewFactory.class;
		case JBossBindingEditPart.VISUAL_ID:
			return JBossBindingViewFactory.class;
		case WebContainer2EditPart.VISUAL_ID:
			return WebContainer2ViewFactory.class;
		case HTTPS2EditPart.VISUAL_ID:
			return HTTPS2ViewFactory.class;
		case HTTP2EditPart.VISUAL_ID:
			return HTTP2ViewFactory.class;
		case AJP2EditPart.VISUAL_ID:
			return AJP2ViewFactory.class;
		case JOnASServicesEditPart.VISUAL_ID:
			return JOnASServicesViewFactory.class;
		case JOnASProtocolsEditPart.VISUAL_ID:
			return JOnASProtocolsViewFactory.class;
		case JOnASWeb_ConnectorsEditPart.VISUAL_ID:
			return JOnASWeb_ConnectorsViewFactory.class;
		case Apache_HTTPdModulesEditPart.VISUAL_ID:
			return Apache_HTTPdModulesViewFactory.class;
		case ClusterContainerClusterSetEditPart.VISUAL_ID:
			return ClusterContainerClusterSetViewFactory.class;
		case JBossASServicesEditPart.VISUAL_ID:
			return JBossASServicesViewFactory.class;
		case JBossASWeb_ConnectorsEditPart.VISUAL_ID:
			return JBossASWeb_ConnectorsViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (!JasmineElementTypes.isKnownElementType(elementType)
				|| (!(elementType instanceof IHintedType))) {
			return null; // foreign element type
		}
		String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
		if (elementTypeHint == null) {
			return null; // our hint is visual id and must be specified
		}
		if (semanticHint != null && !semanticHint.equals(elementTypeHint)) {
			return null; // if semantic hint is specified it should be the same as in element type
		}
		int visualID = JasmineVisualIDRegistry.getVisualID(elementTypeHint);
		EObject domainElement = getSemanticElement(semanticAdapter);
		if (domainElement != null
				&& visualID != JasmineVisualIDRegistry
						.getLinkWithClassVisualID(domainElement)) {
			return null; // visual id for link EClass should match visual id from element type
		}
		return getEdgeViewClass(visualID);
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(int visualID) {
		switch (visualID) {
		case CMIConnectorEditPart.VISUAL_ID:
			return CMIConnectorViewFactory.class;
		case ModjkConnectorEditPart.VISUAL_ID:
			return ModjkConnectorViewFactory.class;
		case RepHTTPConnectorEditPart.VISUAL_ID:
			return RepHTTPConnectorViewFactory.class;
		case HAConnectorEditPart.VISUAL_ID:
			return HAConnectorViewFactory.class;
		case DbLinkEditPart.VISUAL_ID:
			return DbLinkViewFactory.class;
		case RmiConnectorEditPart.VISUAL_ID:
			return RmiConnectorViewFactory.class;
		case JBossHAConnectorEditPart.VISUAL_ID:
			return JBossHAConnectorViewFactory.class;
		case DbLink2EditPart.VISUAL_ID:
			return DbLink2ViewFactory.class;
		case RmiConnector2EditPart.VISUAL_ID:
			return RmiConnector2ViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}
}
