/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.diagram.ui.treeviews;

import org.eclipse.emf.ecore.xmi.XMIResource;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;
import org.objectweb.jasmine.ui.jasminemodel.Cluster;
import org.objectweb.jasmine.ui.jasminemodel.ClusterContainer;
import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IModule;
import org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry;
import org.objectweb.jasmine.ui.jasminemodel.IWebConnector;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;


public class JasmineNodeFilter extends ViewerFilter {

	/*
	 * @see ViewerFilter#select(Viewer, Object, Object)
	 */
	public boolean select(Viewer viewer, Object parentElement, Object element) {
		return element instanceof JASMINeNode || element instanceof XMIResource;
	}
}
