/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.loginAdressPort;

import javax.naming.NamingException;

import org.eclipse.swt.widgets.Shell;
import org.objectweb.jasmine.ui.jasminemodel.properties.JasmineLoadProperties;
import org.objectweb.jasmine.ui.logs.ComLog;
import org.objectweb.jasmine.ui.monitoring.CommunicationAndParsing.JMSConnection;
import org.objectweb.jasmine.ui.rules.ComRules;

public class ConnectionManager {

    public static String CONNECTING = "CONNECTING";

    public static String CONNECTED = "CONNECTED";

    public static String DISCONNECTED = "DISCONNECTED";

    public static String CONNECTION_FAILED = "CONNECTION_FAILED";

    private static String jadeFrontIp;

    private static String jadeFrontPort;

    private static String jadeJMXIp;

    private static String jadeJMXPort;

    private static String jadeRMIIp;

    private static String jadeRMIPort;

    private static String jadeStatus = DISCONNECTED;

    private static String probeFrontIp;

    private static String probeFrontPort;

    private static String probeFrontStatus = DISCONNECTED;

    private static String fdfFrontIp;

    private static String fdfFrontPort;

    private static String fdfJMXIp;

    private static String fdfJMXPort;

    private static String fdfFrontStatus = DISCONNECTED;

    private static String logFrontIp;

    private static String logFrontPort;

    private static String logFrontStatus = DISCONNECTED;

    public static void connectJade() {

        String url = "rmi://" + jadeFrontIp + ":" + jadeFrontPort;
        String status = CONNECTED;

        try {

            org.objectweb.jasmine.jade.application.Application
                    .setEJBConnexion(url);
            org.objectweb.jasmine.jade.application.Application
                    .setJMXConnection(jadeJMXIp, jadeJMXPort);
            org.objectweb.jasmine.jade.application.Application
                    .setRMIConnection(jadeRMIIp, Integer.parseInt(jadeRMIPort));

        } catch (NamingException e) {
            status = CONNECTION_FAILED;
            e.printStackTrace();
        } catch (Exception e) {
            status = CONNECTION_FAILED;
            e.printStackTrace();
        }
        jadeStatus = status;
    }

    public static void disconnectJade() {
        jadeStatus = DISCONNECTED;
    }

    public static void connectProbe() {
        String url = "rmi://" + probeFrontIp + ":" + probeFrontPort;
        String status = DISCONNECTED;
        // try {
        // JMSConnection.connectionWithProbeFront(url);
        //
        // } catch (NamingException e) {
        // status = CONNECTION_FAILED;
        // e.printStackTrace();
        // } catch (Exception e) {
        // status = CONNECTION_FAILED;
        // e.printStackTrace();
        // }
        // try {
        // JMSConnection.connectionWithJMSQueue();
        // } catch (Exception e) {
        // status = CONNECTION_FAILED;
        // }
        probeFrontStatus = status;
    }

    public static void disconnectProbe() {
        probeFrontStatus = DISCONNECTED;
    }

    public static void connectFDF() {
        String url = "rmi://" + fdfFrontIp + ":" + fdfFrontPort;
        String status = DISCONNECTED;
        // try {
        // JasmineNodeDeployerImpl.setEJBConnection(url);
        //
        // } catch (NamingException e) {
        // status = CONNECTION_FAILED;
        // e.printStackTrace();
        // } catch (Exception e) {
        // status = CONNECTION_FAILED;
        // e.printStackTrace();
        // }
        fdfFrontStatus = status;
    }

    public static void disconnectFDF() {
        fdfFrontStatus = DISCONNECTED;
    }

    public static void connectLog() {
        String url = "rmi://" + logFrontIp + ":" + logFrontPort;
        String status = DISCONNECTED;

        // try {
        // ComLog.connection(url);
        // ComRules.connection(url);
        // } catch (NamingException e) {
        // e.printStackTrace();
        // status = CONNECTION_FAILED;
        // } catch (Exception e) {
        // e.printStackTrace();
        // status = CONNECTION_FAILED;
        // }
        logFrontStatus = status;
    }

    public static String getLogURL() {
        return "rmi://" + logFrontIp + ":" + logFrontPort;
    }

    public static void disconnectLog() {
        logFrontStatus = DISCONNECTED;
    }

    public static String getJadeFrontIp() {
        return jadeFrontIp;
    }

    public static void setJadeFrontIp(String jadeFrontIp) {
        ConnectionManager.jadeFrontIp = jadeFrontIp;
    }

    public static String getJadeFrontPort() {
        return jadeFrontPort;
    }

    public static void setJadeFrontPort(String jadeFrontPort) {
        ConnectionManager.jadeFrontPort = jadeFrontPort;
    }

    public static String getJadeJMXIp() {
        return jadeJMXIp;
    }

    public static void setJadeJMXIp(String jadeJMXIp) {
        ConnectionManager.jadeJMXIp = jadeJMXIp;
    }

    public static String getJadeJMXPort() {
        return jadeJMXPort;
    }

    public static void setJadeJMXPort(String jadeJMXPort) {
        ConnectionManager.jadeJMXPort = jadeJMXPort;
    }

    public static String getJadeRMIIp() {
        return jadeRMIIp;
    }

    public static void setJadeRMIIp(String jadeRMIIp) {
        ConnectionManager.jadeRMIIp = jadeRMIIp;
    }

    public static String getJadeRMIPort() {
        return jadeRMIPort;
    }

    public static void setJadeRMIPort(String jadeRMIPort) {
        ConnectionManager.jadeRMIPort = jadeRMIPort;
    }

    public static String getJadeFrontStatus() {
        return jadeStatus;
    }

    public static void setJadeFrontStatus(String jadeFrontStatus) {
        ConnectionManager.jadeStatus = jadeFrontStatus;
    }

    public static String getProbeFrontIp() {
        return probeFrontIp;
    }

    public static void setProbeFrontIp(String probeFrontIp) {
        ConnectionManager.probeFrontIp = probeFrontIp;
    }

    public static String getProbeFrontPort() {
        return probeFrontPort;
    }

    public static void setProbeFrontPort(String probeFrontPort) {
        ConnectionManager.probeFrontPort = probeFrontPort;
    }

    public static String getProbeFrontStatus() {
        return probeFrontStatus;
    }

    public static void setProbeFrontStatus(String probeFrontStatus) {
        ConnectionManager.probeFrontStatus = probeFrontStatus;
    }

    public static String getFDFFrontIp() {
        return fdfFrontIp;
    }

    public static void setFDFFrontIp(String fdfFrontIp) {
        ConnectionManager.fdfFrontIp = fdfFrontIp;
    }

    public static String getFDFFrontPort() {
        return fdfFrontPort;
    }

    public static void setFDFFrontPort(String fdfFrontPort) {
        ConnectionManager.fdfFrontPort = fdfFrontPort;
    }

    public static String getFDFJMXIp() {
        return fdfJMXIp;
    }

    public static void setFDFJMXIp(String fdfJMXIp) {
        ConnectionManager.fdfJMXIp = fdfJMXIp;
    }

    public static String getFDFJMXPort() {
        return fdfJMXPort;
    }

    public static void setFDFJMXPort(String fdfJMXPort) {
        ConnectionManager.fdfJMXPort = fdfJMXPort;
    }

    public static String getFDFFrontStatus() {
        return fdfFrontStatus;
    }

    public static void setFDFFrontStatus(String fdfFrontStatus) {
        ConnectionManager.fdfFrontStatus = fdfFrontStatus;
    }

    public static String getLogFrontIp() {
        return logFrontIp;
    }

    public static void setLogFrontIp(String logFrontIp) {
        ConnectionManager.logFrontIp = logFrontIp;
    }

    public static String getLogFrontPort() {
        return logFrontPort;
    }

    public static void setLogFrontPort(String logFrontPort) {
        ConnectionManager.logFrontPort = logFrontPort;
    }

    public static String getLogFrontStatus() {
        return logFrontStatus;
    }

    public static void setLogFrontStatus(String logFrontStatus) {
        ConnectionManager.logFrontStatus = logFrontStatus;
    }

    /**
     * Try to connect to RMI registry. When a workbench environment is used,
     * this method is intended to be launched in a separated thread
     *
     * @param display
     */
    public static void initConnections(Shell shell) {

        boolean problem = false;

        /*
         * Connect to probes
         */
        ConnectionManager.setProbeFrontIp(JasmineLoadProperties
                .getProbeFrontIp());
        ConnectionManager.setProbeFrontPort(JasmineLoadProperties
                .getProbeFrontPort());
        ConnectionManager.connectProbe();

        /*
         * connect to a Jade platform
         */
        ConnectionManager
                .setJadeFrontIp(JasmineLoadProperties.getJadeFrontIp());
        ConnectionManager.setJadeFrontPort(JasmineLoadProperties
                .getJadeFrontPort());
        ConnectionManager.setJadeJMXIp(JasmineLoadProperties.getJadeJMXIp());
        ConnectionManager
                .setJadeJMXPort(JasmineLoadProperties.getJadeJMXPort());
        ConnectionManager.setJadeRMIIp(JasmineLoadProperties.getJadeRMIIp());
        ConnectionManager
                .setJadeRMIPort(JasmineLoadProperties.getJadeRMIPort());
        ConnectionManager.connectJade();

        /*
         * connect to log engine
         */
        ConnectionManager.setLogFrontIp(JasmineLoadProperties.getLogFrontIp());
        ConnectionManager.setLogFrontPort(JasmineLoadProperties
                .getLogFrontPort());
        ConnectionManager.connectLog();

        /*
         * connect to FDF
         */
        ConnectionManager.setFDFFrontIp(JasmineLoadProperties.getFDFFrontIp());
        ConnectionManager.setFDFFrontPort(JasmineLoadProperties
                .getFDFFrontPort());
        ConnectionManager.connectFDF();

        if (ConnectionManager.getProbeFrontStatus() != ConnectionManager.CONNECTED) {
            problem = true;
            logs("Probe", false);
        } else {
            logs("Probe", true);
        }
        if (ConnectionManager.getJadeFrontStatus() != ConnectionManager.CONNECTED) {
            problem = true;
            logs("Jade ", false);
        } else {
            logs("Jade ", true);
        }
        if (ConnectionManager.getLogFrontStatus() != ConnectionManager.CONNECTED) {
            problem = true;
            logs("Log  ", false);
        } else {
            logs("Log  ", true);
        }
        if (ConnectionManager.getFDFFrontStatus() != ConnectionManager.CONNECTED) {
            problem = true;
            logs("FDF  ", false);
        } else {
            logs("FDF  ", true);
        }

        if (problem) {
            new ConnectionManagerView(ConnectionManagerView.SPLASH, shell);
        }

    }

    private static void logs(String part, boolean ok) {
        if (ok) {
            System.out.println("JASMINe connection : " + part + "[Connected]");
        } else {
            System.out.println("JASMINe connection : " + part + "[Failed   ]");
        }
    }

    public static boolean isConnected() {
        return (ConnectionManager.getLogFrontStatus()
                .equals(ConnectionManager.CONNECTED))
                && (ConnectionManager.getJadeFrontStatus()
                        .equals(ConnectionManager.CONNECTED))
                && (ConnectionManager.getProbeFrontStatus()
                        .equals(ConnectionManager.CONNECTED))
                && (ConnectionManager.getFDFFrontStatus()
                        .equals(ConnectionManager.CONNECTED));
    }

}
