/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.loginAdressPort;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

public class ConnectionManagerView {

    static int insetX = 2;

    static int insetY = 2;

    static int HEIGHT1 = 25;

    static int HEIGHT2 = 25;

    static int HEIGHT3 = 17;

    private boolean exit = true;

    // jade front
    private Group jade;

    private Label jadeEJBIpTitle;

    private Label jadeEJBPortTitle;

    private Label jadeJMXIpTitle;

    private Label jadeJMXPortTitle;

    private Label jadeRMIIpTitle;

    private Label jadeRMIPortTitle;

    private Label jadeStatusTitle;

    private Text jadeEJBIp;

    private Text jadeEJBPort;

    private Text jadeJMXIp;

    private Text jadeJMXPort;

    private Text jadeRMIIp;

    private Text jadeRMIPort;

    private Label jadeStatus;

    private Button jadeStart;

    private Button jadeStop;

    // fdf front
    private Group fdf;

    private Label fdfIpTitle;

    private Label fdfPortTitle;

    private Label fdfStatusTitle;

    private Text fdfIp;

    private Text fdfPort;

    private Label fdfStatus;

    private Button fdfStart;

    private Button fdfStop;

    // probe front
    private Group probe;

    private Label probeIpTitle;

    private Label probePortTitle;

    private Label probeStatusTitle;

    private Text probeIp;

    private Text probePort;

    private Label probeStatus;

    private Button probeStart;

    private Button probeStop;

    // rulelogs front
    private Group log;

    private Label logIpTitle;

    private Label logPortTitle;

    private Label logStatusTitle;

    private Text logIp;

    private Text logPort;

    private Label logStatus;

    private Button logStart;

    private Button logStop;

    // continue/cancel

    private Button jasmineContinue;

    private Button jasmineCancel;

    public static String SPLASH = "SPLASH";

    public static String RCP = "RCP";

    private String type = null;


    // t = splash : in a shell, to close JASMINe when you push cancel button
    // t = rcp : in a rcp shell
    public ConnectionManagerView(String t, Shell parent) {

    	super();
    	type = t;

    	Shell shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
        shell.setSize(400, 750);

        this.createContants(shell);
        this.createControler();
        this.refresh();

        shell.pack();
        shell.open();

        Display display = PlatformUI.getWorkbench().getDisplay();

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch())
                display.sleep();
        }
		while (!parent.isDisposed ()) {
			if (!display.readAndDispatch ()) display.sleep ();
		}
		display.dispose ();


    }

    public void createContants(Shell shell) {

        // create contants

        // jade front
        jade = new Group(shell, SWT.BORDER);
        jade.setText("Jade front");

        jadeStatusTitle = new Label(jade, SWT.NONE);
        jadeStatus = new Label(jade, SWT.BORDER);
        jadeEJBIpTitle = new Label(jade, SWT.NONE);
        jadeEJBPortTitle = new Label(jade, SWT.NONE);
        jadeJMXIpTitle = new Label(jade, SWT.NONE);
        jadeJMXPortTitle = new Label(jade, SWT.NONE);
        jadeRMIIpTitle = new Label(jade, SWT.NONE);
        jadeRMIPortTitle = new Label(jade, SWT.NONE);

        jadeStatusTitle.setText("Connection status");
        jadeStatus.setText("Ok");
        jadeEJBIpTitle.setText("EJB IP");
        jadeEJBPortTitle.setText("EJB Port");
        jadeJMXIpTitle.setText("JMX IP");
        jadeJMXPortTitle.setText("JMX Port");
        jadeRMIIpTitle.setText("RMI IP");
        jadeRMIPortTitle.setText("RMI Port");

        jadeEJBIp = new Text(jade, SWT.BORDER);
        jadeEJBPort = new Text(jade, SWT.BORDER);
        jadeJMXIp = new Text(jade, SWT.BORDER);
        jadeJMXPort = new Text(jade, SWT.BORDER);
        jadeRMIIp = new Text(jade, SWT.BORDER);
        jadeRMIPort = new Text(jade, SWT.BORDER);

        jadeStart = new Button(jade, SWT.PUSH);
        jadeStop = new Button(jade, SWT.PUSH);

        jadeStart.setText("Connection");
        jadeStop.setText("Deconnection");

        // fdf front
        fdf = new Group(shell, SWT.BORDER);
        fdf.setText("FDF front");

        fdfStatusTitle = new Label(fdf, SWT.NONE);
        fdfStatus = new Label(fdf, SWT.BORDER);
        fdfIpTitle = new Label(fdf, SWT.NONE);
        fdfPortTitle = new Label(fdf, SWT.NONE);

        fdfStatusTitle.setText("Connection status");
        fdfStatus.setText("Ok");
        fdfIpTitle.setText("EJB IP");
        fdfPortTitle.setText("EJB Port");

        fdfIp = new Text(fdf, SWT.BORDER);
        fdfPort = new Text(fdf, SWT.BORDER);

        fdfStart = new Button(fdf, SWT.PUSH);
        fdfStop = new Button(fdf, SWT.PUSH);

        fdfStart.setText("Connection");
        fdfStop.setText("Deconnection");

        fdfStart.setEnabled(false);
        fdfStop.setEnabled(false);

        // probe front
        probe = new Group(shell, SWT.BORDER);
        probe.setText("Probe front");

        probeStatusTitle = new Label(probe, SWT.NONE);
        probeStatus = new Label(probe, SWT.BORDER);
        probeIpTitle = new Label(probe, SWT.NONE);
        probePortTitle = new Label(probe, SWT.NONE);

        probeStatusTitle.setText("Connection status");
        probeStatus.setText("Ok");
        probeIpTitle.setText("IP");
        probePortTitle.setText("Port");

        probeIp = new Text(probe, SWT.BORDER);
        probePort = new Text(probe, SWT.BORDER);

        probeStart = new Button(probe, SWT.PUSH);
        probeStop = new Button(probe, SWT.PUSH);

        probeStart.setText("Connection");
        probeStop.setText("Deconnection");

        probeStart.setEnabled(false);
        probeStop.setEnabled(false);

        // log front
        log = new Group(shell, SWT.BORDER);
        log.setText("Rulelogs front");

        logStatusTitle = new Label(log, SWT.NONE);
        logStatus = new Label(log, SWT.BORDER);
        logIpTitle = new Label(log, SWT.NONE);
        logPortTitle = new Label(log, SWT.NONE);

        logStatusTitle.setText("Connection status");
        logStatus.setText("Ok");
        logIpTitle.setText("IP");
        logPortTitle.setText("Port");

        logIp = new Text(log, SWT.BORDER);
        logPort = new Text(log, SWT.BORDER);

        logStart = new Button(log, SWT.PUSH);
        logStop = new Button(log, SWT.PUSH);

        logStart.setText("Connection");
        logStop.setText("Deconnection");

        logStart.setEnabled(false);
        logStop.setEnabled(false);

        // start/cancel jasmine
        jasmineContinue = new Button(shell, SWT.PUSH);
        jasmineCancel = new Button(shell, SWT.PUSH);

        jasmineContinue.setText("Continue");
        jasmineCancel.setText("Cancel");

        FormLayout formLayout;

        formLayout = new FormLayout();
        formLayout.marginWidth = insetX;
        formLayout.marginHeight = insetY;
        shell.setLayout(formLayout);

        formLayout = new FormLayout();
        formLayout.marginWidth = insetX;
        formLayout.marginHeight = insetY;
        jade.setLayout(formLayout);

        formLayout = new FormLayout();
        formLayout.marginWidth = insetX;
        formLayout.marginHeight = insetY;
        fdf.setLayout(formLayout);

        formLayout = new FormLayout();
        formLayout.marginWidth = insetX;
        formLayout.marginHeight = insetY;
        probe.setLayout(formLayout);

        formLayout = new FormLayout();
        formLayout.marginWidth = insetX;
        formLayout.marginHeight = insetY;
        log.setLayout(formLayout);

        FormUtil.setFormLayout(jade, 0, 100, 0, null);
        FormUtil.setFormLayout(fdf, 0, 100, jade, null);
        FormUtil.setFormLayout(probe, 0, 100, fdf, null);
        FormUtil.setFormLayout(log, 0, 100, probe, null);

        FormUtil.setFormLayout(jadeStatusTitle, 0, null, 0, null);
        FormUtil.setFormLayout(jadeStatus, jadeStatusTitle, 100, 0, null);

        FormUtil.setFormLayout(jadeEJBIpTitle, 0, jadeStatus, jadeStatus, null);
        FormUtil.setFormLayout(jadeEJBIp, jadeStatusTitle, 100, jadeStatus, null);
        FormUtil.setFormLayout(jadeEJBPortTitle, 0, jadeStatus, jadeEJBIp, null);
        FormUtil.setFormLayout(jadeEJBPort, jadeEJBPortTitle, 100, jadeEJBIp, null);

        FormUtil.setFormLayout(jadeJMXIpTitle, 0, jadeStatus, jadeEJBPort, null);
        FormUtil.setFormLayout(jadeJMXIp, jadeJMXIpTitle, 100, jadeEJBPort, null);
        FormUtil.setFormLayout(jadeJMXPortTitle, 0, jadeStatus, jadeJMXIp, null);
        FormUtil.setFormLayout(jadeJMXPort, jadeJMXPortTitle, 100, jadeJMXIp, null);

        FormUtil.setFormLayout(jadeRMIIpTitle, 0, jadeStatus, jadeJMXPort, null);
        FormUtil.setFormLayout(jadeRMIIp, jadeJMXPortTitle, 100, jadeJMXPort, null);
        FormUtil.setFormLayout(jadeRMIPortTitle, 0, jadeStatus, jadeRMIIp, null);
        FormUtil.setFormLayout(jadeRMIPort, jadeRMIPortTitle, 100, jadeRMIIp, null);

        FormUtil.setFormLayout(jadeStart, 0, 50, jadeRMIPort, null);
        FormUtil.setFormLayout(jadeStop, 50, 100, jadeRMIPort, null);

        FormUtil.setFormLayout(fdfStatusTitle, 0, null, 0, null);
        FormUtil.setFormLayout(fdfStatus, fdfStatusTitle, 100, 0, null);

        FormUtil.setFormLayout(fdfIpTitle, 0, fdfStatus, fdfStatus, null);
        FormUtil.setFormLayout(fdfIp, fdfStatusTitle, 100, fdfStatus, null);
        FormUtil.setFormLayout(fdfPortTitle, 0, fdfStatus, fdfIp, null);
        FormUtil.setFormLayout(fdfPort, fdfPortTitle, 100, fdfIp, null);

//        FormUtil.setFormLayout(fdfJMXIpTitle, 0, fdfStatus, fdfPort, null);
//        FormUtil.setFormLayout(fdfJMXIp, fdfJMXIpTitle, 100, fdfPort, null);
//        FormUtil.setFormLayout(fdfJMXPortTitle, 0, fdfStatus, fdfJMXIp, null);
//        FormUtil.setFormLayout(fdfJMXPort, fdfJMXPortTitle, 100, fdfJMXIp, null);

        FormUtil.setFormLayout(fdfStart, 0, 50, fdfPort, null);
        FormUtil.setFormLayout(fdfStop, 50, 100, fdfPort, null);

        FormUtil.setFormLayout(probeStatusTitle, 0, null, 0, null);
        FormUtil.setFormLayout(probeStatus, probeStatusTitle, 100, 0, null);
        FormUtil.setFormLayout(probeIpTitle, 0, probeStatus, probeStatus, null);
        FormUtil.setFormLayout(probeIp, probeStatusTitle, 100, probeStatus, null);
        FormUtil.setFormLayout(probePortTitle, 0, probeStatus, probeIp, null);
        FormUtil.setFormLayout(probePort, probeStatusTitle, 100, probeIp, null);

        FormUtil.setFormLayout(probeStart, 0, 50, probePort, null);
        FormUtil.setFormLayout(probeStop, 50, 100, probePort, null);

        FormUtil.setFormLayout(logStatusTitle, 0, null, 0, null);
        FormUtil.setFormLayout(logStatus, logStatusTitle, 100, 0, null);
        FormUtil.setFormLayout(logIpTitle, 0, logStatus, logStatus, null);
        FormUtil.setFormLayout(logIp, logStatusTitle, 100, logStatus, null);
        FormUtil.setFormLayout(logPortTitle, 0, logStatus, logIp, null);
        FormUtil.setFormLayout(logPort, logStatusTitle, 100, logIp, null);

        FormUtil.setFormLayout(logStart, 0, 50, logPort, null);
        FormUtil.setFormLayout(logStop, 50, 100, logPort, null);

        FormUtil.setFormLayout(jasmineContinue, 0, 50, log, null);
        FormUtil.setFormLayout(jasmineCancel, 50, 100, log, null);
    }

    public void refresh() {
        jadeEJBIp.setText(ConnectionManager.getJadeFrontIp());
        jadeEJBPort.setText(ConnectionManager.getJadeFrontPort());
        jadeJMXIp.setText(ConnectionManager.getJadeJMXIp());
        jadeJMXPort.setText(ConnectionManager.getJadeJMXPort());
        jadeRMIIp.setText(ConnectionManager.getJadeRMIIp());
        jadeRMIPort.setText(ConnectionManager.getJadeRMIPort());
        jadeStatus.setText(ConnectionManager.getJadeFrontStatus());

        fdfIp.setText(ConnectionManager.getFDFFrontIp());
        fdfPort.setText(ConnectionManager.getFDFFrontPort());
        fdfStatus.setText(ConnectionManager.getFDFFrontStatus());

        probeIp.setText(ConnectionManager.getProbeFrontIp());
        probePort.setText(ConnectionManager.getProbeFrontPort());
        probeStatus.setText(ConnectionManager.getProbeFrontStatus());

        logIp.setText(ConnectionManager.getLogFrontIp());
        logPort.setText(ConnectionManager.getLogFrontPort());
        logStatus.setText(ConnectionManager.getLogFrontStatus());
    }

    public void refreshInteral() {
        jadeStatus.setText(ConnectionManager.getJadeFrontStatus());
        probeStatus.setText(ConnectionManager.getProbeFrontStatus());
        fdfStatus.setText(ConnectionManager.getFDFFrontStatus());
        logStatus.setText(ConnectionManager.getLogFrontStatus());
    }

    public void createControler() {

        // jade
        jadeEJBIp.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setJadeFrontIp(jadeEJBIp.getText());
            }
        });

        jadeEJBPort.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setJadeFrontPort(jadeEJBPort.getText());
            }
        });
        jadeJMXIp.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setJadeJMXIp(jadeJMXIp.getText());
            }
        });

        jadeJMXPort.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setJadeJMXPort(jadeJMXPort.getText());
            }
        });
        jadeRMIIp.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setJadeRMIIp(jadeRMIIp.getText());
            }
        });

        jadeRMIPort.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setJadeRMIPort(jadeRMIPort.getText());
            }
        });

        jadeStart.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("start jade");
                ConnectionManager.connectJade();
                refreshInteral();
            }
        });

        jadeStop.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("stop jade");
                ConnectionManager.disconnectJade();
                refreshInteral();
            }
        });

        // fdf

        fdfIp.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setFDFFrontIp(fdfIp.getText());
            }
        });

        fdfPort.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setFDFFrontPort(fdfPort.getText());
            }
        });

        fdfStart.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("start fdf");
                ConnectionManager.connectFDF();
                refreshInteral();
            }
        });

        fdfStop.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("stop fdf");
                ConnectionManager.disconnectFDF();
                refreshInteral();
            }
        });

        // probe

        probeIp.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setProbeFrontIp(probeIp.getText());
            }
        });

        probePort.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setProbeFrontPort(probePort.getText());
            }
        });

        probeStart.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("start probe");
                ConnectionManager.connectProbe();
                refreshInteral();
            }
        });

        probeStop.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("stop probe");
                ConnectionManager.disconnectProbe();
                refreshInteral();
            }
        });

        // log

        logIp.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setLogFrontIp(logIp.getText());
            }
        });

        logPort.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent e) {
                ConnectionManager.setLogFrontPort(logPort.getText());
            }
        });

        logStart.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("start log");
                ConnectionManager.connectLog();
                refreshInteral();
            }
        });

        logStop.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                System.out.println("stop probe");
                ConnectionManager.disconnectLog();
                refreshInteral();
            }
        });
        // continue/cancel

        jasmineContinue.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {

                boolean problem = false;

                if (ConnectionManager.getProbeFrontStatus() != ConnectionManager.CONNECTED) {
                    problem = true;
                }
                if (ConnectionManager.getFDFFrontStatus() != ConnectionManager.CONNECTED) {
                    problem = true;
                }
                if (ConnectionManager.getJadeFrontStatus() != ConnectionManager.CONNECTED) {
                    problem = true;
                }
                if (ConnectionManager.getLogFrontStatus() != ConnectionManager.CONNECTED) {
                    problem = true;
                }

//                if (problem) {
//                    MessageDialog.openWarning(jasmineContinue.getShell(),
//                            "Problem",
//                            "One or more connections aren't established");
//                }
                exit = false;
                // exit is used to not use close listener on disposed shell
//                jasmineContinue.getShell().dispose();
                jasmineContinue.getShell().close();
            }
        });

        jasmineCancel.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent event) {
                exit = false;
                jasmineContinue.getShell().dispose();
                if (type.equals(SPLASH)) {
                    System.exit(0);
                }
            }
        });

        jasmineCancel.getShell().addDisposeListener(new DisposeListener() {
            public void widgetDisposed(DisposeEvent e) {
                if (exit) {
                    if (type.equals(SPLASH)) {
                        System.exit(0);
                    }
                }
            }
        });

    }
}