/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.loginAdressPort;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.widgets.Control;

public class FormUtil {

    static int insetX = 2;

    static int insetY = 2;

    static int HEIGHT1 = 25;

    static int HEIGHT2 = 25;

    static int HEIGHT3 = 17;

    static public void setFormLayout(Control c, Object left, Object right,
            Object top, Object bottom) {
        FormData tmpLayout = new FormData();

        // left
        if (left != null) {
            if (left instanceof Integer) {
                tmpLayout.left = new FormAttachment(
                        ((Integer) left).intValue(), insetX);
            } else {
                tmpLayout.left = new FormAttachment((Control) left, insetX);
            }
        } else {
            tmpLayout.width = SWT.DEFAULT;
        }

        // right
        if (right != null) {
            if (right instanceof Integer) {
                tmpLayout.right = new FormAttachment(((Integer) right)
                        .intValue(), -insetX);
            } else {
                tmpLayout.right = new FormAttachment((Control) right, -insetX);
            }
        } else {
            tmpLayout.width = SWT.DEFAULT;
        }

        // top
        if (top != null) {
            if (top instanceof Integer) {
                tmpLayout.top = new FormAttachment(((Integer) top).intValue(),
                        insetY);
            } else {
                tmpLayout.top = new FormAttachment((Control) top, insetY);
            }
        } else {
            tmpLayout.height = SWT.DEFAULT;
        }

        if (bottom != null) {
            if (bottom instanceof Integer) {
                tmpLayout.bottom = new FormAttachment(((Integer) bottom)
                        .intValue(), -insetY);
            } else {
                tmpLayout.bottom = new FormAttachment((Control) bottom, -insetY);
            }
        } else {
            tmpLayout.height = SWT.DEFAULT;
        }

        c.setLayoutData(tmpLayout);
    }

    static public void setFormLayout(Control c, Object left, Object right,
            Object top, Object bottom, int height) {
        FormData tmpLayout = new FormData();

        // left
        if (left != null) {
            if (left instanceof Integer) {
                tmpLayout.left = new FormAttachment(
                        ((Integer) left).intValue(), insetX);
            } else {
                tmpLayout.left = new FormAttachment((Control) left, insetX);
            }
        } else {
            tmpLayout.width = SWT.DEFAULT;
        }

        // right
        if (right != null) {
            if (right instanceof Integer) {
                tmpLayout.right = new FormAttachment(((Integer) right)
                        .intValue(), -insetX);
            } else {
                tmpLayout.right = new FormAttachment((Control) right, -insetX);
            }
        } else {
            tmpLayout.width = SWT.DEFAULT;
        }

        // top
        if (top != null) {
            if (top instanceof Integer) {
                tmpLayout.top = new FormAttachment(((Integer) top).intValue(),
                        insetY);
            } else {
                tmpLayout.top = new FormAttachment((Control) top, insetY);
            }
        } else {
            tmpLayout.height = height;
        }

        if (bottom != null) {
            if (bottom instanceof Integer) {
                tmpLayout.bottom = new FormAttachment(((Integer) bottom)
                        .intValue(), -insetY);
            } else {
                tmpLayout.bottom = new FormAttachment((Control) bottom, -insetY);
            }
        } else {
            tmpLayout.height = height;
        }

        c.setLayoutData(tmpLayout);
    }
}
