package org.objectweb.jasmine.ui.logs;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.objectweb.jasmine.rules.utils.DBException;

public class ComLogListener {
	private ComLog parent;
	private MessageConsumer consumer;
	private Connection connection;
	
	class RefreshRun implements Runnable {
		int id;
		public RefreshRun(int id) { this.id = id; }
        public void run() {
            try { parent.refreshNewLogRules(id); }
            catch (DBException e) { e.printStackTrace(); }
        }
	}
	
	

	public ComLogListener(ComLog parent) {
		super();
		this.parent = parent;
	}



	public void startListening() {
	    try {
			Context context = new InitialContext();

			ConnectionFactory connectionFactory = (ConnectionFactory) context.lookup("JCF");
			Destination destination = (Destination) context.lookup("JASMINeAlarmsTopic");
			connection = connectionFactory.createConnection();
			Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);

			consumer = session.createConsumer(destination);
			consumer.setMessageListener(new MessageListener() {

				public void onMessage (Message message) {

                	try {
						int id = Integer.parseInt(((TextMessage) message).getText());
						
						if (parent.getDisplay() != null)
			            	parent.getDisplay().syncExec(new RefreshRun(id));

					} catch (NumberFormatException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (JMSException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			});
			connection.start();
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			System.out.println("Oula oula");
			e.printStackTrace();
		} catch (JMSException e) {
			// TODO Auto-generated catch block
			System.out.println("Oula oula oula");
			e.printStackTrace();
		}
	}
	
	public void stopListening() {
		try {
			consumer.close();
			connection.stop();
		} catch (JMSException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
