/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.logs;

import org.objectweb.jasmine.rules.utils.DBException;

public class ComLogThread extends Thread {

    private boolean actif = true;

    private ComLog comLog;

    private int timing = 1000;

    public ComLogThread(ComLog comLog) {
        super();
        this.comLog = comLog;
    }

    public void run() {
        while (actif) {

            // it s a mandatory to synchronise SWT threads
            if (comLog.getDisplay() != null) {
                comLog.getDisplay().syncExec(new Runnable() {
                    public void run() {
                        try {
                            comLog.refreshLogRulesDiff();
                        } catch (DBException e) {
                            e.printStackTrace();
                        }
                    }
                });
            }

            try {
                sleep(timing);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    public void stopIt() {
        actif = false;
    }

    public int getTiming() {
        return timing;
    }

    public void setTiming(int timing) {
        this.timing = timing;
    }

}