/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.logs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.objectweb.jasmine.ui.loginAdressPort.ConnectionManager;

public class Test {

    private Display display;

    private Shell shell;

    /**
     * @param args
     */
    public static void main(String[] args) {
        new Test().exec();
    }

    public void exec() {
        ComLog cl = new ComLog();

        GuiRuleLogManager manager = new GuiRuleLogManager(cl);
        GuiRuleLogView view = new GuiRuleLogView(manager);
        GuiRuleLogControler controler = new GuiRuleLogControler(manager, view);
        manager.addObs(view);
        manager.addObs(controler);

        cl.setManager(manager);

        open();
        cl.setDisplay(display);
        Composite c = new Composite(shell, SWT.NONE);
        view.createContent(c);
        view.refresh();
        controler.addListeners();

        ConnectionManager.setLogFrontIp("129.183.91.53");
        ConnectionManager.setLogFrontPort("1099");
        ConnectionManager.connectLog();
        cl.init();
        open2();

    }

    public void open() {
        display = new Display();
        shell = new Shell(display);
        shell.setLayout(new FillLayout());

        /*
         * Composite c = new Composite(shell, SWT.NONE); createContent(c);
         * refresh();
         */

    }

    public void open2() {
        shell.open();

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
        display.dispose();
    }

}
