/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.monitoring.CommunicationAndParsing;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ActiveProbes {

    /*
     * private class ActiveProbes_Machine{ public String ip; public List<ActiveProbes_Probe>
     * probes;
     * 
     * public ActiveProbes_Machine(){ probes = new ArrayList<ActiveProbes_Probe>(); } }
     * 
     * private class ActiveProbes_Probe{ public String type; public Probe probe;
     * public Datas data; }
     */

    private static Map<String, ActiveProbes_Machine> machinesIP = new HashMap<String, ActiveProbes_Machine>();

    private static ActiveProbes_Probe lastProbe;

    public static void addProbe(String ip, String type) {
        ActiveProbes_Machine apm = null;

        if (!machinesIP.containsKey(ip)) {
            apm = new ActiveProbes_Machine();
            apm.ip = ip;
            machinesIP.put(ip, apm);
        } else {
            apm = machinesIP.get(ip);
        }

        ActiveProbes_Probe app = new ActiveProbes_Probe();
        app.type = type;
        app.ip = ip;
        lastProbe = app;
        apm.probes.add(app);

    }

    public static boolean thisMachineHaveAProbe(String ip, String hostName) {
        return machinesIP.containsKey(hostName) || machinesIP.containsKey(ip);
    }

    public static boolean thisMachineHaveAProbe2(String ip, String hostName,
            String type) {
        if (machinesIP.containsKey(ip)) {
            ActiveProbes_Machine apm = machinesIP.get(ip);
            for (ActiveProbes_Probe app : apm.probes) {
                if (app.type.equals(type)) {
                    return true;
                }
            }
        } else if (machinesIP.containsKey(hostName)) {
            ActiveProbes_Machine apm = machinesIP.get(hostName);
            for (ActiveProbes_Probe app : apm.probes) {
                if (app.type.equals(type)) {
                    return true;
                }
            }
        }
        return false;
    }

    public static List<ActiveProbes_Probe> MachineProbes(String ip,
            String hostName, String type) {
        List<ActiveProbes_Probe> tmp = new ArrayList<ActiveProbes_Probe>();
        ActiveProbes_Machine apm = null;
        if (machinesIP.containsKey(ip)) {
            apm = machinesIP.get(ip);
        } else {
            if (machinesIP.containsKey(hostName)) {
                apm = machinesIP.get(hostName);
            } else {
                return tmp;
            }
        }

        for (ActiveProbes_Probe app : apm.probes) {
            if (app.type.equals(type)) {
                tmp.add(app);
            }
        }
        return tmp;
    }

    public static ActiveProbes_Probe getLastProbe() {
        return lastProbe;
    }

    public void delProbe() {
        System.out.println("delProbe : TODO !!");
    }

}
