/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.monitoring.CommunicationAndParsing;

public class CpuProbe extends AbstractProbe {

    /**
     * 
     */
    private static final long serialVersionUID = -6733694306088444114L;

    private float totalCpu;

    private float newCpu;

    private float systemCpu;

    private float ioWaitCpu;

    private float userCpu;

    private float idleCpu;

    private float niceCpu;

    public CpuProbe() {
        super();
    }

    public CpuProbe(String timestamp, String hostname, String ip,
            float totalCpu, float newCpu, float systemCpu, float ioWaitCpu,
            float userCpu, float idleCpu, float niceCpu) {

        super(timestamp, hostname, ip);

        this.totalCpu = totalCpu;
        this.newCpu = newCpu;
        this.systemCpu = systemCpu;
        this.ioWaitCpu = ioWaitCpu;
        this.userCpu = userCpu;
        this.idleCpu = idleCpu;
        this.niceCpu = niceCpu;
    }

    public float getIdleCpu() {
        return idleCpu;
    }

    public void setIdleCpu(float idleCpu) {
        this.idleCpu = idleCpu;
    }

    public float getIoWaitCpu() {
        return ioWaitCpu;
    }

    public void setIoWaitCpu(float ioWaitCpu) {
        this.ioWaitCpu = ioWaitCpu;
    }

    public float getNewCpu() {
        return newCpu;
    }

    public void setNewCpu(float newCpu) {
        this.newCpu = newCpu;
    }

    public float getNiceCpu() {
        return niceCpu;
    }

    public void setNiceCpu(float niceCpu) {
        this.niceCpu = niceCpu;
    }

    public float getSystemCpu() {
        return systemCpu;
    }

    public void setSystemCpu(float systemCpu) {
        this.systemCpu = systemCpu;
    }

    public float getTotalCpu() {
        return totalCpu;
    }

    public void setTotalCpu(float totalCpu) {
        this.totalCpu = totalCpu;
    }

    public float getUserCpu() {
        return userCpu;
    }

    public void setUserCpu(float userCpu) {
        this.userCpu = userCpu;
    }

    public String toString() {
        return new String("CpuProbe[" + getTimestamp() + ", " + getHostname()
                + "] = " + getIdleCpu());
    }

}
/*
 * <probe timestamp="1154606362850" hostname="frecb000707.frec.bull.fr"
 * ip="129.183.91.53"> <name>cpu</name> <method> <name>getData</name> <value>
 * <ProcStats> <Total>7.92</Total> <New>0</New> <System>0.99</System>
 * <IOWait>0</IOWait> <User>6.93</User> <Idle>92.08</Idle> <Nice>0</Nice>
 * </ProcStats> </value> </method> </probe>
 */