/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.monitoring.CommunicationAndParsing;

import javax.jms.MessageConsumer;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class JMSConnection {

    private static Context ictx = null;

    private static TopicConnectionFactory cf = null;

    private static Topic topic = null;

    // JNDI name of the connection factory
    private static String conFactName = "JTCF";

    // JNDI name of the Topic
    private static String topicName = "sampleTopic";

    public static void main(String[] arg) {
        try {
            connectionWithProbeFront("rmi://fidji.dc.frec.bull.fr:1099");
            connectionWithJMSQueue();
        } catch (NamingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public static void connectionWithProbeFront(String url)
            throws NamingException, Exception {
        System.setProperty(Context.INITIAL_CONTEXT_FACTORY,
                "org.objectweb.carol.jndi.spi.MultiOrbInitialContextFactory");
        System.setProperty(Context.PROVIDER_URL, url);

        // Get InitialContext
        ictx = new InitialContext();

        // lookup the TopicConnectionFactory through its JNDI name
        cf = (TopicConnectionFactory) ictx.lookup(conFactName);

        // lookup the Topic through its JNDI name
        topic = (Topic) ictx.lookup(topicName);

    }

    public static void connectionWithJMSQueue() throws Exception {
        try {

            // Connection tc = cf.createConnection("root","root");
            TopicConnection tc = cf.createTopicConnection("root", "root");
            TopicSession session = tc.createTopicSession(false,
                    TopicSession.CLIENT_ACKNOWLEDGE);
            MessageConsumer mc = session.createSubscriber(topic);
            /* create and set a MessageListener */
            ListenerJMS listener = new ListenerJMS();
            mc.setMessageListener(listener);

            tc.start();
            // System.in.read();

            // session.close();
            // tc.close();

        } catch (Exception e) {
            System.out.println("Exception in message reception operations");
            e.printStackTrace();
        }
    }
}
