/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.monitoring.CommunicationAndParsing;

public class MemoryProbe extends AbstractProbe {

    /**
     * 
     */
    private static final long serialVersionUID = -4740453086162298727L;

    private long cachedMemory;

    private long swapUsedMemory;

    private long memTotalMemory;

    private float swapUsedPerMemory;

    private long buffersMemory;

    private long memUsedMemory;

    private long swapTotalMemory;

    private long memFreeMemory;

    private long swapFreeMemory;

    private float memUsedPerMemory;

    public MemoryProbe() {
        super();
    }

    public MemoryProbe(String timestamp, String hostname, String ip,
            long cachedMemory, long swapUsedMemory, long memTotalMemory,
            float swapUsedPerMemory, long buffersMemory, long memUsedMemory,
            long swapTotalMemory, long memFreeMemory, long swapFreeMemory,
            float memUsedPerMemory) {
        super(timestamp, hostname, ip);
        this.cachedMemory = cachedMemory;
        this.swapUsedMemory = swapUsedMemory;
        this.memTotalMemory = memTotalMemory;
        this.swapUsedPerMemory = swapUsedPerMemory;
        this.buffersMemory = buffersMemory;
        this.memUsedMemory = memUsedMemory;
        this.swapTotalMemory = swapTotalMemory;
        this.memFreeMemory = memFreeMemory;
        this.swapFreeMemory = swapFreeMemory;
        this.memUsedPerMemory = memUsedPerMemory;
    }

    public long getBuffersMemory() {
        return buffersMemory;
    }

    public void setBuffersMemory(long buffersMemory) {
        this.buffersMemory = buffersMemory;
    }

    public long getCachedMemory() {
        return cachedMemory;
    }

    public void setCachedMemory(long cachedMemory) {
        this.cachedMemory = cachedMemory;
    }

    public long getMemFreeMemory() {
        return memFreeMemory;
    }

    public void setMemFreeMemory(long memFreeMemory) {
        this.memFreeMemory = memFreeMemory;
    }

    public long getMemTotalMemory() {
        return memTotalMemory;
    }

    public void setMemTotalMemory(long memTotalMemory) {
        this.memTotalMemory = memTotalMemory;
    }

    public long getMemUsedMemory() {
        return memUsedMemory;
    }

    public void setMemUsedMemory(long memUsedMemory) {
        this.memUsedMemory = memUsedMemory;
    }

    public float getMemUsedPerMemory() {
        return memUsedPerMemory;
    }

    public void setMemUsedPerMemory(float memUsedPerMemory) {
        this.memUsedPerMemory = memUsedPerMemory;
    }

    public long getSwapFreeMemory() {
        return swapFreeMemory;
    }

    public void setSwapFreeMemory(long swapFreeMemory) {
        this.swapFreeMemory = swapFreeMemory;
    }

    public long getSwapTotalMemory() {
        return swapTotalMemory;
    }

    public void setSwapTotalMemory(long swapTotalMemory) {
        this.swapTotalMemory = swapTotalMemory;
    }

    public long getSwapUsedMemory() {
        return swapUsedMemory;
    }

    public void setSwapUsedMemory(long swapUsedMemory) {
        this.swapUsedMemory = swapUsedMemory;
    }

    public float getSwapUsedPerMemory() {
        return swapUsedPerMemory;
    }

    public void setSwapUsedPerMemory(float swapUsedPerMemory) {
        this.swapUsedPerMemory = swapUsedPerMemory;
    }

    public String toString() {
        return new String("MemoryProbe[" + getTimestamp() + ", "
                + getHostname() + "] = " + getMemUsedPerMemory());
    }
}

/*
 * <probe timestamp="1156171423767" hostname="frecb000707.frec.bull.fr"
 * ip="129.183.91.53"> <name>memory</name> <method> <name>getData</name>
 * <value> <MemStats> <Cached>110176</Cached> <SwapUsed>370800</SwapUsed>
 * <MemTotal>516608</MemTotal> <SwapUsedPer>40.14</SwapUsedPer> <Buffers>2792</Buffers>
 * <MemUsed>489920</MemUsed> <SwapTotal>923696</SwapTotal> <MemFree>26688</MemFree>
 * <SwapFree>552896</SwapFree> <MemUsedPer>94.83</MemUsedPer> </MemStats>
 * </value> </method> </probe>
 */