/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.monitoring;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class GenericDatas implements Datas {

    public interface Data {

    }

    public class Value implements Data {
        public String name;

        public Object value;

        public Value(String name, Object value) {
            super();
            this.name = name;
            this.value = value;
        }
    }

    public class Category implements Data {
        public String name;

        public List<Data> info = new ArrayList<Data>();

        public Category(String name) {
            super();
            this.name = name;
        }
    }

    private String name;

    private List<Data> info = new ArrayList<Data>();

    private Probe genericProbe;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
        genericProbe.refresh();
    }

    public void addValue(String name, Object obj, String cat) {
        if (cat == null) {
            info.add(new Value(name, obj));
        } else {
            Category tmp = existCategory(cat);
            if (null == tmp) {
                tmp = new Category(cat);
                tmp.info.add(new Value(name, obj));
                info.add(tmp);
            } else {
                tmp.info.add(new Value(name, obj));
            }
        }
        genericProbe.refresh();
    }

    public Category existCategory(String name) {
        Category c = null;
        Iterator<Data> it = info.iterator();
        while (it.hasNext()) {
            Data d = it.next();
            if (d instanceof Category) {
                Category c2 = (Category) d;
                if (c2.name.equals(name)) {
                    c = c2;
                }
            }
        }
        return c;
    }

    public List<Data> getInfo() {
        return info;
    }

    public void XMLtoPDO() {

    }

    public void setProbe(Probe genericProbe) {
        this.genericProbe = genericProbe;
    }

    public void addProbe(Probe probe) {
        // TODO Auto-generated method stub

    }

}
