/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.rules;

import java.util.List;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.objectweb.jasmine.rules.rules.RulesInterfaceRemote;

public class ComRules {

    private static RulesInterfaceRemote rulesRemote = null;

    public static void connection(String url) throws NamingException, Exception {
        try {
            System.setProperty(Context.INITIAL_CONTEXT_FACTORY,
                    "org.objectweb.carol.jndi.spi.JRMPContextWrapperFactory");
            System.setProperty(Context.PROVIDER_URL, url);
            Context initialContext = new InitialContext();
            rulesRemote = (RulesInterfaceRemote) initialContext
                    .lookup("org.objectweb.jasmine.rules.rules.RulesInterface_org.objectweb.jasmine.rules.rules.RulesInterfaceRemote@Remote");
        } catch (Exception e) {
            System.out.println("can't initialize EJB connexion : ");
            e.printStackTrace();
            throw e;
        }
    }

    public List<String> getFileUsed() {
        return rulesRemote.fileUsed();
    }

    public void save(byte[] bytes, String type, String fileName)
            throws Exception {
        rulesRemote.save(bytes, type, fileName);
    }
}
