/**
 * JASMINe
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.rules;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;

public class Converter {
    public static byte[] convertFileToByte(File file) throws IOException {

        InputStream in = new FileInputStream(file);
        byte[] bytes = new byte[(int) file.length()];

        int offset = 0;
        int numRead = 0;

        while (offset < bytes.length
                && (numRead = in.read(bytes, offset, bytes.length - offset)) >= 0) {
            offset += numRead;
        }

        return bytes;
    }

    public static String readFile(File file) throws IOException {
        String fileContent = "";
        BufferedReader buffer = null;
        String ligne;

        buffer = new BufferedReader(new FileReader(file));

        while ((ligne = buffer.readLine()) != null) {
            fileContent = fileContent + ligne + "\n";
        }
        buffer.close();

        return fileContent;
    }

    public static void writeFile(File file, String content) throws IOException {
        PrintWriter writer;

        writer = new PrintWriter(new BufferedWriter(new FileWriter(file)));
        writer.write(content);
        writer.close();
    }
}
