/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.ow2.jasmine.model.domain;

import java.io.Reader;

import org.objectweb.jonas_domain.lib.DomainMapManager;


public class DomainParsing  {

    /**
     * Returns the XML document as a String.
     *
     * @param reader Reader of an domain.xml file
     * @param name not used
     * @param validation true/false
     *
     * @return Returns the XML document as a String.
     *
     * @throws Exception when parsing fails
     */
    public String parse(Reader reader, String name, boolean validation) throws Exception {
        DomainMapManager.setParsingWithValidation(validation);
        String xmlParsed = DomainMapManager.loadDomain(reader, "test").toXML();
        return xmlParsed;
    }
}
