/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.ow2.jasmine.model.domain;

import java.io.File;
import java.util.Collection;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.jface.dialogs.MessageDialog;
import org.objectweb.jonas_domain.api.DomainMap;
import org.objectweb.jonas_domain.api.DomainMapException;
import org.objectweb.jonas_domain.lib.DomainMapManager;
import org.ow2.jasmine.model.discovery.JasmineDiscoveryPlugin;
import org.ow2.jasmine.model.discovery.Messages;
import org.xml.sax.SAXException;

public class XMLDomainManager {

	static DomainMap domainMap = null;
	static ClassLoader classLoader;
	static DomainMapManager domainManager;

	public static DomainMap parse(File file) {
		try {
			domainMap = DomainMapManager.getDomainMap(file.getPath(), classLoader);
		} catch (DomainMapException e) {

			IStatus status = new Status(IStatus.ERROR, JasmineDiscoveryPlugin.PLUGIN_ID, IStatus.OK, e.getCause().toString(), e);
			ErrorDialog.openError(null, Messages.JasmineDiscoveryCreationError, Messages.JasmineDiscoveryCreationError, status );
			JasmineDiscoveryPlugin.getDefault().logError(
					"Error during parsing "+e.getMessage()); //$NON-NLS-1$
		}
		return domainMap;
	}


	/**
	 * @return Returns the clusters.
	 */
	public static Collection getClusters() {
		return domainMap.getClusters();
	}

	/**
	 * @return Returns the servers.
	 */
	public static Collection getServers() {
		return domainMap.getServers();
	}

	/**
	 * @return Returns the clusterDaemons.
	 */
	public static Collection getClusterDaemons() {
		return domainMap.getClusterDaemons();
	}
}