/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * This is the item provider adapter for a {@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties} object.
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * @generated
 */
public class ApacheMiddlewarePropertiesItemProvider extends ItemProviderAdapter
        implements IEditingDomainItemProvider, IStructuredItemContentProvider,
        ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public ApacheMiddlewarePropertiesItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addPropertyFilePropertyDescriptor(object);
			addDescriptionPropertyDescriptor(object);
			addInstance_apache_homePropertyDescriptor(object);
			addServer_listen_adressPropertyDescriptor(object);
			addServer_listen_portPropertyDescriptor(object);
			addServer_userPropertyDescriptor(object);
			addServer_groupPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

    /**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_IMiddlewareProperties_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_IMiddlewareProperties_name_feature", "_UI_IMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.IMIDDLEWARE_PROPERTIES__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Property File feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addPropertyFilePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_IMiddlewareProperties_propertyFile_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_IMiddlewareProperties_propertyFile_feature", "_UI_IMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.IMIDDLEWARE_PROPERTIES__PROPERTY_FILE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Description feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addDescriptionPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_IMiddlewareProperties_description_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_IMiddlewareProperties_description_feature", "_UI_IMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.IMIDDLEWARE_PROPERTIES__DESCRIPTION,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Instance apache home feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addInstance_apache_homePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ApacheMiddlewareProperties_instance_apache_home_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ApacheMiddlewareProperties_instance_apache_home_feature", "_UI_ApacheMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Server listen adress feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addServer_listen_adressPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ApacheMiddlewareProperties_server_listen_adress_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ApacheMiddlewareProperties_server_listen_adress_feature", "_UI_ApacheMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Server listen port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addServer_listen_portPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ApacheMiddlewareProperties_server_listen_port_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ApacheMiddlewareProperties_server_listen_port_feature", "_UI_ApacheMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Server user feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addServer_userPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ApacheMiddlewareProperties_server_user_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ApacheMiddlewareProperties_server_user_feature", "_UI_ApacheMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Server group feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addServer_groupPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ApacheMiddlewareProperties_server_group_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ApacheMiddlewareProperties_server_group_feature", "_UI_ApacheMiddlewareProperties_type"),
				 JasminemodelPackage.Literals.APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This returns ApacheMiddlewareProperties.gif.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    @Override
    public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ApacheMiddlewareProperties"));
	}

    /**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String getText(Object object) {
		String label = ((ApacheMiddlewareProperties)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_ApacheMiddlewareProperties_type") :
			getString("_UI_ApacheMiddlewareProperties_type") + " " + label;
	}

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    @Override
    public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ApacheMiddlewareProperties.class)) {
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__NAME:
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__PROPERTY_FILE:
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__DESCRIPTION:
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME:
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS:
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT:
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER:
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
     * describing the children that can be created under this object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(
            Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

    /**
     * Return the resource locator for this item provider's resources. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
		return JasmineEditPlugin.INSTANCE;
	}

}
