/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * This is the item provider adapter for a
 * {@link org.objectweb.jasmine.ui.jasminemodel.Domain} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 *
 * @generated
 */
public class DomainItemProvider extends ItemProviderAdapter implements
        IEditingDomainItemProvider, IStructuredItemContentProvider,
        ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public DomainItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

    /**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(
            Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(JasminemodelPackage.Literals.DOMAIN__MIDDLEWARE_COMPONENTS);
			childrenFeatures.add(JasminemodelPackage.Literals.DOMAIN__CONNECTORS);
			childrenFeatures.add(JasminemodelPackage.Literals.DOMAIN__CONFIGURATION_NODES);
			childrenFeatures.add(JasminemodelPackage.Literals.DOMAIN__CLUSTER_CONTAINERS);
			childrenFeatures.add(JasminemodelPackage.Literals.DOMAIN__DB);
			childrenFeatures.add(JasminemodelPackage.Literals.DOMAIN__DBLINKS);
		}
		return childrenFeatures;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

    /**
	 * This returns Domain.gif.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Domain"));
	}

    /**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String getText(Object object) {
		return getString("_UI_Domain_type");
	}

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    @Override
    public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Domain.class)) {
			case JasminemodelPackage.DOMAIN__MIDDLEWARE_COMPONENTS:
			case JasminemodelPackage.DOMAIN__CONNECTORS:
			case JasminemodelPackage.DOMAIN__CONFIGURATION_NODES:
			case JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS:
			case JasminemodelPackage.DOMAIN__DB:
			case JasminemodelPackage.DOMAIN__DBLINKS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
     * describing the children that can be created under this object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(
            Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__MIDDLEWARE_COMPONENTS,
				 JasminemodelFactory.eINSTANCE.createMiddlewareComponent()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__MIDDLEWARE_COMPONENTS,
				 JasminemodelFactory.eINSTANCE.createJOnAS()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__MIDDLEWARE_COMPONENTS,
				 JasminemodelFactory.eINSTANCE.createApache_HTTPd()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__MIDDLEWARE_COMPONENTS,
				 JasminemodelFactory.eINSTANCE.createJBossAS()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createRepHTTPConnector()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createHAConnector()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createDbLink()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createRmiConnector()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createIJBossConnector()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createJBossHAConnector()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createJBossHTTPRepConnector()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONNECTORS,
				 JasminemodelFactory.eINSTANCE.createJBossModJKConnector()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONFIGURATION_NODES,
				 JasminemodelFactory.eINSTANCE.createCmiGroup()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONFIGURATION_NODES,
				 JasminemodelFactory.eINSTANCE.createHaGroup()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONFIGURATION_NODES,
				 JasminemodelFactory.eINSTANCE.createHTTP_RepGroup()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONFIGURATION_NODES,
				 JasminemodelFactory.eINSTANCE.createRMIGroup()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CONFIGURATION_NODES,
				 JasminemodelFactory.eINSTANCE.createJBossHAGroup()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__CLUSTER_CONTAINERS,
				 JasminemodelFactory.eINSTANCE.createClusterContainer()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__DB,
				 JasminemodelFactory.eINSTANCE.createDB()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.DOMAIN__DBLINKS,
				 JasminemodelFactory.eINSTANCE.createDbLink()));
	}

    /**
     * This returns the label text for
     * {@link org.eclipse.emf.edit.command.CreateChildCommand}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public String getCreateChildText(Object owner, Object feature,
            Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == JasminemodelPackage.Literals.DOMAIN__CONNECTORS ||
			childFeature == JasminemodelPackage.Literals.DOMAIN__DBLINKS;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

    /**
     * Return the resource locator for this item provider's resources. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
		return JasmineEditPlugin.INSTANCE;
	}

}
