/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * This is the item provider adapter for a
 * {@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 *
 * @generated
 */
public class JASMINeNodeItemProvider extends ItemProviderAdapter implements
        IEditingDomainItemProvider, IStructuredItemContentProvider,
        ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public JASMINeNodeItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addHostPropertyDescriptor(object);
			addUserPropertyDescriptor(object);
			addPasswordPropertyDescriptor(object);
			addSshKeyPropertyDescriptor(object);
			addInstallDirPropertyDescriptor(object);
			addNodeIdPropertyDescriptor(object);
			addRegistryHostPropertyDescriptor(object);
			addRegistryPortPropertyDescriptor(object);
			addDiscoveryHostPropertyDescriptor(object);
			addDiscoveryPortPropertyDescriptor(object);
			addJndiPortPropertyDescriptor(object);
			addFelixProfilePropertyDescriptor(object);
			addRepositoryURLPropertyDescriptor(object);
			addMiddlewaresPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

    /**
     * This adds a property descriptor for the Discovery Host feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addDiscoveryHostPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_discoveryHost_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_discoveryHost_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__DISCOVERY_HOST,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Discovery Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addDiscoveryPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_discoveryPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_discoveryPort_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__DISCOVERY_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Host feature.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addHostPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_host_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_host_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__HOST,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the User feature.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addUserPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_user_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_user_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__USER,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Password feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addPasswordPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_password_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_password_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__PASSWORD,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Ssh Key feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addSshKeyPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_sshKey_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_sshKey_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__SSH_KEY,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Install Dir feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addInstallDirPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_installDir_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_installDir_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__INSTALL_DIR,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Jndi Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addJndiPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_jndiPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_jndiPort_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__JNDI_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Node Id feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addNodeIdPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_nodeId_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_nodeId_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__NODE_ID,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Felix Profile feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addFelixProfilePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_felixProfile_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_felixProfile_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__FELIX_PROFILE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Registry Host feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addRegistryHostPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_registryHost_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_registryHost_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__REGISTRY_HOST,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Registry Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addRegistryPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_registryPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_registryPort_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__REGISTRY_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Repository URL feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addRepositoryURLPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_repositoryURL_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_repositoryURL_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__REPOSITORY_URL,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Middlewares feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addMiddlewaresPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_middlewares_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_middlewares_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__MIDDLEWARES,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JASMINeNode_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JASMINeNode_name_feature", "_UI_JASMINeNode_type"),
				 JasminemodelPackage.Literals.JASMI_NE_NODE__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This returns JASMINeNode.gif. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     *
     * @generated
     */
    @Override
    public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/JASMINeNode"));
	}

    /**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String getText(Object object) {
		String label = ((JASMINeNode)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_JASMINeNode_type") :
			getString("_UI_JASMINeNode_type") + " " + label;
	}

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    @Override
    public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(JASMINeNode.class)) {
			case JasminemodelPackage.JASMI_NE_NODE__NAME:
			case JasminemodelPackage.JASMI_NE_NODE__HOST:
			case JasminemodelPackage.JASMI_NE_NODE__USER:
			case JasminemodelPackage.JASMI_NE_NODE__PASSWORD:
			case JasminemodelPackage.JASMI_NE_NODE__SSH_KEY:
			case JasminemodelPackage.JASMI_NE_NODE__INSTALL_DIR:
			case JasminemodelPackage.JASMI_NE_NODE__NODE_ID:
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_HOST:
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_PORT:
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_HOST:
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_PORT:
			case JasminemodelPackage.JASMI_NE_NODE__JNDI_PORT:
			case JasminemodelPackage.JASMI_NE_NODE__FELIX_PROFILE:
			case JasminemodelPackage.JASMI_NE_NODE__REPOSITORY_URL:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
     * describing the children that can be created under this object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(
            Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

    /**
     * Return the resource locator for this item provider's resources. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
		return JasmineEditPlugin.INSTANCE;
	}

}
