/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.objectweb.jasmine.ui.jasminemodel.JBossAS;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * This is the item provider adapter for a
 * {@link org.objectweb.jasmine.ui.jasminemodel.JBossAS} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 *
 * @generated
 */
public class JBossASItemProvider extends MiddlewareComponentItemProvider
        implements IEditingDomainItemProvider, IStructuredItemContentProvider,
        ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public JBossASItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addHttpServersPropertyDescriptor(object);
			addHomePropertyDescriptor(object);
			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

    /**
	 * This adds a property descriptor for the Http Servers feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addHttpServersPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_IJavaEEServer_httpServers_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_IJavaEEServer_httpServers_feature", "_UI_IJavaEEServer_type"),
				 JasminemodelPackage.Literals.IJAVA_EE_SERVER__HTTP_SERVERS,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

				/**
	 * This adds a property descriptor for the Home feature.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addHomePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossAS_home_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossAS_home_feature", "_UI_JBossAS_type"),
				 JasminemodelPackage.Literals.JBOSS_AS__HOME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossAS_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossAS_name_feature", "_UI_JBossAS_type"),
				 JasminemodelPackage.Literals.JBOSS_AS__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(
            Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(JasminemodelPackage.Literals.IJAVA_EE_SERVER__WEB_CONTAINERS);
			childrenFeatures.add(JasminemodelPackage.Literals.IJAVA_EE_SERVER__RMI_REGISTRIES);
			childrenFeatures.add(JasminemodelPackage.Literals.IJAVA_EE_SERVER__EJB_CONTAINERS);
			childrenFeatures.add(JasminemodelPackage.Literals.IJAVA_EE_SERVER__APPLICATIONS);
			childrenFeatures.add(JasminemodelPackage.Literals.IJAVA_EE_SERVER__JMS_SERVICES);
			childrenFeatures.add(JasminemodelPackage.Literals.IJAVA_EE_SERVER__DISCOVERY_SERVICES);
			childrenFeatures.add(JasminemodelPackage.Literals.JBOSS_AS__BINDING);
			childrenFeatures.add(JasminemodelPackage.Literals.JBOSS_AS__WEBCONNECTORS);
		}
		return childrenFeatures;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

    /**
	 * This returns JBossAS.gif.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/JBossAS"));
	}

    /**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String getText(Object object) {
		String label = ((JBossAS)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_JBossAS_type") :
			getString("_UI_JBossAS_type") + " " + label;
	}

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    @Override
    public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(JBossAS.class)) {
			case JasminemodelPackage.JBOSS_AS__HOME:
			case JasminemodelPackage.JBOSS_AS__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS:
			case JasminemodelPackage.JBOSS_AS__RMI_REGISTRIES:
			case JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS:
			case JasminemodelPackage.JBOSS_AS__APPLICATIONS:
			case JasminemodelPackage.JBOSS_AS__JMS_SERVICES:
			case JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES:
			case JasminemodelPackage.JBOSS_AS__BINDING:
			case JasminemodelPackage.JBOSS_AS__WEBCONNECTORS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
     * describing the children that can be created under this object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(
            Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__WEB_CONTAINERS,
				 JasminemodelFactory.eINSTANCE.createWebContainer()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__RMI_REGISTRIES,
				 JasminemodelFactory.eINSTANCE.createIRMIRegistry()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__RMI_REGISTRIES,
				 JasminemodelFactory.eINSTANCE.createIIOP()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__RMI_REGISTRIES,
				 JasminemodelFactory.eINSTANCE.createJRMP()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__RMI_REGISTRIES,
				 JasminemodelFactory.eINSTANCE.createCMI()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__RMI_REGISTRIES,
				 JasminemodelFactory.eINSTANCE.createIRMI()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__EJB_CONTAINERS,
				 JasminemodelFactory.eINSTANCE.createEJBContainer()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__APPLICATIONS,
				 JasminemodelFactory.eINSTANCE.createEjbJar()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__JMS_SERVICES,
				 JasminemodelFactory.eINSTANCE.createJmsService()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.IJAVA_EE_SERVER__DISCOVERY_SERVICES,
				 JasminemodelFactory.eINSTANCE.createDiscoveryService()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.JBOSS_AS__BINDING,
				 JasminemodelFactory.eINSTANCE.createJBossBinding()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.JBOSS_AS__WEBCONNECTORS,
				 JasminemodelFactory.eINSTANCE.createAJP()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.JBOSS_AS__WEBCONNECTORS,
				 JasminemodelFactory.eINSTANCE.createHTTP()));

		newChildDescriptors.add
			(createChildParameter
				(JasminemodelPackage.Literals.JBOSS_AS__WEBCONNECTORS,
				 JasminemodelFactory.eINSTANCE.createHTTPS()));
	}

    /**
     * Return the resource locator for this item provider's resources. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
		return JasmineEditPlugin.INSTANCE;
	}

}
