/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.objectweb.jasmine.ui.jasminemodel.JBossBinding;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * This is the item provider adapter for a
 * {@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 *
 * @generated
 */
public class JBossBindingItemProvider extends ItemProviderAdapter implements
        IEditingDomainItemProvider, IStructuredItemContentProvider,
        ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public JBossBindingItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addNamingPortPropertyDescriptor(object);
			addNamingRMIPortPropertyDescriptor(object);
			addWebservicePortPropertyDescriptor(object);
			addInvokerRMIObjectPortPropertyDescriptor(object);
			addInvokerServerBindPortPropertyDescriptor(object);
			addHaNamingPortPropertyDescriptor(object);
			addHaNamingRMIPortPropertyDescriptor(object);
			addHaInvokerRMIObjectPortPropertyDescriptor(object);
			addHaInvokerServerBindPortPropertyDescriptor(object);
			addCorbaOrbPortPropertyDescriptor(object);
			addConnectorRMIObjectPortPropertyDescriptor(object);
			addSnmpTrapPortPropertyDescriptor(object);
			addSnmpRequestPortPropertyDescriptor(object);
			addJmsServerBindPortPropertyDescriptor(object);
			addWebserverPortPropertyDescriptor(object);
			addEjb3ConnectorPortPropertyDescriptor(object);
			addMessagingConnectorPortPropertyDescriptor(object);
			addRemotingConnectorPortPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

    /**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_name_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__NAME,
				 false,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Naming Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addNamingPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_namingPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_namingPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__NAMING_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Naming RMI Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addNamingRMIPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_namingRMIPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_namingRMIPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__NAMING_RMI_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Webservice Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addWebservicePortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_webservicePort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_webservicePort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__WEBSERVICE_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Invoker RMI Object Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addInvokerRMIObjectPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_invokerRMIObjectPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_invokerRMIObjectPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Invoker Server Bind Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addInvokerServerBindPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_invokerServerBindPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_invokerServerBindPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__INVOKER_SERVER_BIND_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Ha Naming Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addHaNamingPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_haNamingPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_haNamingPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__HA_NAMING_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Ha Naming RMI Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addHaNamingRMIPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_haNamingRMIPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_haNamingRMIPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__HA_NAMING_RMI_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Ha Invoker RMI Object Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addHaInvokerRMIObjectPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_haInvokerRMIObjectPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_haInvokerRMIObjectPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Ha Invoker Server Bind Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addHaInvokerServerBindPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_haInvokerServerBindPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_haInvokerServerBindPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Corba Orb Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addCorbaOrbPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_corbaOrbPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_corbaOrbPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__CORBA_ORB_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Connector RMI Object Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addConnectorRMIObjectPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_connectorRMIObjectPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_connectorRMIObjectPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Snmp Trap Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addSnmpTrapPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_snmpTrapPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_snmpTrapPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__SNMP_TRAP_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Snmp Request Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addSnmpRequestPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_snmpRequestPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_snmpRequestPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__SNMP_REQUEST_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Jms Server Bind Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addJmsServerBindPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_jmsServerBindPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_jmsServerBindPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__JMS_SERVER_BIND_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Webserver Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addWebserverPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_webserverPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_webserverPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__WEBSERVER_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This adds a property descriptor for the Ejb3 Connector Port feature. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected void addEjb3ConnectorPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_ejb3ConnectorPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_ejb3ConnectorPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__EJB3_CONNECTOR_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Messaging Connector Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addMessagingConnectorPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_messagingConnectorPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_messagingConnectorPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__MESSAGING_CONNECTOR_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
	 * This adds a property descriptor for the Remoting Connector Port feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected void addRemotingConnectorPortPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_JBossBinding_remotingConnectorPort_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_JBossBinding_remotingConnectorPort_feature", "_UI_JBossBinding_type"),
				 JasminemodelPackage.Literals.JBOSS_BINDING__REMOTING_CONNECTOR_PORT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

    /**
     * This returns JBossBinding.gif. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     *
     * @generated
     */
    @Override
    public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/JBossBinding"));
	}

    /**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String getText(Object object) {
		String label = ((JBossBinding)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_JBossBinding_type") :
			getString("_UI_JBossBinding_type") + " " + label;
	}

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    @Override
    public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(JBossBinding.class)) {
			case JasminemodelPackage.JBOSS_BINDING__NAME:
			case JasminemodelPackage.JBOSS_BINDING__NAMING_PORT:
			case JasminemodelPackage.JBOSS_BINDING__NAMING_RMI_PORT:
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVICE_PORT:
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT:
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_SERVER_BIND_PORT:
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_PORT:
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_RMI_PORT:
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT:
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT:
			case JasminemodelPackage.JBOSS_BINDING__CORBA_ORB_PORT:
			case JasminemodelPackage.JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT:
			case JasminemodelPackage.JBOSS_BINDING__SNMP_TRAP_PORT:
			case JasminemodelPackage.JBOSS_BINDING__SNMP_REQUEST_PORT:
			case JasminemodelPackage.JBOSS_BINDING__JMS_SERVER_BIND_PORT:
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVER_PORT:
			case JasminemodelPackage.JBOSS_BINDING__EJB3_CONNECTOR_PORT:
			case JasminemodelPackage.JBOSS_BINDING__MESSAGING_CONNECTOR_PORT:
			case JasminemodelPackage.JBOSS_BINDING__REMOTING_CONNECTOR_PORT:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
     * describing the children that can be created under this object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(
            Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

    /**
     * Return the resource locator for this item provider's resources. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
		return JasmineEditPlugin.INSTANCE;
	}

}
