/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Apache Middleware Properties</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getInstance_apache_home <em>Instance apache home</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_adress <em>Server listen adress</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_port <em>Server listen port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_user <em>Server user</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_group <em>Server group</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApacheMiddlewareProperties()
 * @model
 * @generated
 */
public interface ApacheMiddlewareProperties extends IMiddlewareProperties {
    /**
	 * Returns the value of the '<em><b>Instance apache home</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Instance apache home</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Instance apache home</em>' attribute.
	 * @see #setInstance_apache_home(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApacheMiddlewareProperties_Instance_apache_home()
	 * @model
	 * @generated
	 */
    String getInstance_apache_home();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getInstance_apache_home <em>Instance apache home</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Instance apache home</em>' attribute.
	 * @see #getInstance_apache_home()
	 * @generated
	 */
    void setInstance_apache_home(String value);

    /**
	 * Returns the value of the '<em><b>Server listen adress</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Server listen adress</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Server listen adress</em>' attribute.
	 * @see #setServer_listen_adress(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApacheMiddlewareProperties_Server_listen_adress()
	 * @model
	 * @generated
	 */
    String getServer_listen_adress();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_adress <em>Server listen adress</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Server listen adress</em>' attribute.
	 * @see #getServer_listen_adress()
	 * @generated
	 */
    void setServer_listen_adress(String value);

    /**
	 * Returns the value of the '<em><b>Server listen port</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Server listen port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Server listen port</em>' attribute.
	 * @see #setServer_listen_port(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApacheMiddlewareProperties_Server_listen_port()
	 * @model
	 * @generated
	 */
    String getServer_listen_port();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_port <em>Server listen port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Server listen port</em>' attribute.
	 * @see #getServer_listen_port()
	 * @generated
	 */
    void setServer_listen_port(String value);

    /**
	 * Returns the value of the '<em><b>Server user</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Server user</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Server user</em>' attribute.
	 * @see #setServer_user(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApacheMiddlewareProperties_Server_user()
	 * @model
	 * @generated
	 */
    String getServer_user();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_user <em>Server user</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Server user</em>' attribute.
	 * @see #getServer_user()
	 * @generated
	 */
    void setServer_user(String value);

    /**
	 * Returns the value of the '<em><b>Server group</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Server group</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Server group</em>' attribute.
	 * @see #setServer_group(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApacheMiddlewareProperties_Server_group()
	 * @model
	 * @generated
	 */
    String getServer_group();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_group <em>Server group</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Server group</em>' attribute.
	 * @see #getServer_group()
	 * @generated
	 */
    void setServer_group(String value);

} // ApacheMiddlewareProperties
