/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import java.net.InetAddress;

import org.eclipse.emf.common.util.EList;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Apache HTT Pd</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getModules <em>Modules</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHome <em>Home</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHost <em>Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getPort <em>Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getUser <em>User</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getGroup <em>Group</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd()
 * @model
 * @generated
 */
public interface Apache_HTTPd extends IHTTPServer, ILocatable {
    /**
     * Returns the value of the '<em><b>Name</b></em>' attribute. The
     * default value is <code>"Apache HTTPd Server"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Name</em>' attribute.
     * @see #setName(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd_Name()
     * @model default="Apache HTTPd Server"
     * @generated
     */
    String getName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
    void setName(String value);

    /**
     * Returns the value of the '<em><b>Modules</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.IModule}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Modules</em>' containment reference list
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Modules</em>' containment reference
     *         list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd_Modules()
     * @model containment="true"
     * @generated
     */
    EList<IModule> getModules();

    /**
     * Returns the value of the '<em><b>Home</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Home</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Home</em>' attribute.
     * @see #setHome(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd_Home()
     * @model
     * @generated
     */
    String getHome();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHome <em>Home</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Home</em>' attribute.
	 * @see #getHome()
	 * @generated
	 */
    void setHome(String value);

    /**
	 * Returns the value of the '<em><b>Host</b></em>' attribute.
	 * The default value is <code>"localhost"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Host</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Host</em>' attribute.
	 * @see #setHost(InetAddress)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd_Host()
	 * @model default="localhost" dataType="org.objectweb.jasmine.ui.jasminemodel.InetAddress"
	 * @generated
	 */
    InetAddress getHost();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHost <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Host</em>' attribute.
	 * @see #getHost()
	 * @generated
	 */
    void setHost(InetAddress value);

    /**
	 * Returns the value of the '<em><b>Port</b></em>' attribute.
	 * The default value is <code>"80"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Port</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Port</em>' attribute.
	 * @see #setPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd_Port()
	 * @model default="80" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getPort <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Port</em>' attribute.
	 * @see #getPort()
	 * @generated
	 */
    void setPort(Port value);

    /**
	 * Returns the value of the '<em><b>User</b></em>' attribute.
	 * The default value is <code>"www-data"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>User</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>User</em>' attribute.
	 * @see #setUser(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd_User()
	 * @model default="www-data"
	 * @generated
	 */
    String getUser();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getUser <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>User</em>' attribute.
	 * @see #getUser()
	 * @generated
	 */
    void setUser(String value);

    /**
	 * Returns the value of the '<em><b>Group</b></em>' attribute.
	 * The default value is <code>"www-data"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Group</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Group</em>' attribute.
	 * @see #setGroup(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getApache_HTTPd_Group()
	 * @model default="www-data"
	 * @generated
	 */
    String getGroup();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getGroup <em>Group</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Group</em>' attribute.
	 * @see #getGroup()
	 * @generated
	 */
    void setGroup(String value);

} // Apache_HTTPd
