/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import java.net.InetAddress;
import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Cmi Group</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup#isLanMode <em>Lan Mode</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup#getTcpPingHost <em>Tcp Ping Host</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getCmiGroup()
 * @model
 * @generated
 */
public interface CmiGroup extends ConfigurationNode {
    /**
	 * Returns the value of the '<em><b>Lan Mode</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Lan Mode</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Lan Mode</em>' attribute.
	 * @see #setLanMode(boolean)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getCmiGroup_LanMode()
	 * @model default="true"
	 * @generated
	 */
    boolean isLanMode();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup#isLanMode <em>Lan Mode</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lan Mode</em>' attribute.
	 * @see #isLanMode()
	 * @generated
	 */
    void setLanMode(boolean value);

    /**
	 * Returns the value of the '<em><b>Tcp Ping Host</b></em>' attribute.
	 * The default value is <code>"localhost"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Tcp Ping Host</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Tcp Ping Host</em>' attribute.
	 * @see #setTcpPingHost(InetAddress)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getCmiGroup_TcpPingHost()
	 * @model default="localhost" dataType="org.objectweb.jasmine.ui.jasminemodel.InetAddress"
	 * @generated
	 */
    InetAddress getTcpPingHost();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup#getTcpPingHost <em>Tcp Ping Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tcp Ping Host</em>' attribute.
	 * @see #getTcpPingHost()
	 * @generated
	 */
    void setTcpPingHost(InetAddress value);

} // CmiGroup
