/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import java.net.InetAddress;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Configuration Node</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getDescription <em>Description</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getHost <em>Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getPort <em>Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getConfigurationNode()
 * @model abstract="true"
 * @generated
 */
public interface ConfigurationNode extends IConfigurationNode {
    /**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Description</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getConfigurationNode_Description()
	 * @model
	 * @generated
	 */
    String getDescription();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
    void setDescription(String value);

    /**
	 * Returns the value of the '<em><b>Host</b></em>' attribute.
	 * The default value is <code>"localhost"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Host</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Host</em>' attribute.
	 * @see #setHost(InetAddress)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getConfigurationNode_Host()
	 * @model default="localhost" dataType="org.objectweb.jasmine.ui.jasminemodel.InetAddress"
	 * @generated
	 */
    InetAddress getHost();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getHost <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Host</em>' attribute.
	 * @see #getHost()
	 * @generated
	 */
    void setHost(InetAddress value);

    /**
     * Returns the value of the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Port</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Port</em>' attribute.
     * @see #setPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getConfigurationNode_Port()
     * @model dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getPort <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Port</em>' attribute.
	 * @see #getPort()
	 * @generated
	 */
    void setPort(Port value);

    /**
     * Returns the value of the '<em><b>Name</b></em>' attribute. The
     * default value is <code>"New Configuration Node"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Name</em>' attribute.
     * @see #setName(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getConfigurationNode_Name()
     * @model default="New Configuration Node"
     * @generated
     */
    String getName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
    void setName(String value);

} // ConfigurationNode
