/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>DB</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getProvider <em>Provider</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getUser <em>User</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getPassword <em>Password</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getUrl <em>Url</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getDriverName <em>Driver Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJndiName <em>Jndi Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJdbcDriverJarFile <em>Jdbc Driver Jar File</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getMappernName <em>Mappern Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getPort <em>Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJasmineNode <em>Jasmine Node</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB()
 * @model
 * @generated
 */
public interface DB extends EObject {
    /**
     * Returns the value of the '<em><b>Provider</b></em>' attribute. The
     * literals are from the enumeration
     * {@link org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Provider</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Provider</em>' attribute.
     * @see org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider
     * @see #setProvider(DatabaseProvider)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_Provider()
     * @model
     * @generated
     */
    DatabaseProvider getProvider();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getProvider <em>Provider</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Provider</em>' attribute.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider
	 * @see #getProvider()
	 * @generated
	 */
    void setProvider(DatabaseProvider value);

    /**
	 * Returns the value of the '<em><b>User</b></em>' attribute.
	 * The default value is <code>"jonas"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>User</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>User</em>' attribute.
	 * @see #setUser(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_User()
	 * @model default="jonas"
	 * @generated
	 */
    String getUser();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getUser <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>User</em>' attribute.
	 * @see #getUser()
	 * @generated
	 */
    void setUser(String value);

    /**
	 * Returns the value of the '<em><b>Password</b></em>' attribute.
	 * The default value is <code>"jonas"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Password</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Password</em>' attribute.
	 * @see #setPassword(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_Password()
	 * @model default="jonas"
	 * @generated
	 */
    String getPassword();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getPassword <em>Password</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Password</em>' attribute.
	 * @see #getPassword()
	 * @generated
	 */
    void setPassword(String value);

    /**
     * Returns the value of the '<em><b>Url</b></em>' attribute. The
     * default value is
     * <code>"jdbc:hsqldb:hsql://localhost:9005/db_jonas"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Url</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Url</em>' attribute.
     * @see #setUrl(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_Url()
     * @model default="jdbc:hsqldb:hsql://localhost:9005/db_jonas"
     * @generated
     */
    String getUrl();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getUrl <em>Url</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Url</em>' attribute.
	 * @see #getUrl()
	 * @generated
	 */
    void setUrl(String value);

    /**
     * Returns the value of the '<em><b>Driver Name</b></em>' attribute.
     * The default value is <code>"org.hsqldb.jdbcDriver"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Driver Name</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Driver Name</em>' attribute.
     * @see #setDriverName(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_DriverName()
     * @model default="org.hsqldb.jdbcDriver"
     * @generated
     */
    String getDriverName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getDriverName <em>Driver Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Driver Name</em>' attribute.
	 * @see #getDriverName()
	 * @generated
	 */
    void setDriverName(String value);

    /**
	 * Returns the value of the '<em><b>Jndi Name</b></em>' attribute.
	 * The default value is <code>"jdbc_1"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jndi Name</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jndi Name</em>' attribute.
	 * @see #setJndiName(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_JndiName()
	 * @model default="jdbc_1"
	 * @generated
	 */
    String getJndiName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJndiName <em>Jndi Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jndi Name</em>' attribute.
	 * @see #getJndiName()
	 * @generated
	 */
    void setJndiName(String value);

    /**
     * Returns the value of the '<em><b>Jdbc Driver Jar File</b></em>'
     * attribute. The default value is <code>"none"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jdbc Driver Jar File</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Jdbc Driver Jar File</em>' attribute.
     * @see #setJdbcDriverJarFile(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_JdbcDriverJarFile()
     * @model default="none"
     * @generated
     */
    String getJdbcDriverJarFile();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJdbcDriverJarFile <em>Jdbc Driver Jar File</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jdbc Driver Jar File</em>' attribute.
	 * @see #getJdbcDriverJarFile()
	 * @generated
	 */
    void setJdbcDriverJarFile(String value);

    /**
	 * Returns the value of the '<em><b>Mappern Name</b></em>' attribute.
	 * The default value is <code>"rdb.hsql"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Mappern Name</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Mappern Name</em>' attribute.
	 * @see #setMappernName(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_MappernName()
	 * @model default="rdb.hsql"
	 * @generated
	 */
    String getMappernName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getMappernName <em>Mappern Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mappern Name</em>' attribute.
	 * @see #getMappernName()
	 * @generated
	 */
    void setMappernName(String value);

    /**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * The default value is <code>"HSQL1"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_Name()
	 * @model default="HSQL1"
	 * @generated
	 */
    String getName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
    void setName(String value);

    /**
	 * Returns the value of the '<em><b>Port</b></em>' attribute.
	 * The default value is <code>"9001"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Port</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Port</em>' attribute.
	 * @see #setPort(int)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_Port()
	 * @model default="9001"
	 * @generated
	 */
    int getPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getPort <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Port</em>' attribute.
	 * @see #getPort()
	 * @generated
	 */
    void setPort(int value);

    /**
	 * Returns the value of the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jasmine Node</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jasmine Node</em>' reference.
	 * @see #setJasmineNode(JASMINeNode)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDB_JasmineNode()
	 * @model
	 * @generated
	 */
    JASMINeNode getJasmineNode();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJasmineNode <em>Jasmine Node</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jasmine Node</em>' reference.
	 * @see #getJasmineNode()
	 * @generated
	 */
    void setJasmineNode(JASMINeNode value);

} // DB
