/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Domain</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getMiddlewareComponents <em>Middleware Components</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getConnectors <em>Connectors</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getConfigurationNodes <em>Configuration Nodes</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getClusterContainers <em>Cluster Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getDb <em>Db</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getDblinks <em>Dblinks</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDomain()
 * @model
 * @generated
 */
public interface Domain extends EObject {
    /**
     * Returns the value of the '<em><b>Middleware Components</b></em>'
     * containment reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Middleware Components</em>' containment
     * reference list isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Middleware Components</em>' containment
     *         reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDomain_MiddlewareComponents()
     * @model containment="true"
     * @generated
     */
    EList<IMiddlewareComponent> getMiddlewareComponents();

    /**
     * Returns the value of the '<em><b>Connectors</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.IConnector}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Connectors</em>' containment reference
     * list isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Connectors</em>' containment reference
     *         list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDomain_Connectors()
     * @model containment="true"
     * @generated
     */
    EList<IConnector> getConnectors();

    /**
     * Returns the value of the '<em><b>Configuration Nodes</b></em>'
     * containment reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Configuration Nodes</em>' containment
     * reference list isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Configuration Nodes</em>' containment
     *         reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDomain_ConfigurationNodes()
     * @model containment="true"
     * @generated
     */
    EList<ConfigurationNode> getConfigurationNodes();

    /**
	 * Returns the value of the '<em><b>Cluster Containers</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Cluster Containers</em>' containment
     * reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Cluster Containers</em>' containment reference.
	 * @see #setClusterContainers(ClusterContainer)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDomain_ClusterContainers()
	 * @model containment="true"
	 * @generated
	 */
    ClusterContainer getClusterContainers();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getClusterContainers <em>Cluster Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cluster Containers</em>' containment reference.
	 * @see #getClusterContainers()
	 * @generated
	 */
    void setClusterContainers(ClusterContainer value);

    /**
	 * Returns the value of the '<em><b>Db</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Db</em>' containment reference isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Db</em>' containment reference.
	 * @see #setDb(DB)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDomain_Db()
	 * @model containment="true"
	 * @generated
	 */
    DB getDb();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getDb <em>Db</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Db</em>' containment reference.
	 * @see #getDb()
	 * @generated
	 */
    void setDb(DB value);

    /**
     * Returns the value of the '<em><b>Dblinks</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.DbLink}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Dblinks</em>' containment reference list
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Dblinks</em>' containment reference
     *         list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getDomain_Dblinks()
     * @model containment="true"
     * @generated
     */
    EList<DbLink> getDblinks();

} // Domain
