/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>IHTTP Server</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer#getJavaeeServers <em>Javaee Servers</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIHTTPServer()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface IHTTPServer extends MiddlewareComponent {

	/**
	 * Returns the value of the '<em><b>Javaee Servers</b></em>' reference list.
	 * The list contents are of type {@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer}.
	 * It is bidirectional and its opposite is '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getHttpServers <em>Http Servers</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Javaee Servers</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Javaee Servers</em>' reference list.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIHTTPServer_JavaeeServers()
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getHttpServers
	 * @model opposite="httpServers"
	 * @generated
	 */
	EList<IJavaEEServer> getJavaeeServers();
} // IHTTPServer
