/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>IJava EE Server</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getWebContainers <em>Web Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getRmiRegistries <em>Rmi Registries</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getEjbContainers <em>Ejb Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getApplications <em>Applications</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getJmsServices <em>Jms Services</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getDiscoveryServices <em>Discovery Services</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getHttpServers <em>Http Servers</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface IJavaEEServer extends MiddlewareComponent {
    /**
	 * Returns the value of the '<em><b>Web Containers</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Web Containers</em>' containment reference
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Web Containers</em>' containment reference.
	 * @see #setWebContainers(WebContainer)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer_WebContainers()
	 * @model containment="true"
	 * @generated
	 */
    WebContainer getWebContainers();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getWebContainers <em>Web Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Web Containers</em>' containment reference.
	 * @see #getWebContainers()
	 * @generated
	 */
    void setWebContainers(WebContainer value);

    /**
     * Returns the value of the '<em><b>Rmi Registries</b></em>'
     * containment reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Rmi Registries</em>' containment reference
     * list isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Rmi Registries</em>' containment
     *         reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer_RmiRegistries()
     * @model containment="true"
     * @generated
     */
    EList<IRMIRegistry> getRmiRegistries();

    /**
	 * Returns the value of the '<em><b>Ejb Containers</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ejb Containers</em>' containment reference
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Ejb Containers</em>' containment reference.
	 * @see #setEjbContainers(EJBContainer)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer_EjbContainers()
	 * @model containment="true"
	 * @generated
	 */
    EJBContainer getEjbContainers();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getEjbContainers <em>Ejb Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ejb Containers</em>' containment reference.
	 * @see #getEjbContainers()
	 * @generated
	 */
    void setEjbContainers(EJBContainer value);

    /**
     * Returns the value of the '<em><b>Applications</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.IApplication}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Applications</em>' containment reference
     * list isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Applications</em>' containment
     *         reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer_Applications()
     * @model containment="true"
     * @generated
     */
    EList<IApplication> getApplications();

    /**
	 * Returns the value of the '<em><b>Jms Services</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jms Services</em>' containment reference
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jms Services</em>' containment reference.
	 * @see #setJmsServices(JmsService)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer_JmsServices()
	 * @model containment="true"
	 * @generated
	 */
    JmsService getJmsServices();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getJmsServices <em>Jms Services</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jms Services</em>' containment reference.
	 * @see #getJmsServices()
	 * @generated
	 */
    void setJmsServices(JmsService value);

    /**
	 * Returns the value of the '<em><b>Discovery Services</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Discovery Services</em>' containment
     * reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Discovery Services</em>' containment reference.
	 * @see #setDiscoveryServices(DiscoveryService)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer_DiscoveryServices()
	 * @model containment="true"
	 * @generated
	 */
    DiscoveryService getDiscoveryServices();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getDiscoveryServices <em>Discovery Services</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Discovery Services</em>' containment reference.
	 * @see #getDiscoveryServices()
	 * @generated
	 */
    void setDiscoveryServices(DiscoveryService value);

				/**
	 * Returns the value of the '<em><b>Http Servers</b></em>' reference list.
	 * The list contents are of type {@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer}.
	 * It is bidirectional and its opposite is '{@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer#getJavaeeServers <em>Javaee Servers</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Http Servers</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Http Servers</em>' reference list.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIJavaEEServer_HttpServers()
	 * @see org.objectweb.jasmine.ui.jasminemodel.IHTTPServer#getJavaeeServers
	 * @model opposite="javaeeServers"
	 * @generated
	 */
	EList<IHTTPServer> getHttpServers();

} // IJavaEEServer
