/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.ecore.EObject;
import org.objectweb.jasmine.jade.service.deployer.DeploymentException;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>IMiddleware Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent#getJasmineNode <em>Jasmine Node</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIMiddlewareComponent()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface IMiddlewareComponent extends EObject {

    /**
	 * Returns the value of the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jasmine Node</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jasmine Node</em>' reference.
	 * @see #setJasmineNode(JASMINeNode)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getIMiddlewareComponent_JasmineNode()
	 * @model required="true"
	 * @generated
	 */
    JASMINeNode getJasmineNode();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent#getJasmineNode <em>Jasmine Node</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jasmine Node</em>' reference.
	 * @see #getJasmineNode()
	 * @generated
	 */
    void setJasmineNode(JASMINeNode value);

    /**
     * @generated NOT
     */
    org.objectweb.jasmine.jade.application.Application getApp();

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model exceptions="org.objectweb.jasmine.ui.jasminemodel.DeploymentException"
	 * @generated
	 */
    void deploy() throws DeploymentException;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model exceptions="org.objectweb.jasmine.ui.jasminemodel.DeploymentException"
	 * @generated
	 */
    void start() throws DeploymentException;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model exceptions="org.objectweb.jasmine.ui.jasminemodel.DeploymentException"
	 * @generated
	 */
    void stop() throws DeploymentException;
} // IMiddlewareComponent
