/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import java.net.InetAddress;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>JASMI Ne Node</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getHost <em>Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getUser <em>User</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getPassword <em>Password</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getSshKey <em>Ssh Key</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getInstallDir <em>Install Dir</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getNodeId <em>Node Id</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryHost <em>Registry Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryPort <em>Registry Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryHost <em>Discovery Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryPort <em>Discovery Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getJndiPort <em>Jndi Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getFelixProfile <em>Felix Profile</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRepositoryURL <em>Repository URL</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getMiddlewares <em>Middlewares</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode()
 * @model
 * @generated
 */
public interface JASMINeNode extends EObject {
    /**
	 * Returns the value of the '<em><b>Discovery Host</b></em>' attribute.
	 * The default value is <code>"127.0.0.1"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Discovery Host</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Discovery Host</em>' attribute.
	 * @see #setDiscoveryHost(InetAddress)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_DiscoveryHost()
	 * @model default="127.0.0.1" dataType="org.objectweb.jasmine.ui.jasminemodel.InetAddress"
	 * @generated
	 */
    InetAddress getDiscoveryHost();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryHost <em>Discovery Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Discovery Host</em>' attribute.
	 * @see #getDiscoveryHost()
	 * @generated
	 */
    void setDiscoveryHost(InetAddress value);

    /**
	 * Returns the value of the '<em><b>Discovery Port</b></em>' attribute.
	 * The default value is <code>"9998"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Discovery Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Discovery Port</em>' attribute.
	 * @see #setDiscoveryPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_DiscoveryPort()
	 * @model default="9998" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getDiscoveryPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryPort <em>Discovery Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Discovery Port</em>' attribute.
	 * @see #getDiscoveryPort()
	 * @generated
	 */
    void setDiscoveryPort(Port value);

    /**
     * Returns the value of the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Host</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Host</em>' attribute.
     * @see #setHost(InetAddress)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_Host()
     * @model dataType="org.objectweb.jasmine.ui.jasminemodel.InetAddress"
     * @generated
     */
    InetAddress getHost();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getHost <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Host</em>' attribute.
	 * @see #getHost()
	 * @generated
	 */
    void setHost(InetAddress value);

    /**
     * Returns the value of the '<em><b>User</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>User</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>User</em>' attribute.
     * @see #setUser(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_User()
     * @model
     * @generated
     */
    String getUser();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getUser <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>User</em>' attribute.
	 * @see #getUser()
	 * @generated
	 */
    void setUser(String value);

    /**
     * Returns the value of the '<em><b>Password</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Password</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Password</em>' attribute.
     * @see #setPassword(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_Password()
     * @model
     * @generated
     */
    String getPassword();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getPassword <em>Password</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Password</em>' attribute.
	 * @see #getPassword()
	 * @generated
	 */
    void setPassword(String value);

    /**
     * Returns the value of the '<em><b>Ssh Key</b></em>' attribute. The
     * default value is <code>"${user.dir}/.ssh/id_rsa"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ssh Key</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Ssh Key</em>' attribute.
     * @see #setSshKey(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_SshKey()
     * @model default="${user.dir}/.ssh/id_rsa"
     * @generated
     */
    String getSshKey();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getSshKey <em>Ssh Key</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ssh Key</em>' attribute.
	 * @see #getSshKey()
	 * @generated
	 */
    void setSshKey(String value);

    /**
     * Returns the value of the '<em><b>Install Dir</b></em>' attribute.
     * The default value is <code>"${java.io.tmpdir}"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Install Dir</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Install Dir</em>' attribute.
     * @see #setInstallDir(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_InstallDir()
     * @model default="${java.io.tmpdir}"
     * @generated
     */
    String getInstallDir();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getInstallDir <em>Install Dir</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Install Dir</em>' attribute.
	 * @see #getInstallDir()
	 * @generated
	 */
    void setInstallDir(String value);

    /**
	 * Returns the value of the '<em><b>Jndi Port</b></em>' attribute.
	 * The default value is <code>"1239"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jndi Port</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jndi Port</em>' attribute.
	 * @see #setJndiPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_JndiPort()
	 * @model default="1239" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getJndiPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getJndiPort <em>Jndi Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jndi Port</em>' attribute.
	 * @see #getJndiPort()
	 * @generated
	 */
    void setJndiPort(Port value);

    /**
	 * Returns the value of the '<em><b>Felix Profile</b></em>' attribute.
	 * The default value is <code>"jasminenode"</code>.
	 * <!-- begin-user-doc
     * -->
     * <p>
     * If the meaning of the '<em>Felix Profile</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Felix Profile</em>' attribute.
	 * @see #setFelixProfile(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_FelixProfile()
	 * @model default="jasminenode"
	 * @generated
	 */
    String getFelixProfile();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getFelixProfile <em>Felix Profile</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Felix Profile</em>' attribute.
	 * @see #getFelixProfile()
	 * @generated
	 */
    void setFelixProfile(String value);

    /**
     * Returns the value of the '<em><b>Node Id</b></em>' attribute. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Node Id</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Node Id</em>' attribute.
     * @see #setNodeId(Integer)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_NodeId()
     * @model
     * @generated
     */
    Integer getNodeId();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getNodeId <em>Node Id</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Node Id</em>' attribute.
	 * @see #getNodeId()
	 * @generated
	 */
    void setNodeId(Integer value);

    /**
	 * Returns the value of the '<em><b>Registry Host</b></em>' attribute.
	 * The default value is <code>"127.0.0.1"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Registry Host</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Registry Host</em>' attribute.
	 * @see #setRegistryHost(InetAddress)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_RegistryHost()
	 * @model default="127.0.0.1" dataType="org.objectweb.jasmine.ui.jasminemodel.InetAddress"
	 * @generated
	 */
    InetAddress getRegistryHost();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryHost <em>Registry Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Registry Host</em>' attribute.
	 * @see #getRegistryHost()
	 * @generated
	 */
    void setRegistryHost(InetAddress value);

    /**
	 * Returns the value of the '<em><b>Registry Port</b></em>' attribute.
	 * The default value is <code>"1238"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Registry Port</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Registry Port</em>' attribute.
	 * @see #setRegistryPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_RegistryPort()
	 * @model default="1238" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getRegistryPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryPort <em>Registry Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Registry Port</em>' attribute.
	 * @see #getRegistryPort()
	 * @generated
	 */
    void setRegistryPort(Port value);

    /**
	 * Returns the value of the '<em><b>Repository URL</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Repository URL</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Repository URL</em>' attribute.
	 * @see #setRepositoryURL(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_RepositoryURL()
	 * @model default=""
	 * @generated
	 */
    String getRepositoryURL();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRepositoryURL <em>Repository URL</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Repository URL</em>' attribute.
	 * @see #getRepositoryURL()
	 * @generated
	 */
    void setRepositoryURL(String value);

    /**
     * Returns the value of the '<em><b>Middlewares</b></em>' reference
     * list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Middlewares</em>' reference list isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Middlewares</em>' reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_Middlewares()
     * @model
     * @generated
     */
    EList<IMiddlewareComponent> getMiddlewares();

    /**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * The default value is <code>"JASMINeNode"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJASMINeNode_Name()
	 * @model default="JASMINeNode"
	 * @generated
	 */
    String getName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
    void setName(String value);

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
    void deploy();

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
    void start();

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
    void stop();

} // JASMINeNode
