/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>JBoss AS</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getHome <em>Home</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getBinding <em>Binding</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getWebconnectors <em>Webconnectors</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossAS()
 * @model
 * @generated
 */
public interface JBossAS extends IJavaEEServer, ILocatable {
    /**
     * Returns the value of the '<em><b>Home</b></em>' attribute. The
     * default value is <code>"/home/jasmine/jboss"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Home</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Home</em>' attribute.
     * @see #setHome(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossAS_Home()
     * @model default="/home/jasmine/jboss"
     * @generated
     */
    String getHome();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getHome <em>Home</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Home</em>' attribute.
	 * @see #getHome()
	 * @generated
	 */
    void setHome(String value);

    /**
	 * Returns the value of the '<em><b>Binding</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Binding</em>' containment reference isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Binding</em>' containment reference.
	 * @see #setBinding(JBossBinding)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossAS_Binding()
	 * @model containment="true" required="true"
	 * @generated
	 */
    JBossBinding getBinding();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getBinding <em>Binding</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Binding</em>' containment reference.
	 * @see #getBinding()
	 * @generated
	 */
    void setBinding(JBossBinding value);

    /**
     * Returns the value of the '<em><b>Name</b></em>' attribute. The
     * default value is <code>"JBoss Application Server"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Name</em>' attribute.
     * @see #setName(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossAS_Name()
     * @model default="JBoss Application Server"
     * @generated
     */
    String getName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
    void setName(String value);

    /**
     * Returns the value of the '<em><b>Webconnectors</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.WebConnector}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Webconnectors</em>' containment reference
     * list isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Webconnectors</em>' containment
     *         reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossAS_Webconnectors()
     * @model containment="true"
     * @generated
     */
    EList<WebConnector> getWebconnectors();

} // JBossAS
