/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.ecore.EObject;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>JBoss Binding</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingPort <em>Naming Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingRMIPort <em>Naming RMI Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebservicePort <em>Webservice Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerRMIObjectPort <em>Invoker RMI Object Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerServerBindPort <em>Invoker Server Bind Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingPort <em>Ha Naming Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingRMIPort <em>Ha Naming RMI Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerRMIObjectPort <em>Ha Invoker RMI Object Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerServerBindPort <em>Ha Invoker Server Bind Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getCorbaOrbPort <em>Corba Orb Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getConnectorRMIObjectPort <em>Connector RMI Object Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpTrapPort <em>Snmp Trap Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpRequestPort <em>Snmp Request Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getJmsServerBindPort <em>Jms Server Bind Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebserverPort <em>Webserver Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getEjb3ConnectorPort <em>Ejb3 Connector Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getMessagingConnectorPort <em>Messaging Connector Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getRemotingConnectorPort <em>Remoting Connector Port</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding()
 * @model
 * @generated
 */
public interface JBossBinding extends EObject {
    /**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * The default value is <code>"Binding"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_Name()
	 * @model default="Binding" changeable="false"
	 * @generated
	 */
    String getName();

    /**
	 * Returns the value of the '<em><b>Naming Port</b></em>' attribute.
	 * The default value is <code>"1099"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Naming Port</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Naming Port</em>' attribute.
	 * @see #setNamingPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_NamingPort()
	 * @model default="1099" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getNamingPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingPort <em>Naming Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Naming Port</em>' attribute.
	 * @see #getNamingPort()
	 * @generated
	 */
    void setNamingPort(Port value);

    /**
     * Returns the value of the '<em><b>Naming RMI Port</b></em>'
     * attribute. The default value is <code>"1098"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Naming RMI Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Naming RMI Port</em>' attribute.
     * @see #setNamingRMIPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_NamingRMIPort()
     * @model default="1098"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getNamingRMIPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingRMIPort <em>Naming RMI Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Naming RMI Port</em>' attribute.
	 * @see #getNamingRMIPort()
	 * @generated
	 */
    void setNamingRMIPort(Port value);

    /**
     * Returns the value of the '<em><b>Webservice Port</b></em>'
     * attribute. The default value is <code>"8083"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Webservice Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Webservice Port</em>' attribute.
     * @see #setWebservicePort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_WebservicePort()
     * @model default="8083"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getWebservicePort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebservicePort <em>Webservice Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Webservice Port</em>' attribute.
	 * @see #getWebservicePort()
	 * @generated
	 */
    void setWebservicePort(Port value);

    /**
     * Returns the value of the '<em><b>Invoker RMI Object Port</b></em>'
     * attribute. The default value is <code>"4444"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Invoker RMI Object Port</em>' attribute
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Invoker RMI Object Port</em>'
     *         attribute.
     * @see #setInvokerRMIObjectPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_InvokerRMIObjectPort()
     * @model default="4444"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getInvokerRMIObjectPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerRMIObjectPort <em>Invoker RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Invoker RMI Object Port</em>' attribute.
	 * @see #getInvokerRMIObjectPort()
	 * @generated
	 */
    void setInvokerRMIObjectPort(Port value);

    /**
     * Returns the value of the '<em><b>Invoker Server Bind Port</b></em>'
     * attribute. The default value is <code>"4445"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Invoker Server Bind Port</em>' attribute
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Invoker Server Bind Port</em>'
     *         attribute.
     * @see #setInvokerServerBindPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_InvokerServerBindPort()
     * @model default="4445"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getInvokerServerBindPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerServerBindPort <em>Invoker Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Invoker Server Bind Port</em>' attribute.
	 * @see #getInvokerServerBindPort()
	 * @generated
	 */
    void setInvokerServerBindPort(Port value);

    /**
	 * Returns the value of the '<em><b>Ha Naming Port</b></em>' attribute.
	 * The default value is <code>"1100"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ha Naming Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Ha Naming Port</em>' attribute.
	 * @see #setHaNamingPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_HaNamingPort()
	 * @model default="1100" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getHaNamingPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingPort <em>Ha Naming Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ha Naming Port</em>' attribute.
	 * @see #getHaNamingPort()
	 * @generated
	 */
    void setHaNamingPort(Port value);

    /**
     * Returns the value of the '<em><b>Ha Naming RMI Port</b></em>'
     * attribute. The default value is <code>"1101"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ha Naming RMI Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Ha Naming RMI Port</em>' attribute.
     * @see #setHaNamingRMIPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_HaNamingRMIPort()
     * @model default="1101"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getHaNamingRMIPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingRMIPort <em>Ha Naming RMI Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ha Naming RMI Port</em>' attribute.
	 * @see #getHaNamingRMIPort()
	 * @generated
	 */
    void setHaNamingRMIPort(Port value);

    /**
     * Returns the value of the '<em><b>Ha Invoker RMI Object Port</b></em>'
     * attribute. The default value is <code>"4444"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ha Invoker RMI Object Port</em>' attribute
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Ha Invoker RMI Object Port</em>'
     *         attribute.
     * @see #setHaInvokerRMIObjectPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_HaInvokerRMIObjectPort()
     * @model default="4444"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getHaInvokerRMIObjectPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerRMIObjectPort <em>Ha Invoker RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ha Invoker RMI Object Port</em>' attribute.
	 * @see #getHaInvokerRMIObjectPort()
	 * @generated
	 */
    void setHaInvokerRMIObjectPort(Port value);

    /**
     * Returns the value of the '<em><b>Ha Invoker Server Bind Port</b></em>'
     * attribute. The default value is <code>"4448"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ha Invoker Server Bind Port</em>'
     * attribute isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Ha Invoker Server Bind Port</em>'
     *         attribute.
     * @see #setHaInvokerServerBindPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_HaInvokerServerBindPort()
     * @model default="4448"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getHaInvokerServerBindPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerServerBindPort <em>Ha Invoker Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ha Invoker Server Bind Port</em>' attribute.
	 * @see #getHaInvokerServerBindPort()
	 * @generated
	 */
    void setHaInvokerServerBindPort(Port value);

    /**
	 * Returns the value of the '<em><b>Corba Orb Port</b></em>' attribute.
	 * The default value is <code>"3528"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Corba Orb Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Corba Orb Port</em>' attribute.
	 * @see #setCorbaOrbPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_CorbaOrbPort()
	 * @model default="3528" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getCorbaOrbPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getCorbaOrbPort <em>Corba Orb Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Corba Orb Port</em>' attribute.
	 * @see #getCorbaOrbPort()
	 * @generated
	 */
    void setCorbaOrbPort(Port value);

    /**
     * Returns the value of the '<em><b>Connector RMI Object Port</b></em>'
     * attribute. The default value is <code>"19001"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Connector RMI Object Port</em>' attribute
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Connector RMI Object Port</em>'
     *         attribute.
     * @see #setConnectorRMIObjectPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_ConnectorRMIObjectPort()
     * @model default="19001"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getConnectorRMIObjectPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getConnectorRMIObjectPort <em>Connector RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connector RMI Object Port</em>' attribute.
	 * @see #getConnectorRMIObjectPort()
	 * @generated
	 */
    void setConnectorRMIObjectPort(Port value);

    /**
	 * Returns the value of the '<em><b>Snmp Trap Port</b></em>' attribute.
	 * The default value is <code>"1162"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Snmp Trap Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Snmp Trap Port</em>' attribute.
	 * @see #setSnmpTrapPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_SnmpTrapPort()
	 * @model default="1162" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getSnmpTrapPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpTrapPort <em>Snmp Trap Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Snmp Trap Port</em>' attribute.
	 * @see #getSnmpTrapPort()
	 * @generated
	 */
    void setSnmpTrapPort(Port value);

    /**
     * Returns the value of the '<em><b>Snmp Request Port</b></em>'
     * attribute. The default value is <code>"1161"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Snmp Request Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Snmp Request Port</em>' attribute.
     * @see #setSnmpRequestPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_SnmpRequestPort()
     * @model default="1161"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getSnmpRequestPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpRequestPort <em>Snmp Request Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Snmp Request Port</em>' attribute.
	 * @see #getSnmpRequestPort()
	 * @generated
	 */
    void setSnmpRequestPort(Port value);

    /**
     * Returns the value of the '<em><b>Jms Server Bind Port</b></em>'
     * attribute. The default value is <code>"8093"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jms Server Bind Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Jms Server Bind Port</em>' attribute.
     * @see #setJmsServerBindPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_JmsServerBindPort()
     * @model default="8093"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getJmsServerBindPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getJmsServerBindPort <em>Jms Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jms Server Bind Port</em>' attribute.
	 * @see #getJmsServerBindPort()
	 * @generated
	 */
    void setJmsServerBindPort(Port value);

    /**
	 * Returns the value of the '<em><b>Webserver Port</b></em>' attribute.
	 * The default value is <code>"8080"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Webserver Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Webserver Port</em>' attribute.
	 * @see #setWebserverPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_WebserverPort()
	 * @model default="8080" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getWebserverPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebserverPort <em>Webserver Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Webserver Port</em>' attribute.
	 * @see #getWebserverPort()
	 * @generated
	 */
    void setWebserverPort(Port value);

    /**
     * Returns the value of the '<em><b>Ejb3 Connector Port</b></em>'
     * attribute. The default value is <code>"3873"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ejb3 Connector Port</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Ejb3 Connector Port</em>' attribute.
     * @see #setEjb3ConnectorPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_Ejb3ConnectorPort()
     * @model default="3873"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getEjb3ConnectorPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getEjb3ConnectorPort <em>Ejb3 Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ejb3 Connector Port</em>' attribute.
	 * @see #getEjb3ConnectorPort()
	 * @generated
	 */
    void setEjb3ConnectorPort(Port value);

    /**
     * Returns the value of the '<em><b>Messaging Connector Port</b></em>'
     * attribute. The default value is <code>"4457"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Messaging Connector Port</em>' attribute
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Messaging Connector Port</em>'
     *         attribute.
     * @see #setMessagingConnectorPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_MessagingConnectorPort()
     * @model default="4457"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getMessagingConnectorPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getMessagingConnectorPort <em>Messaging Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Messaging Connector Port</em>' attribute.
	 * @see #getMessagingConnectorPort()
	 * @generated
	 */
    void setMessagingConnectorPort(Port value);

    /**
     * Returns the value of the '<em><b>Remoting Connector Port</b></em>'
     * attribute. The default value is <code>"4446"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Remoting Connector Port</em>' attribute
     * isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Remoting Connector Port</em>'
     *         attribute.
     * @see #setRemotingConnectorPort(Port)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJBossBinding_RemotingConnectorPort()
     * @model default="4446"
     *        dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
     * @generated
     */
    Port getRemotingConnectorPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getRemotingConnectorPort <em>Remoting Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Remoting Connector Port</em>' attribute.
	 * @see #getRemotingConnectorPort()
	 * @generated
	 */
    void setRemotingConnectorPort(Port value);

} // JBossBinding
