/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>JOn AS</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getInstanceName <em>Instance Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getWebconnectors <em>Webconnectors</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasBase <em>Jonas Base</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasRoot <em>Jonas Root</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getDomain <em>Domain</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#isMaster <em>Master</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getClusters <em>Clusters</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getCmigroup <em>Cmigroup</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS()
 * @model
 * @generated
 */
public interface JOnAS extends IJavaEEServer, ILocatable {
    /**
     * Returns the value of the '<em><b>Name</b></em>' attribute. The
     * default value is <code>"JOnAS Application Server"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Name</em>' attribute.
     * @see #setName(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_Name()
     * @model default="JOnAS Application Server"
     * @generated
     */
    String getName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
    void setName(String value);

    /**
	 * Returns the value of the '<em><b>Instance Name</b></em>' attribute.
	 * The default value is <code>"jonas"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Instance Name</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Instance Name</em>' attribute.
	 * @see #setInstanceName(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_InstanceName()
	 * @model default="jonas"
	 * @generated
	 */
    String getInstanceName();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getInstanceName <em>Instance Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Instance Name</em>' attribute.
	 * @see #getInstanceName()
	 * @generated
	 */
    void setInstanceName(String value);

    /**
     * Returns the value of the '<em><b>Webconnectors</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.WebConnector}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Webconnectors</em>' containment reference
     * list isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Webconnectors</em>' containment
     *         reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_Webconnectors()
     * @model containment="true"
     * @generated
     */
    EList<WebConnector> getWebconnectors();

    /**
     * Returns the value of the '<em><b>Jonas Base</b></em>' attribute. The
     * default value is <code>"/home/jasmine/JONAS_4_8_4"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jonas Base</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Jonas Base</em>' attribute.
     * @see #setJonasBase(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_JonasBase()
     * @model default="/home/jasmine/JONAS_4_8_4"
     * @generated
     */
    String getJonasBase();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasBase <em>Jonas Base</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jonas Base</em>' attribute.
	 * @see #getJonasBase()
	 * @generated
	 */
    void setJonasBase(String value);

    /**
     * Returns the value of the '<em><b>Jonas Root</b></em>' attribute. The
     * default value is <code>"/home/jasmine/JONAS_4_8_4"</code>. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jonas Root</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Jonas Root</em>' attribute.
     * @see #setJonasRoot(String)
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_JonasRoot()
     * @model default="/home/jasmine/JONAS_4_8_4"
     * @generated
     */
    String getJonasRoot();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasRoot <em>Jonas Root</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jonas Root</em>' attribute.
	 * @see #getJonasRoot()
	 * @generated
	 */
    void setJonasRoot(String value);

    /**
	 * Returns the value of the '<em><b>Domain</b></em>' attribute.
	 * The default value is <code>"jonas"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Domain</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Domain</em>' attribute.
	 * @see #setDomain(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_Domain()
	 * @model default="jonas"
	 * @generated
	 */
    String getDomain();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getDomain <em>Domain</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Domain</em>' attribute.
	 * @see #getDomain()
	 * @generated
	 */
    void setDomain(String value);

    /**
	 * Returns the value of the '<em><b>Master</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Master</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Master</em>' attribute.
	 * @see #setMaster(boolean)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_Master()
	 * @model default="false"
	 * @generated
	 */
    boolean isMaster();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#isMaster <em>Master</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Master</em>' attribute.
	 * @see #isMaster()
	 * @generated
	 */
    void setMaster(boolean value);

    /**
     * Returns the value of the '<em><b>Clusters</b></em>' reference list.
     * The list contents are of type
     * {@link org.objectweb.jasmine.ui.jasminemodel.Cluster}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Clusters</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Clusters</em>' reference list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_Clusters()
     * @model
     * @generated
     */
    EList<Cluster> getClusters();

				/**
	 * Returns the value of the '<em><b>Cmigroup</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cmigroup</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cmigroup</em>' reference.
	 * @see #setCmigroup(CmiGroup)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJOnAS_Cmigroup()
	 * @model
	 * @generated
	 */
	CmiGroup getCmigroup();

				/**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getCmigroup <em>Cmigroup</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cmigroup</em>' reference.
	 * @see #getCmigroup()
	 * @generated
	 */
	void setCmigroup(CmiGroup value);

} // JOnAS
