/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage
 * @generated
 */
public interface JasminemodelFactory extends EFactory {
    /**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    JasminemodelFactory eINSTANCE = org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelFactoryImpl.init();

    /**
     * Returns a new object of class '<em>JASMI Ne</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>JASMI Ne</em>'.
     * @generated
     */
    JASMINe createJASMINe();

    /**
     * Returns a new object of class '<em>Server Pool</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Server Pool</em>'.
     * @generated
     */
    ServerPool createServerPool();

    /**
	 * Returns a new object of class '<em>Server</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Server</em>'.
	 * @generated
	 */
    Server createServer();

    /**
     * Returns a new object of class '<em>JASMI Ne Node</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>JASMI Ne Node</em>'.
     * @generated
     */
    JASMINeNode createJASMINeNode();

    /**
	 * Returns a new object of class '<em>Domain</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Domain</em>'.
	 * @generated
	 */
    Domain createDomain();

    /**
	 * Returns a new object of class '<em>Cluster</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Cluster</em>'.
	 * @generated
	 */
    Cluster createCluster();

    /**
	 * Returns a new object of class '<em>DB</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>DB</em>'.
	 * @generated
	 */
    DB createDB();

    /**
	 * Returns a new object of class '<em>JOn AS</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>JOn AS</em>'.
	 * @generated
	 */
    JOnAS createJOnAS();

    /**
     * Returns a new object of class '<em>Apache HTT Pd</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Apache HTT Pd</em>'.
     * @generated
     */
    Apache_HTTPd createApache_HTTPd();

    /**
     * Returns a new object of class '<em>Web Container</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Web Container</em>'.
     * @generated
     */
    WebContainer createWebContainer();

    /**
     * Returns a new object of class '<em>EJB Container</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>EJB Container</em>'.
     * @generated
     */
    EJBContainer createEJBContainer();

    /**
	 * Returns a new object of class '<em>Ejb Jar</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Jar</em>'.
	 * @generated
	 */
    EjbJar createEjbJar();

    /**
     * Returns a new object of class '<em>Mod JK Module</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Mod JK Module</em>'.
     * @generated
     */
    ModJKModule createModJKModule();

    /**
     * Returns a new object of class '<em>Rep HTTP Connector</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Rep HTTP Connector</em>'.
     * @generated
     */
    RepHTTPConnector createRepHTTPConnector();

    /**
     * Returns a new object of class '<em>HA Connector</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>HA Connector</em>'.
     * @generated
     */
    HAConnector createHAConnector();

    /**
     * Returns a new object of class '<em>IRMI Registry</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>IRMI Registry</em>'.
     * @generated
     */
    IRMIRegistry createIRMIRegistry();

    /**
	 * Returns a new object of class '<em>IIOP</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>IIOP</em>'.
	 * @generated
	 */
    IIOP createIIOP();

    /**
	 * Returns a new object of class '<em>JRMP</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>JRMP</em>'.
	 * @generated
	 */
    JRMP createJRMP();

    /**
	 * Returns a new object of class '<em>CMI</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>CMI</em>'.
	 * @generated
	 */
    CMI createCMI();

    /**
	 * Returns a new object of class '<em>IRMI</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>IRMI</em>'.
	 * @generated
	 */
    IRMI createIRMI();

    /**
     * Returns a new object of class '<em>Cmi Group</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Cmi Group</em>'.
     * @generated
     */
    CmiGroup createCmiGroup();

    /**
     * Returns a new object of class '<em>Ha Group</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Ha Group</em>'.
     * @generated
     */
    HaGroup createHaGroup();

    /**
     * Returns a new object of class '<em>Cluster Container</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Cluster Container</em>'.
     * @generated
     */
    ClusterContainer createClusterContainer();

    /**
     * Returns a new object of class '<em>HTTP Rep Group</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>HTTP Rep Group</em>'.
     * @generated
     */
    HTTP_RepGroup createHTTP_RepGroup();

    /**
     * Returns a new object of class '<em>RMI Group</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>RMI Group</em>'.
     * @generated
     */
    RMIGroup createRMIGroup();

    /**
	 * Returns a new object of class '<em>Db Link</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Db Link</em>'.
	 * @generated
	 */
    DbLink createDbLink();

    /**
     * Returns a new object of class '<em>Rmi Connector</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Rmi Connector</em>'.
     * @generated
     */
    RmiConnector createRmiConnector();

    /**
	 * Returns a new object of class '<em>AJP</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>AJP</em>'.
	 * @generated
	 */
    AJP createAJP();

    /**
	 * Returns a new object of class '<em>HTTP</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>HTTP</em>'.
	 * @generated
	 */
    HTTP createHTTP();

    /**
	 * Returns a new object of class '<em>HTTPS</em>'.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>HTTPS</em>'.
	 * @generated
	 */
    HTTPS createHTTPS();

    /**
     * Returns a new object of class '<em>Jms Service</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Jms Service</em>'.
     * @generated
     */
    JmsService createJmsService();

    /**
     * Returns a new object of class '<em>Discovery Service</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Discovery Service</em>'.
     * @generated
     */
    DiscoveryService createDiscoveryService();

    /**
     * Returns a new object of class '<em>Middleware Component</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Middleware Component</em>'.
     * @generated
     */
    MiddlewareComponent createMiddlewareComponent();

    /**
     * Returns a new object of class '<em>Apache Properties</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>Apache Properties</em>'.
     * @generated
     */
    ApacheProperties createApacheProperties();

    /**
	 * Returns a new object of class '<em>Apache Middleware Properties</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Apache Middleware Properties</em>'.
	 * @generated
	 */
    ApacheMiddlewareProperties createApacheMiddlewareProperties();

    /**
     * Returns a new object of class '<em>JBoss AS</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>JBoss AS</em>'.
     * @generated
     */
    JBossAS createJBossAS();

    /**
     * Returns a new object of class '<em>JBoss Binding</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>JBoss Binding</em>'.
     * @generated
     */
    JBossBinding createJBossBinding();

    /**
     * Returns a new object of class '<em>IJ Boss Connector</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>IJ Boss Connector</em>'.
     * @generated
     */
    IJBossConnector createIJBossConnector();

    /**
     * Returns a new object of class '<em>JBoss HA Connector</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>JBoss HA Connector</em>'.
     * @generated
     */
    JBossHAConnector createJBossHAConnector();

    /**
	 * Returns a new object of class '<em>JBoss HTTP Rep Connector</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>JBoss HTTP Rep Connector</em>'.
	 * @generated
	 */
    JBossHTTPRepConnector createJBossHTTPRepConnector();

    /**
     * Returns a new object of class '<em>JBoss HA Group</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>JBoss HA Group</em>'.
     * @generated
     */
    JBossHAGroup createJBossHAGroup();

    /**
     * Returns a new object of class '<em>JBoss Mod JK Connector</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return a new object of class '<em>JBoss Mod JK Connector</em>'.
     * @generated
     */
    JBossModJKConnector createJBossModJKConnector();

    /**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
    JasminemodelPackage getJasminemodelPackage();

} // JasminemodelFactory
