/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Jms Service</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmxServiceURL <em>Jmx Service URL</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsPort <em>Jms Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsTopics <em>Jms Topics</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsQueues <em>Jms Queues</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJmsService()
 * @model
 * @generated
 */
public interface JmsService extends EObject {
    /**
	 * Returns the value of the '<em><b>Jmx Service URL</b></em>' attribute.
	 * The default value is <code>"service:jmx:rmi://jndi/rmi://localhost:9098/jasmine"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jmx Service URL</em>' attribute isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jmx Service URL</em>' attribute.
	 * @see #setJmxServiceURL(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJmsService_JmxServiceURL()
	 * @model default="service:jmx:rmi://jndi/rmi://localhost:9098/jasmine"
	 * @generated
	 */
    String getJmxServiceURL();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmxServiceURL <em>Jmx Service URL</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jmx Service URL</em>' attribute.
	 * @see #getJmxServiceURL()
	 * @generated
	 */
    void setJmxServiceURL(String value);

    /**
	 * Returns the value of the '<em><b>Jms Port</b></em>' attribute.
	 * The default value is <code>"16010"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jms Port</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jms Port</em>' attribute.
	 * @see #setJmsPort(Port)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJmsService_JmsPort()
	 * @model default="16010" dataType="org.objectweb.jasmine.ui.jasminemodel.Port"
	 * @generated
	 */
    Port getJmsPort();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsPort <em>Jms Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jms Port</em>' attribute.
	 * @see #getJmsPort()
	 * @generated
	 */
    void setJmsPort(Port value);

    /**
     * Returns the value of the '<em><b>Jms Topics</b></em>' attribute
     * list. The list contents are of type {@link java.lang.String}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jms Topics</em>' attribute list isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Jms Topics</em>' attribute list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJmsService_JmsTopics()
     * @model default="sampleTopic,invoiceTopic"
     * @generated
     */
    EList<String> getJmsTopics();

    /**
     * Returns the value of the '<em><b>Jms Queues</b></em>' attribute
     * list. The list contents are of type {@link java.lang.String}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jms Queues</em>' attribute list isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     *
     * @return the value of the '<em>Jms Queues</em>' attribute list.
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJmsService_JmsQueues()
     * @model default="SampleQueue,OrderApprovalQueue,OrdersQueue,MailCompletedOrderQueue,SupPurchaseOrderQueue,MailOrderApprovalQueue,mailQueue"
     * @generated
     */
    EList<String> getJmsQueues();

    /**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * The default value is <code>"JMS Service "</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getJmsService_Name()
	 * @model default="JMS Service " changeable="false"
	 * @generated
	 */
    String getName();

} // JmsService
