/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import java.net.InetAddress;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Web Container</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getType <em>Type</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getJvmRoute <em>Jvm Route</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getHost <em>Host</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getWebContainer()
 * @model
 * @generated
 */
public interface WebContainer extends IContainer {
    /**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The literals are from the enumeration {@link org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation}.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Type</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation
	 * @see #setType(WebContainerImplementation)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getWebContainer_Type()
	 * @model
	 * @generated
	 */
    WebContainerImplementation getType();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation
	 * @see #getType()
	 * @generated
	 */
    void setType(WebContainerImplementation value);

    /**
	 * Returns the value of the '<em><b>Jvm Route</b></em>' attribute.
	 * The default value is <code>"jvmroute"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Jvm Route</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Jvm Route</em>' attribute.
	 * @see #setJvmRoute(String)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getWebContainer_JvmRoute()
	 * @model default="jvmroute"
	 * @generated
	 */
    String getJvmRoute();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getJvmRoute <em>Jvm Route</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jvm Route</em>' attribute.
	 * @see #getJvmRoute()
	 * @generated
	 */
    void setJvmRoute(String value);

    /**
	 * Returns the value of the '<em><b>Host</b></em>' attribute.
	 * The default value is <code>"localhost"</code>.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Host</em>' attribute isn't clear, there
     * really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Host</em>' attribute.
	 * @see #setHost(InetAddress)
	 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getWebContainer_Host()
	 * @model default="localhost" dataType="org.objectweb.jasmine.ui.jasminemodel.InetAddress"
	 * @generated
	 */
    InetAddress getHost();

    /**
	 * Sets the value of the '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getHost <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Host</em>' attribute.
	 * @see #getHost()
	 * @generated
	 */
    void setHost(InetAddress value);

} // WebContainer
