/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>Web Container Implementation</b></em>',
 * and utility methods for working with them. <!-- end-user-doc -->
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#getWebContainerImplementation()
 * @model
 * @generated
 */
public enum WebContainerImplementation implements Enumerator {
    /**
	 * The '<em><b>Tomcat 0</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #TOMCAT_0_VALUE
	 * @generated
	 * @ordered
	 */
    TOMCAT_0(0, "Tomcat_0", "apache-tomcat-5.5.30"),

    /**
	 * The '<em><b>Tomcat 1</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #TOMCAT_1_VALUE
	 * @generated
	 * @ordered
	 */
    TOMCAT_1(1, "Tomcat_1", "apache-tomcat-5.5.17"),

    /**
	 * The '<em><b>Tomcat 2</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #TOMCAT_2_VALUE
	 * @generated
	 * @ordered
	 */
    TOMCAT_2(2, "Tomcat_2", "apache-tomcat-5.5.15"),

    /**
	 * The '<em><b>Tomcat 3</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #TOMCAT_3_VALUE
	 * @generated
	 * @ordered
	 */
    TOMCAT_3(3, "Tomcat_3", "apache-tomcat-4.1.30"),

    /**
	 * The '<em><b>Jetty 0</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #JETTY_0_VALUE
	 * @generated
	 * @ordered
	 */
    JETTY_0(4, "Jetty_0", "jetty-5.1.12"),

    /**
	 * The '<em><b>Jetty 1</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #JETTY_1_VALUE
	 * @generated
	 * @ordered
	 */
    JETTY_1(5, "Jetty_1", "jetty-5.1.10"),

    /**
	 * The '<em><b>Jetty 2</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #JETTY_2_VALUE
	 * @generated
	 * @ordered
	 */
    JETTY_2(6, "Jetty_2", "jetty-4.2.18");

    /**
	 * The '<em><b>Tomcat 0</b></em>' literal value.
	 * <!-- begin-user-doc
     * -->
     * <p>
     * If the meaning of '<em><b>Tomcat 0</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #TOMCAT_0
	 * @model name="Tomcat_0" literal="apache-tomcat-5.5.30"
	 * @generated
	 * @ordered
	 */
    public static final int TOMCAT_0_VALUE = 0;

    /**
	 * The '<em><b>Tomcat 1</b></em>' literal value.
	 * <!-- begin-user-doc
     * -->
     * <p>
     * If the meaning of '<em><b>Tomcat 1</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #TOMCAT_1
	 * @model name="Tomcat_1" literal="apache-tomcat-5.5.17"
	 * @generated
	 * @ordered
	 */
    public static final int TOMCAT_1_VALUE = 1;

    /**
	 * The '<em><b>Tomcat 2</b></em>' literal value.
	 * <!-- begin-user-doc
     * -->
     * <p>
     * If the meaning of '<em><b>Tomcat 2</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #TOMCAT_2
	 * @model name="Tomcat_2" literal="apache-tomcat-5.5.15"
	 * @generated
	 * @ordered
	 */
    public static final int TOMCAT_2_VALUE = 2;

    /**
	 * The '<em><b>Tomcat 3</b></em>' literal value.
	 * <!-- begin-user-doc
     * -->
     * <p>
     * If the meaning of '<em><b>Tomcat 3</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #TOMCAT_3
	 * @model name="Tomcat_3" literal="apache-tomcat-4.1.30"
	 * @generated
	 * @ordered
	 */
    public static final int TOMCAT_3_VALUE = 3;

    /**
	 * The '<em><b>Jetty 0</b></em>' literal value.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Jetty 0</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #JETTY_0
	 * @model name="Jetty_0" literal="jetty-5.1.12"
	 * @generated
	 * @ordered
	 */
    public static final int JETTY_0_VALUE = 4;

    /**
	 * The '<em><b>Jetty 1</b></em>' literal value.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Jetty 1</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #JETTY_1
	 * @model name="Jetty_1" literal="jetty-5.1.10"
	 * @generated
	 * @ordered
	 */
    public static final int JETTY_1_VALUE = 5;

    /**
	 * The '<em><b>Jetty 2</b></em>' literal value.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Jetty 2</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #JETTY_2
	 * @model name="Jetty_2" literal="jetty-4.2.18"
	 * @generated
	 * @ordered
	 */
    public static final int JETTY_2_VALUE = 6;

    /**
	 * An array of all the '<em><b>Web Container Implementation</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private static final WebContainerImplementation[] VALUES_ARRAY = new WebContainerImplementation[] {
			TOMCAT_0,
			TOMCAT_1,
			TOMCAT_2,
			TOMCAT_3,
			JETTY_0,
			JETTY_1,
			JETTY_2,
		};

    /**
	 * A public read-only list of all the '<em><b>Web Container Implementation</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final List<WebContainerImplementation> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
	 * Returns the '<em><b>Web Container Implementation</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public static WebContainerImplementation get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			WebContainerImplementation result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Web Container Implementation</b></em>' literal with the specified name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static WebContainerImplementation getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			WebContainerImplementation result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Web Container Implementation</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public static WebContainerImplementation get(int value) {
		switch (value) {
			case TOMCAT_0_VALUE: return TOMCAT_0;
			case TOMCAT_1_VALUE: return TOMCAT_1;
			case TOMCAT_2_VALUE: return TOMCAT_2;
			case TOMCAT_3_VALUE: return TOMCAT_3;
			case JETTY_0_VALUE: return JETTY_0;
			case JETTY_1_VALUE: return JETTY_1;
			case JETTY_2_VALUE: return JETTY_2;
		}
		return null;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final int value;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String name;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String literal;

    /**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    private WebContainerImplementation(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public int getValue() {
	  return value;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
	  return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getLiteral() {
	  return literal;
	}

    /**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		return literal;
	}

} // WebContainerImplementation
