/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.resource.Resource;

import org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Apache Middleware Properties</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getName <em>Name</em>}</li>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getPropertyFile <em>Property File</em>}</li>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getDescription <em>Description</em>}</li>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getInstance_apache_home <em>Instance apache home</em>}</li>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getServer_listen_adress <em>Server listen adress</em>}</li>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getServer_listen_port <em>Server listen port</em>}</li>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getServer_user <em>Server user</em>}</li>
 * <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl#getServer_group <em>Server group</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ApacheMiddlewarePropertiesImpl extends EObjectImpl implements
        ApacheMiddlewareProperties {
    /**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated
     * @ordered
     */
    protected static final String NAME_EDEFAULT = "New extended property";

    /**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated
     * @ordered
     */
    protected String name = NAME_EDEFAULT;

    /**
     * The default value of the '{@link #getPropertyFile() <em>Property File</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getPropertyFile()
     * @generated
     * @ordered
     */
    protected static final Resource PROPERTY_FILE_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getPropertyFile() <em>Property File</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getPropertyFile()
     * @generated
     * @ordered
     */
    protected Resource propertyFile = PROPERTY_FILE_EDEFAULT;

    /**
     * The default value of the '{@link #getDescription() <em>Description</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getDescription()
     * @generated
     * @ordered
     */
    protected static final String DESCRIPTION_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getDescription() <em>Description</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getDescription()
     * @generated
     * @ordered
     */
    protected String description = DESCRIPTION_EDEFAULT;

    /**
     * The default value of the '{@link #getInstance_apache_home() <em>Instance apache home</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getInstance_apache_home()
     * @generated
     * @ordered
     */
    protected static final String INSTANCE_APACHE_HOME_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getInstance_apache_home() <em>Instance apache home</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getInstance_apache_home()
     * @generated
     * @ordered
     */
    protected String instance_apache_home = INSTANCE_APACHE_HOME_EDEFAULT;

    /**
     * The default value of the '{@link #getServer_listen_adress() <em>Server listen adress</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_listen_adress()
     * @generated
     * @ordered
     */
    protected static final String SERVER_LISTEN_ADRESS_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getServer_listen_adress() <em>Server listen adress</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_listen_adress()
     * @generated
     * @ordered
     */
    protected String server_listen_adress = SERVER_LISTEN_ADRESS_EDEFAULT;

    /**
     * The default value of the '{@link #getServer_listen_port() <em>Server listen port</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_listen_port()
     * @generated
     * @ordered
     */
    protected static final String SERVER_LISTEN_PORT_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getServer_listen_port() <em>Server listen port</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_listen_port()
     * @generated
     * @ordered
     */
    protected String server_listen_port = SERVER_LISTEN_PORT_EDEFAULT;

    /**
     * The default value of the '{@link #getServer_user() <em>Server user</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_user()
     * @generated
     * @ordered
     */
    protected static final String SERVER_USER_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getServer_user() <em>Server user</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_user()
     * @generated
     * @ordered
     */
    protected String server_user = SERVER_USER_EDEFAULT;

    /**
     * The default value of the '{@link #getServer_group() <em>Server group</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_group()
     * @generated
     * @ordered
     */
    protected static final String SERVER_GROUP_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getServer_group() <em>Server group</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getServer_group()
     * @generated
     * @ordered
     */
    protected String server_group = SERVER_GROUP_EDEFAULT;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected ApacheMiddlewarePropertiesImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return JasminemodelPackage.Literals.APACHE_MIDDLEWARE_PROPERTIES;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__NAME,
                    oldName, name));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public Resource getPropertyFile() {
        return propertyFile;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setPropertyFile(Resource newPropertyFile) {
        Resource oldPropertyFile = propertyFile;
        propertyFile = newPropertyFile;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__PROPERTY_FILE,
                    oldPropertyFile, propertyFile));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public String getDescription() {
        return description;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setDescription(String newDescription) {
        String oldDescription = description;
        description = newDescription;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__DESCRIPTION,
                    oldDescription, description));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public String getInstance_apache_home() {
        return instance_apache_home;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setInstance_apache_home(String newInstance_apache_home) {
        String oldInstance_apache_home = instance_apache_home;
        instance_apache_home = newInstance_apache_home;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME,
                    oldInstance_apache_home, instance_apache_home));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public String getServer_listen_adress() {
        return server_listen_adress;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setServer_listen_adress(String newServer_listen_adress) {
        String oldServer_listen_adress = server_listen_adress;
        server_listen_adress = newServer_listen_adress;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS,
                    oldServer_listen_adress, server_listen_adress));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public String getServer_listen_port() {
        return server_listen_port;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setServer_listen_port(String newServer_listen_port) {
        String oldServer_listen_port = server_listen_port;
        server_listen_port = newServer_listen_port;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT,
                    oldServer_listen_port, server_listen_port));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public String getServer_user() {
        return server_user;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setServer_user(String newServer_user) {
        String oldServer_user = server_user;
        server_user = newServer_user;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER,
                    oldServer_user, server_user));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public String getServer_group() {
        return server_group;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void setServer_group(String newServer_group) {
        String oldServer_group = server_group;
        server_group = newServer_group;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP,
                    oldServer_group, server_group));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__NAME:
            return getName();
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__PROPERTY_FILE:
            return getPropertyFile();
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__DESCRIPTION:
            return getDescription();
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME:
            return getInstance_apache_home();
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS:
            return getServer_listen_adress();
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT:
            return getServer_listen_port();
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER:
            return getServer_user();
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP:
            return getServer_group();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__NAME:
            setName((String) newValue);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__PROPERTY_FILE:
            setPropertyFile((Resource) newValue);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__DESCRIPTION:
            setDescription((String) newValue);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME:
            setInstance_apache_home((String) newValue);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS:
            setServer_listen_adress((String) newValue);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT:
            setServer_listen_port((String) newValue);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER:
            setServer_user((String) newValue);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP:
            setServer_group((String) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__NAME:
            setName(NAME_EDEFAULT);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__PROPERTY_FILE:
            setPropertyFile(PROPERTY_FILE_EDEFAULT);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__DESCRIPTION:
            setDescription(DESCRIPTION_EDEFAULT);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME:
            setInstance_apache_home(INSTANCE_APACHE_HOME_EDEFAULT);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS:
            setServer_listen_adress(SERVER_LISTEN_ADRESS_EDEFAULT);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT:
            setServer_listen_port(SERVER_LISTEN_PORT_EDEFAULT);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER:
            setServer_user(SERVER_USER_EDEFAULT);
            return;
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP:
            setServer_group(SERVER_GROUP_EDEFAULT);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
                    .equals(name);
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__PROPERTY_FILE:
            return PROPERTY_FILE_EDEFAULT == null ? propertyFile != null
                    : !PROPERTY_FILE_EDEFAULT.equals(propertyFile);
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__DESCRIPTION:
            return DESCRIPTION_EDEFAULT == null ? description != null
                    : !DESCRIPTION_EDEFAULT.equals(description);
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME:
            return INSTANCE_APACHE_HOME_EDEFAULT == null ? instance_apache_home != null
                    : !INSTANCE_APACHE_HOME_EDEFAULT
                            .equals(instance_apache_home);
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS:
            return SERVER_LISTEN_ADRESS_EDEFAULT == null ? server_listen_adress != null
                    : !SERVER_LISTEN_ADRESS_EDEFAULT
                            .equals(server_listen_adress);
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT:
            return SERVER_LISTEN_PORT_EDEFAULT == null ? server_listen_port != null
                    : !SERVER_LISTEN_PORT_EDEFAULT.equals(server_listen_port);
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER:
            return SERVER_USER_EDEFAULT == null ? server_user != null
                    : !SERVER_USER_EDEFAULT.equals(server_user);
        case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP:
            return SERVER_GROUP_EDEFAULT == null ? server_group != null
                    : !SERVER_GROUP_EDEFAULT.equals(server_group);
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (name: ");
        result.append(name);
        result.append(", propertyFile: ");
        result.append(propertyFile);
        result.append(", description: ");
        result.append(description);
        result.append(", instance_apache_home: ");
        result.append(instance_apache_home);
        result.append(", server_listen_adress: ");
        result.append(server_listen_adress);
        result.append(", server_listen_port: ");
        result.append(server_listen_port);
        result.append(", server_user: ");
        result.append(server_user);
        result.append(", server_group: ");
        result.append(server_group);
        result.append(')');
        return result.toString();
    }

} // ApacheMiddlewarePropertiesImpl
