/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.net.InetAddress;
import java.util.Collection;
import java.util.Iterator;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.objectweb.jasmine.ui.jasminemodel.AJP;
import org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd;
import org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IModule;
import org.objectweb.jasmine.ui.jasminemodel.JOnAS;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.WebConnector;
import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;
import org.objectweb.jasmine.ui.jasminemodel.properties.ApacheLoadProperties;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Apache HTT Pd</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getJavaeeServers <em>Javaee Servers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getModules <em>Modules</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getHome <em>Home</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getHost <em>Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getPort <em>Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getUser <em>User</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl#getGroup <em>Group</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class Apache_HTTPdImpl extends MiddlewareComponentImpl implements
        Apache_HTTPd {
    /**
	 * The cached value of the '{@link #getJavaeeServers() <em>Javaee Servers</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getJavaeeServers()
	 * @generated
	 * @ordered
	 */
	protected EList<IJavaEEServer> javaeeServers;

				/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "Apache HTTPd Server";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * The cached value of the '{@link #getModules() <em>Modules</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getModules()
	 * @generated
	 * @ordered
	 */
    protected EList<IModule> modules;

    /**
	 * The default value of the '{@link #getHome() <em>Home</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHome()
	 * @generated
	 * @ordered
	 */
    protected static final String HOME_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getHome() <em>Home</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHome()
	 * @generated
	 * @ordered
	 */
    protected String home = HOME_EDEFAULT;

    /**
	 * The default value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected static final InetAddress HOST_EDEFAULT = (InetAddress)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getInetAddress(), "localhost");

    /**
	 * The cached value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected InetAddress host = HOST_EDEFAULT;

    /**
	 * The default value of the '{@link #getPort() <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "80");

    /**
	 * The cached value of the '{@link #getPort() <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPort()
	 * @generated
	 * @ordered
	 */
    protected Port port = PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getUser() <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUser()
	 * @generated
	 * @ordered
	 */
    protected static final String USER_EDEFAULT = "www-data";

    /**
	 * The cached value of the '{@link #getUser() <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUser()
	 * @generated
	 * @ordered
	 */
    protected String user = USER_EDEFAULT;

    /**
	 * The default value of the '{@link #getGroup() <em>Group</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGroup()
	 * @generated
	 * @ordered
	 */
    protected static final String GROUP_EDEFAULT = "www-data";

    /**
	 * The cached value of the '{@link #getGroup() <em>Group</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGroup()
	 * @generated
	 * @ordered
	 */
    protected String group = GROUP_EDEFAULT;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    protected Apache_HTTPdImpl() {
        super();

        try {
            setApp(new org.objectweb.jasmine.jade.application.ApplicationImpl(
                    "apache"));
        } catch (Exception e) {
            e.printStackTrace();
        }

        ApacheLoadProperties.load(this);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.APACHE_HTT_PD;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<IJavaEEServer> getJavaeeServers() {
		if (javaeeServers == null) {
			javaeeServers = new EObjectWithInverseResolvingEList.ManyInverse<IJavaEEServer>(IJavaEEServer.class, this, JasminemodelPackage.APACHE_HTT_PD__JAVAEE_SERVERS, JasminemodelPackage.IJAVA_EE_SERVER__HTTP_SERVERS);
		}
		return javaeeServers;
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.APACHE_HTT_PD__NAME, oldName, name));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IModule> getModules() {
		if (modules == null) {
			modules = new EObjectContainmentEList<IModule>(IModule.class, this, JasminemodelPackage.APACHE_HTT_PD__MODULES);
		}
		return modules;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getHome() {
		return home;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHome(String newHome) {
		String oldHome = home;
		home = newHome;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.APACHE_HTT_PD__HOME, oldHome, home));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public InetAddress getHost() {
		return host;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHost(InetAddress newHost) {
		InetAddress oldHost = host;
		host = newHost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.APACHE_HTT_PD__HOST, oldHost, host));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getPort() {
		return port;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setPort(Port newPort) {
		Port oldPort = port;
		port = newPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.APACHE_HTT_PD__PORT, oldPort, port));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getUser() {
		return user;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setUser(String newUser) {
		String oldUser = user;
		user = newUser;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.APACHE_HTT_PD__USER, oldUser, user));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getGroup() {
		return group;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setGroup(String newGroup) {
		String oldGroup = group;
		group = newGroup;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.APACHE_HTT_PD__GROUP, oldGroup, group));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getIpAddress() {
        try {
            return jasmineNode.getHost().getHostAddress();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getNodeId() {
        try {
            return jasmineNode.getNodeId().toString();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getInstanceHome() {
        try {
            return getHome();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.APACHE_HTT_PD__JAVAEE_SERVERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getJavaeeServers()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void configure(IMiddlewareComponent middleware) {

        if (middleware instanceof Apache_HTTPd) {

            Apache_HTTPd apache = (Apache_HTTPd) middleware;

            org.objectweb.jasmine.jade.application.ApplicationImpl dep = (org.objectweb.jasmine.jade.application.ApplicationImpl) apache
                    .getApp();

            try {

                dep.setAttribute("instance-apache-home", apache.getHome());
                dep.setAttribute("server-listen-address", apache.getHost()
                        .getHostAddress());
                dep.setAttribute("server-listen-port", apache.getPort()
                        .toString());
                dep.setAttribute("server-user", apache.getUser());
                dep.setAttribute("server-group", apache.getGroup());

            } catch (Exception e) {
                e.printStackTrace();
            }

            Iterator<IJavaEEServer> it = getJavaeeServers().iterator();

            while(it.hasNext()){
            	IJavaEEServer javaeeServer = it.next();

            	if(javaeeServer instanceof JOnAS){
            		JOnAS jonas = (JOnAS) javaeeServer;

            		Iterator<WebConnector> ite = jonas.getWebconnectors().iterator();

            		while(ite.hasNext()){
            			WebConnector webConnector = ite.next();
            			if(webConnector instanceof AJP){
            				AJP ajp = (AJP) webConnector;
            				String workerName = ajp.getName();
            				String host = jonas.getJasmineNode().getHost().getHostAddress();
            				Port p = ajp.getPort();

            				try {
								dep.setAttribute("workers", workerName + "," + host + "," + p.toString());
							} catch (Exception e) {
								e.printStackTrace();
							}
            			}
            		}
            	}
            }
        }
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.APACHE_HTT_PD__JAVAEE_SERVERS:
				return ((InternalEList<?>)getJavaeeServers()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.APACHE_HTT_PD__MODULES:
				return ((InternalEList<?>)getModules()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.APACHE_HTT_PD__JAVAEE_SERVERS:
				return getJavaeeServers();
			case JasminemodelPackage.APACHE_HTT_PD__NAME:
				return getName();
			case JasminemodelPackage.APACHE_HTT_PD__MODULES:
				return getModules();
			case JasminemodelPackage.APACHE_HTT_PD__HOME:
				return getHome();
			case JasminemodelPackage.APACHE_HTT_PD__HOST:
				return getHost();
			case JasminemodelPackage.APACHE_HTT_PD__PORT:
				return getPort();
			case JasminemodelPackage.APACHE_HTT_PD__USER:
				return getUser();
			case JasminemodelPackage.APACHE_HTT_PD__GROUP:
				return getGroup();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.APACHE_HTT_PD__JAVAEE_SERVERS:
				getJavaeeServers().clear();
				getJavaeeServers().addAll((Collection<? extends IJavaEEServer>)newValue);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__NAME:
				setName((String)newValue);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__MODULES:
				getModules().clear();
				getModules().addAll((Collection<? extends IModule>)newValue);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__HOME:
				setHome((String)newValue);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__HOST:
				setHost((InetAddress)newValue);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__PORT:
				setPort((Port)newValue);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__USER:
				setUser((String)newValue);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__GROUP:
				setGroup((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.APACHE_HTT_PD__JAVAEE_SERVERS:
				getJavaeeServers().clear();
				return;
			case JasminemodelPackage.APACHE_HTT_PD__NAME:
				setName(NAME_EDEFAULT);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__MODULES:
				getModules().clear();
				return;
			case JasminemodelPackage.APACHE_HTT_PD__HOME:
				setHome(HOME_EDEFAULT);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__HOST:
				setHost(HOST_EDEFAULT);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__PORT:
				setPort(PORT_EDEFAULT);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__USER:
				setUser(USER_EDEFAULT);
				return;
			case JasminemodelPackage.APACHE_HTT_PD__GROUP:
				setGroup(GROUP_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.APACHE_HTT_PD__JAVAEE_SERVERS:
				return javaeeServers != null && !javaeeServers.isEmpty();
			case JasminemodelPackage.APACHE_HTT_PD__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case JasminemodelPackage.APACHE_HTT_PD__MODULES:
				return modules != null && !modules.isEmpty();
			case JasminemodelPackage.APACHE_HTT_PD__HOME:
				return HOME_EDEFAULT == null ? home != null : !HOME_EDEFAULT.equals(home);
			case JasminemodelPackage.APACHE_HTT_PD__HOST:
				return HOST_EDEFAULT == null ? host != null : !HOST_EDEFAULT.equals(host);
			case JasminemodelPackage.APACHE_HTT_PD__PORT:
				return PORT_EDEFAULT == null ? port != null : !PORT_EDEFAULT.equals(port);
			case JasminemodelPackage.APACHE_HTT_PD__USER:
				return USER_EDEFAULT == null ? user != null : !USER_EDEFAULT.equals(user);
			case JasminemodelPackage.APACHE_HTT_PD__GROUP:
				return GROUP_EDEFAULT == null ? group != null : !GROUP_EDEFAULT.equals(group);
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (Name: ");
		result.append(name);
		result.append(", home: ");
		result.append(home);
		result.append(", host: ");
		result.append(host);
		result.append(", port: ");
		result.append(port);
		result.append(", user: ");
		result.append(user);
		result.append(", group: ");
		result.append(group);
		result.append(')');
		return result.toString();
	}

} // Apache_HTTPdImpl
