/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.net.InetAddress;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.objectweb.jasmine.ui.jasminemodel.CMIConnector;
import org.objectweb.jasmine.ui.jasminemodel.CmiGroup;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Cmi Group</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.CmiGroupImpl#isLanMode <em>Lan Mode</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.CmiGroupImpl#getTcpPingHost <em>Tcp Ping Host</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CmiGroupImpl extends ConfigurationNodeImpl implements CmiGroup {
    /**
	 * The default value of the '{@link #isLanMode() <em>Lan Mode</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isLanMode()
	 * @generated
	 * @ordered
	 */
    protected static final boolean LAN_MODE_EDEFAULT = true;

    /**
	 * The cached value of the '{@link #isLanMode() <em>Lan Mode</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isLanMode()
	 * @generated
	 * @ordered
	 */
    protected boolean lanMode = LAN_MODE_EDEFAULT;

    /**
	 * The default value of the '{@link #getTcpPingHost() <em>Tcp Ping Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTcpPingHost()
	 * @generated
	 * @ordered
	 */
    protected static final InetAddress TCP_PING_HOST_EDEFAULT = (InetAddress)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getInetAddress(), "localhost");

    /**
	 * The cached value of the '{@link #getTcpPingHost() <em>Tcp Ping Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTcpPingHost()
	 * @generated
	 * @ordered
	 */
    protected InetAddress tcpPingHost = TCP_PING_HOST_EDEFAULT;

    /**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected static final String NAME_EDEFAULT = "CMI";

    /**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected String name = NAME_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected CmiGroupImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.CMI_GROUP;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public boolean isLanMode() {
		return lanMode;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setLanMode(boolean newLanMode) {
		boolean oldLanMode = lanMode;
		lanMode = newLanMode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.CMI_GROUP__LAN_MODE, oldLanMode, lanMode));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public InetAddress getTcpPingHost() {
		return tcpPingHost;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setTcpPingHost(InetAddress newTcpPingHost) {
		InetAddress oldTcpPingHost = tcpPingHost;
		tcpPingHost = newTcpPingHost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.CMI_GROUP__TCP_PING_HOST, oldTcpPingHost, tcpPingHost));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    JasminemodelPackage.CMI_GROUP__NAME, oldName, name));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case JasminemodelPackage.CMI_GROUP__LAN_MODE:
            return isLanMode() ? Boolean.TRUE : Boolean.FALSE;
        case JasminemodelPackage.CMI_GROUP__TCP_PING_HOST:
            return getTcpPingHost();
        case JasminemodelPackage.CMI_GROUP__NAME:
            return getName();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case JasminemodelPackage.CMI_GROUP__LAN_MODE:
            setLanMode(((Boolean) newValue).booleanValue());
            return;
        case JasminemodelPackage.CMI_GROUP__TCP_PING_HOST:
            setTcpPingHost((InetAddress) newValue);
            return;
        case JasminemodelPackage.CMI_GROUP__NAME:
            setName((String) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.CMI_GROUP__LAN_MODE:
            setLanMode(LAN_MODE_EDEFAULT);
            return;
        case JasminemodelPackage.CMI_GROUP__TCP_PING_HOST:
            setTcpPingHost(TCP_PING_HOST_EDEFAULT);
            return;
        case JasminemodelPackage.CMI_GROUP__NAME:
            setName(NAME_EDEFAULT);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.CMI_GROUP__LAN_MODE:
            return lanMode != LAN_MODE_EDEFAULT;
        case JasminemodelPackage.CMI_GROUP__TCP_PING_HOST:
            return TCP_PING_HOST_EDEFAULT == null ? tcpPingHost != null
                    : !TCP_PING_HOST_EDEFAULT.equals(tcpPingHost);
        case JasminemodelPackage.CMI_GROUP__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
                    .equals(name);
        }
        return super.eIsSet(featureID);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (lanMode: ");
		result.append(lanMode);
		result.append(", tcpPingHost: ");
		result.append(tcpPingHost);
		result.append(')');
		return result.toString();
	}

} // CmiGroupImpl
