/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.objectweb.jasmine.ui.jasminemodel.DB;
import org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>DB</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getProvider <em>Provider</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getUser <em>User</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getPassword <em>Password</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getUrl <em>Url</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getDriverName <em>Driver Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getJndiName <em>Jndi Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getJdbcDriverJarFile <em>Jdbc Driver Jar File</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getMappernName <em>Mappern Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getPort <em>Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl#getJasmineNode <em>Jasmine Node</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DBImpl extends EObjectImpl implements DB {
    /**
	 * The default value of the '{@link #getProvider() <em>Provider</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getProvider()
	 * @generated
	 * @ordered
	 */
    protected static final DatabaseProvider PROVIDER_EDEFAULT = DatabaseProvider.HSQL;

    /**
	 * The cached value of the '{@link #getProvider() <em>Provider</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getProvider()
	 * @generated
	 * @ordered
	 */
    protected DatabaseProvider provider = PROVIDER_EDEFAULT;

    /**
	 * The default value of the '{@link #getUser() <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUser()
	 * @generated
	 * @ordered
	 */
    protected static final String USER_EDEFAULT = "jonas";

    /**
	 * The cached value of the '{@link #getUser() <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUser()
	 * @generated
	 * @ordered
	 */
    protected String user = USER_EDEFAULT;

    /**
	 * The default value of the '{@link #getPassword() <em>Password</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPassword()
	 * @generated
	 * @ordered
	 */
    protected static final String PASSWORD_EDEFAULT = "jonas";

    /**
	 * The cached value of the '{@link #getPassword() <em>Password</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPassword()
	 * @generated
	 * @ordered
	 */
    protected String password = PASSWORD_EDEFAULT;

    /**
	 * The default value of the '{@link #getUrl() <em>Url</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUrl()
	 * @generated
	 * @ordered
	 */
    protected static final String URL_EDEFAULT = "jdbc:hsqldb:hsql://localhost:9005/db_jonas";

    /**
	 * The cached value of the '{@link #getUrl() <em>Url</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUrl()
	 * @generated
	 * @ordered
	 */
    protected String url = URL_EDEFAULT;

    /**
	 * The default value of the '{@link #getDriverName() <em>Driver Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDriverName()
	 * @generated
	 * @ordered
	 */
    protected static final String DRIVER_NAME_EDEFAULT = "org.hsqldb.jdbcDriver";

    /**
	 * The cached value of the '{@link #getDriverName() <em>Driver Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDriverName()
	 * @generated
	 * @ordered
	 */
    protected String driverName = DRIVER_NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getJndiName() <em>Jndi Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJndiName()
	 * @generated
	 * @ordered
	 */
    protected static final String JNDI_NAME_EDEFAULT = "jdbc_1";

    /**
	 * The cached value of the '{@link #getJndiName() <em>Jndi Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJndiName()
	 * @generated
	 * @ordered
	 */
    protected String jndiName = JNDI_NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getJdbcDriverJarFile() <em>Jdbc Driver Jar File</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJdbcDriverJarFile()
	 * @generated
	 * @ordered
	 */
    protected static final String JDBC_DRIVER_JAR_FILE_EDEFAULT = "none";

    /**
	 * The cached value of the '{@link #getJdbcDriverJarFile() <em>Jdbc Driver Jar File</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJdbcDriverJarFile()
	 * @generated
	 * @ordered
	 */
    protected String jdbcDriverJarFile = JDBC_DRIVER_JAR_FILE_EDEFAULT;

    /**
	 * The default value of the '{@link #getMappernName() <em>Mappern Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMappernName()
	 * @generated
	 * @ordered
	 */
    protected static final String MAPPERN_NAME_EDEFAULT = "rdb.hsql";

    /**
	 * The cached value of the '{@link #getMappernName() <em>Mappern Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMappernName()
	 * @generated
	 * @ordered
	 */
    protected String mappernName = MAPPERN_NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "HSQL1";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getPort() <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPort()
	 * @generated
	 * @ordered
	 */
    protected static final int PORT_EDEFAULT = 9001;

    /**
	 * The cached value of the '{@link #getPort() <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPort()
	 * @generated
	 * @ordered
	 */
    protected int port = PORT_EDEFAULT;

    /**
	 * The cached value of the '{@link #getJasmineNode() <em>Jasmine Node</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJasmineNode()
	 * @generated
	 * @ordered
	 */
    protected JASMINeNode jasmineNode;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected DBImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.DB;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DatabaseProvider getProvider() {
		return provider;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setProvider(DatabaseProvider newProvider) {
		DatabaseProvider oldProvider = provider;
		provider = newProvider == null ? PROVIDER_EDEFAULT : newProvider;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__PROVIDER, oldProvider, provider));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getUser() {
		return user;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setUser(String newUser) {
		String oldUser = user;
		user = newUser;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__USER, oldUser, user));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getPassword() {
		return password;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setPassword(String newPassword) {
		String oldPassword = password;
		password = newPassword;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__PASSWORD, oldPassword, password));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getUrl() {
		return url;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setUrl(String newUrl) {
		String oldUrl = url;
		url = newUrl;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__URL, oldUrl, url));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getDriverName() {
		return driverName;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDriverName(String newDriverName) {
		String oldDriverName = driverName;
		driverName = newDriverName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__DRIVER_NAME, oldDriverName, driverName));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getJndiName() {
		return jndiName;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJndiName(String newJndiName) {
		String oldJndiName = jndiName;
		jndiName = newJndiName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__JNDI_NAME, oldJndiName, jndiName));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getJdbcDriverJarFile() {
		return jdbcDriverJarFile;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJdbcDriverJarFile(String newJdbcDriverJarFile) {
		String oldJdbcDriverJarFile = jdbcDriverJarFile;
		jdbcDriverJarFile = newJdbcDriverJarFile;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__JDBC_DRIVER_JAR_FILE, oldJdbcDriverJarFile, jdbcDriverJarFile));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getMappernName() {
		return mappernName;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setMappernName(String newMappernName) {
		String oldMappernName = mappernName;
		mappernName = newMappernName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__MAPPERN_NAME, oldMappernName, mappernName));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__NAME, oldName, name));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public int getPort() {
		return port;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setPort(int newPort) {
		int oldPort = port;
		port = newPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__PORT, oldPort, port));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JASMINeNode getJasmineNode() {
		if (jasmineNode != null && jasmineNode.eIsProxy()) {
			InternalEObject oldJasmineNode = (InternalEObject)jasmineNode;
			jasmineNode = (JASMINeNode)eResolveProxy(oldJasmineNode);
			if (jasmineNode != oldJasmineNode) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, JasminemodelPackage.DB__JASMINE_NODE, oldJasmineNode, jasmineNode));
			}
		}
		return jasmineNode;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JASMINeNode basicGetJasmineNode() {
		return jasmineNode;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJasmineNode(JASMINeNode newJasmineNode) {
		JASMINeNode oldJasmineNode = jasmineNode;
		jasmineNode = newJasmineNode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DB__JASMINE_NODE, oldJasmineNode, jasmineNode));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.DB__PROVIDER:
				return getProvider();
			case JasminemodelPackage.DB__USER:
				return getUser();
			case JasminemodelPackage.DB__PASSWORD:
				return getPassword();
			case JasminemodelPackage.DB__URL:
				return getUrl();
			case JasminemodelPackage.DB__DRIVER_NAME:
				return getDriverName();
			case JasminemodelPackage.DB__JNDI_NAME:
				return getJndiName();
			case JasminemodelPackage.DB__JDBC_DRIVER_JAR_FILE:
				return getJdbcDriverJarFile();
			case JasminemodelPackage.DB__MAPPERN_NAME:
				return getMappernName();
			case JasminemodelPackage.DB__NAME:
				return getName();
			case JasminemodelPackage.DB__PORT:
				return new Integer(getPort());
			case JasminemodelPackage.DB__JASMINE_NODE:
				if (resolve) return getJasmineNode();
				return basicGetJasmineNode();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.DB__PROVIDER:
				setProvider((DatabaseProvider)newValue);
				return;
			case JasminemodelPackage.DB__USER:
				setUser((String)newValue);
				return;
			case JasminemodelPackage.DB__PASSWORD:
				setPassword((String)newValue);
				return;
			case JasminemodelPackage.DB__URL:
				setUrl((String)newValue);
				return;
			case JasminemodelPackage.DB__DRIVER_NAME:
				setDriverName((String)newValue);
				return;
			case JasminemodelPackage.DB__JNDI_NAME:
				setJndiName((String)newValue);
				return;
			case JasminemodelPackage.DB__JDBC_DRIVER_JAR_FILE:
				setJdbcDriverJarFile((String)newValue);
				return;
			case JasminemodelPackage.DB__MAPPERN_NAME:
				setMappernName((String)newValue);
				return;
			case JasminemodelPackage.DB__NAME:
				setName((String)newValue);
				return;
			case JasminemodelPackage.DB__PORT:
				setPort(((Integer)newValue).intValue());
				return;
			case JasminemodelPackage.DB__JASMINE_NODE:
				setJasmineNode((JASMINeNode)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.DB__PROVIDER:
				setProvider(PROVIDER_EDEFAULT);
				return;
			case JasminemodelPackage.DB__USER:
				setUser(USER_EDEFAULT);
				return;
			case JasminemodelPackage.DB__PASSWORD:
				setPassword(PASSWORD_EDEFAULT);
				return;
			case JasminemodelPackage.DB__URL:
				setUrl(URL_EDEFAULT);
				return;
			case JasminemodelPackage.DB__DRIVER_NAME:
				setDriverName(DRIVER_NAME_EDEFAULT);
				return;
			case JasminemodelPackage.DB__JNDI_NAME:
				setJndiName(JNDI_NAME_EDEFAULT);
				return;
			case JasminemodelPackage.DB__JDBC_DRIVER_JAR_FILE:
				setJdbcDriverJarFile(JDBC_DRIVER_JAR_FILE_EDEFAULT);
				return;
			case JasminemodelPackage.DB__MAPPERN_NAME:
				setMappernName(MAPPERN_NAME_EDEFAULT);
				return;
			case JasminemodelPackage.DB__NAME:
				setName(NAME_EDEFAULT);
				return;
			case JasminemodelPackage.DB__PORT:
				setPort(PORT_EDEFAULT);
				return;
			case JasminemodelPackage.DB__JASMINE_NODE:
				setJasmineNode((JASMINeNode)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.DB__PROVIDER:
				return provider != PROVIDER_EDEFAULT;
			case JasminemodelPackage.DB__USER:
				return USER_EDEFAULT == null ? user != null : !USER_EDEFAULT.equals(user);
			case JasminemodelPackage.DB__PASSWORD:
				return PASSWORD_EDEFAULT == null ? password != null : !PASSWORD_EDEFAULT.equals(password);
			case JasminemodelPackage.DB__URL:
				return URL_EDEFAULT == null ? url != null : !URL_EDEFAULT.equals(url);
			case JasminemodelPackage.DB__DRIVER_NAME:
				return DRIVER_NAME_EDEFAULT == null ? driverName != null : !DRIVER_NAME_EDEFAULT.equals(driverName);
			case JasminemodelPackage.DB__JNDI_NAME:
				return JNDI_NAME_EDEFAULT == null ? jndiName != null : !JNDI_NAME_EDEFAULT.equals(jndiName);
			case JasminemodelPackage.DB__JDBC_DRIVER_JAR_FILE:
				return JDBC_DRIVER_JAR_FILE_EDEFAULT == null ? jdbcDriverJarFile != null : !JDBC_DRIVER_JAR_FILE_EDEFAULT.equals(jdbcDriverJarFile);
			case JasminemodelPackage.DB__MAPPERN_NAME:
				return MAPPERN_NAME_EDEFAULT == null ? mappernName != null : !MAPPERN_NAME_EDEFAULT.equals(mappernName);
			case JasminemodelPackage.DB__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case JasminemodelPackage.DB__PORT:
				return port != PORT_EDEFAULT;
			case JasminemodelPackage.DB__JASMINE_NODE:
				return jasmineNode != null;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (provider: ");
		result.append(provider);
		result.append(", user: ");
		result.append(user);
		result.append(", password: ");
		result.append(password);
		result.append(", url: ");
		result.append(url);
		result.append(", driverName: ");
		result.append(driverName);
		result.append(", jndiName: ");
		result.append(jndiName);
		result.append(", jdbcDriverJarFile: ");
		result.append(jdbcDriverJarFile);
		result.append(", mappernName: ");
		result.append(mappernName);
		result.append(", name: ");
		result.append(name);
		result.append(", port: ");
		result.append(port);
		result.append(')');
		return result.toString();
	}

} // DBImpl
