/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.net.InetAddress;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.objectweb.jasmine.ui.jasminemodel.DiscoveryService;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Discovery Service</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl#getHost <em>Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl#getPort <em>Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl#getGreetingPort <em>Greeting Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl#getSourcePort <em>Source Port</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DiscoveryServiceImpl extends EObjectImpl implements
        DiscoveryService {
    /**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "Discovery Service";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected static final InetAddress HOST_EDEFAULT = (InetAddress)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getInetAddress(), "224.224.224.224");

    /**
	 * The cached value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected InetAddress host = HOST_EDEFAULT;

    /**
	 * The default value of the '{@link #getPort() <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "9080");

    /**
	 * The cached value of the '{@link #getPort() <em>Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPort()
	 * @generated
	 * @ordered
	 */
    protected Port port = PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getGreetingPort() <em>Greeting Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGreetingPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port GREETING_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "9899");

    /**
	 * The cached value of the '{@link #getGreetingPort() <em>Greeting Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGreetingPort()
	 * @generated
	 * @ordered
	 */
    protected Port greetingPort = GREETING_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getSourcePort() <em>Source Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSourcePort()
	 * @generated
	 * @ordered
	 */
    protected static final Port SOURCE_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "9888");

    /**
	 * The cached value of the '{@link #getSourcePort() <em>Source Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSourcePort()
	 * @generated
	 * @ordered
	 */
    protected Port sourcePort = SOURCE_PORT_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected DiscoveryServiceImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.DISCOVERY_SERVICE;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DISCOVERY_SERVICE__NAME, oldName, name));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public InetAddress getHost() {
		return host;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHost(InetAddress newHost) {
		InetAddress oldHost = host;
		host = newHost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DISCOVERY_SERVICE__HOST, oldHost, host));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getPort() {
		return port;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setPort(Port newPort) {
		Port oldPort = port;
		port = newPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DISCOVERY_SERVICE__PORT, oldPort, port));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getGreetingPort() {
		return greetingPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setGreetingPort(Port newGreetingPort) {
		Port oldGreetingPort = greetingPort;
		greetingPort = newGreetingPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DISCOVERY_SERVICE__GREETING_PORT, oldGreetingPort, greetingPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getSourcePort() {
		return sourcePort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setSourcePort(Port newSourcePort) {
		Port oldSourcePort = sourcePort;
		sourcePort = newSourcePort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DISCOVERY_SERVICE__SOURCE_PORT, oldSourcePort, sourcePort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.DISCOVERY_SERVICE__NAME:
				return getName();
			case JasminemodelPackage.DISCOVERY_SERVICE__HOST:
				return getHost();
			case JasminemodelPackage.DISCOVERY_SERVICE__PORT:
				return getPort();
			case JasminemodelPackage.DISCOVERY_SERVICE__GREETING_PORT:
				return getGreetingPort();
			case JasminemodelPackage.DISCOVERY_SERVICE__SOURCE_PORT:
				return getSourcePort();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.DISCOVERY_SERVICE__NAME:
				setName((String)newValue);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__HOST:
				setHost((InetAddress)newValue);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__PORT:
				setPort((Port)newValue);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__GREETING_PORT:
				setGreetingPort((Port)newValue);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__SOURCE_PORT:
				setSourcePort((Port)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.DISCOVERY_SERVICE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__HOST:
				setHost(HOST_EDEFAULT);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__PORT:
				setPort(PORT_EDEFAULT);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__GREETING_PORT:
				setGreetingPort(GREETING_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.DISCOVERY_SERVICE__SOURCE_PORT:
				setSourcePort(SOURCE_PORT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.DISCOVERY_SERVICE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case JasminemodelPackage.DISCOVERY_SERVICE__HOST:
				return HOST_EDEFAULT == null ? host != null : !HOST_EDEFAULT.equals(host);
			case JasminemodelPackage.DISCOVERY_SERVICE__PORT:
				return PORT_EDEFAULT == null ? port != null : !PORT_EDEFAULT.equals(port);
			case JasminemodelPackage.DISCOVERY_SERVICE__GREETING_PORT:
				return GREETING_PORT_EDEFAULT == null ? greetingPort != null : !GREETING_PORT_EDEFAULT.equals(greetingPort);
			case JasminemodelPackage.DISCOVERY_SERVICE__SOURCE_PORT:
				return SOURCE_PORT_EDEFAULT == null ? sourcePort != null : !SOURCE_PORT_EDEFAULT.equals(sourcePort);
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", host: ");
		result.append(host);
		result.append(", port: ");
		result.append(port);
		result.append(", greetingPort: ");
		result.append(greetingPort);
		result.append(", sourcePort: ");
		result.append(sourcePort);
		result.append(')');
		return result.toString();
	}

} // DiscoveryServiceImpl
