/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.objectweb.jasmine.ui.jasminemodel.ClusterContainer;
import org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode;
import org.objectweb.jasmine.ui.jasminemodel.DB;
import org.objectweb.jasmine.ui.jasminemodel.DbLink;
import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.IConnector;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Domain</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl#getMiddlewareComponents <em>Middleware Components</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl#getConnectors <em>Connectors</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl#getConfigurationNodes <em>Configuration Nodes</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl#getClusterContainers <em>Cluster Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl#getDb <em>Db</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl#getDblinks <em>Dblinks</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DomainImpl extends EObjectImpl implements Domain {
    /**
	 * The cached value of the '{@link #getMiddlewareComponents() <em>Middleware Components</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMiddlewareComponents()
	 * @generated
	 * @ordered
	 */
    protected EList<IMiddlewareComponent> middlewareComponents;

    /**
	 * The cached value of the '{@link #getConnectors() <em>Connectors</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConnectors()
	 * @generated
	 * @ordered
	 */
    protected EList<IConnector> connectors;

    /**
	 * The cached value of the '{@link #getConfigurationNodes() <em>Configuration Nodes</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConfigurationNodes()
	 * @generated
	 * @ordered
	 */
    protected EList<ConfigurationNode> configurationNodes;

    /**
	 * The cached value of the '{@link #getClusterContainers() <em>Cluster Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getClusterContainers()
	 * @generated
	 * @ordered
	 */
    protected ClusterContainer clusterContainers;

    /**
	 * The cached value of the '{@link #getDb() <em>Db</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDb()
	 * @generated
	 * @ordered
	 */
    protected DB db;

    /**
	 * The cached value of the '{@link #getDblinks() <em>Dblinks</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDblinks()
	 * @generated
	 * @ordered
	 */
    protected EList<DbLink> dblinks;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected DomainImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.DOMAIN;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IMiddlewareComponent> getMiddlewareComponents() {
		if (middlewareComponents == null) {
			middlewareComponents = new EObjectContainmentEList<IMiddlewareComponent>(IMiddlewareComponent.class, this, JasminemodelPackage.DOMAIN__MIDDLEWARE_COMPONENTS);
		}
		return middlewareComponents;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IConnector> getConnectors() {
		if (connectors == null) {
			connectors = new EObjectContainmentEList<IConnector>(IConnector.class, this, JasminemodelPackage.DOMAIN__CONNECTORS);
		}
		return connectors;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<ConfigurationNode> getConfigurationNodes() {
		if (configurationNodes == null) {
			configurationNodes = new EObjectContainmentEList<ConfigurationNode>(ConfigurationNode.class, this, JasminemodelPackage.DOMAIN__CONFIGURATION_NODES);
		}
		return configurationNodes;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ClusterContainer getClusterContainers() {
		return clusterContainers;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetClusterContainers(
            ClusterContainer newClusterContainers, NotificationChain msgs) {
		ClusterContainer oldClusterContainers = clusterContainers;
		clusterContainers = newClusterContainers;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS, oldClusterContainers, newClusterContainers);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setClusterContainers(ClusterContainer newClusterContainers) {
		if (newClusterContainers != clusterContainers) {
			NotificationChain msgs = null;
			if (clusterContainers != null)
				msgs = ((InternalEObject)clusterContainers).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS, null, msgs);
			if (newClusterContainers != null)
				msgs = ((InternalEObject)newClusterContainers).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS, null, msgs);
			msgs = basicSetClusterContainers(newClusterContainers, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS, newClusterContainers, newClusterContainers));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DB getDb() {
		return db;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetDb(DB newDb, NotificationChain msgs) {
		DB oldDb = db;
		db = newDb;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DOMAIN__DB, oldDb, newDb);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDb(DB newDb) {
		if (newDb != db) {
			NotificationChain msgs = null;
			if (db != null)
				msgs = ((InternalEObject)db).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.DOMAIN__DB, null, msgs);
			if (newDb != null)
				msgs = ((InternalEObject)newDb).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.DOMAIN__DB, null, msgs);
			msgs = basicSetDb(newDb, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.DOMAIN__DB, newDb, newDb));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<DbLink> getDblinks() {
		if (dblinks == null) {
			dblinks = new EObjectContainmentEList<DbLink>(DbLink.class, this, JasminemodelPackage.DOMAIN__DBLINKS);
		}
		return dblinks;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.DOMAIN__MIDDLEWARE_COMPONENTS:
				return ((InternalEList<?>)getMiddlewareComponents()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.DOMAIN__CONNECTORS:
				return ((InternalEList<?>)getConnectors()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.DOMAIN__CONFIGURATION_NODES:
				return ((InternalEList<?>)getConfigurationNodes()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS:
				return basicSetClusterContainers(null, msgs);
			case JasminemodelPackage.DOMAIN__DB:
				return basicSetDb(null, msgs);
			case JasminemodelPackage.DOMAIN__DBLINKS:
				return ((InternalEList<?>)getDblinks()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.DOMAIN__MIDDLEWARE_COMPONENTS:
				return getMiddlewareComponents();
			case JasminemodelPackage.DOMAIN__CONNECTORS:
				return getConnectors();
			case JasminemodelPackage.DOMAIN__CONFIGURATION_NODES:
				return getConfigurationNodes();
			case JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS:
				return getClusterContainers();
			case JasminemodelPackage.DOMAIN__DB:
				return getDb();
			case JasminemodelPackage.DOMAIN__DBLINKS:
				return getDblinks();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.DOMAIN__MIDDLEWARE_COMPONENTS:
				getMiddlewareComponents().clear();
				getMiddlewareComponents().addAll((Collection<? extends IMiddlewareComponent>)newValue);
				return;
			case JasminemodelPackage.DOMAIN__CONNECTORS:
				getConnectors().clear();
				getConnectors().addAll((Collection<? extends IConnector>)newValue);
				return;
			case JasminemodelPackage.DOMAIN__CONFIGURATION_NODES:
				getConfigurationNodes().clear();
				getConfigurationNodes().addAll((Collection<? extends ConfigurationNode>)newValue);
				return;
			case JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS:
				setClusterContainers((ClusterContainer)newValue);
				return;
			case JasminemodelPackage.DOMAIN__DB:
				setDb((DB)newValue);
				return;
			case JasminemodelPackage.DOMAIN__DBLINKS:
				getDblinks().clear();
				getDblinks().addAll((Collection<? extends DbLink>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.DOMAIN__MIDDLEWARE_COMPONENTS:
				getMiddlewareComponents().clear();
				return;
			case JasminemodelPackage.DOMAIN__CONNECTORS:
				getConnectors().clear();
				return;
			case JasminemodelPackage.DOMAIN__CONFIGURATION_NODES:
				getConfigurationNodes().clear();
				return;
			case JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS:
				setClusterContainers((ClusterContainer)null);
				return;
			case JasminemodelPackage.DOMAIN__DB:
				setDb((DB)null);
				return;
			case JasminemodelPackage.DOMAIN__DBLINKS:
				getDblinks().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.DOMAIN__MIDDLEWARE_COMPONENTS:
				return middlewareComponents != null && !middlewareComponents.isEmpty();
			case JasminemodelPackage.DOMAIN__CONNECTORS:
				return connectors != null && !connectors.isEmpty();
			case JasminemodelPackage.DOMAIN__CONFIGURATION_NODES:
				return configurationNodes != null && !configurationNodes.isEmpty();
			case JasminemodelPackage.DOMAIN__CLUSTER_CONTAINERS:
				return clusterContainers != null;
			case JasminemodelPackage.DOMAIN__DB:
				return db != null;
			case JasminemodelPackage.DOMAIN__DBLINKS:
				return dblinks != null && !dblinks.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} // DomainImpl
