/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>EJB Container</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.EJBContainerImpl#isAutoGenic <em>Auto Genic</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class EJBContainerImpl extends IContainerImpl implements EJBContainer {
    /**
	 * The default value of the '{@link #isAutoGenic() <em>Auto Genic</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isAutoGenic()
	 * @generated
	 * @ordered
	 */
    protected static final boolean AUTO_GENIC_EDEFAULT = true;

    /**
	 * The cached value of the '{@link #isAutoGenic() <em>Auto Genic</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isAutoGenic()
	 * @generated
	 * @ordered
	 */
    protected boolean autoGenic = AUTO_GENIC_EDEFAULT;

    /**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected static final String NAME_EDEFAULT = "Ejb container";

    /**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected String name = NAME_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected EJBContainerImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.EJB_CONTAINER;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public boolean isAutoGenic() {
		return autoGenic;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setAutoGenic(boolean newAutoGenic) {
		boolean oldAutoGenic = autoGenic;
		autoGenic = newAutoGenic;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.EJB_CONTAINER__AUTO_GENIC, oldAutoGenic, autoGenic));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    JasminemodelPackage.EJB_CONTAINER__NAME, oldName, name));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case JasminemodelPackage.EJB_CONTAINER__AUTO_GENIC:
            return isAutoGenic() ? Boolean.TRUE : Boolean.FALSE;
        case JasminemodelPackage.EJB_CONTAINER__NAME:
            return getName();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case JasminemodelPackage.EJB_CONTAINER__AUTO_GENIC:
            setAutoGenic(((Boolean) newValue).booleanValue());
            return;
        case JasminemodelPackage.EJB_CONTAINER__NAME:
            setName((String) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.EJB_CONTAINER__AUTO_GENIC:
            setAutoGenic(AUTO_GENIC_EDEFAULT);
            return;
        case JasminemodelPackage.EJB_CONTAINER__NAME:
            setName(NAME_EDEFAULT);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.EJB_CONTAINER__AUTO_GENIC:
            return autoGenic != AUTO_GENIC_EDEFAULT;
        case JasminemodelPackage.EJB_CONTAINER__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
                    .equals(name);
        }
        return super.eIsSet(featureID);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (autoGenic: ");
		result.append(autoGenic);
		result.append(')');
		return result.toString();
	}

} // EJBContainerImpl
