/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>HTTP Rep Group</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.HTTP_RepGroupImpl#getTcpListenPort <em>Tcp Listen Port</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HTTP_RepGroupImpl extends ConfigurationNodeImpl implements
        HTTP_RepGroup {

    /**
	 * The default value of the '{@link #getTcpListenPort() <em>Tcp Listen Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTcpListenPort()
	 * @generated
	 * @ordered
	 */
    protected static final int TCP_LISTEN_PORT_EDEFAULT = 4001;

    /**
	 * The cached value of the '{@link #getTcpListenPort() <em>Tcp Listen Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTcpListenPort()
	 * @generated
	 * @ordered
	 */
    protected int tcpListenPort = TCP_LISTEN_PORT_EDEFAULT;

    /**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected static final String NAME_EDEFAULT = "HTTP Replication";

    /**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected String name = NAME_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected HTTP_RepGroupImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.HTTP_REP_GROUP;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public int getTcpListenPort() {
		return tcpListenPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setTcpListenPort(int newTcpListenPort) {
		int oldTcpListenPort = tcpListenPort;
		tcpListenPort = newTcpListenPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.HTTP_REP_GROUP__TCP_LISTEN_PORT, oldTcpListenPort, tcpListenPort));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    JasminemodelPackage.HTTP_REP_GROUP__NAME, oldName, name));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case JasminemodelPackage.HTTP_REP_GROUP__TCP_LISTEN_PORT:
            return new Integer(getTcpListenPort());
        case JasminemodelPackage.HTTP_REP_GROUP__NAME:
            return getName();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case JasminemodelPackage.HTTP_REP_GROUP__TCP_LISTEN_PORT:
            setTcpListenPort(((Integer) newValue).intValue());
            return;
        case JasminemodelPackage.HTTP_REP_GROUP__NAME:
            setName((String) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.HTTP_REP_GROUP__TCP_LISTEN_PORT:
				setTcpListenPort(TCP_LISTEN_PORT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.HTTP_REP_GROUP__TCP_LISTEN_PORT:
            return tcpListenPort != TCP_LISTEN_PORT_EDEFAULT;
        case JasminemodelPackage.HTTP_REP_GROUP__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
                    .equals(name);
        }
        return super.eIsSet(featureID);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (tcpListenPort: ");
		result.append(tcpListenPort);
		result.append(')');
		return result.toString();
	}

} // HTTP_RepGroupImpl
