/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.net.InetAddress;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>JASMI Ne Node</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getHost <em>Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getUser <em>User</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getPassword <em>Password</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getSshKey <em>Ssh Key</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getInstallDir <em>Install Dir</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getNodeId <em>Node Id</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getRegistryHost <em>Registry Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getRegistryPort <em>Registry Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getDiscoveryHost <em>Discovery Host</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getDiscoveryPort <em>Discovery Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getJndiPort <em>Jndi Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getFelixProfile <em>Felix Profile</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getRepositoryURL <em>Repository URL</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl#getMiddlewares <em>Middlewares</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JASMINeNodeImpl extends EObjectImpl implements JASMINeNode {
    /**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "JASMINeNode";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected static final InetAddress HOST_EDEFAULT = (InetAddress)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getInetAddress(), "localhost");

    /**
	 * The cached value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected InetAddress host = HOST_EDEFAULT;

    /**
	 * The default value of the '{@link #getUser() <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUser()
	 * @generated
	 * @ordered
	 */
    protected static final String USER_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getUser() <em>User</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getUser()
	 * @generated
	 * @ordered
	 */
    protected String user = USER_EDEFAULT;

    /**
	 * The default value of the '{@link #getPassword() <em>Password</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPassword()
	 * @generated
	 * @ordered
	 */
    protected static final String PASSWORD_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getPassword() <em>Password</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPassword()
	 * @generated
	 * @ordered
	 */
    protected String password = PASSWORD_EDEFAULT;

    /**
	 * The default value of the '{@link #getSshKey() <em>Ssh Key</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSshKey()
	 * @generated
	 * @ordered
	 */
    protected static final String SSH_KEY_EDEFAULT = "${user.dir}/.ssh/id_rsa";

    /**
	 * The cached value of the '{@link #getSshKey() <em>Ssh Key</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSshKey()
	 * @generated
	 * @ordered
	 */
    protected String sshKey = SSH_KEY_EDEFAULT;

    /**
	 * The default value of the '{@link #getInstallDir() <em>Install Dir</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInstallDir()
	 * @generated
	 * @ordered
	 */
    protected static final String INSTALL_DIR_EDEFAULT = "${java.io.tmpdir}";

    /**
	 * The cached value of the '{@link #getInstallDir() <em>Install Dir</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInstallDir()
	 * @generated
	 * @ordered
	 */
    protected String installDir = INSTALL_DIR_EDEFAULT;

    /**
	 * The default value of the '{@link #getNodeId() <em>Node Id</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNodeId()
	 * @generated
	 * @ordered
	 */
    protected static final Integer NODE_ID_EDEFAULT = new Integer(1);

    /**
	 * The cached value of the '{@link #getNodeId() <em>Node Id</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNodeId()
	 * @generated
	 * @ordered
	 */
    protected Integer nodeId = NODE_ID_EDEFAULT;

    /**
	 * The default value of the '{@link #getRegistryHost() <em>Registry Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRegistryHost()
	 * @generated
	 * @ordered
	 */
    protected static final InetAddress REGISTRY_HOST_EDEFAULT = (InetAddress)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getInetAddress(), "127.0.0.1");

    /**
	 * The cached value of the '{@link #getRegistryHost() <em>Registry Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRegistryHost()
	 * @generated
	 * @ordered
	 */
    protected InetAddress registryHost = REGISTRY_HOST_EDEFAULT;

    /**
	 * The default value of the '{@link #getRegistryPort() <em>Registry Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRegistryPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port REGISTRY_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1238");

    /**
	 * The cached value of the '{@link #getRegistryPort() <em>Registry Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRegistryPort()
	 * @generated
	 * @ordered
	 */
    protected Port registryPort = REGISTRY_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getDiscoveryHost() <em>Discovery Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDiscoveryHost()
	 * @generated
	 * @ordered
	 */
    protected static final InetAddress DISCOVERY_HOST_EDEFAULT = (InetAddress)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getInetAddress(), "127.0.0.1");

    /**
	 * The cached value of the '{@link #getDiscoveryHost() <em>Discovery Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDiscoveryHost()
	 * @generated
	 * @ordered
	 */
    protected InetAddress discoveryHost = DISCOVERY_HOST_EDEFAULT;

    /**
	 * The default value of the '{@link #getDiscoveryPort() <em>Discovery Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDiscoveryPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port DISCOVERY_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "9998");

    /**
	 * The cached value of the '{@link #getDiscoveryPort() <em>Discovery Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDiscoveryPort()
	 * @generated
	 * @ordered
	 */
    protected Port discoveryPort = DISCOVERY_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getJndiPort() <em>Jndi Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJndiPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port JNDI_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1239");

    /**
	 * The cached value of the '{@link #getJndiPort() <em>Jndi Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJndiPort()
	 * @generated
	 * @ordered
	 */
    protected Port jndiPort = JNDI_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getFelixProfile() <em>Felix Profile</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFelixProfile()
	 * @generated
	 * @ordered
	 */
    protected static final String FELIX_PROFILE_EDEFAULT = "jasminenode";

    /**
	 * The cached value of the '{@link #getFelixProfile() <em>Felix Profile</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFelixProfile()
	 * @generated
	 * @ordered
	 */
    protected String felixProfile = FELIX_PROFILE_EDEFAULT;

    /**
	 * The default value of the '{@link #getRepositoryURL() <em>Repository URL</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRepositoryURL()
	 * @generated
	 * @ordered
	 */
    protected static final String REPOSITORY_URL_EDEFAULT = "";

    /**
	 * The cached value of the '{@link #getRepositoryURL() <em>Repository URL</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRepositoryURL()
	 * @generated
	 * @ordered
	 */
    protected String repositoryURL = REPOSITORY_URL_EDEFAULT;

    /**
	 * The cached value of the '{@link #getMiddlewares() <em>Middlewares</em>}' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMiddlewares()
	 * @generated
	 * @ordered
	 */
    protected EList<IMiddlewareComponent> middlewares;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected JASMINeNodeImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.JASMI_NE_NODE;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public InetAddress getDiscoveryHost() {
		return discoveryHost;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDiscoveryHost(InetAddress newDiscoveryHost) {
		InetAddress oldDiscoveryHost = discoveryHost;
		discoveryHost = newDiscoveryHost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_HOST, oldDiscoveryHost, discoveryHost));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getDiscoveryPort() {
		return discoveryPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDiscoveryPort(Port newDiscoveryPort) {
		Port oldDiscoveryPort = discoveryPort;
		discoveryPort = newDiscoveryPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_PORT, oldDiscoveryPort, discoveryPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public InetAddress getHost() {
		return host;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHost(InetAddress newHost) {
		InetAddress oldHost = host;
		host = newHost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__HOST, oldHost, host));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getUser() {
		return user;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setUser(String newUser) {
		String oldUser = user;
		user = newUser;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__USER, oldUser, user));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getPassword() {
		return password;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setPassword(String newPassword) {
		String oldPassword = password;
		password = newPassword;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__PASSWORD, oldPassword, password));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getSshKey() {
		return sshKey;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setSshKey(String newSshKey) {
		String oldSshKey = sshKey;
		sshKey = newSshKey;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__SSH_KEY, oldSshKey, sshKey));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getInstallDir() {
		return installDir;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setInstallDir(String newInstallDir) {
		String oldInstallDir = installDir;
		installDir = newInstallDir;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__INSTALL_DIR, oldInstallDir, installDir));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getJndiPort() {
		return jndiPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJndiPort(Port newJndiPort) {
		Port oldJndiPort = jndiPort;
		jndiPort = newJndiPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__JNDI_PORT, oldJndiPort, jndiPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Integer getNodeId() {
		return nodeId;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setNodeId(Integer newNodeId) {
		Integer oldNodeId = nodeId;
		nodeId = newNodeId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__NODE_ID, oldNodeId, nodeId));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getFelixProfile() {
		return felixProfile;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setFelixProfile(String newFelixProfile) {
		String oldFelixProfile = felixProfile;
		felixProfile = newFelixProfile;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__FELIX_PROFILE, oldFelixProfile, felixProfile));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public InetAddress getRegistryHost() {
		return registryHost;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setRegistryHost(InetAddress newRegistryHost) {
		InetAddress oldRegistryHost = registryHost;
		registryHost = newRegistryHost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__REGISTRY_HOST, oldRegistryHost, registryHost));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getRegistryPort() {
		return registryPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setRegistryPort(Port newRegistryPort) {
		Port oldRegistryPort = registryPort;
		registryPort = newRegistryPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__REGISTRY_PORT, oldRegistryPort, registryPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getRepositoryURL() {
		return repositoryURL;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setRepositoryURL(String newRepositoryURL) {
		String oldRepositoryURL = repositoryURL;
		repositoryURL = newRepositoryURL;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__REPOSITORY_URL, oldRepositoryURL, repositoryURL));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IMiddlewareComponent> getMiddlewares() {
		if (middlewares == null) {
			middlewares = new EObjectResolvingEList<IMiddlewareComponent>(IMiddlewareComponent.class, this, JasminemodelPackage.JASMI_NE_NODE__MIDDLEWARES);
		}
		return middlewares;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JASMI_NE_NODE__NAME, oldName, name));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated NOT
     */
    public void deploy() {

    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void start() {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void stop() {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.JASMI_NE_NODE__NAME:
				return getName();
			case JasminemodelPackage.JASMI_NE_NODE__HOST:
				return getHost();
			case JasminemodelPackage.JASMI_NE_NODE__USER:
				return getUser();
			case JasminemodelPackage.JASMI_NE_NODE__PASSWORD:
				return getPassword();
			case JasminemodelPackage.JASMI_NE_NODE__SSH_KEY:
				return getSshKey();
			case JasminemodelPackage.JASMI_NE_NODE__INSTALL_DIR:
				return getInstallDir();
			case JasminemodelPackage.JASMI_NE_NODE__NODE_ID:
				return getNodeId();
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_HOST:
				return getRegistryHost();
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_PORT:
				return getRegistryPort();
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_HOST:
				return getDiscoveryHost();
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_PORT:
				return getDiscoveryPort();
			case JasminemodelPackage.JASMI_NE_NODE__JNDI_PORT:
				return getJndiPort();
			case JasminemodelPackage.JASMI_NE_NODE__FELIX_PROFILE:
				return getFelixProfile();
			case JasminemodelPackage.JASMI_NE_NODE__REPOSITORY_URL:
				return getRepositoryURL();
			case JasminemodelPackage.JASMI_NE_NODE__MIDDLEWARES:
				return getMiddlewares();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.JASMI_NE_NODE__NAME:
				setName((String)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__HOST:
				setHost((InetAddress)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__USER:
				setUser((String)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__PASSWORD:
				setPassword((String)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__SSH_KEY:
				setSshKey((String)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__INSTALL_DIR:
				setInstallDir((String)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__NODE_ID:
				setNodeId((Integer)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_HOST:
				setRegistryHost((InetAddress)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_PORT:
				setRegistryPort((Port)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_HOST:
				setDiscoveryHost((InetAddress)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_PORT:
				setDiscoveryPort((Port)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__JNDI_PORT:
				setJndiPort((Port)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__FELIX_PROFILE:
				setFelixProfile((String)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__REPOSITORY_URL:
				setRepositoryURL((String)newValue);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__MIDDLEWARES:
				getMiddlewares().clear();
				getMiddlewares().addAll((Collection<? extends IMiddlewareComponent>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JASMI_NE_NODE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__HOST:
				setHost(HOST_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__USER:
				setUser(USER_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__PASSWORD:
				setPassword(PASSWORD_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__SSH_KEY:
				setSshKey(SSH_KEY_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__INSTALL_DIR:
				setInstallDir(INSTALL_DIR_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__NODE_ID:
				setNodeId(NODE_ID_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_HOST:
				setRegistryHost(REGISTRY_HOST_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_PORT:
				setRegistryPort(REGISTRY_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_HOST:
				setDiscoveryHost(DISCOVERY_HOST_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_PORT:
				setDiscoveryPort(DISCOVERY_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__JNDI_PORT:
				setJndiPort(JNDI_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__FELIX_PROFILE:
				setFelixProfile(FELIX_PROFILE_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__REPOSITORY_URL:
				setRepositoryURL(REPOSITORY_URL_EDEFAULT);
				return;
			case JasminemodelPackage.JASMI_NE_NODE__MIDDLEWARES:
				getMiddlewares().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JASMI_NE_NODE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case JasminemodelPackage.JASMI_NE_NODE__HOST:
				return HOST_EDEFAULT == null ? host != null : !HOST_EDEFAULT.equals(host);
			case JasminemodelPackage.JASMI_NE_NODE__USER:
				return USER_EDEFAULT == null ? user != null : !USER_EDEFAULT.equals(user);
			case JasminemodelPackage.JASMI_NE_NODE__PASSWORD:
				return PASSWORD_EDEFAULT == null ? password != null : !PASSWORD_EDEFAULT.equals(password);
			case JasminemodelPackage.JASMI_NE_NODE__SSH_KEY:
				return SSH_KEY_EDEFAULT == null ? sshKey != null : !SSH_KEY_EDEFAULT.equals(sshKey);
			case JasminemodelPackage.JASMI_NE_NODE__INSTALL_DIR:
				return INSTALL_DIR_EDEFAULT == null ? installDir != null : !INSTALL_DIR_EDEFAULT.equals(installDir);
			case JasminemodelPackage.JASMI_NE_NODE__NODE_ID:
				return NODE_ID_EDEFAULT == null ? nodeId != null : !NODE_ID_EDEFAULT.equals(nodeId);
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_HOST:
				return REGISTRY_HOST_EDEFAULT == null ? registryHost != null : !REGISTRY_HOST_EDEFAULT.equals(registryHost);
			case JasminemodelPackage.JASMI_NE_NODE__REGISTRY_PORT:
				return REGISTRY_PORT_EDEFAULT == null ? registryPort != null : !REGISTRY_PORT_EDEFAULT.equals(registryPort);
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_HOST:
				return DISCOVERY_HOST_EDEFAULT == null ? discoveryHost != null : !DISCOVERY_HOST_EDEFAULT.equals(discoveryHost);
			case JasminemodelPackage.JASMI_NE_NODE__DISCOVERY_PORT:
				return DISCOVERY_PORT_EDEFAULT == null ? discoveryPort != null : !DISCOVERY_PORT_EDEFAULT.equals(discoveryPort);
			case JasminemodelPackage.JASMI_NE_NODE__JNDI_PORT:
				return JNDI_PORT_EDEFAULT == null ? jndiPort != null : !JNDI_PORT_EDEFAULT.equals(jndiPort);
			case JasminemodelPackage.JASMI_NE_NODE__FELIX_PROFILE:
				return FELIX_PROFILE_EDEFAULT == null ? felixProfile != null : !FELIX_PROFILE_EDEFAULT.equals(felixProfile);
			case JasminemodelPackage.JASMI_NE_NODE__REPOSITORY_URL:
				return REPOSITORY_URL_EDEFAULT == null ? repositoryURL != null : !REPOSITORY_URL_EDEFAULT.equals(repositoryURL);
			case JasminemodelPackage.JASMI_NE_NODE__MIDDLEWARES:
				return middlewares != null && !middlewares.isEmpty();
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", host: ");
		result.append(host);
		result.append(", user: ");
		result.append(user);
		result.append(", password: ");
		result.append(password);
		result.append(", sshKey: ");
		result.append(sshKey);
		result.append(", installDir: ");
		result.append(installDir);
		result.append(", nodeId: ");
		result.append(nodeId);
		result.append(", registryHost: ");
		result.append(registryHost);
		result.append(", registryPort: ");
		result.append(registryPort);
		result.append(", discoveryHost: ");
		result.append(discoveryHost);
		result.append(", discoveryPort: ");
		result.append(discoveryPort);
		result.append(", jndiPort: ");
		result.append(jndiPort);
		result.append(", felixProfile: ");
		result.append(felixProfile);
		result.append(", repositoryURL: ");
		result.append(repositoryURL);
		result.append(')');
		return result.toString();
	}

} // JASMINeNodeImpl
