/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.objectweb.jasmine.ui.jasminemodel.AJP;
import org.objectweb.jasmine.ui.jasminemodel.DiscoveryService;
import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.HTTP;
import org.objectweb.jasmine.ui.jasminemodel.HTTPS;
import org.objectweb.jasmine.ui.jasminemodel.IApplication;
import org.objectweb.jasmine.ui.jasminemodel.IHTTPServer;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry;
import org.objectweb.jasmine.ui.jasminemodel.JBossAS;
import org.objectweb.jasmine.ui.jasminemodel.JBossBinding;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;
import org.objectweb.jasmine.ui.jasminemodel.WebConnector;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>JBoss AS</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getWebContainers <em>Web Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getRmiRegistries <em>Rmi Registries</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getEjbContainers <em>Ejb Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getApplications <em>Applications</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getJmsServices <em>Jms Services</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getDiscoveryServices <em>Discovery Services</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getHttpServers <em>Http Servers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getHome <em>Home</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getBinding <em>Binding</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl#getWebconnectors <em>Webconnectors</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JBossASImpl extends MiddlewareComponentImpl implements JBossAS {
    /**
	 * The cached value of the '{@link #getWebContainers() <em>Web Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebContainers()
	 * @generated
	 * @ordered
	 */
    protected WebContainer webContainers;

    /**
	 * The cached value of the '{@link #getRmiRegistries() <em>Rmi Registries</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRmiRegistries()
	 * @generated
	 * @ordered
	 */
    protected EList<IRMIRegistry> rmiRegistries;

    /**
	 * The cached value of the '{@link #getEjbContainers() <em>Ejb Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEjbContainers()
	 * @generated
	 * @ordered
	 */
    protected EJBContainer ejbContainers;

    /**
	 * The cached value of the '{@link #getApplications() <em>Applications</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getApplications()
	 * @generated
	 * @ordered
	 */
    protected EList<IApplication> applications;

    /**
	 * The cached value of the '{@link #getJmsServices() <em>Jms Services</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsServices()
	 * @generated
	 * @ordered
	 */
    protected JmsService jmsServices;

    /**
	 * The cached value of the '{@link #getDiscoveryServices() <em>Discovery Services</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDiscoveryServices()
	 * @generated
	 * @ordered
	 */
    protected DiscoveryService discoveryServices;

    /**
	 * The cached value of the '{@link #getHttpServers() <em>Http Servers</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHttpServers()
	 * @generated
	 * @ordered
	 */
	protected EList<IHTTPServer> httpServers;

				/**
	 * The default value of the '{@link #getHome() <em>Home</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHome()
	 * @generated
	 * @ordered
	 */
    protected static final String HOME_EDEFAULT = "/home/jasmine/jboss";

    /**
	 * The cached value of the '{@link #getHome() <em>Home</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHome()
	 * @generated
	 * @ordered
	 */
    protected String home = HOME_EDEFAULT;

    /**
	 * The cached value of the '{@link #getBinding() <em>Binding</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getBinding()
	 * @generated
	 * @ordered
	 */
    protected JBossBinding binding;

    /**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "JBoss Application Server";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * The cached value of the '{@link #getWebconnectors() <em>Webconnectors</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebconnectors()
	 * @generated
	 * @ordered
	 */
    protected EList<WebConnector> webconnectors;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    protected JBossASImpl() {
        super();

        try {
            setApp(new org.objectweb.jasmine.jade.application.ApplicationImpl(
                    "jboss"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.JBOSS_AS;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public WebContainer getWebContainers() {
		return webContainers;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetWebContainers(
            WebContainer newWebContainers, NotificationChain msgs) {
		WebContainer oldWebContainers = webContainers;
		webContainers = newWebContainers;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS, oldWebContainers, newWebContainers);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setWebContainers(WebContainer newWebContainers) {
		if (newWebContainers != webContainers) {
			NotificationChain msgs = null;
			if (webContainers != null)
				msgs = ((InternalEObject)webContainers).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS, null, msgs);
			if (newWebContainers != null)
				msgs = ((InternalEObject)newWebContainers).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS, null, msgs);
			msgs = basicSetWebContainers(newWebContainers, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS, newWebContainers, newWebContainers));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IRMIRegistry> getRmiRegistries() {
		if (rmiRegistries == null) {
			rmiRegistries = new EObjectContainmentEList<IRMIRegistry>(IRMIRegistry.class, this, JasminemodelPackage.JBOSS_AS__RMI_REGISTRIES);
		}
		return rmiRegistries;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EJBContainer getEjbContainers() {
		return ejbContainers;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetEjbContainers(
            EJBContainer newEjbContainers, NotificationChain msgs) {
		EJBContainer oldEjbContainers = ejbContainers;
		ejbContainers = newEjbContainers;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS, oldEjbContainers, newEjbContainers);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setEjbContainers(EJBContainer newEjbContainers) {
		if (newEjbContainers != ejbContainers) {
			NotificationChain msgs = null;
			if (ejbContainers != null)
				msgs = ((InternalEObject)ejbContainers).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS, null, msgs);
			if (newEjbContainers != null)
				msgs = ((InternalEObject)newEjbContainers).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS, null, msgs);
			msgs = basicSetEjbContainers(newEjbContainers, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS, newEjbContainers, newEjbContainers));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IApplication> getApplications() {
		if (applications == null) {
			applications = new EObjectContainmentEList<IApplication>(IApplication.class, this, JasminemodelPackage.JBOSS_AS__APPLICATIONS);
		}
		return applications;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JmsService getJmsServices() {
		return jmsServices;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetJmsServices(JmsService newJmsServices,
            NotificationChain msgs) {
		JmsService oldJmsServices = jmsServices;
		jmsServices = newJmsServices;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__JMS_SERVICES, oldJmsServices, newJmsServices);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJmsServices(JmsService newJmsServices) {
		if (newJmsServices != jmsServices) {
			NotificationChain msgs = null;
			if (jmsServices != null)
				msgs = ((InternalEObject)jmsServices).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__JMS_SERVICES, null, msgs);
			if (newJmsServices != null)
				msgs = ((InternalEObject)newJmsServices).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__JMS_SERVICES, null, msgs);
			msgs = basicSetJmsServices(newJmsServices, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__JMS_SERVICES, newJmsServices, newJmsServices));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DiscoveryService getDiscoveryServices() {
		return discoveryServices;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetDiscoveryServices(
            DiscoveryService newDiscoveryServices, NotificationChain msgs) {
		DiscoveryService oldDiscoveryServices = discoveryServices;
		discoveryServices = newDiscoveryServices;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES, oldDiscoveryServices, newDiscoveryServices);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDiscoveryServices(DiscoveryService newDiscoveryServices) {
		if (newDiscoveryServices != discoveryServices) {
			NotificationChain msgs = null;
			if (discoveryServices != null)
				msgs = ((InternalEObject)discoveryServices).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES, null, msgs);
			if (newDiscoveryServices != null)
				msgs = ((InternalEObject)newDiscoveryServices).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES, null, msgs);
			msgs = basicSetDiscoveryServices(newDiscoveryServices, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES, newDiscoveryServices, newDiscoveryServices));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<IHTTPServer> getHttpServers() {
		if (httpServers == null) {
			httpServers = new EObjectWithInverseResolvingEList.ManyInverse<IHTTPServer>(IHTTPServer.class, this, JasminemodelPackage.JBOSS_AS__HTTP_SERVERS, JasminemodelPackage.IHTTP_SERVER__JAVAEE_SERVERS);
		}
		return httpServers;
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getHome() {
		return home;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHome(String newHome) {
		String oldHome = home;
		home = newHome;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__HOME, oldHome, home));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossBinding getBinding() {
		return binding;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetBinding(JBossBinding newBinding,
            NotificationChain msgs) {
		JBossBinding oldBinding = binding;
		binding = newBinding;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__BINDING, oldBinding, newBinding);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setBinding(JBossBinding newBinding) {
		if (newBinding != binding) {
			NotificationChain msgs = null;
			if (binding != null)
				msgs = ((InternalEObject)binding).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__BINDING, null, msgs);
			if (newBinding != null)
				msgs = ((InternalEObject)newBinding).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JBOSS_AS__BINDING, null, msgs);
			msgs = basicSetBinding(newBinding, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__BINDING, newBinding, newBinding));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_AS__NAME, oldName, name));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<WebConnector> getWebconnectors() {
		if (webconnectors == null) {
			webconnectors = new EObjectContainmentEList<WebConnector>(WebConnector.class, this, JasminemodelPackage.JBOSS_AS__WEBCONNECTORS);
		}
		return webconnectors;
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getIpAddress() {
        try {
            return jasmineNode.getHost().getHostAddress();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getNodeId() {
        try {
            return jasmineNode.getNodeId().toString();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getInstanceHome() {
        try {
            return getHome();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_AS__HTTP_SERVERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getHttpServers()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void configure(IMiddlewareComponent middleware) {
        if (middleware instanceof JBossAS) {
            JBossAS jboss = (JBossAS) middleware;
            org.objectweb.jasmine.jade.application.ApplicationImpl dep = (org.objectweb.jasmine.jade.application.ApplicationImpl) jboss
                    .getApp();
            try {
                // --- Instance Properties
                // TODO: Implement conf selection
                dep.setAttribute("instance-jboss-home", jboss.getHome());
                // dep.setAttribute("instance-jboss-conf", jboss.getConf());

                // --- Binding Service Properties
                if (jboss.getBinding() != null) {
                    dep.setAttribute("binding-use", "true");

                    dep.setAttribute("binding-naming-port", jboss.getBinding()
                            .getNamingPort().toString());
                    dep.setAttribute("binding-naming-rmi-port", jboss
                            .getBinding().getNamingRMIPort().toString());
                    dep.setAttribute("binding-webservice-port", jboss
                            .getBinding().getWebservicePort().toString());
                    dep.setAttribute("binding-invoker-rmi-object-port", jboss
                            .getBinding().getInvokerRMIObjectPort().toString());
                    dep
                            .setAttribute("binding-invoker-server-bind-port",
                                    jboss.getBinding()
                                            .getInvokerServerBindPort()
                                            .toString());
                    dep.setAttribute("binding-ha-naming-port", jboss
                            .getBinding().getHaNamingPort().toString());
                    dep.setAttribute("binding-ha-naming-rmi-port", jboss
                            .getBinding().getHaNamingRMIPort().toString());
                    dep.setAttribute("binding-ha-invoker-rmi-object-port",
                            jboss.getBinding().getHaInvokerRMIObjectPort()
                                    .toString());
                    dep.setAttribute("binding-ha-invoker-server-bind-port",
                            jboss.getBinding().getHaInvokerServerBindPort()
                                    .toString());
                    dep.setAttribute("binding-corba-orb-port", jboss
                            .getBinding().getCorbaOrbPort().toString());
                    dep.setAttribute("binding-connector-rmi-object-port", jboss
                            .getBinding().getConnectorRMIObjectPort()
                            .toString());
                    dep.setAttribute("binding-snmp-trap-port", jboss
                            .getBinding().getSnmpTrapPort().toString());
                    dep.setAttribute("binding-snmp-port", jboss.getBinding()
                            .getSnmpRequestPort().toString());
                    dep.setAttribute("binding-jms-server-bind-port", jboss
                            .getBinding().getJmsServerBindPort().toString());
                    dep.setAttribute("binding-webserver-port", jboss
                            .getBinding().getWebserverPort().toString());
                    dep.setAttribute("binding-ejb3-connector-port", jboss
                            .getBinding().getEjb3ConnectorPort().toString());
                    dep.setAttribute("binding-messaging-connector-port", jboss
                            .getBinding().getMessagingConnectorPort()
                            .toString());
                    dep
                            .setAttribute("binding-remoting-connector-port",
                                    jboss.getBinding()
                                            .getRemotingConnectorPort()
                                            .toString());
                } else {
                    dep.setAttribute("binding-use", "false");
                }

                // --- Web Container Properties
                // TODO: Implement the de/activation of web container
                if (jboss.getWebContainers() != null) {
                    // dep.setAttribute("jonas-web-mode", "true");

                    dep.setAttribute("web-jvm-route", jboss.getWebContainers()
                            .getJvmRoute());
                    dep.setAttribute("web-host", jboss.getWebContainers()
                            .getHost().getHostAddress());
                } else {
                    // dep.setAttribute("jonas-web-mode", "false");
                }

                // --- Web Connectors Properties
                if (jboss.getWebconnectors() != null
                        && !jboss.getWebconnectors().isEmpty()) {
                    String https = "";
                    String http = "";
                    String ajp = "";
                    for (WebConnector webc : jboss.getWebconnectors()) {
                        if (webc instanceof AJP)
                            ajp += webc.getPort().toString() + ',';
                        if (webc instanceof HTTP)
                            https += webc.getPort().toString() + ',';
                        if (webc instanceof HTTPS)
                            https += webc.getPort().toString() + ',';
                    }
                    dep.setAttribute("server-https-connectors", https);
                    dep.setAttribute("server-http-connectors", http);
                    dep.setAttribute("server-ajp-connectors", ajp);
                }

                // --- EJB Container Properties
                // TODO: Implement the de/activation of ejb container
                if (jboss.getEjbContainers() != null) {
                    // dep.setAttribute("jonas-ejb-mode", "true");
                } else {
                    // dep.setAttribute("jonas-ejb-mode", "false");
                }

                // --- Datasource Properties
                // TODO: read DB properties

            } catch (Exception e1) {
                e1.printStackTrace();
            }
        }
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS:
				return basicSetWebContainers(null, msgs);
			case JasminemodelPackage.JBOSS_AS__RMI_REGISTRIES:
				return ((InternalEList<?>)getRmiRegistries()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS:
				return basicSetEjbContainers(null, msgs);
			case JasminemodelPackage.JBOSS_AS__APPLICATIONS:
				return ((InternalEList<?>)getApplications()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.JBOSS_AS__JMS_SERVICES:
				return basicSetJmsServices(null, msgs);
			case JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES:
				return basicSetDiscoveryServices(null, msgs);
			case JasminemodelPackage.JBOSS_AS__HTTP_SERVERS:
				return ((InternalEList<?>)getHttpServers()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.JBOSS_AS__BINDING:
				return basicSetBinding(null, msgs);
			case JasminemodelPackage.JBOSS_AS__WEBCONNECTORS:
				return ((InternalEList<?>)getWebconnectors()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS:
				return getWebContainers();
			case JasminemodelPackage.JBOSS_AS__RMI_REGISTRIES:
				return getRmiRegistries();
			case JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS:
				return getEjbContainers();
			case JasminemodelPackage.JBOSS_AS__APPLICATIONS:
				return getApplications();
			case JasminemodelPackage.JBOSS_AS__JMS_SERVICES:
				return getJmsServices();
			case JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES:
				return getDiscoveryServices();
			case JasminemodelPackage.JBOSS_AS__HTTP_SERVERS:
				return getHttpServers();
			case JasminemodelPackage.JBOSS_AS__HOME:
				return getHome();
			case JasminemodelPackage.JBOSS_AS__BINDING:
				return getBinding();
			case JasminemodelPackage.JBOSS_AS__NAME:
				return getName();
			case JasminemodelPackage.JBOSS_AS__WEBCONNECTORS:
				return getWebconnectors();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS:
				setWebContainers((WebContainer)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__RMI_REGISTRIES:
				getRmiRegistries().clear();
				getRmiRegistries().addAll((Collection<? extends IRMIRegistry>)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS:
				setEjbContainers((EJBContainer)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__APPLICATIONS:
				getApplications().clear();
				getApplications().addAll((Collection<? extends IApplication>)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__JMS_SERVICES:
				setJmsServices((JmsService)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES:
				setDiscoveryServices((DiscoveryService)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__HTTP_SERVERS:
				getHttpServers().clear();
				getHttpServers().addAll((Collection<? extends IHTTPServer>)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__HOME:
				setHome((String)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__BINDING:
				setBinding((JBossBinding)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__NAME:
				setName((String)newValue);
				return;
			case JasminemodelPackage.JBOSS_AS__WEBCONNECTORS:
				getWebconnectors().clear();
				getWebconnectors().addAll((Collection<? extends WebConnector>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS:
				setWebContainers((WebContainer)null);
				return;
			case JasminemodelPackage.JBOSS_AS__RMI_REGISTRIES:
				getRmiRegistries().clear();
				return;
			case JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS:
				setEjbContainers((EJBContainer)null);
				return;
			case JasminemodelPackage.JBOSS_AS__APPLICATIONS:
				getApplications().clear();
				return;
			case JasminemodelPackage.JBOSS_AS__JMS_SERVICES:
				setJmsServices((JmsService)null);
				return;
			case JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES:
				setDiscoveryServices((DiscoveryService)null);
				return;
			case JasminemodelPackage.JBOSS_AS__HTTP_SERVERS:
				getHttpServers().clear();
				return;
			case JasminemodelPackage.JBOSS_AS__HOME:
				setHome(HOME_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_AS__BINDING:
				setBinding((JBossBinding)null);
				return;
			case JasminemodelPackage.JBOSS_AS__NAME:
				setName(NAME_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_AS__WEBCONNECTORS:
				getWebconnectors().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_AS__WEB_CONTAINERS:
				return webContainers != null;
			case JasminemodelPackage.JBOSS_AS__RMI_REGISTRIES:
				return rmiRegistries != null && !rmiRegistries.isEmpty();
			case JasminemodelPackage.JBOSS_AS__EJB_CONTAINERS:
				return ejbContainers != null;
			case JasminemodelPackage.JBOSS_AS__APPLICATIONS:
				return applications != null && !applications.isEmpty();
			case JasminemodelPackage.JBOSS_AS__JMS_SERVICES:
				return jmsServices != null;
			case JasminemodelPackage.JBOSS_AS__DISCOVERY_SERVICES:
				return discoveryServices != null;
			case JasminemodelPackage.JBOSS_AS__HTTP_SERVERS:
				return httpServers != null && !httpServers.isEmpty();
			case JasminemodelPackage.JBOSS_AS__HOME:
				return HOME_EDEFAULT == null ? home != null : !HOME_EDEFAULT.equals(home);
			case JasminemodelPackage.JBOSS_AS__BINDING:
				return binding != null;
			case JasminemodelPackage.JBOSS_AS__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case JasminemodelPackage.JBOSS_AS__WEBCONNECTORS:
				return webconnectors != null && !webconnectors.isEmpty();
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (home: ");
		result.append(home);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // JBossASImpl
