/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.objectweb.jasmine.ui.jasminemodel.JBossBinding;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>JBoss Binding</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getNamingPort <em>Naming Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getNamingRMIPort <em>Naming RMI Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getWebservicePort <em>Webservice Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getInvokerRMIObjectPort <em>Invoker RMI Object Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getInvokerServerBindPort <em>Invoker Server Bind Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getHaNamingPort <em>Ha Naming Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getHaNamingRMIPort <em>Ha Naming RMI Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getHaInvokerRMIObjectPort <em>Ha Invoker RMI Object Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getHaInvokerServerBindPort <em>Ha Invoker Server Bind Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getCorbaOrbPort <em>Corba Orb Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getConnectorRMIObjectPort <em>Connector RMI Object Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getSnmpTrapPort <em>Snmp Trap Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getSnmpRequestPort <em>Snmp Request Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getJmsServerBindPort <em>Jms Server Bind Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getWebserverPort <em>Webserver Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getEjb3ConnectorPort <em>Ejb3 Connector Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getMessagingConnectorPort <em>Messaging Connector Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl#getRemotingConnectorPort <em>Remoting Connector Port</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JBossBindingImpl extends EObjectImpl implements JBossBinding {
    /**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "Binding";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getNamingPort() <em>Naming Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNamingPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port NAMING_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1099");

    /**
	 * The cached value of the '{@link #getNamingPort() <em>Naming Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNamingPort()
	 * @generated
	 * @ordered
	 */
    protected Port namingPort = NAMING_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getNamingRMIPort() <em>Naming RMI Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNamingRMIPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port NAMING_RMI_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1098");

    /**
	 * The cached value of the '{@link #getNamingRMIPort() <em>Naming RMI Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNamingRMIPort()
	 * @generated
	 * @ordered
	 */
    protected Port namingRMIPort = NAMING_RMI_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getWebservicePort() <em>Webservice Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebservicePort()
	 * @generated
	 * @ordered
	 */
    protected static final Port WEBSERVICE_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "8083");

    /**
	 * The cached value of the '{@link #getWebservicePort() <em>Webservice Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebservicePort()
	 * @generated
	 * @ordered
	 */
    protected Port webservicePort = WEBSERVICE_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getInvokerRMIObjectPort() <em>Invoker RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInvokerRMIObjectPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port INVOKER_RMI_OBJECT_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "4444");

    /**
	 * The cached value of the '{@link #getInvokerRMIObjectPort() <em>Invoker RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInvokerRMIObjectPort()
	 * @generated
	 * @ordered
	 */
    protected Port invokerRMIObjectPort = INVOKER_RMI_OBJECT_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getInvokerServerBindPort() <em>Invoker Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInvokerServerBindPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port INVOKER_SERVER_BIND_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "4445");

    /**
	 * The cached value of the '{@link #getInvokerServerBindPort() <em>Invoker Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInvokerServerBindPort()
	 * @generated
	 * @ordered
	 */
    protected Port invokerServerBindPort = INVOKER_SERVER_BIND_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getHaNamingPort() <em>Ha Naming Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaNamingPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port HA_NAMING_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1100");

    /**
	 * The cached value of the '{@link #getHaNamingPort() <em>Ha Naming Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaNamingPort()
	 * @generated
	 * @ordered
	 */
    protected Port haNamingPort = HA_NAMING_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getHaNamingRMIPort() <em>Ha Naming RMI Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaNamingRMIPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port HA_NAMING_RMI_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1101");

    /**
	 * The cached value of the '{@link #getHaNamingRMIPort() <em>Ha Naming RMI Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaNamingRMIPort()
	 * @generated
	 * @ordered
	 */
    protected Port haNamingRMIPort = HA_NAMING_RMI_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getHaInvokerRMIObjectPort() <em>Ha Invoker RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaInvokerRMIObjectPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port HA_INVOKER_RMI_OBJECT_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "4444");

    /**
	 * The cached value of the '{@link #getHaInvokerRMIObjectPort() <em>Ha Invoker RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaInvokerRMIObjectPort()
	 * @generated
	 * @ordered
	 */
    protected Port haInvokerRMIObjectPort = HA_INVOKER_RMI_OBJECT_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getHaInvokerServerBindPort() <em>Ha Invoker Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaInvokerServerBindPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port HA_INVOKER_SERVER_BIND_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "4448");

    /**
	 * The cached value of the '{@link #getHaInvokerServerBindPort() <em>Ha Invoker Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHaInvokerServerBindPort()
	 * @generated
	 * @ordered
	 */
    protected Port haInvokerServerBindPort = HA_INVOKER_SERVER_BIND_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getCorbaOrbPort() <em>Corba Orb Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getCorbaOrbPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port CORBA_ORB_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "3528");

    /**
	 * The cached value of the '{@link #getCorbaOrbPort() <em>Corba Orb Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getCorbaOrbPort()
	 * @generated
	 * @ordered
	 */
    protected Port corbaOrbPort = CORBA_ORB_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getConnectorRMIObjectPort() <em>Connector RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConnectorRMIObjectPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port CONNECTOR_RMI_OBJECT_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "19001");

    /**
	 * The cached value of the '{@link #getConnectorRMIObjectPort() <em>Connector RMI Object Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConnectorRMIObjectPort()
	 * @generated
	 * @ordered
	 */
    protected Port connectorRMIObjectPort = CONNECTOR_RMI_OBJECT_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getSnmpTrapPort() <em>Snmp Trap Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSnmpTrapPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port SNMP_TRAP_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1162");

    /**
	 * The cached value of the '{@link #getSnmpTrapPort() <em>Snmp Trap Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSnmpTrapPort()
	 * @generated
	 * @ordered
	 */
    protected Port snmpTrapPort = SNMP_TRAP_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getSnmpRequestPort() <em>Snmp Request Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSnmpRequestPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port SNMP_REQUEST_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "1161");

    /**
	 * The cached value of the '{@link #getSnmpRequestPort() <em>Snmp Request Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSnmpRequestPort()
	 * @generated
	 * @ordered
	 */
    protected Port snmpRequestPort = SNMP_REQUEST_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getJmsServerBindPort() <em>Jms Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsServerBindPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port JMS_SERVER_BIND_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "8093");

    /**
	 * The cached value of the '{@link #getJmsServerBindPort() <em>Jms Server Bind Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsServerBindPort()
	 * @generated
	 * @ordered
	 */
    protected Port jmsServerBindPort = JMS_SERVER_BIND_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getWebserverPort() <em>Webserver Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebserverPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port WEBSERVER_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "8080");

    /**
	 * The cached value of the '{@link #getWebserverPort() <em>Webserver Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebserverPort()
	 * @generated
	 * @ordered
	 */
    protected Port webserverPort = WEBSERVER_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getEjb3ConnectorPort() <em>Ejb3 Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEjb3ConnectorPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port EJB3_CONNECTOR_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "3873");

    /**
	 * The cached value of the '{@link #getEjb3ConnectorPort() <em>Ejb3 Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEjb3ConnectorPort()
	 * @generated
	 * @ordered
	 */
    protected Port ejb3ConnectorPort = EJB3_CONNECTOR_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getMessagingConnectorPort() <em>Messaging Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMessagingConnectorPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port MESSAGING_CONNECTOR_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "4457");

    /**
	 * The cached value of the '{@link #getMessagingConnectorPort() <em>Messaging Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMessagingConnectorPort()
	 * @generated
	 * @ordered
	 */
    protected Port messagingConnectorPort = MESSAGING_CONNECTOR_PORT_EDEFAULT;

    /**
	 * The default value of the '{@link #getRemotingConnectorPort() <em>Remoting Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRemotingConnectorPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port REMOTING_CONNECTOR_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "4446");

    /**
	 * The cached value of the '{@link #getRemotingConnectorPort() <em>Remoting Connector Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRemotingConnectorPort()
	 * @generated
	 * @ordered
	 */
    protected Port remotingConnectorPort = REMOTING_CONNECTOR_PORT_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected JBossBindingImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.JBOSS_BINDING;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getNamingPort() {
		return namingPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setNamingPort(Port newNamingPort) {
		Port oldNamingPort = namingPort;
		namingPort = newNamingPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__NAMING_PORT, oldNamingPort, namingPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getNamingRMIPort() {
		return namingRMIPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setNamingRMIPort(Port newNamingRMIPort) {
		Port oldNamingRMIPort = namingRMIPort;
		namingRMIPort = newNamingRMIPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__NAMING_RMI_PORT, oldNamingRMIPort, namingRMIPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getWebservicePort() {
		return webservicePort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setWebservicePort(Port newWebservicePort) {
		Port oldWebservicePort = webservicePort;
		webservicePort = newWebservicePort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__WEBSERVICE_PORT, oldWebservicePort, webservicePort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getInvokerRMIObjectPort() {
		return invokerRMIObjectPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setInvokerRMIObjectPort(Port newInvokerRMIObjectPort) {
		Port oldInvokerRMIObjectPort = invokerRMIObjectPort;
		invokerRMIObjectPort = newInvokerRMIObjectPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT, oldInvokerRMIObjectPort, invokerRMIObjectPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getInvokerServerBindPort() {
		return invokerServerBindPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setInvokerServerBindPort(Port newInvokerServerBindPort) {
		Port oldInvokerServerBindPort = invokerServerBindPort;
		invokerServerBindPort = newInvokerServerBindPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__INVOKER_SERVER_BIND_PORT, oldInvokerServerBindPort, invokerServerBindPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getHaNamingPort() {
		return haNamingPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHaNamingPort(Port newHaNamingPort) {
		Port oldHaNamingPort = haNamingPort;
		haNamingPort = newHaNamingPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__HA_NAMING_PORT, oldHaNamingPort, haNamingPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getHaNamingRMIPort() {
		return haNamingRMIPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHaNamingRMIPort(Port newHaNamingRMIPort) {
		Port oldHaNamingRMIPort = haNamingRMIPort;
		haNamingRMIPort = newHaNamingRMIPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__HA_NAMING_RMI_PORT, oldHaNamingRMIPort, haNamingRMIPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getHaInvokerRMIObjectPort() {
		return haInvokerRMIObjectPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHaInvokerRMIObjectPort(Port newHaInvokerRMIObjectPort) {
		Port oldHaInvokerRMIObjectPort = haInvokerRMIObjectPort;
		haInvokerRMIObjectPort = newHaInvokerRMIObjectPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT, oldHaInvokerRMIObjectPort, haInvokerRMIObjectPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getHaInvokerServerBindPort() {
		return haInvokerServerBindPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHaInvokerServerBindPort(Port newHaInvokerServerBindPort) {
		Port oldHaInvokerServerBindPort = haInvokerServerBindPort;
		haInvokerServerBindPort = newHaInvokerServerBindPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT, oldHaInvokerServerBindPort, haInvokerServerBindPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getCorbaOrbPort() {
		return corbaOrbPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setCorbaOrbPort(Port newCorbaOrbPort) {
		Port oldCorbaOrbPort = corbaOrbPort;
		corbaOrbPort = newCorbaOrbPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__CORBA_ORB_PORT, oldCorbaOrbPort, corbaOrbPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getConnectorRMIObjectPort() {
		return connectorRMIObjectPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setConnectorRMIObjectPort(Port newConnectorRMIObjectPort) {
		Port oldConnectorRMIObjectPort = connectorRMIObjectPort;
		connectorRMIObjectPort = newConnectorRMIObjectPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT, oldConnectorRMIObjectPort, connectorRMIObjectPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getSnmpTrapPort() {
		return snmpTrapPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setSnmpTrapPort(Port newSnmpTrapPort) {
		Port oldSnmpTrapPort = snmpTrapPort;
		snmpTrapPort = newSnmpTrapPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__SNMP_TRAP_PORT, oldSnmpTrapPort, snmpTrapPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getSnmpRequestPort() {
		return snmpRequestPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setSnmpRequestPort(Port newSnmpRequestPort) {
		Port oldSnmpRequestPort = snmpRequestPort;
		snmpRequestPort = newSnmpRequestPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__SNMP_REQUEST_PORT, oldSnmpRequestPort, snmpRequestPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getJmsServerBindPort() {
		return jmsServerBindPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJmsServerBindPort(Port newJmsServerBindPort) {
		Port oldJmsServerBindPort = jmsServerBindPort;
		jmsServerBindPort = newJmsServerBindPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__JMS_SERVER_BIND_PORT, oldJmsServerBindPort, jmsServerBindPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getWebserverPort() {
		return webserverPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setWebserverPort(Port newWebserverPort) {
		Port oldWebserverPort = webserverPort;
		webserverPort = newWebserverPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__WEBSERVER_PORT, oldWebserverPort, webserverPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getEjb3ConnectorPort() {
		return ejb3ConnectorPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setEjb3ConnectorPort(Port newEjb3ConnectorPort) {
		Port oldEjb3ConnectorPort = ejb3ConnectorPort;
		ejb3ConnectorPort = newEjb3ConnectorPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__EJB3_CONNECTOR_PORT, oldEjb3ConnectorPort, ejb3ConnectorPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getMessagingConnectorPort() {
		return messagingConnectorPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setMessagingConnectorPort(Port newMessagingConnectorPort) {
		Port oldMessagingConnectorPort = messagingConnectorPort;
		messagingConnectorPort = newMessagingConnectorPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__MESSAGING_CONNECTOR_PORT, oldMessagingConnectorPort, messagingConnectorPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getRemotingConnectorPort() {
		return remotingConnectorPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setRemotingConnectorPort(Port newRemotingConnectorPort) {
		Port oldRemotingConnectorPort = remotingConnectorPort;
		remotingConnectorPort = newRemotingConnectorPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_BINDING__REMOTING_CONNECTOR_PORT, oldRemotingConnectorPort, remotingConnectorPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_BINDING__NAME:
				return getName();
			case JasminemodelPackage.JBOSS_BINDING__NAMING_PORT:
				return getNamingPort();
			case JasminemodelPackage.JBOSS_BINDING__NAMING_RMI_PORT:
				return getNamingRMIPort();
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVICE_PORT:
				return getWebservicePort();
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT:
				return getInvokerRMIObjectPort();
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_SERVER_BIND_PORT:
				return getInvokerServerBindPort();
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_PORT:
				return getHaNamingPort();
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_RMI_PORT:
				return getHaNamingRMIPort();
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT:
				return getHaInvokerRMIObjectPort();
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT:
				return getHaInvokerServerBindPort();
			case JasminemodelPackage.JBOSS_BINDING__CORBA_ORB_PORT:
				return getCorbaOrbPort();
			case JasminemodelPackage.JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT:
				return getConnectorRMIObjectPort();
			case JasminemodelPackage.JBOSS_BINDING__SNMP_TRAP_PORT:
				return getSnmpTrapPort();
			case JasminemodelPackage.JBOSS_BINDING__SNMP_REQUEST_PORT:
				return getSnmpRequestPort();
			case JasminemodelPackage.JBOSS_BINDING__JMS_SERVER_BIND_PORT:
				return getJmsServerBindPort();
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVER_PORT:
				return getWebserverPort();
			case JasminemodelPackage.JBOSS_BINDING__EJB3_CONNECTOR_PORT:
				return getEjb3ConnectorPort();
			case JasminemodelPackage.JBOSS_BINDING__MESSAGING_CONNECTOR_PORT:
				return getMessagingConnectorPort();
			case JasminemodelPackage.JBOSS_BINDING__REMOTING_CONNECTOR_PORT:
				return getRemotingConnectorPort();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_BINDING__NAMING_PORT:
				setNamingPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__NAMING_RMI_PORT:
				setNamingRMIPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVICE_PORT:
				setWebservicePort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT:
				setInvokerRMIObjectPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_SERVER_BIND_PORT:
				setInvokerServerBindPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_PORT:
				setHaNamingPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_RMI_PORT:
				setHaNamingRMIPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT:
				setHaInvokerRMIObjectPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT:
				setHaInvokerServerBindPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__CORBA_ORB_PORT:
				setCorbaOrbPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT:
				setConnectorRMIObjectPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__SNMP_TRAP_PORT:
				setSnmpTrapPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__SNMP_REQUEST_PORT:
				setSnmpRequestPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__JMS_SERVER_BIND_PORT:
				setJmsServerBindPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVER_PORT:
				setWebserverPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__EJB3_CONNECTOR_PORT:
				setEjb3ConnectorPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__MESSAGING_CONNECTOR_PORT:
				setMessagingConnectorPort((Port)newValue);
				return;
			case JasminemodelPackage.JBOSS_BINDING__REMOTING_CONNECTOR_PORT:
				setRemotingConnectorPort((Port)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_BINDING__NAMING_PORT:
				setNamingPort(NAMING_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__NAMING_RMI_PORT:
				setNamingRMIPort(NAMING_RMI_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVICE_PORT:
				setWebservicePort(WEBSERVICE_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT:
				setInvokerRMIObjectPort(INVOKER_RMI_OBJECT_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_SERVER_BIND_PORT:
				setInvokerServerBindPort(INVOKER_SERVER_BIND_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_PORT:
				setHaNamingPort(HA_NAMING_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_RMI_PORT:
				setHaNamingRMIPort(HA_NAMING_RMI_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT:
				setHaInvokerRMIObjectPort(HA_INVOKER_RMI_OBJECT_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT:
				setHaInvokerServerBindPort(HA_INVOKER_SERVER_BIND_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__CORBA_ORB_PORT:
				setCorbaOrbPort(CORBA_ORB_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT:
				setConnectorRMIObjectPort(CONNECTOR_RMI_OBJECT_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__SNMP_TRAP_PORT:
				setSnmpTrapPort(SNMP_TRAP_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__SNMP_REQUEST_PORT:
				setSnmpRequestPort(SNMP_REQUEST_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__JMS_SERVER_BIND_PORT:
				setJmsServerBindPort(JMS_SERVER_BIND_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVER_PORT:
				setWebserverPort(WEBSERVER_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__EJB3_CONNECTOR_PORT:
				setEjb3ConnectorPort(EJB3_CONNECTOR_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__MESSAGING_CONNECTOR_PORT:
				setMessagingConnectorPort(MESSAGING_CONNECTOR_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JBOSS_BINDING__REMOTING_CONNECTOR_PORT:
				setRemotingConnectorPort(REMOTING_CONNECTOR_PORT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_BINDING__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case JasminemodelPackage.JBOSS_BINDING__NAMING_PORT:
				return NAMING_PORT_EDEFAULT == null ? namingPort != null : !NAMING_PORT_EDEFAULT.equals(namingPort);
			case JasminemodelPackage.JBOSS_BINDING__NAMING_RMI_PORT:
				return NAMING_RMI_PORT_EDEFAULT == null ? namingRMIPort != null : !NAMING_RMI_PORT_EDEFAULT.equals(namingRMIPort);
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVICE_PORT:
				return WEBSERVICE_PORT_EDEFAULT == null ? webservicePort != null : !WEBSERVICE_PORT_EDEFAULT.equals(webservicePort);
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT:
				return INVOKER_RMI_OBJECT_PORT_EDEFAULT == null ? invokerRMIObjectPort != null : !INVOKER_RMI_OBJECT_PORT_EDEFAULT.equals(invokerRMIObjectPort);
			case JasminemodelPackage.JBOSS_BINDING__INVOKER_SERVER_BIND_PORT:
				return INVOKER_SERVER_BIND_PORT_EDEFAULT == null ? invokerServerBindPort != null : !INVOKER_SERVER_BIND_PORT_EDEFAULT.equals(invokerServerBindPort);
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_PORT:
				return HA_NAMING_PORT_EDEFAULT == null ? haNamingPort != null : !HA_NAMING_PORT_EDEFAULT.equals(haNamingPort);
			case JasminemodelPackage.JBOSS_BINDING__HA_NAMING_RMI_PORT:
				return HA_NAMING_RMI_PORT_EDEFAULT == null ? haNamingRMIPort != null : !HA_NAMING_RMI_PORT_EDEFAULT.equals(haNamingRMIPort);
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT:
				return HA_INVOKER_RMI_OBJECT_PORT_EDEFAULT == null ? haInvokerRMIObjectPort != null : !HA_INVOKER_RMI_OBJECT_PORT_EDEFAULT.equals(haInvokerRMIObjectPort);
			case JasminemodelPackage.JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT:
				return HA_INVOKER_SERVER_BIND_PORT_EDEFAULT == null ? haInvokerServerBindPort != null : !HA_INVOKER_SERVER_BIND_PORT_EDEFAULT.equals(haInvokerServerBindPort);
			case JasminemodelPackage.JBOSS_BINDING__CORBA_ORB_PORT:
				return CORBA_ORB_PORT_EDEFAULT == null ? corbaOrbPort != null : !CORBA_ORB_PORT_EDEFAULT.equals(corbaOrbPort);
			case JasminemodelPackage.JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT:
				return CONNECTOR_RMI_OBJECT_PORT_EDEFAULT == null ? connectorRMIObjectPort != null : !CONNECTOR_RMI_OBJECT_PORT_EDEFAULT.equals(connectorRMIObjectPort);
			case JasminemodelPackage.JBOSS_BINDING__SNMP_TRAP_PORT:
				return SNMP_TRAP_PORT_EDEFAULT == null ? snmpTrapPort != null : !SNMP_TRAP_PORT_EDEFAULT.equals(snmpTrapPort);
			case JasminemodelPackage.JBOSS_BINDING__SNMP_REQUEST_PORT:
				return SNMP_REQUEST_PORT_EDEFAULT == null ? snmpRequestPort != null : !SNMP_REQUEST_PORT_EDEFAULT.equals(snmpRequestPort);
			case JasminemodelPackage.JBOSS_BINDING__JMS_SERVER_BIND_PORT:
				return JMS_SERVER_BIND_PORT_EDEFAULT == null ? jmsServerBindPort != null : !JMS_SERVER_BIND_PORT_EDEFAULT.equals(jmsServerBindPort);
			case JasminemodelPackage.JBOSS_BINDING__WEBSERVER_PORT:
				return WEBSERVER_PORT_EDEFAULT == null ? webserverPort != null : !WEBSERVER_PORT_EDEFAULT.equals(webserverPort);
			case JasminemodelPackage.JBOSS_BINDING__EJB3_CONNECTOR_PORT:
				return EJB3_CONNECTOR_PORT_EDEFAULT == null ? ejb3ConnectorPort != null : !EJB3_CONNECTOR_PORT_EDEFAULT.equals(ejb3ConnectorPort);
			case JasminemodelPackage.JBOSS_BINDING__MESSAGING_CONNECTOR_PORT:
				return MESSAGING_CONNECTOR_PORT_EDEFAULT == null ? messagingConnectorPort != null : !MESSAGING_CONNECTOR_PORT_EDEFAULT.equals(messagingConnectorPort);
			case JasminemodelPackage.JBOSS_BINDING__REMOTING_CONNECTOR_PORT:
				return REMOTING_CONNECTOR_PORT_EDEFAULT == null ? remotingConnectorPort != null : !REMOTING_CONNECTOR_PORT_EDEFAULT.equals(remotingConnectorPort);
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", namingPort: ");
		result.append(namingPort);
		result.append(", namingRMIPort: ");
		result.append(namingRMIPort);
		result.append(", webservicePort: ");
		result.append(webservicePort);
		result.append(", invokerRMIObjectPort: ");
		result.append(invokerRMIObjectPort);
		result.append(", invokerServerBindPort: ");
		result.append(invokerServerBindPort);
		result.append(", haNamingPort: ");
		result.append(haNamingPort);
		result.append(", haNamingRMIPort: ");
		result.append(haNamingRMIPort);
		result.append(", haInvokerRMIObjectPort: ");
		result.append(haInvokerRMIObjectPort);
		result.append(", haInvokerServerBindPort: ");
		result.append(haInvokerServerBindPort);
		result.append(", corbaOrbPort: ");
		result.append(corbaOrbPort);
		result.append(", connectorRMIObjectPort: ");
		result.append(connectorRMIObjectPort);
		result.append(", snmpTrapPort: ");
		result.append(snmpTrapPort);
		result.append(", snmpRequestPort: ");
		result.append(snmpRequestPort);
		result.append(", jmsServerBindPort: ");
		result.append(jmsServerBindPort);
		result.append(", webserverPort: ");
		result.append(webserverPort);
		result.append(", ejb3ConnectorPort: ");
		result.append(ejb3ConnectorPort);
		result.append(", messagingConnectorPort: ");
		result.append(messagingConnectorPort);
		result.append(", remotingConnectorPort: ");
		result.append(remotingConnectorPort);
		result.append(')');
		return result.toString();
	}

} // JBossBindingImpl
