/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>JBoss HA Group</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAGroupImpl#getLanMode <em>Lan Mode</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAGroupImpl#getPingHosts <em>Ping Hosts</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JBossHAGroupImpl extends ConfigurationNodeImpl implements
        JBossHAGroup {
    /**
	 * The default value of the '{@link #getLanMode() <em>Lan Mode</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getLanMode()
	 * @generated
	 * @ordered
	 */
    protected static final String LAN_MODE_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getLanMode() <em>Lan Mode</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getLanMode()
	 * @generated
	 * @ordered
	 */
    protected String lanMode = LAN_MODE_EDEFAULT;

    /**
	 * The default value of the '{@link #getPingHosts() <em>Ping Hosts</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPingHosts()
	 * @generated
	 * @ordered
	 */
    protected static final String PING_HOSTS_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getPingHosts() <em>Ping Hosts</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPingHosts()
	 * @generated
	 * @ordered
	 */
    protected String pingHosts = PING_HOSTS_EDEFAULT;

    /**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected static final String NAME_EDEFAULT = "JBoss HA";

    /**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected String name = NAME_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected JBossHAGroupImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.JBOSS_HA_GROUP;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getLanMode() {
		return lanMode;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setLanMode(String newLanMode) {
		String oldLanMode = lanMode;
		lanMode = newLanMode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_HA_GROUP__LAN_MODE, oldLanMode, lanMode));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getPingHosts() {
		return pingHosts;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setPingHosts(String newPingHosts) {
		String oldPingHosts = pingHosts;
		pingHosts = newPingHosts;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_HA_GROUP__PING_HOSTS, oldPingHosts, pingHosts));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    JasminemodelPackage.JBOSS_HA_GROUP__NAME, oldName, name));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case JasminemodelPackage.JBOSS_HA_GROUP__LAN_MODE:
            return getLanMode();
        case JasminemodelPackage.JBOSS_HA_GROUP__PING_HOSTS:
            return getPingHosts();
        case JasminemodelPackage.JBOSS_HA_GROUP__NAME:
            return getName();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case JasminemodelPackage.JBOSS_HA_GROUP__LAN_MODE:
            setLanMode((String) newValue);
            return;
        case JasminemodelPackage.JBOSS_HA_GROUP__PING_HOSTS:
            setPingHosts((String) newValue);
            return;
        case JasminemodelPackage.JBOSS_HA_GROUP__NAME:
            setName((String) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.JBOSS_HA_GROUP__LAN_MODE:
            setLanMode(LAN_MODE_EDEFAULT);
            return;
        case JasminemodelPackage.JBOSS_HA_GROUP__PING_HOSTS:
            setPingHosts(PING_HOSTS_EDEFAULT);
            return;
        case JasminemodelPackage.JBOSS_HA_GROUP__NAME:
            setName(NAME_EDEFAULT);
            return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.JBOSS_HA_GROUP__LAN_MODE:
            return LAN_MODE_EDEFAULT == null ? lanMode != null
                    : !LAN_MODE_EDEFAULT.equals(lanMode);
        case JasminemodelPackage.JBOSS_HA_GROUP__PING_HOSTS:
            return PING_HOSTS_EDEFAULT == null ? pingHosts != null
                    : !PING_HOSTS_EDEFAULT.equals(pingHosts);
        case JasminemodelPackage.JBOSS_HA_GROUP__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
                    .equals(name);
        }
        return super.eIsSet(featureID);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (lanMode: ");
		result.append(lanMode);
		result.append(", pingHosts: ");
		result.append(pingHosts);
		result.append(')');
		return result.toString();
	}

} // JBossHAGroupImpl
