/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd;
import org.objectweb.jasmine.ui.jasminemodel.JBossAS;
import org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>JBoss Mod JK Connector</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossModJKConnectorImpl#getJboss <em>Jboss</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossModJKConnectorImpl#getApache <em>Apache</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JBossModJKConnectorImpl extends IJBossConnectorImpl implements
        JBossModJKConnector {
    /**
	 * The cached value of the '{@link #getJboss() <em>Jboss</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJboss()
	 * @generated
	 * @ordered
	 */
    protected JBossAS jboss;

    /**
	 * The cached value of the '{@link #getApache() <em>Apache</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getApache()
	 * @generated
	 * @ordered
	 */
    protected Apache_HTTPd apache;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected JBossModJKConnectorImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.JBOSS_MOD_JK_CONNECTOR;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossAS getJboss() {
		if (jboss != null && jboss.eIsProxy()) {
			InternalEObject oldJboss = (InternalEObject)jboss;
			jboss = (JBossAS)eResolveProxy(oldJboss);
			if (jboss != oldJboss) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__JBOSS, oldJboss, jboss));
			}
		}
		return jboss;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossAS basicGetJboss() {
		return jboss;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJboss(JBossAS newJboss) {
		JBossAS oldJboss = jboss;
		jboss = newJboss;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__JBOSS, oldJboss, jboss));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Apache_HTTPd getApache() {
		if (apache != null && apache.eIsProxy()) {
			InternalEObject oldApache = (InternalEObject)apache;
			apache = (Apache_HTTPd)eResolveProxy(oldApache);
			if (apache != oldApache) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__APACHE, oldApache, apache));
			}
		}
		return apache;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Apache_HTTPd basicGetApache() {
		return apache;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setApache(Apache_HTTPd newApache) {
		Apache_HTTPd oldApache = apache;
		apache = newApache;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__APACHE, oldApache, apache));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__JBOSS:
				if (resolve) return getJboss();
				return basicGetJboss();
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__APACHE:
				if (resolve) return getApache();
				return basicGetApache();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__JBOSS:
				setJboss((JBossAS)newValue);
				return;
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__APACHE:
				setApache((Apache_HTTPd)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__JBOSS:
				setJboss((JBossAS)null);
				return;
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__APACHE:
				setApache((Apache_HTTPd)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__JBOSS:
				return jboss != null;
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR__APACHE:
				return apache != null;
		}
		return super.eIsSet(featureID);
	}

} // JBossModJKConnectorImpl
