/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.objectweb.jasmine.ui.jasminemodel.Cluster;
import org.objectweb.jasmine.ui.jasminemodel.CmiGroup;
import org.objectweb.jasmine.ui.jasminemodel.DiscoveryService;
import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.IApplication;
import org.objectweb.jasmine.ui.jasminemodel.IHTTPServer;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry;
import org.objectweb.jasmine.ui.jasminemodel.JOnAS;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;
import org.objectweb.jasmine.ui.jasminemodel.WebConnector;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>JOn AS</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getWebContainers <em>Web Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getRmiRegistries <em>Rmi Registries</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getEjbContainers <em>Ejb Containers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getApplications <em>Applications</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getJmsServices <em>Jms Services</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getDiscoveryServices <em>Discovery Services</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getHttpServers <em>Http Servers</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getInstanceName <em>Instance Name</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getWebconnectors <em>Webconnectors</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getJonasBase <em>Jonas Base</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getJonasRoot <em>Jonas Root</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getDomain <em>Domain</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#isMaster <em>Master</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getClusters <em>Clusters</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl#getCmigroup <em>Cmigroup</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JOnASImpl extends MiddlewareComponentImpl implements JOnAS {
    /**
	 * The cached value of the '{@link #getWebContainers() <em>Web Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebContainers()
	 * @generated
	 * @ordered
	 */
    protected WebContainer webContainers;

    /**
	 * The cached value of the '{@link #getRmiRegistries() <em>Rmi Registries</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRmiRegistries()
	 * @generated
	 * @ordered
	 */
    protected EList<IRMIRegistry> rmiRegistries;

    /**
	 * The cached value of the '{@link #getEjbContainers() <em>Ejb Containers</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEjbContainers()
	 * @generated
	 * @ordered
	 */
    protected EJBContainer ejbContainers;

    /**
	 * The cached value of the '{@link #getApplications() <em>Applications</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getApplications()
	 * @generated
	 * @ordered
	 */
    protected EList<IApplication> applications;

    /**
	 * The cached value of the '{@link #getJmsServices() <em>Jms Services</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsServices()
	 * @generated
	 * @ordered
	 */
    protected JmsService jmsServices;

    /**
	 * The cached value of the '{@link #getDiscoveryServices() <em>Discovery Services</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDiscoveryServices()
	 * @generated
	 * @ordered
	 */
    protected DiscoveryService discoveryServices;

    /**
	 * The cached value of the '{@link #getHttpServers() <em>Http Servers</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHttpServers()
	 * @generated
	 * @ordered
	 */
	protected EList<IHTTPServer> httpServers;

				/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "JOnAS Application Server";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * The default value of the '{@link #getInstanceName() <em>Instance Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInstanceName()
	 * @generated
	 * @ordered
	 */
    protected static final String INSTANCE_NAME_EDEFAULT = "jonas";

    /**
	 * The cached value of the '{@link #getInstanceName() <em>Instance Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getInstanceName()
	 * @generated
	 * @ordered
	 */
    protected String instanceName = INSTANCE_NAME_EDEFAULT;

    /**
	 * The cached value of the '{@link #getWebconnectors() <em>Webconnectors</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getWebconnectors()
	 * @generated
	 * @ordered
	 */
    protected EList<WebConnector> webconnectors;

    /**
	 * The default value of the '{@link #getJonasBase() <em>Jonas Base</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJonasBase()
	 * @generated
	 * @ordered
	 */
    protected static final String JONAS_BASE_EDEFAULT = "/home/jasmine/JONAS_4_8_4";

    /**
	 * The cached value of the '{@link #getJonasBase() <em>Jonas Base</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJonasBase()
	 * @generated
	 * @ordered
	 */
    protected String jonasBase = JONAS_BASE_EDEFAULT;

    /**
	 * The default value of the '{@link #getJonasRoot() <em>Jonas Root</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJonasRoot()
	 * @generated
	 * @ordered
	 */
    protected static final String JONAS_ROOT_EDEFAULT = "/home/jasmine/JONAS_4_8_4";

    /**
	 * The cached value of the '{@link #getJonasRoot() <em>Jonas Root</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJonasRoot()
	 * @generated
	 * @ordered
	 */
    protected String jonasRoot = JONAS_ROOT_EDEFAULT;

    /**
	 * The default value of the '{@link #getDomain() <em>Domain</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDomain()
	 * @generated
	 * @ordered
	 */
    protected static final String DOMAIN_EDEFAULT = "jonas";

    /**
	 * The cached value of the '{@link #getDomain() <em>Domain</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDomain()
	 * @generated
	 * @ordered
	 */
    protected String domain = DOMAIN_EDEFAULT;

    /**
	 * The default value of the '{@link #isMaster() <em>Master</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isMaster()
	 * @generated
	 * @ordered
	 */
    protected static final boolean MASTER_EDEFAULT = false;

    /**
	 * The cached value of the '{@link #isMaster() <em>Master</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isMaster()
	 * @generated
	 * @ordered
	 */
    protected boolean master = MASTER_EDEFAULT;

    /**
	 * The cached value of the '{@link #getClusters() <em>Clusters</em>}' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getClusters()
	 * @generated
	 * @ordered
	 */
    protected EList<Cluster> clusters;

    /**
	 * The cached value of the '{@link #getCmigroup() <em>Cmigroup</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCmigroup()
	 * @generated
	 * @ordered
	 */
	protected CmiGroup cmigroup;

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    protected JOnASImpl() {
        super();

        try {
            setApp(new org.objectweb.jasmine.jade.application.ApplicationImpl(
                    "jonas"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.JON_AS;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public WebContainer getWebContainers() {
		return webContainers;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetWebContainers(
            WebContainer newWebContainers, NotificationChain msgs) {
		WebContainer oldWebContainers = webContainers;
		webContainers = newWebContainers;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__WEB_CONTAINERS, oldWebContainers, newWebContainers);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setWebContainers(WebContainer newWebContainers) {
		if (newWebContainers != webContainers) {
			NotificationChain msgs = null;
			if (webContainers != null)
				msgs = ((InternalEObject)webContainers).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__WEB_CONTAINERS, null, msgs);
			if (newWebContainers != null)
				msgs = ((InternalEObject)newWebContainers).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__WEB_CONTAINERS, null, msgs);
			msgs = basicSetWebContainers(newWebContainers, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__WEB_CONTAINERS, newWebContainers, newWebContainers));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IRMIRegistry> getRmiRegistries() {
		if (rmiRegistries == null) {
			rmiRegistries = new EObjectContainmentEList<IRMIRegistry>(IRMIRegistry.class, this, JasminemodelPackage.JON_AS__RMI_REGISTRIES);
		}
		return rmiRegistries;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EJBContainer getEjbContainers() {
		return ejbContainers;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetEjbContainers(
            EJBContainer newEjbContainers, NotificationChain msgs) {
		EJBContainer oldEjbContainers = ejbContainers;
		ejbContainers = newEjbContainers;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__EJB_CONTAINERS, oldEjbContainers, newEjbContainers);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setEjbContainers(EJBContainer newEjbContainers) {
		if (newEjbContainers != ejbContainers) {
			NotificationChain msgs = null;
			if (ejbContainers != null)
				msgs = ((InternalEObject)ejbContainers).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__EJB_CONTAINERS, null, msgs);
			if (newEjbContainers != null)
				msgs = ((InternalEObject)newEjbContainers).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__EJB_CONTAINERS, null, msgs);
			msgs = basicSetEjbContainers(newEjbContainers, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__EJB_CONTAINERS, newEjbContainers, newEjbContainers));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IApplication> getApplications() {
		if (applications == null) {
			applications = new EObjectContainmentEList<IApplication>(IApplication.class, this, JasminemodelPackage.JON_AS__APPLICATIONS);
		}
		return applications;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JmsService getJmsServices() {
		return jmsServices;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetJmsServices(JmsService newJmsServices,
            NotificationChain msgs) {
		JmsService oldJmsServices = jmsServices;
		jmsServices = newJmsServices;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__JMS_SERVICES, oldJmsServices, newJmsServices);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJmsServices(JmsService newJmsServices) {
		if (newJmsServices != jmsServices) {
			NotificationChain msgs = null;
			if (jmsServices != null)
				msgs = ((InternalEObject)jmsServices).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__JMS_SERVICES, null, msgs);
			if (newJmsServices != null)
				msgs = ((InternalEObject)newJmsServices).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__JMS_SERVICES, null, msgs);
			msgs = basicSetJmsServices(newJmsServices, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__JMS_SERVICES, newJmsServices, newJmsServices));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DiscoveryService getDiscoveryServices() {
		return discoveryServices;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetDiscoveryServices(
            DiscoveryService newDiscoveryServices, NotificationChain msgs) {
		DiscoveryService oldDiscoveryServices = discoveryServices;
		discoveryServices = newDiscoveryServices;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__DISCOVERY_SERVICES, oldDiscoveryServices, newDiscoveryServices);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDiscoveryServices(DiscoveryService newDiscoveryServices) {
		if (newDiscoveryServices != discoveryServices) {
			NotificationChain msgs = null;
			if (discoveryServices != null)
				msgs = ((InternalEObject)discoveryServices).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__DISCOVERY_SERVICES, null, msgs);
			if (newDiscoveryServices != null)
				msgs = ((InternalEObject)newDiscoveryServices).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - JasminemodelPackage.JON_AS__DISCOVERY_SERVICES, null, msgs);
			msgs = basicSetDiscoveryServices(newDiscoveryServices, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__DISCOVERY_SERVICES, newDiscoveryServices, newDiscoveryServices));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<IHTTPServer> getHttpServers() {
		if (httpServers == null) {
			httpServers = new EObjectWithInverseResolvingEList.ManyInverse<IHTTPServer>(IHTTPServer.class, this, JasminemodelPackage.JON_AS__HTTP_SERVERS, JasminemodelPackage.IHTTP_SERVER__JAVAEE_SERVERS);
		}
		return httpServers;
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__NAME, oldName, name));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getInstanceName() {
		return instanceName;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setInstanceName(String newInstanceName) {
		String oldInstanceName = instanceName;
		instanceName = newInstanceName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__INSTANCE_NAME, oldInstanceName, instanceName));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<WebConnector> getWebconnectors() {
		if (webconnectors == null) {
			webconnectors = new EObjectContainmentEList<WebConnector>(WebConnector.class, this, JasminemodelPackage.JON_AS__WEBCONNECTORS);
		}
		return webconnectors;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getJonasBase() {
		return jonasBase;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJonasBase(String newJonasBase) {
		String oldJonasBase = jonasBase;
		jonasBase = newJonasBase;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__JONAS_BASE, oldJonasBase, jonasBase));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getJonasRoot() {
		return jonasRoot;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJonasRoot(String newJonasRoot) {
		String oldJonasRoot = jonasRoot;
		jonasRoot = newJonasRoot;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__JONAS_ROOT, oldJonasRoot, jonasRoot));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getDomain() {
		return domain;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDomain(String newDomain) {
		String oldDomain = domain;
		domain = newDomain;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__DOMAIN, oldDomain, domain));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public boolean isMaster() {
		return master;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setMaster(boolean newMaster) {
		boolean oldMaster = master;
		master = newMaster;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__MASTER, oldMaster, master));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Cluster> getClusters() {
		if (clusters == null) {
			clusters = new EObjectResolvingEList<Cluster>(Cluster.class, this, JasminemodelPackage.JON_AS__CLUSTERS);
		}
		return clusters;
	}

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CmiGroup getCmigroup() {
		if (cmigroup != null && cmigroup.eIsProxy()) {
			InternalEObject oldCmigroup = (InternalEObject)cmigroup;
			cmigroup = (CmiGroup)eResolveProxy(oldCmigroup);
			if (cmigroup != oldCmigroup) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, JasminemodelPackage.JON_AS__CMIGROUP, oldCmigroup, cmigroup));
			}
		}
		return cmigroup;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CmiGroup basicGetCmigroup() {
		return cmigroup;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCmigroup(CmiGroup newCmigroup) {
		CmiGroup oldCmigroup = cmigroup;
		cmigroup = newCmigroup;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JON_AS__CMIGROUP, oldCmigroup, cmigroup));
	}

				//    /**
//     * <!-- begin-user-doc --> <!-- end-user-doc -->
//     *
//     * @generated NOT
//     */
//    public void setConnector(IJOnASConnector connector) {
//        if (connectors == null) {
//            connectors = new EObjectResolvingEList.Unsettable<IJOnASConnector>(
//                    IJOnASConnector.class, this,
//                    JasminemodelPackage.JON_AS__CONNECTORS);
//        }
//        connectors.add(connector);
//    }
//
//    /**
//     * <!-- begin-user-doc --> <!-- end-user-doc -->
//     *
//     * @generated NOT
//     */
//    public void unsetConnector(IJOnASConnector connector) {
//        if (connectors != null) {
//            connectors.remove(connector);
//        }
//    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getIpAddress() {
        try {
            return jasmineNode.getHost().getHostAddress();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getNodeId() {
        try {
            return jasmineNode.getNodeId().toString();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String getInstanceHome() {
        try {
            return getJonasRoot();
        } catch (NullPointerException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.JON_AS__HTTP_SERVERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getHttpServers()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void configure(IMiddlewareComponent middleware) {

        String carolProtocols = "";

        if (middleware instanceof JOnAS) {
            JOnAS jonas = (JOnAS) middleware;

            org.objectweb.jasmine.jade.application.ApplicationImpl dep = (org.objectweb.jasmine.jade.application.ApplicationImpl) jonas
                    .getApp();

            try {

            	/*
            	 * carol.properties
            	 */
                if (rmiRegistries != null && !rmiRegistries.isEmpty()) {
                    for (int i = 0; i < rmiRegistries.size(); i++) {

                        if (rmiRegistries.get(i) instanceof IIOPImpl) {
                            dep.setAttribute("carol-iiop-address",
                                    ((IRMIRegistry) rmiRegistries.get(i))
                                            .getHost().getHostAddress());
                            dep.setAttribute("carol-iiop-port",
                                    ((IRMIRegistry) rmiRegistries.get(i))
                                            .getPort().toString());

                            if (carolProtocols.length() > 0
                                    && !carolProtocols.contains("iiop")) {
                                carolProtocols += ",iiop";
                            } else {
                                carolProtocols += "iiop";
                            }
                        } else {
                            if (rmiRegistries.get(i) instanceof JRMPImpl) {
                                dep.setAttribute("carol-jrmp-address",
                                        ((IRMIRegistry) rmiRegistries.get(i))
                                                .getHost().getHostAddress());
                                dep.setAttribute("carol-jrmp-port",
                                        ((IRMIRegistry) rmiRegistries.get(i))
                                                .getPort().toString());

                                if (carolProtocols.length() > 0
                                        && !carolProtocols.contains("jrmp")) {
                                    carolProtocols += ",jrmp";
                                } else {
                                    carolProtocols += "jrmp";
                                }
                            } else {
                                if (rmiRegistries.get(i) instanceof IRMIImpl) {
                                    dep.setAttribute("carol-irmi-address",
                                            ((IRMIRegistry) rmiRegistries
                                                    .get(i)).getHost()
                                                    .getHostAddress());
                                    dep.setAttribute("carol-irmi-port",
                                            ((IRMIRegistry) rmiRegistries
                                                    .get(i)).getPort()
                                                    .toString());

                                    if (carolProtocols.length() > 0
                                            && !carolProtocols.contains("irmi")) {
                                        carolProtocols += ",irmi";
                                    } else {
                                        carolProtocols += "irmi";
                                    }
                                } else {
                                    if (rmiRegistries.get(i) instanceof CMIImpl) {
                                        dep.setAttribute("carol-cmi-address",
                                                ((IRMIRegistry) rmiRegistries
                                                        .get(i)).getHost()
                                                        .getHostAddress());
                                        dep.setAttribute("carol-cmi-port",
                                                ((IRMIRegistry) rmiRegistries
                                                        .get(i)).getPort()
                                                        .toString());

                                        if (carolProtocols.length() > 0
                                                && !carolProtocols
                                                        .contains("cmi")) {
                                            carolProtocols += ",cmi";
                                        } else {
                                            carolProtocols += "cmi";
                                        }
                                    } else {
                                        // Protocol not supported
                                        throw new UnsupportedOperationException();
                                    }
                                }
                            }
                        }
                    }
                    dep.setAttribute("carol-protocols", carolProtocols);
                }

                if (jonas.getWebContainers() != null) {
                    dep.setAttribute("jonas-web-mode", "true");
                    dep.setAttribute("server-jvm-route", jonas
                            .getWebContainers().getJvmRoute());
                } else {
                    dep.setAttribute("jonas-web-mode", "false");
                }

                if (jonas.getEjbContainers() != null) {
                    dep.setAttribute("jonas-ejb-mode", "true");
                } else {
                    dep.setAttribute("jonas-ejb-mode", "false");
                }

                // TODO : read DB properties
                // DB
                dep.setAttribute("jonas-service-db-port", "9011");
                dep.setAttribute("jonas-service-db-dbname", "db_jonas");
                dep.setAttribute("jonas-service-db-user1", "jonas:jonas");

                if (discoveryServices != null) {
                    dep.setAttribute("jonas-service-discovery-source-port",
                            discoveryServices.getSourcePort().toString());
                    dep.setAttribute(
                            "jonas-service-discovery-multicast-address",
                            discoveryServices.getHost().getHostAddress());
                    dep.setAttribute("jonas-service-discovery-multicast-port",
                            discoveryServices.getPort().toString());
                    dep.setAttribute("jonas-service-discovery-greeting-port",
                            discoveryServices.getGreetingPort().toString());
                }

                dep
                        .setAttribute("instance-jonas-name", jonas
                                .getInstanceName());
                dep.setAttribute("instance-jonas-domain", jonas.getDomain());
                dep.setAttribute("instance-jonas-root", jonas.getJonasRoot());
                dep.setAttribute("instance-jonas-base", jonas.getJonasBase());

                /*
                 * jgroups-cmi.xml
                 */
                CmiGroup cmiGroup = getCmigroup();
                if(cmiGroup != null){

                	dep.setAttribute("jgroups-cmi-lan-mode", new Boolean(cmiGroup.isLanMode()).toString());
                	dep.setAttribute("jgroups-cmi-udp-multicast-address",
                            cmiGroup.getHost().getHostAddress());
                    dep.setAttribute("jgroups-cmi-udp-multicast-port", cmiGroup.getPort().toString());
                    dep.setAttribute("jgroups-cmi-tcp-ping-hosts", cmiGroup.getTcpPingHost().getHostAddress());
                }

                /*
                 * is cluster mode ?
                 */
                if (clusters != null && !clusters.isEmpty()) {
                    dep.setAttribute("server-cluster-mode", "true");
                } else {
                    dep.setAttribute("server-cluster-mode", "false");
                }

                // TODO : read HTTP Rep. Group properties
                // HTTP Replication group
                dep.setAttribute("server-multicast-address", "228.0.0.4");
                dep.setAttribute("server-multicast-port", "45574");
                dep.setAttribute("server-tcp-listen-port", "4011");

                // TODO : read Web connectors properties
                // Web connectors
                dep.setAttribute("server-http-connectors", "9010");
                dep.setAttribute("server-ajp-connectors", "8019");

            } catch (Exception e1) {
                e1.printStackTrace();
            }
        }
    }

//    /**
//     * <!-- begin-user-doc --> <!-- end-user-doc -->
//     *
//     * @generated Not
//     */
//    @Override
//    public void stop() {
//
//        System.out.println(this.getConnectors().toString());
//
//        for (IJOnASConnector jc : this.getConnectors()) {
//            if (jc instanceof CMIConnector) {
//                System.out.println(((CMIConnector) jc).getSource());
//                System.out.println(((CMIConnector) jc).getTarget());
//            }
//            if (jc instanceof HAConnector) {
//                System.out.println(((HAConnector) jc).getSource());
//                System.out.println(((HAConnector) jc).getTarget());
//            }
//        }
//
//    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.JON_AS__WEB_CONTAINERS:
				return basicSetWebContainers(null, msgs);
			case JasminemodelPackage.JON_AS__RMI_REGISTRIES:
				return ((InternalEList<?>)getRmiRegistries()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.JON_AS__EJB_CONTAINERS:
				return basicSetEjbContainers(null, msgs);
			case JasminemodelPackage.JON_AS__APPLICATIONS:
				return ((InternalEList<?>)getApplications()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.JON_AS__JMS_SERVICES:
				return basicSetJmsServices(null, msgs);
			case JasminemodelPackage.JON_AS__DISCOVERY_SERVICES:
				return basicSetDiscoveryServices(null, msgs);
			case JasminemodelPackage.JON_AS__HTTP_SERVERS:
				return ((InternalEList<?>)getHttpServers()).basicRemove(otherEnd, msgs);
			case JasminemodelPackage.JON_AS__WEBCONNECTORS:
				return ((InternalEList<?>)getWebconnectors()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.JON_AS__WEB_CONTAINERS:
				return getWebContainers();
			case JasminemodelPackage.JON_AS__RMI_REGISTRIES:
				return getRmiRegistries();
			case JasminemodelPackage.JON_AS__EJB_CONTAINERS:
				return getEjbContainers();
			case JasminemodelPackage.JON_AS__APPLICATIONS:
				return getApplications();
			case JasminemodelPackage.JON_AS__JMS_SERVICES:
				return getJmsServices();
			case JasminemodelPackage.JON_AS__DISCOVERY_SERVICES:
				return getDiscoveryServices();
			case JasminemodelPackage.JON_AS__HTTP_SERVERS:
				return getHttpServers();
			case JasminemodelPackage.JON_AS__NAME:
				return getName();
			case JasminemodelPackage.JON_AS__INSTANCE_NAME:
				return getInstanceName();
			case JasminemodelPackage.JON_AS__WEBCONNECTORS:
				return getWebconnectors();
			case JasminemodelPackage.JON_AS__JONAS_BASE:
				return getJonasBase();
			case JasminemodelPackage.JON_AS__JONAS_ROOT:
				return getJonasRoot();
			case JasminemodelPackage.JON_AS__DOMAIN:
				return getDomain();
			case JasminemodelPackage.JON_AS__MASTER:
				return isMaster() ? Boolean.TRUE : Boolean.FALSE;
			case JasminemodelPackage.JON_AS__CLUSTERS:
				return getClusters();
			case JasminemodelPackage.JON_AS__CMIGROUP:
				if (resolve) return getCmigroup();
				return basicGetCmigroup();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.JON_AS__WEB_CONTAINERS:
				setWebContainers((WebContainer)newValue);
				return;
			case JasminemodelPackage.JON_AS__RMI_REGISTRIES:
				getRmiRegistries().clear();
				getRmiRegistries().addAll((Collection<? extends IRMIRegistry>)newValue);
				return;
			case JasminemodelPackage.JON_AS__EJB_CONTAINERS:
				setEjbContainers((EJBContainer)newValue);
				return;
			case JasminemodelPackage.JON_AS__APPLICATIONS:
				getApplications().clear();
				getApplications().addAll((Collection<? extends IApplication>)newValue);
				return;
			case JasminemodelPackage.JON_AS__JMS_SERVICES:
				setJmsServices((JmsService)newValue);
				return;
			case JasminemodelPackage.JON_AS__DISCOVERY_SERVICES:
				setDiscoveryServices((DiscoveryService)newValue);
				return;
			case JasminemodelPackage.JON_AS__HTTP_SERVERS:
				getHttpServers().clear();
				getHttpServers().addAll((Collection<? extends IHTTPServer>)newValue);
				return;
			case JasminemodelPackage.JON_AS__NAME:
				setName((String)newValue);
				return;
			case JasminemodelPackage.JON_AS__INSTANCE_NAME:
				setInstanceName((String)newValue);
				return;
			case JasminemodelPackage.JON_AS__WEBCONNECTORS:
				getWebconnectors().clear();
				getWebconnectors().addAll((Collection<? extends WebConnector>)newValue);
				return;
			case JasminemodelPackage.JON_AS__JONAS_BASE:
				setJonasBase((String)newValue);
				return;
			case JasminemodelPackage.JON_AS__JONAS_ROOT:
				setJonasRoot((String)newValue);
				return;
			case JasminemodelPackage.JON_AS__DOMAIN:
				setDomain((String)newValue);
				return;
			case JasminemodelPackage.JON_AS__MASTER:
				setMaster(((Boolean)newValue).booleanValue());
				return;
			case JasminemodelPackage.JON_AS__CLUSTERS:
				getClusters().clear();
				getClusters().addAll((Collection<? extends Cluster>)newValue);
				return;
			case JasminemodelPackage.JON_AS__CMIGROUP:
				setCmigroup((CmiGroup)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JON_AS__WEB_CONTAINERS:
				setWebContainers((WebContainer)null);
				return;
			case JasminemodelPackage.JON_AS__RMI_REGISTRIES:
				getRmiRegistries().clear();
				return;
			case JasminemodelPackage.JON_AS__EJB_CONTAINERS:
				setEjbContainers((EJBContainer)null);
				return;
			case JasminemodelPackage.JON_AS__APPLICATIONS:
				getApplications().clear();
				return;
			case JasminemodelPackage.JON_AS__JMS_SERVICES:
				setJmsServices((JmsService)null);
				return;
			case JasminemodelPackage.JON_AS__DISCOVERY_SERVICES:
				setDiscoveryServices((DiscoveryService)null);
				return;
			case JasminemodelPackage.JON_AS__HTTP_SERVERS:
				getHttpServers().clear();
				return;
			case JasminemodelPackage.JON_AS__NAME:
				setName(NAME_EDEFAULT);
				return;
			case JasminemodelPackage.JON_AS__INSTANCE_NAME:
				setInstanceName(INSTANCE_NAME_EDEFAULT);
				return;
			case JasminemodelPackage.JON_AS__WEBCONNECTORS:
				getWebconnectors().clear();
				return;
			case JasminemodelPackage.JON_AS__JONAS_BASE:
				setJonasBase(JONAS_BASE_EDEFAULT);
				return;
			case JasminemodelPackage.JON_AS__JONAS_ROOT:
				setJonasRoot(JONAS_ROOT_EDEFAULT);
				return;
			case JasminemodelPackage.JON_AS__DOMAIN:
				setDomain(DOMAIN_EDEFAULT);
				return;
			case JasminemodelPackage.JON_AS__MASTER:
				setMaster(MASTER_EDEFAULT);
				return;
			case JasminemodelPackage.JON_AS__CLUSTERS:
				getClusters().clear();
				return;
			case JasminemodelPackage.JON_AS__CMIGROUP:
				setCmigroup((CmiGroup)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JON_AS__WEB_CONTAINERS:
				return webContainers != null;
			case JasminemodelPackage.JON_AS__RMI_REGISTRIES:
				return rmiRegistries != null && !rmiRegistries.isEmpty();
			case JasminemodelPackage.JON_AS__EJB_CONTAINERS:
				return ejbContainers != null;
			case JasminemodelPackage.JON_AS__APPLICATIONS:
				return applications != null && !applications.isEmpty();
			case JasminemodelPackage.JON_AS__JMS_SERVICES:
				return jmsServices != null;
			case JasminemodelPackage.JON_AS__DISCOVERY_SERVICES:
				return discoveryServices != null;
			case JasminemodelPackage.JON_AS__HTTP_SERVERS:
				return httpServers != null && !httpServers.isEmpty();
			case JasminemodelPackage.JON_AS__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case JasminemodelPackage.JON_AS__INSTANCE_NAME:
				return INSTANCE_NAME_EDEFAULT == null ? instanceName != null : !INSTANCE_NAME_EDEFAULT.equals(instanceName);
			case JasminemodelPackage.JON_AS__WEBCONNECTORS:
				return webconnectors != null && !webconnectors.isEmpty();
			case JasminemodelPackage.JON_AS__JONAS_BASE:
				return JONAS_BASE_EDEFAULT == null ? jonasBase != null : !JONAS_BASE_EDEFAULT.equals(jonasBase);
			case JasminemodelPackage.JON_AS__JONAS_ROOT:
				return JONAS_ROOT_EDEFAULT == null ? jonasRoot != null : !JONAS_ROOT_EDEFAULT.equals(jonasRoot);
			case JasminemodelPackage.JON_AS__DOMAIN:
				return DOMAIN_EDEFAULT == null ? domain != null : !DOMAIN_EDEFAULT.equals(domain);
			case JasminemodelPackage.JON_AS__MASTER:
				return master != MASTER_EDEFAULT;
			case JasminemodelPackage.JON_AS__CLUSTERS:
				return clusters != null && !clusters.isEmpty();
			case JasminemodelPackage.JON_AS__CMIGROUP:
				return cmigroup != null;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", instanceName: ");
		result.append(instanceName);
		result.append(", jonasBase: ");
		result.append(jonasBase);
		result.append(", jonasRoot: ");
		result.append(jonasRoot);
		result.append(", domain: ");
		result.append(domain);
		result.append(", master: ");
		result.append(master);
		result.append(')');
		return result.toString();
	}

} // JOnASImpl
