/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.objectweb.jasmine.jade.service.deployer.DeploymentException;
import org.objectweb.jasmine.ui.jasminemodel.*;
import org.objectweb.jasmine.ui.jasminemodel.AJP;
import org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.ApacheProperties;
import org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd;
import org.objectweb.jasmine.ui.jasminemodel.CMI;
import org.objectweb.jasmine.ui.jasminemodel.CMIConnector;
import org.objectweb.jasmine.ui.jasminemodel.Cluster;
import org.objectweb.jasmine.ui.jasminemodel.ClusterContainer;
import org.objectweb.jasmine.ui.jasminemodel.CmiGroup;
import org.objectweb.jasmine.ui.jasminemodel.DB;
import org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider;
import org.objectweb.jasmine.ui.jasminemodel.DbLink;
import org.objectweb.jasmine.ui.jasminemodel.DiscoveryService;
import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.EjbJar;
import org.objectweb.jasmine.ui.jasminemodel.HAConnector;
import org.objectweb.jasmine.ui.jasminemodel.HTTP;
import org.objectweb.jasmine.ui.jasminemodel.HTTPS;
import org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup;
import org.objectweb.jasmine.ui.jasminemodel.HaGroup;
import org.objectweb.jasmine.ui.jasminemodel.IIOP;
import org.objectweb.jasmine.ui.jasminemodel.IJBossConnector;
import org.objectweb.jasmine.ui.jasminemodel.IRMI;
import org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry;
import org.objectweb.jasmine.ui.jasminemodel.JASMINe;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JBossAS;
import org.objectweb.jasmine.ui.jasminemodel.JBossBinding;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup;
import org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector;
import org.objectweb.jasmine.ui.jasminemodel.JOnAS;
import org.objectweb.jasmine.ui.jasminemodel.JRMP;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;
import org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.ModJKModule;
import org.objectweb.jasmine.ui.jasminemodel.RMIGroup;
import org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector;
import org.objectweb.jasmine.ui.jasminemodel.RmiConnector;
import org.objectweb.jasmine.ui.jasminemodel.Server;
import org.objectweb.jasmine.ui.jasminemodel.ServerPool;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;
import org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation;
import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class JasminemodelFactoryImpl extends EFactoryImpl implements
        JasminemodelFactory {
    /**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public static JasminemodelFactory init() {
		try {
			JasminemodelFactory theJasminemodelFactory = (JasminemodelFactory)EPackage.Registry.INSTANCE.getEFactory("http:///org.objectweb.jasmine.model.ecore");
			if (theJasminemodelFactory != null) {
				return theJasminemodelFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new JasminemodelFactoryImpl();
	}

    /**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public JasminemodelFactoryImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case JasminemodelPackage.JASMI_NE: return createJASMINe();
			case JasminemodelPackage.SERVER_POOL: return createServerPool();
			case JasminemodelPackage.SERVER: return createServer();
			case JasminemodelPackage.JASMI_NE_NODE: return createJASMINeNode();
			case JasminemodelPackage.DOMAIN: return createDomain();
			case JasminemodelPackage.CLUSTER: return createCluster();
			case JasminemodelPackage.DB: return createDB();
			case JasminemodelPackage.JON_AS: return createJOnAS();
			case JasminemodelPackage.APACHE_HTT_PD: return createApache_HTTPd();
			case JasminemodelPackage.WEB_CONTAINER: return createWebContainer();
			case JasminemodelPackage.EJB_CONTAINER: return createEJBContainer();
			case JasminemodelPackage.EJB_JAR: return createEjbJar();
			case JasminemodelPackage.MOD_JK_MODULE: return createModJKModule();
			case JasminemodelPackage.REP_HTTP_CONNECTOR: return createRepHTTPConnector();
			case JasminemodelPackage.HA_CONNECTOR: return createHAConnector();
			case JasminemodelPackage.IRMI_REGISTRY: return createIRMIRegistry();
			case JasminemodelPackage.IIOP: return createIIOP();
			case JasminemodelPackage.JRMP: return createJRMP();
			case JasminemodelPackage.CMI: return createCMI();
			case JasminemodelPackage.IRMI: return createIRMI();
			case JasminemodelPackage.CMI_GROUP: return createCmiGroup();
			case JasminemodelPackage.HA_GROUP: return createHaGroup();
			case JasminemodelPackage.CLUSTER_CONTAINER: return createClusterContainer();
			case JasminemodelPackage.HTTP_REP_GROUP: return createHTTP_RepGroup();
			case JasminemodelPackage.RMI_GROUP: return createRMIGroup();
			case JasminemodelPackage.DB_LINK: return createDbLink();
			case JasminemodelPackage.RMI_CONNECTOR: return createRmiConnector();
			case JasminemodelPackage.AJP: return createAJP();
			case JasminemodelPackage.HTTP: return createHTTP();
			case JasminemodelPackage.HTTPS: return createHTTPS();
			case JasminemodelPackage.JMS_SERVICE: return createJmsService();
			case JasminemodelPackage.DISCOVERY_SERVICE: return createDiscoveryService();
			case JasminemodelPackage.MIDDLEWARE_COMPONENT: return createMiddlewareComponent();
			case JasminemodelPackage.APACHE_PROPERTIES: return createApacheProperties();
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES: return createApacheMiddlewareProperties();
			case JasminemodelPackage.JBOSS_AS: return createJBossAS();
			case JasminemodelPackage.JBOSS_BINDING: return createJBossBinding();
			case JasminemodelPackage.IJ_BOSS_CONNECTOR: return createIJBossConnector();
			case JasminemodelPackage.JBOSS_HA_CONNECTOR: return createJBossHAConnector();
			case JasminemodelPackage.JBOSS_HTTP_REP_CONNECTOR: return createJBossHTTPRepConnector();
			case JasminemodelPackage.JBOSS_HA_GROUP: return createJBossHAGroup();
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR: return createJBossModJKConnector();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case JasminemodelPackage.WEB_CONTAINER_IMPLEMENTATION:
				return createWebContainerImplementationFromString(eDataType, initialValue);
			case JasminemodelPackage.DATABASE_PROVIDER:
				return createDatabaseProviderFromString(eDataType, initialValue);
			case JasminemodelPackage.INET_ADDRESS:
				return createInetAddressFromString(eDataType, initialValue);
			case JasminemodelPackage.PORT:
				return createPortFromString(eDataType, initialValue);
			case JasminemodelPackage.DEPLOYMENT_EXCEPTION:
				return createDeploymentExceptionFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case JasminemodelPackage.WEB_CONTAINER_IMPLEMENTATION:
				return convertWebContainerImplementationToString(eDataType, instanceValue);
			case JasminemodelPackage.DATABASE_PROVIDER:
				return convertDatabaseProviderToString(eDataType, instanceValue);
			case JasminemodelPackage.INET_ADDRESS:
				return convertInetAddressToString(eDataType, instanceValue);
			case JasminemodelPackage.PORT:
				return convertPortToString(eDataType, instanceValue);
			case JasminemodelPackage.DEPLOYMENT_EXCEPTION:
				return convertDeploymentExceptionToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JASMINe createJASMINe() {
		JASMINeImpl jasmiNe = new JASMINeImpl();
		return jasmiNe;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ServerPool createServerPool() {
		ServerPoolImpl serverPool = new ServerPoolImpl();
		return serverPool;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Server createServer() {
		ServerImpl server = new ServerImpl();
		return server;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JASMINeNode createJASMINeNode() {
		JASMINeNodeImpl jasmiNeNode = new JASMINeNodeImpl();
		return jasmiNeNode;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Domain createDomain() {
		DomainImpl domain = new DomainImpl();
		return domain;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Cluster createCluster() {
		ClusterImpl cluster = new ClusterImpl();
		return cluster;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DB createDB() {
		DBImpl db = new DBImpl();
		return db;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JOnAS createJOnAS() {
		JOnASImpl jOnAS = new JOnASImpl();
		return jOnAS;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Apache_HTTPd createApache_HTTPd() {
		Apache_HTTPdImpl apache_HTTPd = new Apache_HTTPdImpl();
		return apache_HTTPd;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public WebContainer createWebContainer() {
		WebContainerImpl webContainer = new WebContainerImpl();
		return webContainer;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EJBContainer createEJBContainer() {
		EJBContainerImpl ejbContainer = new EJBContainerImpl();
		return ejbContainer;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public IRMIRegistry createIRMIRegistry() {
		IRMIRegistryImpl irmiRegistry = new IRMIRegistryImpl();
		return irmiRegistry;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EjbJar createEjbJar() {
		EjbJarImpl ejbJar = new EjbJarImpl();
		return ejbJar;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ModJKModule createModJKModule() {
		ModJKModuleImpl modJKModule = new ModJKModuleImpl();
		return modJKModule;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RepHTTPConnector createRepHTTPConnector() {
		RepHTTPConnectorImpl repHTTPConnector = new RepHTTPConnectorImpl();
		return repHTTPConnector;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public HAConnector createHAConnector() {
		HAConnectorImpl haConnector = new HAConnectorImpl();
		return haConnector;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public IIOP createIIOP() {
		IIOPImpl iiop = new IIOPImpl();
		return iiop;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JRMP createJRMP() {
		JRMPImpl jrmp = new JRMPImpl();
		return jrmp;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public CMI createCMI() {
		CMIImpl cmi = new CMIImpl();
		return cmi;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public IRMI createIRMI() {
		IRMIImpl irmi = new IRMIImpl();
		return irmi;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public CmiGroup createCmiGroup() {
		CmiGroupImpl cmiGroup = new CmiGroupImpl();
		return cmiGroup;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public HaGroup createHaGroup() {
		HaGroupImpl haGroup = new HaGroupImpl();
		return haGroup;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ClusterContainer createClusterContainer() {
		ClusterContainerImpl clusterContainer = new ClusterContainerImpl();
		return clusterContainer;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public HTTP_RepGroup createHTTP_RepGroup() {
		HTTP_RepGroupImpl httP_RepGroup = new HTTP_RepGroupImpl();
		return httP_RepGroup;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RMIGroup createRMIGroup() {
		RMIGroupImpl rmiGroup = new RMIGroupImpl();
		return rmiGroup;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DbLink createDbLink() {
		DbLinkImpl dbLink = new DbLinkImpl();
		return dbLink;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RmiConnector createRmiConnector() {
		RmiConnectorImpl rmiConnector = new RmiConnectorImpl();
		return rmiConnector;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public AJP createAJP() {
		AJPImpl ajp = new AJPImpl();
		return ajp;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public HTTP createHTTP() {
		HTTPImpl http = new HTTPImpl();
		return http;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public HTTPS createHTTPS() {
		HTTPSImpl https = new HTTPSImpl();
		return https;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JmsService createJmsService() {
		JmsServiceImpl jmsService = new JmsServiceImpl();
		return jmsService;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DiscoveryService createDiscoveryService() {
		DiscoveryServiceImpl discoveryService = new DiscoveryServiceImpl();
		return discoveryService;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public MiddlewareComponent createMiddlewareComponent() {
		MiddlewareComponentImpl middlewareComponent = new MiddlewareComponentImpl();
		return middlewareComponent;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ApacheProperties createApacheProperties() {
		ApachePropertiesImpl apacheProperties = new ApachePropertiesImpl();
		return apacheProperties;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ApacheMiddlewareProperties createApacheMiddlewareProperties() {
		ApacheMiddlewarePropertiesImpl apacheMiddlewareProperties = new ApacheMiddlewarePropertiesImpl();
		return apacheMiddlewareProperties;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossAS createJBossAS() {
		JBossASImpl jBossAS = new JBossASImpl();
		return jBossAS;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossBinding createJBossBinding() {
		JBossBindingImpl jBossBinding = new JBossBindingImpl();
		return jBossBinding;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public IJBossConnector createIJBossConnector() {
		IJBossConnectorImpl ijBossConnector = new IJBossConnectorImpl();
		return ijBossConnector;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossHAConnector createJBossHAConnector() {
		JBossHAConnectorImpl jBossHAConnector = new JBossHAConnectorImpl();
		return jBossHAConnector;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossHTTPRepConnector createJBossHTTPRepConnector() {
		JBossHTTPRepConnectorImpl jBossHTTPRepConnector = new JBossHTTPRepConnectorImpl();
		return jBossHTTPRepConnector;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossHAGroup createJBossHAGroup() {
		JBossHAGroupImpl jBossHAGroup = new JBossHAGroupImpl();
		return jBossHAGroup;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JBossModJKConnector createJBossModJKConnector() {
		JBossModJKConnectorImpl jBossModJKConnector = new JBossModJKConnectorImpl();
		return jBossModJKConnector;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public WebContainerImplementation createWebContainerImplementationFromString(
            EDataType eDataType, String initialValue) {
		WebContainerImplementation result = WebContainerImplementation.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertWebContainerImplementationToString(
            EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DatabaseProvider createDatabaseProviderFromString(
            EDataType eDataType, String initialValue) {
		DatabaseProvider result = DatabaseProvider.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertDatabaseProviderToString(EDataType eDataType,
            Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public InetAddress createInetAddressFromString(EDataType eDataType,
            String initialValue) {
        return getIpFromString(initialValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String convertInetAddressToString(EDataType eDataType,
            Object instanceValue) {

        if (instanceValue == null)
            return null;
        String address = ((InetAddress) instanceValue).toString();
        StringTokenizer st = new StringTokenizer(address, "/");
        return getNextToken(st);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public Port createPortFromString(EDataType eDataType, String initialValue) {
        return initialValue == null ? null : (initialValue.equals("") ? null
                : new Port(Integer.parseInt(initialValue)));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public String convertPortToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DeploymentException createDeploymentExceptionFromString(
            EDataType eDataType, String initialValue) {
		return (DeploymentException)super.createFromString(eDataType, initialValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertDeploymentExceptionToString(EDataType eDataType,
            Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JasminemodelPackage getJasminemodelPackage() {
		return (JasminemodelPackage)getEPackage();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
    @Deprecated
    public static JasminemodelPackage getPackage() {
		return JasminemodelPackage.eINSTANCE;
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    private static InetAddress getIpFromString(String address) {
        try {
            return address == null ? null : (address.equals("") ? null
                    : (InetAddress) InetAddress.getByName(address));
        } catch (UnknownHostException e) {
            throw new IllegalArgumentException("The value '" + address
                    + "' is not a valid IP address");
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    private static String getNextToken(StringTokenizer st) {

        String value = "";
        try {
            if ((value = st.nextToken()).equals("\\/"))
                return "";

            else {
                st.nextToken();
                return value;
            }
        } catch (NoSuchElementException nsee) {
            return value;
        }

    }

} // JasminemodelFactoryImpl
