/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.net.InetAddress;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.objectweb.jasmine.jade.service.deployer.DeploymentException;
import org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.ApacheProperties;
import org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd;
import org.objectweb.jasmine.ui.jasminemodel.CMIConnector;
import org.objectweb.jasmine.ui.jasminemodel.Cluster;
import org.objectweb.jasmine.ui.jasminemodel.ClusterContainer;
import org.objectweb.jasmine.ui.jasminemodel.CmiGroup;
import org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode;
import org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider;
import org.objectweb.jasmine.ui.jasminemodel.DbLink;
import org.objectweb.jasmine.ui.jasminemodel.DiscoveryService;
import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.EjbJar;
import org.objectweb.jasmine.ui.jasminemodel.HAConnector;
import org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup;
import org.objectweb.jasmine.ui.jasminemodel.HaGroup;
import org.objectweb.jasmine.ui.jasminemodel.IApplication;
import org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode;
import org.objectweb.jasmine.ui.jasminemodel.IConnector;
import org.objectweb.jasmine.ui.jasminemodel.IContainer;
import org.objectweb.jasmine.ui.jasminemodel.IHTTPServer;
import org.objectweb.jasmine.ui.jasminemodel.IJBossConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJavaEEConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer;
import org.objectweb.jasmine.ui.jasminemodel.ILocatable;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.IModule;
import org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry;
import org.objectweb.jasmine.ui.jasminemodel.IWebConnector;
import org.objectweb.jasmine.ui.jasminemodel.JASMINe;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JBossAS;
import org.objectweb.jasmine.ui.jasminemodel.JBossBinding;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup;
import org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector;
import org.objectweb.jasmine.ui.jasminemodel.JOnAS;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;
import org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.ModJKModule;
import org.objectweb.jasmine.ui.jasminemodel.RMIGroup;
import org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector;
import org.objectweb.jasmine.ui.jasminemodel.RmiConnector;
import org.objectweb.jasmine.ui.jasminemodel.Server;
import org.objectweb.jasmine.ui.jasminemodel.ServerPool;
import org.objectweb.jasmine.ui.jasminemodel.WebConnector;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;
import org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation;
import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class JasminemodelPackageImpl extends EPackageImpl implements
        JasminemodelPackage {
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jasmiNeEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass serverPoolEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass serverEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jasmiNeNodeEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass domainEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass clusterEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iJavaEEConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass ijOnASConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass dbEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iMiddlewareComponentEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iMiddlewarePropertiesEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jOnASEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass apache_HTTPdEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iContainerEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iJavaEEServerEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass ihttpServerEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass webContainerEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass ejbContainerEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass ejbJarEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iModuleEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass modJKModuleEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iApplicationEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass repHTTPConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass haConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass irmiRegistryEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iiopEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jrmpEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass cmiEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass irmiEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass cmiGroupEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass configurationNodeEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass haGroupEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass clusterContainerEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass httP_RepGroupEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass rmiGroupEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass dbLinkEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iConfigurationNodeEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass rmiConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass webConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass ajpEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass httpEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass httpsEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iWebConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jmsServiceEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass discoveryServiceEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass middlewareComponentEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass apachePropertiesEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass apacheMiddlewarePropertiesEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass iLocatableEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jBossASEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jBossBindingEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass ijBossConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jBossHAConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jBossHTTPRepConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jBossHAGroupEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass jBossModJKConnectorEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum webContainerImplementationEEnum = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum databaseProviderEEnum = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EDataType inetAddressEDataType = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EDataType portEDataType = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EDataType deploymentExceptionEDataType = null;

    /**
     * Creates an instance of the model <b>Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
     * package package URI value.
     * <p>
     * Note: the correct way to create the package is via the static factory
     * method {@link #init init()}, which also performs initialization of the
     * package, or returns the registered package, if one already exists. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private JasminemodelPackageImpl() {
		super(eNS_URI, JasminemodelFactory.eINSTANCE);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private static boolean isInited = false;

    /**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
    public static JasminemodelPackage init() {
		if (isInited) return (JasminemodelPackage)EPackage.Registry.INSTANCE.getEPackage(JasminemodelPackage.eNS_URI);

		// Obtain or create and register package
		JasminemodelPackageImpl theJasminemodelPackage = (JasminemodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof JasminemodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new JasminemodelPackageImpl());

		isInited = true;

		// Create package meta-data objects
		theJasminemodelPackage.createPackageContents();

		// Initialize created meta-data
		theJasminemodelPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theJasminemodelPackage.freeze();

		return theJasminemodelPackage;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJASMINe() {
		return jasmiNeEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJASMINe_ServerPool() {
		return (EReference)jasmiNeEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJASMINe_Domain() {
		return (EReference)jasmiNeEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getServerPool() {
		return serverPoolEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getServerPool_Server() {
		return (EReference)serverPoolEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getServer() {
		return serverEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getServer_JadeNode() {
		return (EReference)serverEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJASMINeNode() {
		return jasmiNeNodeEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_DiscoveryHost() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(9);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_DiscoveryPort() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(10);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_Host() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_User() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_Password() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_SshKey() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_InstallDir() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_JndiPort() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(11);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_NodeId() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(6);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_FelixProfile() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(12);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_RegistryHost() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(7);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_RegistryPort() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(8);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_RepositoryURL() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(13);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJASMINeNode_Middlewares() {
		return (EReference)jasmiNeNodeEClass.getEStructuralFeatures().get(14);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJASMINeNode_Name() {
		return (EAttribute)jasmiNeNodeEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getDomain() {
		return domainEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDomain_MiddlewareComponents() {
		return (EReference)domainEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDomain_Connectors() {
		return (EReference)domainEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDomain_ConfigurationNodes() {
		return (EReference)domainEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDomain_ClusterContainers() {
		return (EReference)domainEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDomain_Db() {
		return (EReference)domainEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDomain_Dblinks() {
		return (EReference)domainEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getCluster() {
		return clusterEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getCluster_Name() {
		return (EAttribute)clusterEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIConnector() {
		return iConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIJavaEEConnector() {
		return iJavaEEConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIJOnASConnector() {
		return ijOnASConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getDB() {
		return dbEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_Provider() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_User() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_Password() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_Url() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_DriverName() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_JndiName() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_JdbcDriverJarFile() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(6);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_MappernName() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(7);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_Name() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(8);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDB_Port() {
		return (EAttribute)dbEClass.getEStructuralFeatures().get(9);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDB_JasmineNode() {
		return (EReference)dbEClass.getEStructuralFeatures().get(10);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIMiddlewareComponent() {
		return iMiddlewareComponentEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getIMiddlewareComponent_JasmineNode() {
		return (EReference)iMiddlewareComponentEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIMiddlewareProperties() {
		return iMiddlewarePropertiesEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIMiddlewareProperties_Name() {
		return (EAttribute)iMiddlewarePropertiesEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIMiddlewareProperties_PropertyFile() {
		return (EAttribute)iMiddlewarePropertiesEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIMiddlewareProperties_Description() {
		return (EAttribute)iMiddlewarePropertiesEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJOnAS() {
		return jOnASEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJOnAS_Name() {
		return (EAttribute)jOnASEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJOnAS_InstanceName() {
		return (EAttribute)jOnASEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJOnAS_Webconnectors() {
		return (EReference)jOnASEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJOnAS_JonasBase() {
		return (EAttribute)jOnASEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJOnAS_JonasRoot() {
		return (EAttribute)jOnASEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJOnAS_Domain() {
		return (EAttribute)jOnASEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJOnAS_Master() {
		return (EAttribute)jOnASEClass.getEStructuralFeatures().get(6);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJOnAS_Clusters() {
		return (EReference)jOnASEClass.getEStructuralFeatures().get(7);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getJOnAS_Cmigroup() {
		return (EReference)jOnASEClass.getEStructuralFeatures().get(8);
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getApache_HTTPd() {
		return apache_HTTPdEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApache_HTTPd_Name() {
		return (EAttribute)apache_HTTPdEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getApache_HTTPd_Modules() {
		return (EReference)apache_HTTPdEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApache_HTTPd_Home() {
		return (EAttribute)apache_HTTPdEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApache_HTTPd_Host() {
		return (EAttribute)apache_HTTPdEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApache_HTTPd_Port() {
		return (EAttribute)apache_HTTPdEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApache_HTTPd_User() {
		return (EAttribute)apache_HTTPdEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApache_HTTPd_Group() {
		return (EAttribute)apache_HTTPdEClass.getEStructuralFeatures().get(6);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIContainer() {
		return iContainerEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIContainer_Description() {
		return (EAttribute)iContainerEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIContainer_Name() {
		return (EAttribute)iContainerEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIJavaEEServer() {
		return iJavaEEServerEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getIJavaEEServer_WebContainers() {
		return (EReference)iJavaEEServerEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getIJavaEEServer_RmiRegistries() {
		return (EReference)iJavaEEServerEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getIJavaEEServer_EjbContainers() {
		return (EReference)iJavaEEServerEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getIJavaEEServer_Applications() {
		return (EReference)iJavaEEServerEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getIJavaEEServer_JmsServices() {
		return (EReference)iJavaEEServerEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getIJavaEEServer_DiscoveryServices() {
		return (EReference)iJavaEEServerEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIJavaEEServer_HttpServers() {
		return (EReference)iJavaEEServerEClass.getEStructuralFeatures().get(6);
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIHTTPServer() {
		return ihttpServerEClass;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIHTTPServer_JavaeeServers() {
		return (EReference)ihttpServerEClass.getEStructuralFeatures().get(0);
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getWebContainer() {
		return webContainerEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWebContainer_Type() {
		return (EAttribute)webContainerEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWebContainer_JvmRoute() {
		return (EAttribute)webContainerEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWebContainer_Host() {
		return (EAttribute)webContainerEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getEJBContainer() {
		return ejbContainerEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getEJBContainer_AutoGenic() {
		return (EAttribute)ejbContainerEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getEjbJar() {
		return ejbJarEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getEjbJar_Description() {
		return (EAttribute)ejbJarEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getEjbJar_Name() {
		return (EAttribute)ejbJarEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIModule() {
		return iModuleEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getModJKModule() {
		return modJKModuleEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getModJKModule_Description() {
		return (EAttribute)modJKModuleEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getModJKModule_Name() {
		return (EAttribute)modJKModuleEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIApplication() {
		return iApplicationEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRepHTTPConnector() {
		return repHTTPConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRepHTTPConnector_Source() {
		return (EReference)repHTTPConnectorEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRepHTTPConnector_Target() {
		return (EReference)repHTTPConnectorEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getHAConnector() {
		return haConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getHAConnector_Source() {
		return (EReference)haConnectorEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getHAConnector_Target() {
		return (EReference)haConnectorEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIRMIRegistry() {
		return irmiRegistryEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIRMIRegistry_Host() {
		return (EAttribute)irmiRegistryEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIRMIRegistry_Port() {
		return (EAttribute)irmiRegistryEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getIRMIRegistry_Name() {
		return (EAttribute)irmiRegistryEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIIOP() {
		return iiopEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJRMP() {
		return jrmpEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getCMI() {
		return cmiEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIRMI() {
		return irmiEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getCmiGroup() {
		return cmiGroupEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getCmiGroup_LanMode() {
		return (EAttribute)cmiGroupEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getCmiGroup_TcpPingHost() {
		return (EAttribute)cmiGroupEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getConfigurationNode() {
		return configurationNodeEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getConfigurationNode_Description() {
		return (EAttribute)configurationNodeEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getConfigurationNode_Host() {
		return (EAttribute)configurationNodeEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getConfigurationNode_Port() {
		return (EAttribute)configurationNodeEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getConfigurationNode_Name() {
		return (EAttribute)configurationNodeEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getHaGroup() {
		return haGroupEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getHaGroup_LanMode() {
		return (EAttribute)haGroupEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getHaGroup_TcpPingHost() {
		return (EAttribute)haGroupEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getClusterContainer() {
		return clusterContainerEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getClusterContainer_Clusters() {
		return (EReference)clusterContainerEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getHTTP_RepGroup() {
		return httP_RepGroupEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getHTTP_RepGroup_TcpListenPort() {
		return (EAttribute)httP_RepGroupEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRMIGroup() {
		return rmiGroupEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getDbLink() {
		return dbLinkEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDbLink_Source() {
		return (EReference)dbLinkEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getDbLink_Target() {
		return (EReference)dbLinkEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIConfigurationNode() {
		return iConfigurationNodeEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRmiConnector() {
		return rmiConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRmiConnector_Source() {
		return (EReference)rmiConnectorEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRmiConnector_Target() {
		return (EReference)rmiConnectorEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getWebConnector() {
		return webConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWebConnector_Description() {
		return (EAttribute)webConnectorEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWebConnector_Port() {
		return (EAttribute)webConnectorEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getWebConnector_Name() {
		return (EAttribute)webConnectorEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getAJP() {
		return ajpEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getHTTP() {
		return httpEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getHTTPS() {
		return httpsEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIWebConnector() {
		return iWebConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJmsService() {
		return jmsServiceEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJmsService_JmxServiceURL() {
		return (EAttribute)jmsServiceEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJmsService_JmsPort() {
		return (EAttribute)jmsServiceEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJmsService_JmsTopics() {
		return (EAttribute)jmsServiceEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJmsService_JmsQueues() {
		return (EAttribute)jmsServiceEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJmsService_Name() {
		return (EAttribute)jmsServiceEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getDiscoveryService() {
		return discoveryServiceEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDiscoveryService_Name() {
		return (EAttribute)discoveryServiceEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDiscoveryService_Host() {
		return (EAttribute)discoveryServiceEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDiscoveryService_Port() {
		return (EAttribute)discoveryServiceEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDiscoveryService_GreetingPort() {
		return (EAttribute)discoveryServiceEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getDiscoveryService_SourcePort() {
		return (EAttribute)discoveryServiceEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getMiddlewareComponent() {
		return middlewareComponentEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getMiddlewareComponent_MiddlewareProperties() {
		return (EReference)middlewareComponentEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getApacheProperties() {
		return apachePropertiesEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getApacheMiddlewareProperties() {
		return apacheMiddlewarePropertiesEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApacheMiddlewareProperties_Instance_apache_home() {
		return (EAttribute)apacheMiddlewarePropertiesEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApacheMiddlewareProperties_Server_listen_adress() {
		return (EAttribute)apacheMiddlewarePropertiesEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApacheMiddlewareProperties_Server_listen_port() {
		return (EAttribute)apacheMiddlewarePropertiesEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApacheMiddlewareProperties_Server_user() {
		return (EAttribute)apacheMiddlewarePropertiesEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getApacheMiddlewareProperties_Server_group() {
		return (EAttribute)apacheMiddlewarePropertiesEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getILocatable() {
		return iLocatableEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJBossAS() {
		return jBossASEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossAS_Home() {
		return (EAttribute)jBossASEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossAS_Binding() {
		return (EReference)jBossASEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossAS_Name() {
		return (EAttribute)jBossASEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossAS_Webconnectors() {
		return (EReference)jBossASEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJBossBinding() {
		return jBossBindingEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_Name() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_NamingPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_NamingRMIPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_WebservicePort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_InvokerRMIObjectPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_InvokerServerBindPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_HaNamingPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(6);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_HaNamingRMIPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(7);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_HaInvokerRMIObjectPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(8);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_HaInvokerServerBindPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(9);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_CorbaOrbPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(10);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_ConnectorRMIObjectPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(11);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_SnmpTrapPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(12);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_SnmpRequestPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(13);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_JmsServerBindPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(14);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_WebserverPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(15);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_Ejb3ConnectorPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(16);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_MessagingConnectorPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(17);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossBinding_RemotingConnectorPort() {
		return (EAttribute)jBossBindingEClass.getEStructuralFeatures().get(18);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getIJBossConnector() {
		return ijBossConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJBossHAConnector() {
		return jBossHAConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossHAConnector_Instance() {
		return (EReference)jBossHAConnectorEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossHAConnector_Group() {
		return (EReference)jBossHAConnectorEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJBossHTTPRepConnector() {
		return jBossHTTPRepConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossHTTPRepConnector_Instance() {
		return (EReference)jBossHTTPRepConnectorEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossHTTPRepConnector_Group() {
		return (EReference)jBossHTTPRepConnectorEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJBossHAGroup() {
		return jBossHAGroupEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossHAGroup_LanMode() {
		return (EAttribute)jBossHAGroupEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getJBossHAGroup_PingHosts() {
		return (EAttribute)jBossHAGroupEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getJBossModJKConnector() {
		return jBossModJKConnectorEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossModJKConnector_Jboss() {
		return (EReference)jBossModJKConnectorEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getJBossModJKConnector_Apache() {
		return (EReference)jBossModJKConnectorEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getWebContainerImplementation() {
		return webContainerImplementationEEnum;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getDatabaseProvider() {
		return databaseProviderEEnum;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EDataType getInetAddress() {
		return inetAddressEDataType;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EDataType getPort() {
		return portEDataType;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EDataType getDeploymentException() {
		return deploymentExceptionEDataType;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JasminemodelFactory getJasminemodelFactory() {
		return (JasminemodelFactory)getEFactoryInstance();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private boolean isCreated = false;

    /**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		jasmiNeEClass = createEClass(JASMI_NE);
		createEReference(jasmiNeEClass, JASMI_NE__SERVER_POOL);
		createEReference(jasmiNeEClass, JASMI_NE__DOMAIN);

		serverPoolEClass = createEClass(SERVER_POOL);
		createEReference(serverPoolEClass, SERVER_POOL__SERVER);

		serverEClass = createEClass(SERVER);
		createEReference(serverEClass, SERVER__JADE_NODE);

		jasmiNeNodeEClass = createEClass(JASMI_NE_NODE);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__NAME);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__HOST);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__USER);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__PASSWORD);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__SSH_KEY);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__INSTALL_DIR);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__NODE_ID);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__REGISTRY_HOST);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__REGISTRY_PORT);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__DISCOVERY_HOST);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__DISCOVERY_PORT);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__JNDI_PORT);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__FELIX_PROFILE);
		createEAttribute(jasmiNeNodeEClass, JASMI_NE_NODE__REPOSITORY_URL);
		createEReference(jasmiNeNodeEClass, JASMI_NE_NODE__MIDDLEWARES);

		domainEClass = createEClass(DOMAIN);
		createEReference(domainEClass, DOMAIN__MIDDLEWARE_COMPONENTS);
		createEReference(domainEClass, DOMAIN__CONNECTORS);
		createEReference(domainEClass, DOMAIN__CONFIGURATION_NODES);
		createEReference(domainEClass, DOMAIN__CLUSTER_CONTAINERS);
		createEReference(domainEClass, DOMAIN__DB);
		createEReference(domainEClass, DOMAIN__DBLINKS);

		clusterEClass = createEClass(CLUSTER);
		createEAttribute(clusterEClass, CLUSTER__NAME);

		iConnectorEClass = createEClass(ICONNECTOR);

		iJavaEEConnectorEClass = createEClass(IJAVA_EE_CONNECTOR);

		ijOnASConnectorEClass = createEClass(IJ_ON_AS_CONNECTOR);

		dbEClass = createEClass(DB);
		createEAttribute(dbEClass, DB__PROVIDER);
		createEAttribute(dbEClass, DB__USER);
		createEAttribute(dbEClass, DB__PASSWORD);
		createEAttribute(dbEClass, DB__URL);
		createEAttribute(dbEClass, DB__DRIVER_NAME);
		createEAttribute(dbEClass, DB__JNDI_NAME);
		createEAttribute(dbEClass, DB__JDBC_DRIVER_JAR_FILE);
		createEAttribute(dbEClass, DB__MAPPERN_NAME);
		createEAttribute(dbEClass, DB__NAME);
		createEAttribute(dbEClass, DB__PORT);
		createEReference(dbEClass, DB__JASMINE_NODE);

		iMiddlewareComponentEClass = createEClass(IMIDDLEWARE_COMPONENT);
		createEReference(iMiddlewareComponentEClass, IMIDDLEWARE_COMPONENT__JASMINE_NODE);

		iMiddlewarePropertiesEClass = createEClass(IMIDDLEWARE_PROPERTIES);
		createEAttribute(iMiddlewarePropertiesEClass, IMIDDLEWARE_PROPERTIES__NAME);
		createEAttribute(iMiddlewarePropertiesEClass, IMIDDLEWARE_PROPERTIES__PROPERTY_FILE);
		createEAttribute(iMiddlewarePropertiesEClass, IMIDDLEWARE_PROPERTIES__DESCRIPTION);

		jOnASEClass = createEClass(JON_AS);
		createEAttribute(jOnASEClass, JON_AS__NAME);
		createEAttribute(jOnASEClass, JON_AS__INSTANCE_NAME);
		createEReference(jOnASEClass, JON_AS__WEBCONNECTORS);
		createEAttribute(jOnASEClass, JON_AS__JONAS_BASE);
		createEAttribute(jOnASEClass, JON_AS__JONAS_ROOT);
		createEAttribute(jOnASEClass, JON_AS__DOMAIN);
		createEAttribute(jOnASEClass, JON_AS__MASTER);
		createEReference(jOnASEClass, JON_AS__CLUSTERS);
		createEReference(jOnASEClass, JON_AS__CMIGROUP);

		apache_HTTPdEClass = createEClass(APACHE_HTT_PD);
		createEAttribute(apache_HTTPdEClass, APACHE_HTT_PD__NAME);
		createEReference(apache_HTTPdEClass, APACHE_HTT_PD__MODULES);
		createEAttribute(apache_HTTPdEClass, APACHE_HTT_PD__HOME);
		createEAttribute(apache_HTTPdEClass, APACHE_HTT_PD__HOST);
		createEAttribute(apache_HTTPdEClass, APACHE_HTT_PD__PORT);
		createEAttribute(apache_HTTPdEClass, APACHE_HTT_PD__USER);
		createEAttribute(apache_HTTPdEClass, APACHE_HTT_PD__GROUP);

		iContainerEClass = createEClass(ICONTAINER);
		createEAttribute(iContainerEClass, ICONTAINER__DESCRIPTION);
		createEAttribute(iContainerEClass, ICONTAINER__NAME);

		iJavaEEServerEClass = createEClass(IJAVA_EE_SERVER);
		createEReference(iJavaEEServerEClass, IJAVA_EE_SERVER__WEB_CONTAINERS);
		createEReference(iJavaEEServerEClass, IJAVA_EE_SERVER__RMI_REGISTRIES);
		createEReference(iJavaEEServerEClass, IJAVA_EE_SERVER__EJB_CONTAINERS);
		createEReference(iJavaEEServerEClass, IJAVA_EE_SERVER__APPLICATIONS);
		createEReference(iJavaEEServerEClass, IJAVA_EE_SERVER__JMS_SERVICES);
		createEReference(iJavaEEServerEClass, IJAVA_EE_SERVER__DISCOVERY_SERVICES);
		createEReference(iJavaEEServerEClass, IJAVA_EE_SERVER__HTTP_SERVERS);

		ihttpServerEClass = createEClass(IHTTP_SERVER);
		createEReference(ihttpServerEClass, IHTTP_SERVER__JAVAEE_SERVERS);

		webContainerEClass = createEClass(WEB_CONTAINER);
		createEAttribute(webContainerEClass, WEB_CONTAINER__TYPE);
		createEAttribute(webContainerEClass, WEB_CONTAINER__JVM_ROUTE);
		createEAttribute(webContainerEClass, WEB_CONTAINER__HOST);

		ejbContainerEClass = createEClass(EJB_CONTAINER);
		createEAttribute(ejbContainerEClass, EJB_CONTAINER__AUTO_GENIC);

		ejbJarEClass = createEClass(EJB_JAR);
		createEAttribute(ejbJarEClass, EJB_JAR__DESCRIPTION);
		createEAttribute(ejbJarEClass, EJB_JAR__NAME);

		iModuleEClass = createEClass(IMODULE);

		modJKModuleEClass = createEClass(MOD_JK_MODULE);
		createEAttribute(modJKModuleEClass, MOD_JK_MODULE__DESCRIPTION);
		createEAttribute(modJKModuleEClass, MOD_JK_MODULE__NAME);

		iApplicationEClass = createEClass(IAPPLICATION);

		repHTTPConnectorEClass = createEClass(REP_HTTP_CONNECTOR);
		createEReference(repHTTPConnectorEClass, REP_HTTP_CONNECTOR__SOURCE);
		createEReference(repHTTPConnectorEClass, REP_HTTP_CONNECTOR__TARGET);

		haConnectorEClass = createEClass(HA_CONNECTOR);
		createEReference(haConnectorEClass, HA_CONNECTOR__SOURCE);
		createEReference(haConnectorEClass, HA_CONNECTOR__TARGET);

		irmiRegistryEClass = createEClass(IRMI_REGISTRY);
		createEAttribute(irmiRegistryEClass, IRMI_REGISTRY__HOST);
		createEAttribute(irmiRegistryEClass, IRMI_REGISTRY__PORT);
		createEAttribute(irmiRegistryEClass, IRMI_REGISTRY__NAME);

		iiopEClass = createEClass(IIOP);

		jrmpEClass = createEClass(JRMP);

		cmiEClass = createEClass(CMI);

		irmiEClass = createEClass(IRMI);

		cmiGroupEClass = createEClass(CMI_GROUP);
		createEAttribute(cmiGroupEClass, CMI_GROUP__LAN_MODE);
		createEAttribute(cmiGroupEClass, CMI_GROUP__TCP_PING_HOST);

		configurationNodeEClass = createEClass(CONFIGURATION_NODE);
		createEAttribute(configurationNodeEClass, CONFIGURATION_NODE__DESCRIPTION);
		createEAttribute(configurationNodeEClass, CONFIGURATION_NODE__HOST);
		createEAttribute(configurationNodeEClass, CONFIGURATION_NODE__PORT);
		createEAttribute(configurationNodeEClass, CONFIGURATION_NODE__NAME);

		haGroupEClass = createEClass(HA_GROUP);
		createEAttribute(haGroupEClass, HA_GROUP__LAN_MODE);
		createEAttribute(haGroupEClass, HA_GROUP__TCP_PING_HOST);

		clusterContainerEClass = createEClass(CLUSTER_CONTAINER);
		createEReference(clusterContainerEClass, CLUSTER_CONTAINER__CLUSTERS);

		httP_RepGroupEClass = createEClass(HTTP_REP_GROUP);
		createEAttribute(httP_RepGroupEClass, HTTP_REP_GROUP__TCP_LISTEN_PORT);

		rmiGroupEClass = createEClass(RMI_GROUP);

		dbLinkEClass = createEClass(DB_LINK);
		createEReference(dbLinkEClass, DB_LINK__SOURCE);
		createEReference(dbLinkEClass, DB_LINK__TARGET);

		iConfigurationNodeEClass = createEClass(ICONFIGURATION_NODE);

		rmiConnectorEClass = createEClass(RMI_CONNECTOR);
		createEReference(rmiConnectorEClass, RMI_CONNECTOR__SOURCE);
		createEReference(rmiConnectorEClass, RMI_CONNECTOR__TARGET);

		webConnectorEClass = createEClass(WEB_CONNECTOR);
		createEAttribute(webConnectorEClass, WEB_CONNECTOR__DESCRIPTION);
		createEAttribute(webConnectorEClass, WEB_CONNECTOR__PORT);
		createEAttribute(webConnectorEClass, WEB_CONNECTOR__NAME);

		ajpEClass = createEClass(AJP);

		httpEClass = createEClass(HTTP);

		httpsEClass = createEClass(HTTPS);

		iWebConnectorEClass = createEClass(IWEB_CONNECTOR);

		jmsServiceEClass = createEClass(JMS_SERVICE);
		createEAttribute(jmsServiceEClass, JMS_SERVICE__JMX_SERVICE_URL);
		createEAttribute(jmsServiceEClass, JMS_SERVICE__JMS_PORT);
		createEAttribute(jmsServiceEClass, JMS_SERVICE__JMS_TOPICS);
		createEAttribute(jmsServiceEClass, JMS_SERVICE__JMS_QUEUES);
		createEAttribute(jmsServiceEClass, JMS_SERVICE__NAME);

		discoveryServiceEClass = createEClass(DISCOVERY_SERVICE);
		createEAttribute(discoveryServiceEClass, DISCOVERY_SERVICE__NAME);
		createEAttribute(discoveryServiceEClass, DISCOVERY_SERVICE__HOST);
		createEAttribute(discoveryServiceEClass, DISCOVERY_SERVICE__PORT);
		createEAttribute(discoveryServiceEClass, DISCOVERY_SERVICE__GREETING_PORT);
		createEAttribute(discoveryServiceEClass, DISCOVERY_SERVICE__SOURCE_PORT);

		middlewareComponentEClass = createEClass(MIDDLEWARE_COMPONENT);
		createEReference(middlewareComponentEClass, MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES);

		apachePropertiesEClass = createEClass(APACHE_PROPERTIES);

		apacheMiddlewarePropertiesEClass = createEClass(APACHE_MIDDLEWARE_PROPERTIES);
		createEAttribute(apacheMiddlewarePropertiesEClass, APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME);
		createEAttribute(apacheMiddlewarePropertiesEClass, APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS);
		createEAttribute(apacheMiddlewarePropertiesEClass, APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT);
		createEAttribute(apacheMiddlewarePropertiesEClass, APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER);
		createEAttribute(apacheMiddlewarePropertiesEClass, APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP);

		iLocatableEClass = createEClass(ILOCATABLE);

		jBossASEClass = createEClass(JBOSS_AS);
		createEAttribute(jBossASEClass, JBOSS_AS__HOME);
		createEReference(jBossASEClass, JBOSS_AS__BINDING);
		createEAttribute(jBossASEClass, JBOSS_AS__NAME);
		createEReference(jBossASEClass, JBOSS_AS__WEBCONNECTORS);

		jBossBindingEClass = createEClass(JBOSS_BINDING);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__NAME);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__NAMING_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__NAMING_RMI_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__WEBSERVICE_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__INVOKER_SERVER_BIND_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__HA_NAMING_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__HA_NAMING_RMI_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__CORBA_ORB_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__SNMP_TRAP_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__SNMP_REQUEST_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__JMS_SERVER_BIND_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__WEBSERVER_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__EJB3_CONNECTOR_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__MESSAGING_CONNECTOR_PORT);
		createEAttribute(jBossBindingEClass, JBOSS_BINDING__REMOTING_CONNECTOR_PORT);

		ijBossConnectorEClass = createEClass(IJ_BOSS_CONNECTOR);

		jBossHAConnectorEClass = createEClass(JBOSS_HA_CONNECTOR);
		createEReference(jBossHAConnectorEClass, JBOSS_HA_CONNECTOR__INSTANCE);
		createEReference(jBossHAConnectorEClass, JBOSS_HA_CONNECTOR__GROUP);

		jBossHTTPRepConnectorEClass = createEClass(JBOSS_HTTP_REP_CONNECTOR);
		createEReference(jBossHTTPRepConnectorEClass, JBOSS_HTTP_REP_CONNECTOR__INSTANCE);
		createEReference(jBossHTTPRepConnectorEClass, JBOSS_HTTP_REP_CONNECTOR__GROUP);

		jBossHAGroupEClass = createEClass(JBOSS_HA_GROUP);
		createEAttribute(jBossHAGroupEClass, JBOSS_HA_GROUP__LAN_MODE);
		createEAttribute(jBossHAGroupEClass, JBOSS_HA_GROUP__PING_HOSTS);

		jBossModJKConnectorEClass = createEClass(JBOSS_MOD_JK_CONNECTOR);
		createEReference(jBossModJKConnectorEClass, JBOSS_MOD_JK_CONNECTOR__JBOSS);
		createEReference(jBossModJKConnectorEClass, JBOSS_MOD_JK_CONNECTOR__APACHE);

		// Create enums
		webContainerImplementationEEnum = createEEnum(WEB_CONTAINER_IMPLEMENTATION);
		databaseProviderEEnum = createEEnum(DATABASE_PROVIDER);

		// Create data types
		inetAddressEDataType = createEDataType(INET_ADDRESS);
		portEDataType = createEDataType(PORT);
		deploymentExceptionEDataType = createEDataType(DEPLOYMENT_EXCEPTION);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model. This
     * method is guarded to have no affect on any invocation but its first. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		iJavaEEConnectorEClass.getESuperTypes().add(this.getIConnector());
		ijOnASConnectorEClass.getESuperTypes().add(this.getIJavaEEConnector());
		jOnASEClass.getESuperTypes().add(this.getIJavaEEServer());
		jOnASEClass.getESuperTypes().add(this.getILocatable());
		apache_HTTPdEClass.getESuperTypes().add(this.getIHTTPServer());
		apache_HTTPdEClass.getESuperTypes().add(this.getILocatable());
		iJavaEEServerEClass.getESuperTypes().add(this.getMiddlewareComponent());
		ihttpServerEClass.getESuperTypes().add(this.getMiddlewareComponent());
		webContainerEClass.getESuperTypes().add(this.getIContainer());
		ejbContainerEClass.getESuperTypes().add(this.getIContainer());
		ejbJarEClass.getESuperTypes().add(this.getIApplication());
		modJKModuleEClass.getESuperTypes().add(this.getIModule());
		repHTTPConnectorEClass.getESuperTypes().add(this.getIJOnASConnector());
		haConnectorEClass.getESuperTypes().add(this.getIJOnASConnector());
		iiopEClass.getESuperTypes().add(this.getIRMIRegistry());
		jrmpEClass.getESuperTypes().add(this.getIRMIRegistry());
		cmiEClass.getESuperTypes().add(this.getIRMIRegistry());
		irmiEClass.getESuperTypes().add(this.getIRMIRegistry());
		cmiGroupEClass.getESuperTypes().add(this.getConfigurationNode());
		configurationNodeEClass.getESuperTypes().add(this.getIConfigurationNode());
		haGroupEClass.getESuperTypes().add(this.getConfigurationNode());
		httP_RepGroupEClass.getESuperTypes().add(this.getConfigurationNode());
		rmiGroupEClass.getESuperTypes().add(this.getConfigurationNode());
		dbLinkEClass.getESuperTypes().add(this.getIConnector());
		rmiConnectorEClass.getESuperTypes().add(this.getIJOnASConnector());
		webConnectorEClass.getESuperTypes().add(this.getIWebConnector());
		ajpEClass.getESuperTypes().add(this.getWebConnector());
		httpEClass.getESuperTypes().add(this.getWebConnector());
		httpsEClass.getESuperTypes().add(this.getWebConnector());
		middlewareComponentEClass.getESuperTypes().add(this.getIMiddlewareComponent());
		apacheMiddlewarePropertiesEClass.getESuperTypes().add(this.getIMiddlewareProperties());
		jBossASEClass.getESuperTypes().add(this.getIJavaEEServer());
		jBossASEClass.getESuperTypes().add(this.getILocatable());
		ijBossConnectorEClass.getESuperTypes().add(this.getIJavaEEConnector());
		jBossHAConnectorEClass.getESuperTypes().add(this.getIJBossConnector());
		jBossHTTPRepConnectorEClass.getESuperTypes().add(this.getIJBossConnector());
		jBossHAGroupEClass.getESuperTypes().add(this.getConfigurationNode());
		jBossModJKConnectorEClass.getESuperTypes().add(this.getIJBossConnector());

		// Initialize classes and features; add operations and parameters
		initEClass(jasmiNeEClass, JASMINe.class, "JASMINe", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getJASMINe_ServerPool(), this.getServerPool(), null, "ServerPool", null, 1, 1, JASMINe.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJASMINe_Domain(), this.getDomain(), null, "Domain", null, 1, 1, JASMINe.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(serverPoolEClass, ServerPool.class, "ServerPool", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServerPool_Server(), this.getServer(), null, "Server", null, 0, -1, ServerPool.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(serverEClass, Server.class, "Server", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServer_JadeNode(), this.getJASMINeNode(), null, "JadeNode", null, 0, -1, Server.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(jasmiNeNodeEClass, JASMINeNode.class, "JASMINeNode", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getJASMINeNode_Name(), ecorePackage.getEString(), "name", "JASMINeNode", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_Host(), this.getInetAddress(), "host", "localhost", 1, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_User(), ecorePackage.getEString(), "user", null, 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_Password(), ecorePackage.getEString(), "password", null, 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_SshKey(), ecorePackage.getEString(), "sshKey", "${user.dir}/.ssh/id_rsa", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_InstallDir(), ecorePackage.getEString(), "installDir", "${java.io.tmpdir}", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_NodeId(), ecorePackage.getEIntegerObject(), "nodeId", "1", 1, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_RegistryHost(), this.getInetAddress(), "registryHost", "127.0.0.1", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_RegistryPort(), this.getPort(), "registryPort", "1238", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_DiscoveryHost(), this.getInetAddress(), "discoveryHost", "127.0.0.1", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_DiscoveryPort(), this.getPort(), "discoveryPort", "9998", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_JndiPort(), this.getPort(), "jndiPort", "1239", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_FelixProfile(), ecorePackage.getEString(), "felixProfile", "jasminenode", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJASMINeNode_RepositoryURL(), ecorePackage.getEString(), "repositoryURL", "", 0, 1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJASMINeNode_Middlewares(), this.getIMiddlewareComponent(), null, "middlewares", null, 0, -1, JASMINeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(jasmiNeNodeEClass, null, "deploy", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(jasmiNeNodeEClass, null, "start", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(jasmiNeNodeEClass, null, "stop", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(domainEClass, Domain.class, "Domain", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDomain_MiddlewareComponents(), this.getIMiddlewareComponent(), null, "MiddlewareComponents", null, 0, -1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDomain_Connectors(), this.getIConnector(), null, "connectors", null, 0, -1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDomain_ConfigurationNodes(), this.getConfigurationNode(), null, "configurationNodes", null, 0, -1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDomain_ClusterContainers(), this.getClusterContainer(), null, "clusterContainers", null, 0, 1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDomain_Db(), this.getDB(), null, "db", null, 0, 1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDomain_Dblinks(), this.getDbLink(), null, "dblinks", null, 0, -1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(clusterEClass, Cluster.class, "Cluster", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCluster_Name(), ecorePackage.getEString(), "name", "Cluster", 0, 1, Cluster.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iConnectorEClass, IConnector.class, "IConnector", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(iJavaEEConnectorEClass, IJavaEEConnector.class, "IJavaEEConnector", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(ijOnASConnectorEClass, IJOnASConnector.class, "IJOnASConnector", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dbEClass, org.objectweb.jasmine.ui.jasminemodel.DB.class, "DB", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDB_Provider(), this.getDatabaseProvider(), "provider", null, 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_User(), ecorePackage.getEString(), "user", "jonas", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_Password(), ecorePackage.getEString(), "password", "jonas", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_Url(), ecorePackage.getEString(), "url", "jdbc:hsqldb:hsql://localhost:9005/db_jonas", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_DriverName(), ecorePackage.getEString(), "driverName", "org.hsqldb.jdbcDriver", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_JndiName(), ecorePackage.getEString(), "jndiName", "jdbc_1", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_JdbcDriverJarFile(), ecorePackage.getEString(), "jdbcDriverJarFile", "none", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_MappernName(), ecorePackage.getEString(), "mappernName", "rdb.hsql", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_Name(), ecorePackage.getEString(), "name", "HSQL1", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDB_Port(), ecorePackage.getEInt(), "port", "9001", 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDB_JasmineNode(), this.getJASMINeNode(), null, "jasmineNode", null, 0, 1, org.objectweb.jasmine.ui.jasminemodel.DB.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iMiddlewareComponentEClass, IMiddlewareComponent.class, "IMiddlewareComponent", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIMiddlewareComponent_JasmineNode(), this.getJASMINeNode(), null, "jasmineNode", null, 0, 1, IMiddlewareComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(iMiddlewareComponentEClass, null, "deploy", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getDeploymentException());

		op = addEOperation(iMiddlewareComponentEClass, null, "start", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getDeploymentException());

		op = addEOperation(iMiddlewareComponentEClass, null, "stop", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getDeploymentException());

		initEClass(iMiddlewarePropertiesEClass, IMiddlewareProperties.class, "IMiddlewareProperties", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIMiddlewareProperties_Name(), ecorePackage.getEString(), "name", "New extended property", 0, 1, IMiddlewareProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIMiddlewareProperties_PropertyFile(), ecorePackage.getEResource(), "propertyFile", null, 0, 1, IMiddlewareProperties.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIMiddlewareProperties_Description(), ecorePackage.getEString(), "description", null, 0, 1, IMiddlewareProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(jOnASEClass, JOnAS.class, "JOnAS", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getJOnAS_Name(), ecorePackage.getEString(), "name", "JOnAS Application Server", 0, 1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJOnAS_InstanceName(), ecorePackage.getEString(), "instanceName", "jonas", 0, 1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJOnAS_Webconnectors(), this.getWebConnector(), null, "webconnectors", null, 0, -1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJOnAS_JonasBase(), ecorePackage.getEString(), "jonasBase", "/home/jasmine/JONAS_4_8_4", 0, 1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJOnAS_JonasRoot(), ecorePackage.getEString(), "jonasRoot", "/home/jasmine/JONAS_4_8_4", 1, 1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJOnAS_Domain(), ecorePackage.getEString(), "domain", "jonas", 0, 1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJOnAS_Master(), ecorePackage.getEBoolean(), "master", "false", 0, 1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJOnAS_Clusters(), this.getCluster(), null, "clusters", null, 0, -1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJOnAS_Cmigroup(), this.getCmiGroup(), null, "cmigroup", null, 0, 1, JOnAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(apache_HTTPdEClass, Apache_HTTPd.class, "Apache_HTTPd", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getApache_HTTPd_Name(), ecorePackage.getEString(), "Name", "Apache HTTPd Server", 0, 1, Apache_HTTPd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getApache_HTTPd_Modules(), this.getIModule(), null, "modules", null, 0, -1, Apache_HTTPd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApache_HTTPd_Home(), ecorePackage.getEString(), "home", null, 1, 1, Apache_HTTPd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApache_HTTPd_Host(), this.getInetAddress(), "host", "localhost", 0, 1, Apache_HTTPd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApache_HTTPd_Port(), this.getPort(), "port", "80", 0, 1, Apache_HTTPd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApache_HTTPd_User(), ecorePackage.getEString(), "user", "www-data", 0, 1, Apache_HTTPd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApache_HTTPd_Group(), ecorePackage.getEString(), "group", "www-data", 0, 1, Apache_HTTPd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iContainerEClass, IContainer.class, "IContainer", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIContainer_Description(), ecorePackage.getEString(), "description", null, 0, 1, IContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIContainer_Name(), ecorePackage.getEString(), "name", "New container", 0, 1, IContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iJavaEEServerEClass, IJavaEEServer.class, "IJavaEEServer", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIJavaEEServer_WebContainers(), this.getWebContainer(), null, "webContainers", null, 0, 1, IJavaEEServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIJavaEEServer_RmiRegistries(), this.getIRMIRegistry(), null, "rmiRegistries", null, 0, -1, IJavaEEServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIJavaEEServer_EjbContainers(), this.getEJBContainer(), null, "ejbContainers", null, 0, 1, IJavaEEServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIJavaEEServer_Applications(), this.getIApplication(), null, "applications", null, 0, -1, IJavaEEServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIJavaEEServer_JmsServices(), this.getJmsService(), null, "jmsServices", null, 0, 1, IJavaEEServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIJavaEEServer_DiscoveryServices(), this.getDiscoveryService(), null, "discoveryServices", null, 0, 1, IJavaEEServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIJavaEEServer_HttpServers(), this.getIHTTPServer(), this.getIHTTPServer_JavaeeServers(), "httpServers", null, 0, -1, IJavaEEServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(ihttpServerEClass, IHTTPServer.class, "IHTTPServer", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIHTTPServer_JavaeeServers(), this.getIJavaEEServer(), this.getIJavaEEServer_HttpServers(), "javaeeServers", null, 0, -1, IHTTPServer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(webContainerEClass, WebContainer.class, "WebContainer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getWebContainer_Type(), this.getWebContainerImplementation(), "type", null, 0, 1, WebContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getWebContainer_JvmRoute(), ecorePackage.getEString(), "jvmRoute", "jvmroute", 0, 1, WebContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getWebContainer_Host(), this.getInetAddress(), "host", "localhost", 0, 1, WebContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(ejbContainerEClass, EJBContainer.class, "EJBContainer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEJBContainer_AutoGenic(), ecorePackage.getEBoolean(), "autoGenic", "true", 0, 1, EJBContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(ejbJarEClass, EjbJar.class, "EjbJar", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEjbJar_Description(), ecorePackage.getEString(), "description", null, 0, 1, EjbJar.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEjbJar_Name(), ecorePackage.getEString(), "name", "New Ejb application", 0, 1, EjbJar.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iModuleEClass, IModule.class, "IModule", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(modJKModuleEClass, ModJKModule.class, "ModJKModule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getModJKModule_Description(), ecorePackage.getEString(), "description", null, 0, 1, ModJKModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModJKModule_Name(), ecorePackage.getEString(), "name", "Mod Jk", 0, 1, ModJKModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iApplicationEClass, IApplication.class, "IApplication", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(repHTTPConnectorEClass, RepHTTPConnector.class, "RepHTTPConnector", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRepHTTPConnector_Source(), this.getJOnAS(), null, "source", null, 0, 1, RepHTTPConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRepHTTPConnector_Target(), this.getHTTP_RepGroup(), null, "target", null, 0, 1, RepHTTPConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(haConnectorEClass, HAConnector.class, "HAConnector", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getHAConnector_Source(), this.getJOnAS(), null, "source", null, 0, 1, HAConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHAConnector_Target(), this.getHaGroup(), null, "target", null, 0, 1, HAConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(irmiRegistryEClass, IRMIRegistry.class, "IRMIRegistry", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIRMIRegistry_Host(), this.getInetAddress(), "host", "localhost", 0, 1, IRMIRegistry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIRMIRegistry_Port(), this.getPort(), "port", null, 0, 1, IRMIRegistry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIRMIRegistry_Name(), ecorePackage.getEString(), "name", "New protocol", 0, 1, IRMIRegistry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(iiopEClass, org.objectweb.jasmine.ui.jasminemodel.IIOP.class, "IIOP", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(jrmpEClass, org.objectweb.jasmine.ui.jasminemodel.JRMP.class, "JRMP", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cmiEClass, org.objectweb.jasmine.ui.jasminemodel.CMI.class, "CMI", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(irmiEClass, org.objectweb.jasmine.ui.jasminemodel.IRMI.class, "IRMI", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cmiGroupEClass, CmiGroup.class, "CmiGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCmiGroup_LanMode(), ecorePackage.getEBoolean(), "lanMode", "true", 0, 1, CmiGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCmiGroup_TcpPingHost(), this.getInetAddress(), "tcpPingHost", "localhost", 0, 1, CmiGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(configurationNodeEClass, ConfigurationNode.class, "ConfigurationNode", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getConfigurationNode_Description(), ecorePackage.getEString(), "description", null, 0, 1, ConfigurationNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfigurationNode_Host(), this.getInetAddress(), "host", "localhost", 0, 1, ConfigurationNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfigurationNode_Port(), this.getPort(), "port", null, 0, 1, ConfigurationNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfigurationNode_Name(), ecorePackage.getEString(), "name", "New Configuration Node", 0, 1, ConfigurationNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(haGroupEClass, HaGroup.class, "HaGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHaGroup_LanMode(), ecorePackage.getEBoolean(), "lanMode", "true", 0, 1, HaGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHaGroup_TcpPingHost(), this.getInetAddress(), "tcpPingHost", "localhost", 0, 1, HaGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(clusterContainerEClass, ClusterContainer.class, "ClusterContainer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getClusterContainer_Clusters(), this.getCluster(), null, "clusters", null, 0, -1, ClusterContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(httP_RepGroupEClass, HTTP_RepGroup.class, "HTTP_RepGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHTTP_RepGroup_TcpListenPort(), ecorePackage.getEInt(), "tcpListenPort", "4001", 0, 1, HTTP_RepGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rmiGroupEClass, RMIGroup.class, "RMIGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dbLinkEClass, DbLink.class, "DbLink", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDbLink_Source(), this.getDB(), null, "source", null, 0, 1, DbLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDbLink_Target(), this.getIJavaEEServer(), null, "target", null, 0, 1, DbLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iConfigurationNodeEClass, IConfigurationNode.class, "IConfigurationNode", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(rmiConnectorEClass, RmiConnector.class, "RmiConnector", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRmiConnector_Source(), this.getJOnAS(), null, "source", null, 0, 1, RmiConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRmiConnector_Target(), this.getRMIGroup(), null, "target", null, 0, 1, RmiConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(webConnectorEClass, WebConnector.class, "WebConnector", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getWebConnector_Description(), ecorePackage.getEString(), "description", null, 0, 1, WebConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getWebConnector_Port(), this.getPort(), "port", "0", 0, 1, WebConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getWebConnector_Name(), ecorePackage.getEString(), "name", "New Web Connector", 0, 1, WebConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(ajpEClass, org.objectweb.jasmine.ui.jasminemodel.AJP.class, "AJP", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(httpEClass, org.objectweb.jasmine.ui.jasminemodel.HTTP.class, "HTTP", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(httpsEClass, org.objectweb.jasmine.ui.jasminemodel.HTTPS.class, "HTTPS", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(iWebConnectorEClass, IWebConnector.class, "IWebConnector", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(jmsServiceEClass, JmsService.class, "JmsService", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getJmsService_JmxServiceURL(), ecorePackage.getEString(), "jmxServiceURL", "service:jmx:rmi://jndi/rmi://localhost:9098/jasmine", 0, 1, JmsService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJmsService_JmsPort(), this.getPort(), "jmsPort", "16010", 0, 1, JmsService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJmsService_JmsTopics(), ecorePackage.getEString(), "jmsTopics", "sampleTopic,invoiceTopic", 0, -1, JmsService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJmsService_JmsQueues(), ecorePackage.getEString(), "jmsQueues", "SampleQueue,OrderApprovalQueue,OrdersQueue,MailCompletedOrderQueue,SupPurchaseOrderQueue,MailOrderApprovalQueue,mailQueue", 0, -1, JmsService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJmsService_Name(), ecorePackage.getEString(), "name", "JMS Service ", 0, 1, JmsService.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(discoveryServiceEClass, DiscoveryService.class, "DiscoveryService", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDiscoveryService_Name(), ecorePackage.getEString(), "name", "Discovery Service", 0, 1, DiscoveryService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDiscoveryService_Host(), this.getInetAddress(), "host", "224.224.224.224", 0, 1, DiscoveryService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDiscoveryService_Port(), this.getPort(), "port", "9080", 0, 1, DiscoveryService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDiscoveryService_GreetingPort(), this.getPort(), "greetingPort", "9899", 0, 1, DiscoveryService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDiscoveryService_SourcePort(), this.getPort(), "sourcePort", "9888", 0, 1, DiscoveryService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(middlewareComponentEClass, MiddlewareComponent.class, "MiddlewareComponent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMiddlewareComponent_MiddlewareProperties(), this.getIMiddlewareProperties(), null, "middlewareProperties", null, 0, -1, MiddlewareComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(apachePropertiesEClass, ApacheProperties.class, "ApacheProperties", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(apacheMiddlewarePropertiesEClass, ApacheMiddlewareProperties.class, "ApacheMiddlewareProperties", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getApacheMiddlewareProperties_Instance_apache_home(), ecorePackage.getEString(), "instance_apache_home", null, 0, 1, ApacheMiddlewareProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApacheMiddlewareProperties_Server_listen_adress(), ecorePackage.getEString(), "server_listen_adress", null, 0, 1, ApacheMiddlewareProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApacheMiddlewareProperties_Server_listen_port(), ecorePackage.getEString(), "server_listen_port", null, 0, 1, ApacheMiddlewareProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApacheMiddlewareProperties_Server_user(), ecorePackage.getEString(), "server_user", null, 0, 1, ApacheMiddlewareProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApacheMiddlewareProperties_Server_group(), ecorePackage.getEString(), "server_group", null, 0, 1, ApacheMiddlewareProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iLocatableEClass, ILocatable.class, "ILocatable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		addEOperation(iLocatableEClass, ecorePackage.getEString(), "getIpAddress", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(iLocatableEClass, ecorePackage.getEString(), "getNodeId", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(iLocatableEClass, ecorePackage.getEString(), "getInstanceHome", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(jBossASEClass, JBossAS.class, "JBossAS", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getJBossAS_Home(), ecorePackage.getEString(), "home", "/home/jasmine/jboss", 0, 1, JBossAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJBossAS_Binding(), this.getJBossBinding(), null, "binding", null, 1, 1, JBossAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossAS_Name(), ecorePackage.getEString(), "name", "JBoss Application Server", 0, 1, JBossAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJBossAS_Webconnectors(), this.getWebConnector(), null, "webconnectors", null, 0, -1, JBossAS.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(jBossBindingEClass, JBossBinding.class, "JBossBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getJBossBinding_Name(), ecorePackage.getEString(), "name", "Binding", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_NamingPort(), this.getPort(), "namingPort", "1099", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_NamingRMIPort(), this.getPort(), "namingRMIPort", "1098", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_WebservicePort(), this.getPort(), "webservicePort", "8083", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_InvokerRMIObjectPort(), this.getPort(), "invokerRMIObjectPort", "4444", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_InvokerServerBindPort(), this.getPort(), "invokerServerBindPort", "4445", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_HaNamingPort(), this.getPort(), "haNamingPort", "1100", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_HaNamingRMIPort(), this.getPort(), "haNamingRMIPort", "1101", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_HaInvokerRMIObjectPort(), this.getPort(), "haInvokerRMIObjectPort", "4444", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_HaInvokerServerBindPort(), this.getPort(), "haInvokerServerBindPort", "4448", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_CorbaOrbPort(), this.getPort(), "corbaOrbPort", "3528", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_ConnectorRMIObjectPort(), this.getPort(), "connectorRMIObjectPort", "19001", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_SnmpTrapPort(), this.getPort(), "snmpTrapPort", "1162", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_SnmpRequestPort(), this.getPort(), "snmpRequestPort", "1161", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_JmsServerBindPort(), this.getPort(), "jmsServerBindPort", "8093", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_WebserverPort(), this.getPort(), "webserverPort", "8080", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_Ejb3ConnectorPort(), this.getPort(), "ejb3ConnectorPort", "3873", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_MessagingConnectorPort(), this.getPort(), "messagingConnectorPort", "4457", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossBinding_RemotingConnectorPort(), this.getPort(), "remotingConnectorPort", "4446", 0, 1, JBossBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(ijBossConnectorEClass, IJBossConnector.class, "IJBossConnector", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(jBossHAConnectorEClass, JBossHAConnector.class, "JBossHAConnector", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getJBossHAConnector_Instance(), this.getJBossAS(), null, "instance", null, 0, 1, JBossHAConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJBossHAConnector_Group(), this.getJBossHAGroup(), null, "group", null, 0, 1, JBossHAConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(jBossHTTPRepConnectorEClass, JBossHTTPRepConnector.class, "JBossHTTPRepConnector", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getJBossHTTPRepConnector_Instance(), this.getJBossAS(), null, "instance", null, 0, 1, JBossHTTPRepConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJBossHTTPRepConnector_Group(), this.getHTTP_RepGroup(), null, "group", null, 0, 1, JBossHTTPRepConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(jBossHAGroupEClass, JBossHAGroup.class, "JBossHAGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getJBossHAGroup_LanMode(), ecorePackage.getEString(), "lanMode", null, 0, 1, JBossHAGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getJBossHAGroup_PingHosts(), ecorePackage.getEString(), "pingHosts", null, 0, 1, JBossHAGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(jBossModJKConnectorEClass, JBossModJKConnector.class, "JBossModJKConnector", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getJBossModJKConnector_Jboss(), this.getJBossAS(), null, "jboss", null, 0, 1, JBossModJKConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getJBossModJKConnector_Apache(), this.getApache_HTTPd(), null, "apache", null, 0, 1, JBossModJKConnector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(webContainerImplementationEEnum, WebContainerImplementation.class, "WebContainerImplementation");
		addEEnumLiteral(webContainerImplementationEEnum, WebContainerImplementation.TOMCAT_0);
		addEEnumLiteral(webContainerImplementationEEnum, WebContainerImplementation.TOMCAT_1);
		addEEnumLiteral(webContainerImplementationEEnum, WebContainerImplementation.TOMCAT_2);
		addEEnumLiteral(webContainerImplementationEEnum, WebContainerImplementation.TOMCAT_3);
		addEEnumLiteral(webContainerImplementationEEnum, WebContainerImplementation.JETTY_0);
		addEEnumLiteral(webContainerImplementationEEnum, WebContainerImplementation.JETTY_1);
		addEEnumLiteral(webContainerImplementationEEnum, WebContainerImplementation.JETTY_2);

		initEEnum(databaseProviderEEnum, DatabaseProvider.class, "DatabaseProvider");
		addEEnumLiteral(databaseProviderEEnum, DatabaseProvider.HSQL);
		addEEnumLiteral(databaseProviderEEnum, DatabaseProvider.MY_SQL);
		addEEnumLiteral(databaseProviderEEnum, DatabaseProvider.ORACLE);
		addEEnumLiteral(databaseProviderEEnum, DatabaseProvider.POSTGRE_SQL);

		// Initialize data types
		initEDataType(inetAddressEDataType, InetAddress.class, "InetAddress", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(portEDataType, Port.class, "Port", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(deploymentExceptionEDataType, DeploymentException.class, "DeploymentException", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);
	}

} // JasminemodelPackageImpl
