/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;

import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;

import org.objectweb.jasmine.ui.jasminemodel.datatype.Port;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Jms Service</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl#getJmxServiceURL <em>Jmx Service URL</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl#getJmsPort <em>Jms Port</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl#getJmsTopics <em>Jms Topics</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl#getJmsQueues <em>Jms Queues</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JmsServiceImpl extends EObjectImpl implements JmsService {
    /**
	 * The default value of the '{@link #getJmxServiceURL() <em>Jmx Service URL</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmxServiceURL()
	 * @generated
	 * @ordered
	 */
    protected static final String JMX_SERVICE_URL_EDEFAULT = "service:jmx:rmi://jndi/rmi://localhost:9098/jasmine";

    /**
	 * The cached value of the '{@link #getJmxServiceURL() <em>Jmx Service URL</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmxServiceURL()
	 * @generated
	 * @ordered
	 */
    protected String jmxServiceURL = JMX_SERVICE_URL_EDEFAULT;

    /**
	 * The default value of the '{@link #getJmsPort() <em>Jms Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsPort()
	 * @generated
	 * @ordered
	 */
    protected static final Port JMS_PORT_EDEFAULT = (Port)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getPort(), "16010");

    /**
	 * The cached value of the '{@link #getJmsPort() <em>Jms Port</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsPort()
	 * @generated
	 * @ordered
	 */
    protected Port jmsPort = JMS_PORT_EDEFAULT;

    /**
	 * The cached value of the '{@link #getJmsTopics() <em>Jms Topics</em>}' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsTopics()
	 * @generated
	 * @ordered
	 */
    protected EList<String> jmsTopics;

    /**
	 * The cached value of the '{@link #getJmsQueues() <em>Jms Queues</em>}' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJmsQueues()
	 * @generated
	 * @ordered
	 */
    protected EList<String> jmsQueues;

    /**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected static final String NAME_EDEFAULT = "JMS Service ";

    /**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
    protected String name = NAME_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected JmsServiceImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.JMS_SERVICE;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getJmxServiceURL() {
		return jmxServiceURL;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJmxServiceURL(String newJmxServiceURL) {
		String oldJmxServiceURL = jmxServiceURL;
		jmxServiceURL = newJmxServiceURL;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JMS_SERVICE__JMX_SERVICE_URL, oldJmxServiceURL, jmxServiceURL));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Port getJmsPort() {
		return jmsPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJmsPort(Port newJmsPort) {
		Port oldJmsPort = jmsPort;
		jmsPort = newJmsPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.JMS_SERVICE__JMS_PORT, oldJmsPort, jmsPort));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<String> getJmsTopics() {
		if (jmsTopics == null) {
			jmsTopics = new EDataTypeUniqueEList<String>(String.class, this, JasminemodelPackage.JMS_SERVICE__JMS_TOPICS);
		}
		return jmsTopics;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<String> getJmsQueues() {
		if (jmsQueues == null) {
			jmsQueues = new EDataTypeUniqueEList<String>(String.class, this, JasminemodelPackage.JMS_SERVICE__JMS_QUEUES);
		}
		return jmsQueues;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName() {
		return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.JMS_SERVICE__JMX_SERVICE_URL:
				return getJmxServiceURL();
			case JasminemodelPackage.JMS_SERVICE__JMS_PORT:
				return getJmsPort();
			case JasminemodelPackage.JMS_SERVICE__JMS_TOPICS:
				return getJmsTopics();
			case JasminemodelPackage.JMS_SERVICE__JMS_QUEUES:
				return getJmsQueues();
			case JasminemodelPackage.JMS_SERVICE__NAME:
				return getName();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.JMS_SERVICE__JMX_SERVICE_URL:
				setJmxServiceURL((String)newValue);
				return;
			case JasminemodelPackage.JMS_SERVICE__JMS_PORT:
				setJmsPort((Port)newValue);
				return;
			case JasminemodelPackage.JMS_SERVICE__JMS_TOPICS:
				getJmsTopics().clear();
				getJmsTopics().addAll((Collection<? extends String>)newValue);
				return;
			case JasminemodelPackage.JMS_SERVICE__JMS_QUEUES:
				getJmsQueues().clear();
				getJmsQueues().addAll((Collection<? extends String>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JMS_SERVICE__JMX_SERVICE_URL:
				setJmxServiceURL(JMX_SERVICE_URL_EDEFAULT);
				return;
			case JasminemodelPackage.JMS_SERVICE__JMS_PORT:
				setJmsPort(JMS_PORT_EDEFAULT);
				return;
			case JasminemodelPackage.JMS_SERVICE__JMS_TOPICS:
				getJmsTopics().clear();
				return;
			case JasminemodelPackage.JMS_SERVICE__JMS_QUEUES:
				getJmsQueues().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.JMS_SERVICE__JMX_SERVICE_URL:
				return JMX_SERVICE_URL_EDEFAULT == null ? jmxServiceURL != null : !JMX_SERVICE_URL_EDEFAULT.equals(jmxServiceURL);
			case JasminemodelPackage.JMS_SERVICE__JMS_PORT:
				return JMS_PORT_EDEFAULT == null ? jmsPort != null : !JMS_PORT_EDEFAULT.equals(jmsPort);
			case JasminemodelPackage.JMS_SERVICE__JMS_TOPICS:
				return jmsTopics != null && !jmsTopics.isEmpty();
			case JasminemodelPackage.JMS_SERVICE__JMS_QUEUES:
				return jmsQueues != null && !jmsQueues.isEmpty();
			case JasminemodelPackage.JMS_SERVICE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (jmxServiceURL: ");
		result.append(jmxServiceURL);
		result.append(", jmsPort: ");
		result.append(jmsPort);
		result.append(", jmsTopics: ");
		result.append(jmsTopics);
		result.append(", jmsQueues: ");
		result.append(jmsQueues);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // JmsServiceImpl
