/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.objectweb.jasmine.jade.service.deployer.DeploymentException;
import org.objectweb.jasmine.ui.jasminemodel.ILocatable;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Middleware Component</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.MiddlewareComponentImpl#getJasmineNode <em>Jasmine Node</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.MiddlewareComponentImpl#getMiddlewareProperties <em>Middleware Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MiddlewareComponentImpl extends EObjectImpl implements
        MiddlewareComponent {
    /**
	 * The cached value of the '{@link #getJasmineNode() <em>Jasmine Node</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJasmineNode()
	 * @generated
	 * @ordered
	 */
    protected JASMINeNode jasmineNode;
    /**
	 * The cached value of the '{@link #getMiddlewareProperties() <em>Middleware Properties</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMiddlewareProperties()
	 * @generated
	 * @ordered
	 */
    protected EList<IMiddlewareProperties> middlewareProperties;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected MiddlewareComponentImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.MIDDLEWARE_COMPONENT;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JASMINeNode getJasmineNode() {
		if (jasmineNode != null && jasmineNode.eIsProxy()) {
			InternalEObject oldJasmineNode = (InternalEObject)jasmineNode;
			jasmineNode = (JASMINeNode)eResolveProxy(oldJasmineNode);
			if (jasmineNode != oldJasmineNode) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, JasminemodelPackage.MIDDLEWARE_COMPONENT__JASMINE_NODE, oldJasmineNode, jasmineNode));
			}
		}
		return jasmineNode;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public JASMINeNode basicGetJasmineNode() {
		return jasmineNode;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJasmineNode(JASMINeNode newJasmineNode) {
		JASMINeNode oldJasmineNode = jasmineNode;
		jasmineNode = newJasmineNode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.MIDDLEWARE_COMPONENT__JASMINE_NODE, oldJasmineNode, jasmineNode));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<IMiddlewareProperties> getMiddlewareProperties() {
		if (middlewareProperties == null) {
			middlewareProperties = new EObjectContainmentEList<IMiddlewareProperties>(IMiddlewareProperties.class, this, JasminemodelPackage.MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES);
		}
		return middlewareProperties;
	}

    /**
     * @generated NOT
     */
    private org.objectweb.jasmine.jade.application.Application apps;

    /**
     * @generated NOT
     */
    public org.objectweb.jasmine.jade.application.Application getApp() {
        return apps;
    }

    /**
     * @generated NOT
     */
    public void setApp(org.objectweb.jasmine.jade.application.Application app) {
        this.apps = app;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated NOT
     */
    public void deploy() throws DeploymentException {

        if (this instanceof ILocatable) {

            String address = ((ILocatable) this).getIpAddress();
            String instance_home = ((ILocatable) this).getInstanceHome();
            String nodeId = ((ILocatable) this).getNodeId();

            try {
                ((org.objectweb.jasmine.jade.application.ApplicationIfc) getApp())
                        .deploy(address, instance_home, nodeId);

            } catch (Exception e) {
            	throw new DeploymentException(e);
            }

        } else {
            throw new UnsupportedOperationException();
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public void start() throws DeploymentException {

    	if (this instanceof ILocatable) {
            try {
                configure((IMiddlewareComponent) this);
                ((org.objectweb.jasmine.jade.application.ApplicationImpl) this
                        .getApp()).start();
            } catch (Exception e) {
            	throw new DeploymentException(e);
            }
        } else {
            throw new UnsupportedOperationException();
        }

    }

    /**
     * MiddlewareComponents instances should override this method.
     *
     * @param the
     *            value of the '<em>MiddlewareComponent</em>' reference.
     *            <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated Not
     */
    public void configure(IMiddlewareComponent app) {
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    public void stop() throws DeploymentException {

    	if (this instanceof ILocatable) {
            try {
                ((org.objectweb.jasmine.jade.application.ApplicationImpl) this
                        .getApp()).stop();
            } catch (Exception e) {
            	throw new DeploymentException(e);
            }
        } else {
            throw new UnsupportedOperationException();
        }
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, NotificationChain msgs) {
		switch (featureID) {
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES:
				return ((InternalEList<?>)getMiddlewareProperties()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__JASMINE_NODE:
				if (resolve) return getJasmineNode();
				return basicGetJasmineNode();
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES:
				return getMiddlewareProperties();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__JASMINE_NODE:
				setJasmineNode((JASMINeNode)newValue);
				return;
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES:
				getMiddlewareProperties().clear();
				getMiddlewareProperties().addAll((Collection<? extends IMiddlewareProperties>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__JASMINE_NODE:
				setJasmineNode((JASMINeNode)null);
				return;
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES:
				getMiddlewareProperties().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__JASMINE_NODE:
				return jasmineNode != null;
			case JasminemodelPackage.MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES:
				return middlewareProperties != null && !middlewareProperties.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} // MiddlewareComponentImpl
