/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.impl;

import java.net.InetAddress;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;
import org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Web Container</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.WebContainerImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.WebContainerImpl#getJvmRoute <em>Jvm Route</em>}</li>
 *   <li>{@link org.objectweb.jasmine.ui.jasminemodel.impl.WebContainerImpl#getHost <em>Host</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class WebContainerImpl extends IContainerImpl implements WebContainer {
    /**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
    protected static final WebContainerImplementation TYPE_EDEFAULT = WebContainerImplementation.TOMCAT_0;

    /**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
    protected WebContainerImplementation type = TYPE_EDEFAULT;

    /**
	 * The default value of the '{@link #getJvmRoute() <em>Jvm Route</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJvmRoute()
	 * @generated
	 * @ordered
	 */
    protected static final String JVM_ROUTE_EDEFAULT = "jvmroute";

    /**
	 * The cached value of the '{@link #getJvmRoute() <em>Jvm Route</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getJvmRoute()
	 * @generated
	 * @ordered
	 */
    protected String jvmRoute = JVM_ROUTE_EDEFAULT;

    /**
	 * The default value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected static final InetAddress HOST_EDEFAULT = (InetAddress)JasminemodelFactory.eINSTANCE.createFromString(JasminemodelPackage.eINSTANCE.getInetAddress(), "localhost");

    /**
	 * The cached value of the '{@link #getHost() <em>Host</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHost()
	 * @generated
	 * @ordered
	 */
    protected InetAddress host = HOST_EDEFAULT;

    /**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected static final String NAME_EDEFAULT = "Web container";

    /**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @see #getName()
     * @generated Not
     * @ordered
     */
    protected String name = NAME_EDEFAULT;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected WebContainerImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return JasminemodelPackage.Literals.WEB_CONTAINER;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public WebContainerImplementation getType() {
		return type;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setType(WebContainerImplementation newType) {
		WebContainerImplementation oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.WEB_CONTAINER__TYPE, oldType, type));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getJvmRoute() {
		return jvmRoute;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setJvmRoute(String newJvmRoute) {
		String oldJvmRoute = jvmRoute;
		jvmRoute = newJvmRoute;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.WEB_CONTAINER__JVM_ROUTE, oldJvmRoute, jvmRoute));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public InetAddress getHost() {
		return host;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setHost(InetAddress newHost) {
		InetAddress oldHost = host;
		host = newHost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, JasminemodelPackage.WEB_CONTAINER__HOST, oldHost, host));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    JasminemodelPackage.WEB_CONTAINER__NAME, oldName, name));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
        case JasminemodelPackage.WEB_CONTAINER__TYPE:
            return getType();
        case JasminemodelPackage.WEB_CONTAINER__JVM_ROUTE:
            return getJvmRoute();
        case JasminemodelPackage.WEB_CONTAINER__HOST:
            return getHost();
        case JasminemodelPackage.WEB_CONTAINER__NAME:
            return getName();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
        case JasminemodelPackage.WEB_CONTAINER__TYPE:
            setType((WebContainerImplementation) newValue);
            return;
        case JasminemodelPackage.WEB_CONTAINER__JVM_ROUTE:
            setJvmRoute((String) newValue);
            return;
        case JasminemodelPackage.WEB_CONTAINER__HOST:
            setHost((InetAddress) newValue);
            return;
        case JasminemodelPackage.WEB_CONTAINER__NAME:
            setName((String) newValue);
            return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.WEB_CONTAINER__TYPE:
            setType(TYPE_EDEFAULT);
            return;
        case JasminemodelPackage.WEB_CONTAINER__JVM_ROUTE:
            setJvmRoute(JVM_ROUTE_EDEFAULT);
            return;
        case JasminemodelPackage.WEB_CONTAINER__HOST:
            setHost(HOST_EDEFAULT);
            return;
        case JasminemodelPackage.WEB_CONTAINER__NAME:
            setName(NAME_EDEFAULT);
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated Not
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
        case JasminemodelPackage.WEB_CONTAINER__TYPE:
            return type != TYPE_EDEFAULT;
        case JasminemodelPackage.WEB_CONTAINER__JVM_ROUTE:
            return JVM_ROUTE_EDEFAULT == null ? jvmRoute != null
                    : !JVM_ROUTE_EDEFAULT.equals(jvmRoute);
        case JasminemodelPackage.WEB_CONTAINER__HOST:
            return HOST_EDEFAULT == null ? host != null : !HOST_EDEFAULT
                    .equals(host);
        case JasminemodelPackage.WEB_CONTAINER__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
                    .equals(name);
        }
        return super.eIsSet(featureID);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(", jvmRoute: ");
		result.append(jvmRoute);
		result.append(", host: ");
		result.append(host);
		result.append(')');
		return result.toString();
	}

} // WebContainerImpl
