/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.properties;

import java.io.File;
import java.util.Properties;

public class LoadProperties {

//	TODO : ResourceBundle with Properties Files
	public static String JASMINE = "./conf/jasmine.properties";

	public static String JONAS = "./conf/jonas.properties";

	public static String APACHE = "./conf/apache.properties";

	public static String MONITORING_SYSTEM = "./conf/monitoring.properties";

	public static Properties loadJasmineProperties() throws Exception {
		return loadProperties(JASMINE);
	}

	public static Properties loadJonasProperties() throws Exception {
		return loadProperties(JONAS);
	}

	public static Properties loadApacheProperties() throws Exception {
		return loadProperties(APACHE);
	}

	public static Properties loadMonitoringSystemProperties() throws Exception {
		return loadProperties(MONITORING_SYSTEM);
	}

	private static Properties loadProperties(String path) throws Exception {
		Properties props = new java.util.Properties();

		File file = new File(path);

		java.io.FileInputStream fis = new java.io.FileInputStream(
				file.getAbsolutePath());

		props.load(fis);

		return props;
	}

}
