/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;
import org.objectweb.jasmine.ui.jasminemodel.*;
import org.objectweb.jasmine.ui.jasminemodel.AJP;
import org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.ApacheProperties;
import org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd;
import org.objectweb.jasmine.ui.jasminemodel.CMI;
import org.objectweb.jasmine.ui.jasminemodel.CMIConnector;
import org.objectweb.jasmine.ui.jasminemodel.Cluster;
import org.objectweb.jasmine.ui.jasminemodel.ClusterContainer;
import org.objectweb.jasmine.ui.jasminemodel.CmiGroup;
import org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode;
import org.objectweb.jasmine.ui.jasminemodel.DB;
import org.objectweb.jasmine.ui.jasminemodel.DbLink;
import org.objectweb.jasmine.ui.jasminemodel.DiscoveryService;
import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.EjbJar;
import org.objectweb.jasmine.ui.jasminemodel.HAConnector;
import org.objectweb.jasmine.ui.jasminemodel.HTTP;
import org.objectweb.jasmine.ui.jasminemodel.HTTPS;
import org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup;
import org.objectweb.jasmine.ui.jasminemodel.HaGroup;
import org.objectweb.jasmine.ui.jasminemodel.IApplication;
import org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode;
import org.objectweb.jasmine.ui.jasminemodel.IConnector;
import org.objectweb.jasmine.ui.jasminemodel.IContainer;
import org.objectweb.jasmine.ui.jasminemodel.IHTTPServer;
import org.objectweb.jasmine.ui.jasminemodel.IIOP;
import org.objectweb.jasmine.ui.jasminemodel.IJBossConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJavaEEConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer;
import org.objectweb.jasmine.ui.jasminemodel.ILocatable;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.IModule;
import org.objectweb.jasmine.ui.jasminemodel.IRMI;
import org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry;
import org.objectweb.jasmine.ui.jasminemodel.IWebConnector;
import org.objectweb.jasmine.ui.jasminemodel.JASMINe;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JBossAS;
import org.objectweb.jasmine.ui.jasminemodel.JBossBinding;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup;
import org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector;
import org.objectweb.jasmine.ui.jasminemodel.JOnAS;
import org.objectweb.jasmine.ui.jasminemodel.JRMP;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;
import org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.ModJKModule;
import org.objectweb.jasmine.ui.jasminemodel.RMIGroup;
import org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector;
import org.objectweb.jasmine.ui.jasminemodel.RmiConnector;
import org.objectweb.jasmine.ui.jasminemodel.Server;
import org.objectweb.jasmine.ui.jasminemodel.ServerPool;
import org.objectweb.jasmine.ui.jasminemodel.WebConnector;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It
 * provides an adapter <code>createXXX</code> method for each class of the
 * model. <!-- end-user-doc -->
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage
 * @generated
 */
public class JasminemodelAdapterFactory extends AdapterFactoryImpl {
    /**
	 * The cached model package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected static JasminemodelPackage modelPackage;

    /**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public JasminemodelAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = JasminemodelPackage.eINSTANCE;
		}
	}

    /**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code>
     * if the object is either the model's package or is an instance object of
     * the model. <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
    @Override
    public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

    /**
     * The switch the delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     */
    protected JasminemodelSwitch<Adapter> modelSwitch = new JasminemodelSwitch<Adapter>() {
			@Override
			public Adapter caseJASMINe(JASMINe object) {
				return createJASMINeAdapter();
			}
			@Override
			public Adapter caseServerPool(ServerPool object) {
				return createServerPoolAdapter();
			}
			@Override
			public Adapter caseServer(Server object) {
				return createServerAdapter();
			}
			@Override
			public Adapter caseJASMINeNode(JASMINeNode object) {
				return createJASMINeNodeAdapter();
			}
			@Override
			public Adapter caseDomain(Domain object) {
				return createDomainAdapter();
			}
			@Override
			public Adapter caseCluster(Cluster object) {
				return createClusterAdapter();
			}
			@Override
			public Adapter caseIConnector(IConnector object) {
				return createIConnectorAdapter();
			}
			@Override
			public Adapter caseIJavaEEConnector(IJavaEEConnector object) {
				return createIJavaEEConnectorAdapter();
			}
			@Override
			public Adapter caseIJOnASConnector(IJOnASConnector object) {
				return createIJOnASConnectorAdapter();
			}
			@Override
			public Adapter caseDB(DB object) {
				return createDBAdapter();
			}
			@Override
			public Adapter caseIMiddlewareComponent(IMiddlewareComponent object) {
				return createIMiddlewareComponentAdapter();
			}
			@Override
			public Adapter caseIMiddlewareProperties(IMiddlewareProperties object) {
				return createIMiddlewarePropertiesAdapter();
			}
			@Override
			public Adapter caseJOnAS(JOnAS object) {
				return createJOnASAdapter();
			}
			@Override
			public Adapter caseApache_HTTPd(Apache_HTTPd object) {
				return createApache_HTTPdAdapter();
			}
			@Override
			public Adapter caseIContainer(IContainer object) {
				return createIContainerAdapter();
			}
			@Override
			public Adapter caseIJavaEEServer(IJavaEEServer object) {
				return createIJavaEEServerAdapter();
			}
			@Override
			public Adapter caseIHTTPServer(IHTTPServer object) {
				return createIHTTPServerAdapter();
			}
			@Override
			public Adapter caseWebContainer(WebContainer object) {
				return createWebContainerAdapter();
			}
			@Override
			public Adapter caseEJBContainer(EJBContainer object) {
				return createEJBContainerAdapter();
			}
			@Override
			public Adapter caseEjbJar(EjbJar object) {
				return createEjbJarAdapter();
			}
			@Override
			public Adapter caseIModule(IModule object) {
				return createIModuleAdapter();
			}
			@Override
			public Adapter caseModJKModule(ModJKModule object) {
				return createModJKModuleAdapter();
			}
			@Override
			public Adapter caseIApplication(IApplication object) {
				return createIApplicationAdapter();
			}
			@Override
			public Adapter caseRepHTTPConnector(RepHTTPConnector object) {
				return createRepHTTPConnectorAdapter();
			}
			@Override
			public Adapter caseHAConnector(HAConnector object) {
				return createHAConnectorAdapter();
			}
			@Override
			public Adapter caseIRMIRegistry(IRMIRegistry object) {
				return createIRMIRegistryAdapter();
			}
			@Override
			public Adapter caseIIOP(IIOP object) {
				return createIIOPAdapter();
			}
			@Override
			public Adapter caseJRMP(JRMP object) {
				return createJRMPAdapter();
			}
			@Override
			public Adapter caseCMI(CMI object) {
				return createCMIAdapter();
			}
			@Override
			public Adapter caseIRMI(IRMI object) {
				return createIRMIAdapter();
			}
			@Override
			public Adapter caseCmiGroup(CmiGroup object) {
				return createCmiGroupAdapter();
			}
			@Override
			public Adapter caseConfigurationNode(ConfigurationNode object) {
				return createConfigurationNodeAdapter();
			}
			@Override
			public Adapter caseHaGroup(HaGroup object) {
				return createHaGroupAdapter();
			}
			@Override
			public Adapter caseClusterContainer(ClusterContainer object) {
				return createClusterContainerAdapter();
			}
			@Override
			public Adapter caseHTTP_RepGroup(HTTP_RepGroup object) {
				return createHTTP_RepGroupAdapter();
			}
			@Override
			public Adapter caseRMIGroup(RMIGroup object) {
				return createRMIGroupAdapter();
			}
			@Override
			public Adapter caseDbLink(DbLink object) {
				return createDbLinkAdapter();
			}
			@Override
			public Adapter caseIConfigurationNode(IConfigurationNode object) {
				return createIConfigurationNodeAdapter();
			}
			@Override
			public Adapter caseRmiConnector(RmiConnector object) {
				return createRmiConnectorAdapter();
			}
			@Override
			public Adapter caseWebConnector(WebConnector object) {
				return createWebConnectorAdapter();
			}
			@Override
			public Adapter caseAJP(AJP object) {
				return createAJPAdapter();
			}
			@Override
			public Adapter caseHTTP(HTTP object) {
				return createHTTPAdapter();
			}
			@Override
			public Adapter caseHTTPS(HTTPS object) {
				return createHTTPSAdapter();
			}
			@Override
			public Adapter caseIWebConnector(IWebConnector object) {
				return createIWebConnectorAdapter();
			}
			@Override
			public Adapter caseJmsService(JmsService object) {
				return createJmsServiceAdapter();
			}
			@Override
			public Adapter caseDiscoveryService(DiscoveryService object) {
				return createDiscoveryServiceAdapter();
			}
			@Override
			public Adapter caseMiddlewareComponent(MiddlewareComponent object) {
				return createMiddlewareComponentAdapter();
			}
			@Override
			public Adapter caseApacheProperties(ApacheProperties object) {
				return createApachePropertiesAdapter();
			}
			@Override
			public Adapter caseApacheMiddlewareProperties(ApacheMiddlewareProperties object) {
				return createApacheMiddlewarePropertiesAdapter();
			}
			@Override
			public Adapter caseILocatable(ILocatable object) {
				return createILocatableAdapter();
			}
			@Override
			public Adapter caseJBossAS(JBossAS object) {
				return createJBossASAdapter();
			}
			@Override
			public Adapter caseJBossBinding(JBossBinding object) {
				return createJBossBindingAdapter();
			}
			@Override
			public Adapter caseIJBossConnector(IJBossConnector object) {
				return createIJBossConnectorAdapter();
			}
			@Override
			public Adapter caseJBossHAConnector(JBossHAConnector object) {
				return createJBossHAConnectorAdapter();
			}
			@Override
			public Adapter caseJBossHTTPRepConnector(JBossHTTPRepConnector object) {
				return createJBossHTTPRepConnectorAdapter();
			}
			@Override
			public Adapter caseJBossHAGroup(JBossHAGroup object) {
				return createJBossHAGroupAdapter();
			}
			@Override
			public Adapter caseJBossModJKConnector(JBossModJKConnector object) {
				return createJBossModJKConnectorAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

    /**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
    @Override
    public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINe <em>JASMI Ne</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINe
	 * @generated
	 */
    public Adapter createJASMINeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.ServerPool <em>Server Pool</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ServerPool
	 * @generated
	 */
    public Adapter createServerPoolAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.Server <em>Server</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Server
	 * @generated
	 */
    public Adapter createServerAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode <em>JASMI Ne Node</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode
	 * @generated
	 */
    public Adapter createJASMINeNodeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.Domain <em>Domain</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain
	 * @generated
	 */
    public Adapter createDomainAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.Cluster <em>Cluster</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Cluster
	 * @generated
	 */
    public Adapter createClusterAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IConnector <em>IConnector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IConnector
	 * @generated
	 */
    public Adapter createIConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEConnector <em>IJava EE Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEConnector
	 * @generated
	 */
    public Adapter createIJavaEEConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector <em>IJ On AS Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector
	 * @generated
	 */
    public Adapter createIJOnASConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.DB <em>DB</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB
	 * @generated
	 */
    public Adapter createDBAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent <em>IMiddleware Component</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent
	 * @generated
	 */
    public Adapter createIMiddlewareComponentAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties <em>IMiddleware Properties</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties
	 * @generated
	 */
    public Adapter createIMiddlewarePropertiesAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS <em>JOn AS</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS
	 * @generated
	 */
    public Adapter createJOnASAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd <em>Apache HTT Pd</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd
	 * @generated
	 */
    public Adapter createApache_HTTPdAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IContainer <em>IContainer</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IContainer
	 * @generated
	 */
    public Adapter createIContainerAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer <em>IJava EE Server</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer
	 * @generated
	 */
    public Adapter createIJavaEEServerAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer <em>IHTTP Server</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IHTTPServer
	 * @generated
	 */
    public Adapter createIHTTPServerAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer <em>Web Container</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainer
	 * @generated
	 */
    public Adapter createWebContainerAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.EJBContainer <em>EJB Container</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.EJBContainer
	 * @generated
	 */
    public Adapter createEJBContainerAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.EjbJar <em>Ejb Jar</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.EjbJar
	 * @generated
	 */
    public Adapter createEjbJarAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IModule <em>IModule</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IModule
	 * @generated
	 */
    public Adapter createIModuleAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.ModJKModule <em>Mod JK Module</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ModJKModule
	 * @generated
	 */
    public Adapter createModJKModuleAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IApplication <em>IApplication</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IApplication
	 * @generated
	 */
    public Adapter createIApplicationAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector <em>Rep HTTP Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector
	 * @generated
	 */
    public Adapter createRepHTTPConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.HAConnector <em>HA Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HAConnector
	 * @generated
	 */
    public Adapter createHAConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry <em>IRMI Registry</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry
	 * @generated
	 */
    public Adapter createIRMIRegistryAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IIOP <em>IIOP</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IIOP
	 * @generated
	 */
    public Adapter createIIOPAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JRMP <em>JRMP</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JRMP
	 * @generated
	 */
    public Adapter createJRMPAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.CMI <em>CMI</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.CMI
	 * @generated
	 */
    public Adapter createCMIAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IRMI <em>IRMI</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IRMI
	 * @generated
	 */
    public Adapter createIRMIAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup <em>Cmi Group</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.CmiGroup
	 * @generated
	 */
    public Adapter createCmiGroupAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode <em>Configuration Node</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode
	 * @generated
	 */
    public Adapter createConfigurationNodeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.HaGroup <em>Ha Group</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HaGroup
	 * @generated
	 */
    public Adapter createHaGroupAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.ClusterContainer <em>Cluster Container</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ClusterContainer
	 * @generated
	 */
    public Adapter createClusterContainerAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup <em>HTTP Rep Group</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup
	 * @generated
	 */
    public Adapter createHTTP_RepGroupAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.RMIGroup <em>RMI Group</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RMIGroup
	 * @generated
	 */
    public Adapter createRMIGroupAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.DbLink <em>Db Link</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DbLink
	 * @generated
	 */
    public Adapter createDbLinkAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode <em>IConfiguration Node</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode
	 * @generated
	 */
    public Adapter createIConfigurationNodeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.RmiConnector <em>Rmi Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RmiConnector
	 * @generated
	 */
    public Adapter createRmiConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.WebConnector <em>Web Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebConnector
	 * @generated
	 */
    public Adapter createWebConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.AJP <em>AJP</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.AJP
	 * @generated
	 */
    public Adapter createAJPAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.HTTP <em>HTTP</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HTTP
	 * @generated
	 */
    public Adapter createHTTPAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.HTTPS <em>HTTPS</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HTTPS
	 * @generated
	 */
    public Adapter createHTTPSAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IWebConnector <em>IWeb Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IWebConnector
	 * @generated
	 */
    public Adapter createIWebConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService <em>Jms Service</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JmsService
	 * @generated
	 */
    public Adapter createJmsServiceAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.DiscoveryService <em>Discovery Service</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DiscoveryService
	 * @generated
	 */
    public Adapter createDiscoveryServiceAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent <em>Middleware Component</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent
	 * @generated
	 */
    public Adapter createMiddlewareComponentAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheProperties <em>Apache Properties</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheProperties
	 * @generated
	 */
    public Adapter createApachePropertiesAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties <em>Apache Middleware Properties</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties
	 * @generated
	 */
    public Adapter createApacheMiddlewarePropertiesAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.ILocatable <em>ILocatable</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ILocatable
	 * @generated
	 */
    public Adapter createILocatableAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS <em>JBoss AS</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossAS
	 * @generated
	 */
    public Adapter createJBossASAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding <em>JBoss Binding</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding
	 * @generated
	 */
    public Adapter createJBossBindingAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.IJBossConnector <em>IJ Boss Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJBossConnector
	 * @generated
	 */
    public Adapter createIJBossConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector <em>JBoss HA Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector
	 * @generated
	 */
    public Adapter createJBossHAConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector <em>JBoss HTTP Rep Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector
	 * @generated
	 */
    public Adapter createJBossHTTPRepConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup <em>JBoss HA Group</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup
	 * @generated
	 */
    public Adapter createJBossHAGroupAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector <em>JBoss Mod JK Connector</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector
	 * @generated
	 */
    public Adapter createJBossModJKConnectorAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc --> This
     * default implementation returns null. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
    public Adapter createEObjectAdapter() {
		return null;
	}

} // JasminemodelAdapterFactory
