/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.objectweb.jasmine.ui.jasminemodel.*;
import org.objectweb.jasmine.ui.jasminemodel.AJP;
import org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.ApacheProperties;
import org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd;
import org.objectweb.jasmine.ui.jasminemodel.CMI;
import org.objectweb.jasmine.ui.jasminemodel.CMIConnector;
import org.objectweb.jasmine.ui.jasminemodel.Cluster;
import org.objectweb.jasmine.ui.jasminemodel.ClusterContainer;
import org.objectweb.jasmine.ui.jasminemodel.CmiGroup;
import org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode;
import org.objectweb.jasmine.ui.jasminemodel.DB;
import org.objectweb.jasmine.ui.jasminemodel.DbLink;
import org.objectweb.jasmine.ui.jasminemodel.DiscoveryService;
import org.objectweb.jasmine.ui.jasminemodel.Domain;
import org.objectweb.jasmine.ui.jasminemodel.EJBContainer;
import org.objectweb.jasmine.ui.jasminemodel.EjbJar;
import org.objectweb.jasmine.ui.jasminemodel.HAConnector;
import org.objectweb.jasmine.ui.jasminemodel.HTTP;
import org.objectweb.jasmine.ui.jasminemodel.HTTPS;
import org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup;
import org.objectweb.jasmine.ui.jasminemodel.HaGroup;
import org.objectweb.jasmine.ui.jasminemodel.IApplication;
import org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode;
import org.objectweb.jasmine.ui.jasminemodel.IConnector;
import org.objectweb.jasmine.ui.jasminemodel.IContainer;
import org.objectweb.jasmine.ui.jasminemodel.IHTTPServer;
import org.objectweb.jasmine.ui.jasminemodel.IIOP;
import org.objectweb.jasmine.ui.jasminemodel.IJBossConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJavaEEConnector;
import org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer;
import org.objectweb.jasmine.ui.jasminemodel.ILocatable;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties;
import org.objectweb.jasmine.ui.jasminemodel.IModule;
import org.objectweb.jasmine.ui.jasminemodel.IRMI;
import org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry;
import org.objectweb.jasmine.ui.jasminemodel.IWebConnector;
import org.objectweb.jasmine.ui.jasminemodel.JASMINe;
import org.objectweb.jasmine.ui.jasminemodel.JASMINeNode;
import org.objectweb.jasmine.ui.jasminemodel.JBossAS;
import org.objectweb.jasmine.ui.jasminemodel.JBossBinding;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup;
import org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector;
import org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector;
import org.objectweb.jasmine.ui.jasminemodel.JOnAS;
import org.objectweb.jasmine.ui.jasminemodel.JRMP;
import org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage;
import org.objectweb.jasmine.ui.jasminemodel.JmsService;
import org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent;
import org.objectweb.jasmine.ui.jasminemodel.ModJKModule;
import org.objectweb.jasmine.ui.jasminemodel.RMIGroup;
import org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector;
import org.objectweb.jasmine.ui.jasminemodel.RmiConnector;
import org.objectweb.jasmine.ui.jasminemodel.Server;
import org.objectweb.jasmine.ui.jasminemodel.ServerPool;
import org.objectweb.jasmine.ui.jasminemodel.WebConnector;
import org.objectweb.jasmine.ui.jasminemodel.WebContainer;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelPackage
 * @generated
 */
public class JasminemodelSwitch<T> {
    /**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected static JasminemodelPackage modelPackage;

    /**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public JasminemodelSwitch() {
		if (modelPackage == null) {
			modelPackage = JasminemodelPackage.eINSTANCE;
		}
	}

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
    public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
    protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
    protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case JasminemodelPackage.JASMI_NE: {
				JASMINe jasmiNe = (JASMINe)theEObject;
				T result = caseJASMINe(jasmiNe);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.SERVER_POOL: {
				ServerPool serverPool = (ServerPool)theEObject;
				T result = caseServerPool(serverPool);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.SERVER: {
				Server server = (Server)theEObject;
				T result = caseServer(server);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JASMI_NE_NODE: {
				JASMINeNode jasmiNeNode = (JASMINeNode)theEObject;
				T result = caseJASMINeNode(jasmiNeNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.DOMAIN: {
				Domain domain = (Domain)theEObject;
				T result = caseDomain(domain);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.CLUSTER: {
				Cluster cluster = (Cluster)theEObject;
				T result = caseCluster(cluster);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.ICONNECTOR: {
				IConnector iConnector = (IConnector)theEObject;
				T result = caseIConnector(iConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IJAVA_EE_CONNECTOR: {
				IJavaEEConnector iJavaEEConnector = (IJavaEEConnector)theEObject;
				T result = caseIJavaEEConnector(iJavaEEConnector);
				if (result == null) result = caseIConnector(iJavaEEConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IJ_ON_AS_CONNECTOR: {
				IJOnASConnector ijOnASConnector = (IJOnASConnector)theEObject;
				T result = caseIJOnASConnector(ijOnASConnector);
				if (result == null) result = caseIJavaEEConnector(ijOnASConnector);
				if (result == null) result = caseIConnector(ijOnASConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.DB: {
				DB db = (DB)theEObject;
				T result = caseDB(db);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IMIDDLEWARE_COMPONENT: {
				IMiddlewareComponent iMiddlewareComponent = (IMiddlewareComponent)theEObject;
				T result = caseIMiddlewareComponent(iMiddlewareComponent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IMIDDLEWARE_PROPERTIES: {
				IMiddlewareProperties iMiddlewareProperties = (IMiddlewareProperties)theEObject;
				T result = caseIMiddlewareProperties(iMiddlewareProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JON_AS: {
				JOnAS jOnAS = (JOnAS)theEObject;
				T result = caseJOnAS(jOnAS);
				if (result == null) result = caseIJavaEEServer(jOnAS);
				if (result == null) result = caseILocatable(jOnAS);
				if (result == null) result = caseMiddlewareComponent(jOnAS);
				if (result == null) result = caseIMiddlewareComponent(jOnAS);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.APACHE_HTT_PD: {
				Apache_HTTPd apache_HTTPd = (Apache_HTTPd)theEObject;
				T result = caseApache_HTTPd(apache_HTTPd);
				if (result == null) result = caseIHTTPServer(apache_HTTPd);
				if (result == null) result = caseILocatable(apache_HTTPd);
				if (result == null) result = caseMiddlewareComponent(apache_HTTPd);
				if (result == null) result = caseIMiddlewareComponent(apache_HTTPd);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.ICONTAINER: {
				IContainer iContainer = (IContainer)theEObject;
				T result = caseIContainer(iContainer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IJAVA_EE_SERVER: {
				IJavaEEServer iJavaEEServer = (IJavaEEServer)theEObject;
				T result = caseIJavaEEServer(iJavaEEServer);
				if (result == null) result = caseMiddlewareComponent(iJavaEEServer);
				if (result == null) result = caseIMiddlewareComponent(iJavaEEServer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IHTTP_SERVER: {
				IHTTPServer ihttpServer = (IHTTPServer)theEObject;
				T result = caseIHTTPServer(ihttpServer);
				if (result == null) result = caseMiddlewareComponent(ihttpServer);
				if (result == null) result = caseIMiddlewareComponent(ihttpServer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.WEB_CONTAINER: {
				WebContainer webContainer = (WebContainer)theEObject;
				T result = caseWebContainer(webContainer);
				if (result == null) result = caseIContainer(webContainer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.EJB_CONTAINER: {
				EJBContainer ejbContainer = (EJBContainer)theEObject;
				T result = caseEJBContainer(ejbContainer);
				if (result == null) result = caseIContainer(ejbContainer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.EJB_JAR: {
				EjbJar ejbJar = (EjbJar)theEObject;
				T result = caseEjbJar(ejbJar);
				if (result == null) result = caseIApplication(ejbJar);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IMODULE: {
				IModule iModule = (IModule)theEObject;
				T result = caseIModule(iModule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.MOD_JK_MODULE: {
				ModJKModule modJKModule = (ModJKModule)theEObject;
				T result = caseModJKModule(modJKModule);
				if (result == null) result = caseIModule(modJKModule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IAPPLICATION: {
				IApplication iApplication = (IApplication)theEObject;
				T result = caseIApplication(iApplication);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.REP_HTTP_CONNECTOR: {
				RepHTTPConnector repHTTPConnector = (RepHTTPConnector)theEObject;
				T result = caseRepHTTPConnector(repHTTPConnector);
				if (result == null) result = caseIJOnASConnector(repHTTPConnector);
				if (result == null) result = caseIJavaEEConnector(repHTTPConnector);
				if (result == null) result = caseIConnector(repHTTPConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.HA_CONNECTOR: {
				HAConnector haConnector = (HAConnector)theEObject;
				T result = caseHAConnector(haConnector);
				if (result == null) result = caseIJOnASConnector(haConnector);
				if (result == null) result = caseIJavaEEConnector(haConnector);
				if (result == null) result = caseIConnector(haConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IRMI_REGISTRY: {
				IRMIRegistry irmiRegistry = (IRMIRegistry)theEObject;
				T result = caseIRMIRegistry(irmiRegistry);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IIOP: {
				IIOP iiop = (IIOP)theEObject;
				T result = caseIIOP(iiop);
				if (result == null) result = caseIRMIRegistry(iiop);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JRMP: {
				JRMP jrmp = (JRMP)theEObject;
				T result = caseJRMP(jrmp);
				if (result == null) result = caseIRMIRegistry(jrmp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.CMI: {
				CMI cmi = (CMI)theEObject;
				T result = caseCMI(cmi);
				if (result == null) result = caseIRMIRegistry(cmi);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IRMI: {
				IRMI irmi = (IRMI)theEObject;
				T result = caseIRMI(irmi);
				if (result == null) result = caseIRMIRegistry(irmi);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.CMI_GROUP: {
				CmiGroup cmiGroup = (CmiGroup)theEObject;
				T result = caseCmiGroup(cmiGroup);
				if (result == null) result = caseConfigurationNode(cmiGroup);
				if (result == null) result = caseIConfigurationNode(cmiGroup);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.CONFIGURATION_NODE: {
				ConfigurationNode configurationNode = (ConfigurationNode)theEObject;
				T result = caseConfigurationNode(configurationNode);
				if (result == null) result = caseIConfigurationNode(configurationNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.HA_GROUP: {
				HaGroup haGroup = (HaGroup)theEObject;
				T result = caseHaGroup(haGroup);
				if (result == null) result = caseConfigurationNode(haGroup);
				if (result == null) result = caseIConfigurationNode(haGroup);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.CLUSTER_CONTAINER: {
				ClusterContainer clusterContainer = (ClusterContainer)theEObject;
				T result = caseClusterContainer(clusterContainer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.HTTP_REP_GROUP: {
				HTTP_RepGroup httP_RepGroup = (HTTP_RepGroup)theEObject;
				T result = caseHTTP_RepGroup(httP_RepGroup);
				if (result == null) result = caseConfigurationNode(httP_RepGroup);
				if (result == null) result = caseIConfigurationNode(httP_RepGroup);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.RMI_GROUP: {
				RMIGroup rmiGroup = (RMIGroup)theEObject;
				T result = caseRMIGroup(rmiGroup);
				if (result == null) result = caseConfigurationNode(rmiGroup);
				if (result == null) result = caseIConfigurationNode(rmiGroup);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.DB_LINK: {
				DbLink dbLink = (DbLink)theEObject;
				T result = caseDbLink(dbLink);
				if (result == null) result = caseIConnector(dbLink);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.ICONFIGURATION_NODE: {
				IConfigurationNode iConfigurationNode = (IConfigurationNode)theEObject;
				T result = caseIConfigurationNode(iConfigurationNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.RMI_CONNECTOR: {
				RmiConnector rmiConnector = (RmiConnector)theEObject;
				T result = caseRmiConnector(rmiConnector);
				if (result == null) result = caseIJOnASConnector(rmiConnector);
				if (result == null) result = caseIJavaEEConnector(rmiConnector);
				if (result == null) result = caseIConnector(rmiConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.WEB_CONNECTOR: {
				WebConnector webConnector = (WebConnector)theEObject;
				T result = caseWebConnector(webConnector);
				if (result == null) result = caseIWebConnector(webConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.AJP: {
				AJP ajp = (AJP)theEObject;
				T result = caseAJP(ajp);
				if (result == null) result = caseWebConnector(ajp);
				if (result == null) result = caseIWebConnector(ajp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.HTTP: {
				HTTP http = (HTTP)theEObject;
				T result = caseHTTP(http);
				if (result == null) result = caseWebConnector(http);
				if (result == null) result = caseIWebConnector(http);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.HTTPS: {
				HTTPS https = (HTTPS)theEObject;
				T result = caseHTTPS(https);
				if (result == null) result = caseWebConnector(https);
				if (result == null) result = caseIWebConnector(https);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IWEB_CONNECTOR: {
				IWebConnector iWebConnector = (IWebConnector)theEObject;
				T result = caseIWebConnector(iWebConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JMS_SERVICE: {
				JmsService jmsService = (JmsService)theEObject;
				T result = caseJmsService(jmsService);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.DISCOVERY_SERVICE: {
				DiscoveryService discoveryService = (DiscoveryService)theEObject;
				T result = caseDiscoveryService(discoveryService);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.MIDDLEWARE_COMPONENT: {
				MiddlewareComponent middlewareComponent = (MiddlewareComponent)theEObject;
				T result = caseMiddlewareComponent(middlewareComponent);
				if (result == null) result = caseIMiddlewareComponent(middlewareComponent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.APACHE_PROPERTIES: {
				ApacheProperties apacheProperties = (ApacheProperties)theEObject;
				T result = caseApacheProperties(apacheProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.APACHE_MIDDLEWARE_PROPERTIES: {
				ApacheMiddlewareProperties apacheMiddlewareProperties = (ApacheMiddlewareProperties)theEObject;
				T result = caseApacheMiddlewareProperties(apacheMiddlewareProperties);
				if (result == null) result = caseIMiddlewareProperties(apacheMiddlewareProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.ILOCATABLE: {
				ILocatable iLocatable = (ILocatable)theEObject;
				T result = caseILocatable(iLocatable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JBOSS_AS: {
				JBossAS jBossAS = (JBossAS)theEObject;
				T result = caseJBossAS(jBossAS);
				if (result == null) result = caseIJavaEEServer(jBossAS);
				if (result == null) result = caseILocatable(jBossAS);
				if (result == null) result = caseMiddlewareComponent(jBossAS);
				if (result == null) result = caseIMiddlewareComponent(jBossAS);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JBOSS_BINDING: {
				JBossBinding jBossBinding = (JBossBinding)theEObject;
				T result = caseJBossBinding(jBossBinding);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.IJ_BOSS_CONNECTOR: {
				IJBossConnector ijBossConnector = (IJBossConnector)theEObject;
				T result = caseIJBossConnector(ijBossConnector);
				if (result == null) result = caseIJavaEEConnector(ijBossConnector);
				if (result == null) result = caseIConnector(ijBossConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JBOSS_HA_CONNECTOR: {
				JBossHAConnector jBossHAConnector = (JBossHAConnector)theEObject;
				T result = caseJBossHAConnector(jBossHAConnector);
				if (result == null) result = caseIJBossConnector(jBossHAConnector);
				if (result == null) result = caseIJavaEEConnector(jBossHAConnector);
				if (result == null) result = caseIConnector(jBossHAConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JBOSS_HTTP_REP_CONNECTOR: {
				JBossHTTPRepConnector jBossHTTPRepConnector = (JBossHTTPRepConnector)theEObject;
				T result = caseJBossHTTPRepConnector(jBossHTTPRepConnector);
				if (result == null) result = caseIJBossConnector(jBossHTTPRepConnector);
				if (result == null) result = caseIJavaEEConnector(jBossHTTPRepConnector);
				if (result == null) result = caseIConnector(jBossHTTPRepConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JBOSS_HA_GROUP: {
				JBossHAGroup jBossHAGroup = (JBossHAGroup)theEObject;
				T result = caseJBossHAGroup(jBossHAGroup);
				if (result == null) result = caseConfigurationNode(jBossHAGroup);
				if (result == null) result = caseIConfigurationNode(jBossHAGroup);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case JasminemodelPackage.JBOSS_MOD_JK_CONNECTOR: {
				JBossModJKConnector jBossModJKConnector = (JBossModJKConnector)theEObject;
				T result = caseJBossModJKConnector(jBossModJKConnector);
				if (result == null) result = caseIJBossConnector(jBossModJKConnector);
				if (result == null) result = caseIJavaEEConnector(jBossModJKConnector);
				if (result == null) result = caseIConnector(jBossModJKConnector);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JASMI Ne</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JASMI Ne</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJASMINe(JASMINe object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Server Pool</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Server Pool</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseServerPool(ServerPool object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Server</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Server</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseServer(Server object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JASMI Ne Node</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JASMI Ne Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJASMINeNode(JASMINeNode object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Domain</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Domain</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDomain(Domain object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Cluster</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Cluster</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseCluster(Cluster object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IConnector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IConnector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIConnector(IConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IJava EE Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IJava EE Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIJavaEEConnector(IJavaEEConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IJ On AS Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IJ On AS Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIJOnASConnector(IJOnASConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>DB</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>DB</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDB(DB object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IMiddleware Component</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IMiddleware Component</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIMiddlewareComponent(IMiddlewareComponent object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IMiddleware Properties</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IMiddleware Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIMiddlewareProperties(IMiddlewareProperties object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JOn AS</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JOn AS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJOnAS(JOnAS object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Apache HTT Pd</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Apache HTT Pd</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseApache_HTTPd(Apache_HTTPd object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IContainer</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IContainer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIContainer(IContainer object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IJava EE Server</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IJava EE Server</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIJavaEEServer(IJavaEEServer object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IHTTP Server</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IHTTP Server</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIHTTPServer(IHTTPServer object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Web Container</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Web Container</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseWebContainer(WebContainer object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>EJB Container</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EJB Container</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseEJBContainer(EJBContainer object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Ejb Jar</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Ejb Jar</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseEjbJar(EjbJar object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IModule</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IModule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIModule(IModule object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Mod JK Module</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Mod JK Module</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseModJKModule(ModJKModule object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IApplication</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IApplication</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIApplication(IApplication object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Rep HTTP Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rep HTTP Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRepHTTPConnector(RepHTTPConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>HA Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>HA Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseHAConnector(HAConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IRMI Registry</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IRMI Registry</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIRMIRegistry(IRMIRegistry object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IIOP</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IIOP</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIIOP(IIOP object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JRMP</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JRMP</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJRMP(JRMP object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>CMI</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>CMI</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseCMI(CMI object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IRMI</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IRMI</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIRMI(IRMI object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Cmi Group</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Cmi Group</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseCmiGroup(CmiGroup object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Configuration Node</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Configuration Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseConfigurationNode(ConfigurationNode object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Ha Group</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Ha Group</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseHaGroup(HaGroup object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Cluster Container</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Cluster Container</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseClusterContainer(ClusterContainer object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>HTTP Rep Group</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>HTTP Rep Group</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseHTTP_RepGroup(HTTP_RepGroup object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>RMI Group</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>RMI Group</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRMIGroup(RMIGroup object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Db Link</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Db Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDbLink(DbLink object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IConfiguration Node</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IConfiguration Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIConfigurationNode(IConfigurationNode object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Rmi Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rmi Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRmiConnector(RmiConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Web Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Web Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseWebConnector(WebConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>AJP</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>AJP</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseAJP(AJP object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>HTTP</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>HTTP</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseHTTP(HTTP object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>HTTPS</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>HTTPS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseHTTPS(HTTPS object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IWeb Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IWeb Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIWebConnector(IWebConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Jms Service</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Jms Service</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJmsService(JmsService object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Discovery Service</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Discovery Service</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDiscoveryService(DiscoveryService object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Middleware Component</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Middleware Component</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseMiddlewareComponent(MiddlewareComponent object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Apache Properties</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Apache Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseApacheProperties(ApacheProperties object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>Apache Middleware Properties</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Apache Middleware Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseApacheMiddlewareProperties(ApacheMiddlewareProperties object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>ILocatable</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ILocatable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseILocatable(ILocatable object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JBoss AS</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JBoss AS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJBossAS(JBossAS object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JBoss Binding</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JBoss Binding</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJBossBinding(JBossBinding object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>IJ Boss Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IJ Boss Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseIJBossConnector(IJBossConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JBoss HA Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JBoss HA Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJBossHAConnector(JBossHAConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JBoss HTTP Rep Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JBoss HTTP Rep Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJBossHTTPRepConnector(JBossHTTPRepConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JBoss HA Group</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JBoss HA Group</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJBossHAGroup(JBossHAGroup object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>JBoss Mod JK Connector</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>JBoss Mod JK Connector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseJBossModJKConnector(JBossModJKConnector object) {
		return null;
	}

    /**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch, but this is the last case
     * anyway. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
    public T defaultCase(EObject object) {
		return null;
	}

} // JasminemodelSwitch
