/**
 * JASMINe
 * Copyright (C) 2006,2007 Bull S.A.S.
 * Contact: jasmine@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.jade.application;



public interface ApplicationIfc {

    public String getName();

    public void deploy() throws Exception;

    public void deploy(String address) throws Exception;

    public void deploy(String address, String jadenodeNumber) throws Exception;

    public void deploy(String address, String dirLocal, String jadeNodeNumber)
            throws Exception;

    public void start() throws Exception;

    public void stop() throws Exception;

    public String getAttribute(String attribute) throws Exception;

    public void setAttribute(String attribute, String value) throws Exception;

    public String[] listAttributes() throws Exception;

    public void bind(String component1, String itf1, String component2,
            String itf2) throws Exception;

    public void unbind(String component1, String itf1) throws Exception;

    public String[] listFc(String component1) throws Exception;
}
