/**
 * JASMINe
 * Copyright (C) 2007 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jasmine.ui.jasminemodel;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.objectweb.jasmine.ui.jasminemodel.JasminemodelFactory
 * @model kind="package"
 * @generated
 */
public interface JasminemodelPackage extends EPackage {
    /**
	 * The package name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    String eNAME = "jasminemodel";

    /**
	 * The package namespace URI.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    String eNS_URI = "http:///org.objectweb.jasmine.model.ecore";

    /**
	 * The package namespace name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    String eNS_PREFIX = "jasminemodel";

    /**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    JasminemodelPackage eINSTANCE = org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl.init();

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeImpl <em>JASMI Ne</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJASMINe()
	 * @generated
	 */
    int JASMI_NE = 0;

    /**
	 * The feature id for the '<em><b>Server Pool</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE__SERVER_POOL = 0;

    /**
	 * The feature id for the '<em><b>Domain</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE__DOMAIN = 1;

    /**
	 * The number of structural features of the '<em>JASMI Ne</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_FEATURE_COUNT = 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ServerPoolImpl <em>Server Pool</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ServerPoolImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getServerPool()
	 * @generated
	 */
    int SERVER_POOL = 1;

    /**
	 * The feature id for the '<em><b>Server</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_POOL__SERVER = 0;

    /**
	 * The number of structural features of the '<em>Server Pool</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_POOL_FEATURE_COUNT = 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ServerImpl <em>Server</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ServerImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getServer()
	 * @generated
	 */
    int SERVER = 2;

    /**
	 * The feature id for the '<em><b>Jade Node</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__JADE_NODE = 0;

    /**
	 * The number of structural features of the '<em>Server</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_FEATURE_COUNT = 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl <em>JASMI Ne Node</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJASMINeNode()
	 * @generated
	 */
    int JASMI_NE_NODE = 3;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__NAME = 0;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__HOST = 1;

    /**
     * The feature id for the '<em><b>User</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__USER = 2;

    /**
     * The feature id for the '<em><b>Password</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__PASSWORD = 3;

    /**
     * The feature id for the '<em><b>Ssh Key</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__SSH_KEY = 4;

    /**
     * The feature id for the '<em><b>Install Dir</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__INSTALL_DIR = 5;

    /**
     * The feature id for the '<em><b>Node Id</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__NODE_ID = 6;

    /**
	 * The feature id for the '<em><b>Registry Host</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE__REGISTRY_HOST = 7;

    /**
	 * The feature id for the '<em><b>Registry Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE__REGISTRY_PORT = 8;

    /**
	 * The feature id for the '<em><b>Discovery Host</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE__DISCOVERY_HOST = 9;

    /**
	 * The feature id for the '<em><b>Discovery Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE__DISCOVERY_PORT = 10;

    /**
     * The feature id for the '<em><b>Jndi Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JASMI_NE_NODE__JNDI_PORT = 11;

    /**
	 * The feature id for the '<em><b>Felix Profile</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE__FELIX_PROFILE = 12;

    /**
	 * The feature id for the '<em><b>Repository URL</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE__REPOSITORY_URL = 13;

    /**
	 * The feature id for the '<em><b>Middlewares</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE__MIDDLEWARES = 14;

    /**
	 * The number of structural features of the '<em>JASMI Ne Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JASMI_NE_NODE_FEATURE_COUNT = 15;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl <em>Domain</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDomain()
	 * @generated
	 */
    int DOMAIN = 4;

    /**
	 * The feature id for the '<em><b>Middleware Components</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOMAIN__MIDDLEWARE_COMPONENTS = 0;

    /**
	 * The feature id for the '<em><b>Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOMAIN__CONNECTORS = 1;

    /**
	 * The feature id for the '<em><b>Configuration Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOMAIN__CONFIGURATION_NODES = 2;

    /**
	 * The feature id for the '<em><b>Cluster Containers</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOMAIN__CLUSTER_CONTAINERS = 3;

    /**
	 * The feature id for the '<em><b>Db</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOMAIN__DB = 4;

    /**
	 * The feature id for the '<em><b>Dblinks</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOMAIN__DBLINKS = 5;

    /**
	 * The number of structural features of the '<em>Domain</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOMAIN_FEATURE_COUNT = 6;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ClusterImpl <em>Cluster</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ClusterImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getCluster()
	 * @generated
	 */
    int CLUSTER = 5;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CLUSTER__NAME = 0;

    /**
	 * The number of structural features of the '<em>Cluster</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLUSTER_FEATURE_COUNT = 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IConnector <em>IConnector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IConnector
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIConnector()
	 * @generated
	 */
    int ICONNECTOR = 6;

    /**
	 * The number of structural features of the '<em>IConnector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ICONNECTOR_FEATURE_COUNT = 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IJavaEEConnectorImpl <em>IJava EE Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IJavaEEConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJavaEEConnector()
	 * @generated
	 */
    int IJAVA_EE_CONNECTOR = 7;

    /**
	 * The number of structural features of the '<em>IJava EE Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_CONNECTOR_FEATURE_COUNT = ICONNECTOR_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector <em>IJ On AS Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJOnASConnector()
	 * @generated
	 */
    int IJ_ON_AS_CONNECTOR = 8;

    /**
	 * The number of structural features of the '<em>IJ On AS Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJ_ON_AS_CONNECTOR_FEATURE_COUNT = IJAVA_EE_CONNECTOR_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl <em>DB</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDB()
	 * @generated
	 */
    int DB = 9;

    /**
     * The feature id for the '<em><b>Provider</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__PROVIDER = 0;

    /**
     * The feature id for the '<em><b>User</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__USER = 1;

    /**
     * The feature id for the '<em><b>Password</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__PASSWORD = 2;

    /**
     * The feature id for the '<em><b>Url</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__URL = 3;

    /**
     * The feature id for the '<em><b>Driver Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__DRIVER_NAME = 4;

    /**
     * The feature id for the '<em><b>Jndi Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__JNDI_NAME = 5;

    /**
	 * The feature id for the '<em><b>Jdbc Driver Jar File</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DB__JDBC_DRIVER_JAR_FILE = 6;

    /**
	 * The feature id for the '<em><b>Mappern Name</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DB__MAPPERN_NAME = 7;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__NAME = 8;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB__PORT = 9;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DB__JASMINE_NODE = 10;

    /**
     * The number of structural features of the '<em>DB</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB_FEATURE_COUNT = 11;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent <em>IMiddleware Component</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIMiddlewareComponent()
	 * @generated
	 */
    int IMIDDLEWARE_COMPONENT = 10;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IMIDDLEWARE_COMPONENT__JASMINE_NODE = 0;

    /**
	 * The number of structural features of the '<em>IMiddleware Component</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IMIDDLEWARE_COMPONENT_FEATURE_COUNT = 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties <em>IMiddleware Properties</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIMiddlewareProperties()
	 * @generated
	 */
    int IMIDDLEWARE_PROPERTIES = 11;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IMIDDLEWARE_PROPERTIES__NAME = 0;

    /**
	 * The feature id for the '<em><b>Property File</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IMIDDLEWARE_PROPERTIES__PROPERTY_FILE = 1;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IMIDDLEWARE_PROPERTIES__DESCRIPTION = 2;

    /**
	 * The number of structural features of the '<em>IMiddleware Properties</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IMIDDLEWARE_PROPERTIES_FEATURE_COUNT = 3;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.MiddlewareComponentImpl <em>Middleware Component</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.MiddlewareComponentImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getMiddlewareComponent()
	 * @generated
	 */
    int MIDDLEWARE_COMPONENT = 46;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIDDLEWARE_COMPONENT__JASMINE_NODE = IMIDDLEWARE_COMPONENT__JASMINE_NODE;

    /**
	 * The feature id for the '<em><b>Middleware Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES = IMIDDLEWARE_COMPONENT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Middleware Component</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIDDLEWARE_COMPONENT_FEATURE_COUNT = IMIDDLEWARE_COMPONENT_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer <em>IJava EE Server</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJavaEEServer()
	 * @generated
	 */
    int IJAVA_EE_SERVER = 15;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__JASMINE_NODE = MIDDLEWARE_COMPONENT__JASMINE_NODE;

    /**
	 * The feature id for the '<em><b>Middleware Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__MIDDLEWARE_PROPERTIES = MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES;

    /**
	 * The feature id for the '<em><b>Web Containers</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__WEB_CONTAINERS = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Rmi Registries</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__RMI_REGISTRIES = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Ejb Containers</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__EJB_CONTAINERS = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Applications</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__APPLICATIONS = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Jms Services</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__JMS_SERVICES = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Discovery Services</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER__DISCOVERY_SERVICES = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Http Servers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IJAVA_EE_SERVER__HTTP_SERVERS = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 6;

				/**
	 * The number of structural features of the '<em>IJava EE Server</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJAVA_EE_SERVER_FEATURE_COUNT = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 7;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl <em>JOn AS</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJOnAS()
	 * @generated
	 */
    int JON_AS = 12;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__JASMINE_NODE = IJAVA_EE_SERVER__JASMINE_NODE;

    /**
	 * The feature id for the '<em><b>Middleware Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__MIDDLEWARE_PROPERTIES = IJAVA_EE_SERVER__MIDDLEWARE_PROPERTIES;

    /**
	 * The feature id for the '<em><b>Web Containers</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__WEB_CONTAINERS = IJAVA_EE_SERVER__WEB_CONTAINERS;

    /**
	 * The feature id for the '<em><b>Rmi Registries</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__RMI_REGISTRIES = IJAVA_EE_SERVER__RMI_REGISTRIES;

    /**
	 * The feature id for the '<em><b>Ejb Containers</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__EJB_CONTAINERS = IJAVA_EE_SERVER__EJB_CONTAINERS;

    /**
	 * The feature id for the '<em><b>Applications</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__APPLICATIONS = IJAVA_EE_SERVER__APPLICATIONS;

    /**
	 * The feature id for the '<em><b>Jms Services</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__JMS_SERVICES = IJAVA_EE_SERVER__JMS_SERVICES;

    /**
	 * The feature id for the '<em><b>Discovery Services</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__DISCOVERY_SERVICES = IJAVA_EE_SERVER__DISCOVERY_SERVICES;

    /**
	 * The feature id for the '<em><b>Http Servers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JON_AS__HTTP_SERVERS = IJAVA_EE_SERVER__HTTP_SERVERS;

				/**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JON_AS__NAME = IJAVA_EE_SERVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Instance Name</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__INSTANCE_NAME = IJAVA_EE_SERVER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Webconnectors</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__WEBCONNECTORS = IJAVA_EE_SERVER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Jonas Base</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JON_AS__JONAS_BASE = IJAVA_EE_SERVER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Jonas Root</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JON_AS__JONAS_ROOT = IJAVA_EE_SERVER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Domain</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JON_AS__DOMAIN = IJAVA_EE_SERVER_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Master</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JON_AS__MASTER = IJAVA_EE_SERVER_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Clusters</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS__CLUSTERS = IJAVA_EE_SERVER_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Cmigroup</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JON_AS__CMIGROUP = IJAVA_EE_SERVER_FEATURE_COUNT + 8;

				/**
	 * The number of structural features of the '<em>JOn AS</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JON_AS_FEATURE_COUNT = IJAVA_EE_SERVER_FEATURE_COUNT + 9;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer <em>IHTTP Server</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IHTTPServer
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIHTTPServer()
	 * @generated
	 */
    int IHTTP_SERVER = 16;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IHTTP_SERVER__JASMINE_NODE = MIDDLEWARE_COMPONENT__JASMINE_NODE;

    /**
	 * The feature id for the '<em><b>Middleware Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IHTTP_SERVER__MIDDLEWARE_PROPERTIES = MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES;

    /**
	 * The feature id for the '<em><b>Javaee Servers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IHTTP_SERVER__JAVAEE_SERVERS = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 0;

				/**
	 * The number of structural features of the '<em>IHTTP Server</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IHTTP_SERVER_FEATURE_COUNT = MIDDLEWARE_COMPONENT_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl <em>Apache HTT Pd</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getApache_HTTPd()
	 * @generated
	 */
    int APACHE_HTT_PD = 13;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_HTT_PD__JASMINE_NODE = IHTTP_SERVER__JASMINE_NODE;

    /**
	 * The feature id for the '<em><b>Middleware Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_HTT_PD__MIDDLEWARE_PROPERTIES = IHTTP_SERVER__MIDDLEWARE_PROPERTIES;

    /**
	 * The feature id for the '<em><b>Javaee Servers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APACHE_HTT_PD__JAVAEE_SERVERS = IHTTP_SERVER__JAVAEE_SERVERS;

				/**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_HTT_PD__NAME = IHTTP_SERVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Modules</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_HTT_PD__MODULES = IHTTP_SERVER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Home</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_HTT_PD__HOME = IHTTP_SERVER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_HTT_PD__HOST = IHTTP_SERVER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_HTT_PD__PORT = IHTTP_SERVER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>User</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_HTT_PD__USER = IHTTP_SERVER_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Group</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_HTT_PD__GROUP = IHTTP_SERVER_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>Apache HTT Pd</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_HTT_PD_FEATURE_COUNT = IHTTP_SERVER_FEATURE_COUNT + 7;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IContainerImpl <em>IContainer</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IContainerImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIContainer()
	 * @generated
	 */
    int ICONTAINER = 14;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int ICONTAINER__DESCRIPTION = 0;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int ICONTAINER__NAME = 1;

    /**
	 * The number of structural features of the '<em>IContainer</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ICONTAINER_FEATURE_COUNT = 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.WebContainerImpl <em>Web Container</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.WebContainerImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getWebContainer()
	 * @generated
	 */
    int WEB_CONTAINER = 17;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONTAINER__DESCRIPTION = ICONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONTAINER__NAME = ICONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONTAINER__TYPE = ICONTAINER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Jvm Route</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONTAINER__JVM_ROUTE = ICONTAINER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONTAINER__HOST = ICONTAINER_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Web Container</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEB_CONTAINER_FEATURE_COUNT = ICONTAINER_FEATURE_COUNT + 3;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.EJBContainerImpl <em>EJB Container</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.EJBContainerImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getEJBContainer()
	 * @generated
	 */
    int EJB_CONTAINER = 18;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int EJB_CONTAINER__DESCRIPTION = ICONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int EJB_CONTAINER__NAME = ICONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Auto Genic</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int EJB_CONTAINER__AUTO_GENIC = ICONTAINER_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>EJB Container</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EJB_CONTAINER_FEATURE_COUNT = ICONTAINER_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IApplication <em>IApplication</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IApplication
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIApplication()
	 * @generated
	 */
    int IAPPLICATION = 22;

    /**
	 * The number of structural features of the '<em>IApplication</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IAPPLICATION_FEATURE_COUNT = 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.EjbJarImpl <em>Ejb Jar</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.EjbJarImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getEjbJar()
	 * @generated
	 */
    int EJB_JAR = 19;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int EJB_JAR__DESCRIPTION = IAPPLICATION_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int EJB_JAR__NAME = IAPPLICATION_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Ejb Jar</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EJB_JAR_FEATURE_COUNT = IAPPLICATION_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IModuleImpl <em>IModule</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IModuleImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIModule()
	 * @generated
	 */
    int IMODULE = 20;

    /**
	 * The number of structural features of the '<em>IModule</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IMODULE_FEATURE_COUNT = 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ModJKModuleImpl <em>Mod JK Module</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ModJKModuleImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getModJKModule()
	 * @generated
	 */
    int MOD_JK_MODULE = 21;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int MOD_JK_MODULE__DESCRIPTION = IMODULE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int MOD_JK_MODULE__NAME = IMODULE_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Mod JK Module</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MOD_JK_MODULE_FEATURE_COUNT = IMODULE_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.RepHTTPConnectorImpl <em>Rep HTTP Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.RepHTTPConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getRepHTTPConnector()
	 * @generated
	 */
    int REP_HTTP_CONNECTOR = 23;

    /**
     * The feature id for the '<em><b>Source</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int REP_HTTP_CONNECTOR__SOURCE = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Target</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int REP_HTTP_CONNECTOR__TARGET = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Rep HTTP Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REP_HTTP_CONNECTOR_FEATURE_COUNT = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HAConnectorImpl <em>HA Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HAConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHAConnector()
	 * @generated
	 */
    int HA_CONNECTOR = 24;

    /**
     * The feature id for the '<em><b>Source</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HA_CONNECTOR__SOURCE = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Target</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HA_CONNECTOR__TARGET = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>HA Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HA_CONNECTOR_FEATURE_COUNT = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IRMIRegistryImpl <em>IRMI Registry</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IRMIRegistryImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIRMIRegistry()
	 * @generated
	 */
    int IRMI_REGISTRY = 25;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IRMI_REGISTRY__HOST = 0;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IRMI_REGISTRY__PORT = 1;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IRMI_REGISTRY__NAME = 2;

    /**
	 * The number of structural features of the '<em>IRMI Registry</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IRMI_REGISTRY_FEATURE_COUNT = 3;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IIOPImpl <em>IIOP</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IIOPImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIIOP()
	 * @generated
	 */
    int IIOP = 26;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IIOP__HOST = IRMI_REGISTRY__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IIOP__PORT = IRMI_REGISTRY__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IIOP__NAME = IRMI_REGISTRY__NAME;

    /**
     * The number of structural features of the '<em>IIOP</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IIOP_FEATURE_COUNT = IRMI_REGISTRY_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JRMPImpl <em>JRMP</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JRMPImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJRMP()
	 * @generated
	 */
    int JRMP = 27;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JRMP__HOST = IRMI_REGISTRY__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JRMP__PORT = IRMI_REGISTRY__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JRMP__NAME = IRMI_REGISTRY__NAME;

    /**
     * The number of structural features of the '<em>JRMP</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JRMP_FEATURE_COUNT = IRMI_REGISTRY_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.CMIImpl <em>CMI</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.CMIImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getCMI()
	 * @generated
	 */
    int CMI = 28;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI__HOST = IRMI_REGISTRY__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI__PORT = IRMI_REGISTRY__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI__NAME = IRMI_REGISTRY__NAME;

    /**
     * The number of structural features of the '<em>CMI</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI_FEATURE_COUNT = IRMI_REGISTRY_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IRMIImpl <em>IRMI</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IRMIImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIRMI()
	 * @generated
	 */
    int IRMI = 29;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IRMI__HOST = IRMI_REGISTRY__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IRMI__PORT = IRMI_REGISTRY__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IRMI__NAME = IRMI_REGISTRY__NAME;

    /**
     * The number of structural features of the '<em>IRMI</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int IRMI_FEATURE_COUNT = IRMI_REGISTRY_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode <em>IConfiguration Node</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIConfigurationNode()
	 * @generated
	 */
    int ICONFIGURATION_NODE = 37;

    /**
	 * The number of structural features of the '<em>IConfiguration Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ICONFIGURATION_NODE_FEATURE_COUNT = 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ConfigurationNodeImpl <em>Configuration Node</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ConfigurationNodeImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getConfigurationNode()
	 * @generated
	 */
    int CONFIGURATION_NODE = 31;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CONFIGURATION_NODE__DESCRIPTION = ICONFIGURATION_NODE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CONFIGURATION_NODE__HOST = ICONFIGURATION_NODE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CONFIGURATION_NODE__PORT = ICONFIGURATION_NODE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CONFIGURATION_NODE__NAME = ICONFIGURATION_NODE_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Configuration Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONFIGURATION_NODE_FEATURE_COUNT = ICONFIGURATION_NODE_FEATURE_COUNT + 4;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.CmiGroupImpl <em>Cmi Group</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.CmiGroupImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getCmiGroup()
	 * @generated
	 */
    int CMI_GROUP = 30;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI_GROUP__DESCRIPTION = CONFIGURATION_NODE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI_GROUP__HOST = CONFIGURATION_NODE__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI_GROUP__PORT = CONFIGURATION_NODE__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI_GROUP__NAME = CONFIGURATION_NODE__NAME;

    /**
     * The feature id for the '<em><b>Lan Mode</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int CMI_GROUP__LAN_MODE = CONFIGURATION_NODE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Tcp Ping Host</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CMI_GROUP__TCP_PING_HOST = CONFIGURATION_NODE_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Cmi Group</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CMI_GROUP_FEATURE_COUNT = CONFIGURATION_NODE_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HaGroupImpl <em>Ha Group</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HaGroupImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHaGroup()
	 * @generated
	 */
    int HA_GROUP = 32;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HA_GROUP__DESCRIPTION = CONFIGURATION_NODE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HA_GROUP__HOST = CONFIGURATION_NODE__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HA_GROUP__PORT = CONFIGURATION_NODE__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HA_GROUP__NAME = CONFIGURATION_NODE__NAME;

    /**
     * The feature id for the '<em><b>Lan Mode</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HA_GROUP__LAN_MODE = CONFIGURATION_NODE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Tcp Ping Host</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HA_GROUP__TCP_PING_HOST = CONFIGURATION_NODE_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Ha Group</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HA_GROUP_FEATURE_COUNT = CONFIGURATION_NODE_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ClusterContainerImpl <em>Cluster Container</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ClusterContainerImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getClusterContainer()
	 * @generated
	 */
    int CLUSTER_CONTAINER = 33;

    /**
	 * The feature id for the '<em><b>Clusters</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLUSTER_CONTAINER__CLUSTERS = 0;

    /**
	 * The number of structural features of the '<em>Cluster Container</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLUSTER_CONTAINER_FEATURE_COUNT = 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HTTP_RepGroupImpl <em>HTTP Rep Group</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HTTP_RepGroupImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHTTP_RepGroup()
	 * @generated
	 */
    int HTTP_REP_GROUP = 34;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP_REP_GROUP__DESCRIPTION = CONFIGURATION_NODE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP_REP_GROUP__HOST = CONFIGURATION_NODE__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP_REP_GROUP__PORT = CONFIGURATION_NODE__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP_REP_GROUP__NAME = CONFIGURATION_NODE__NAME;

    /**
	 * The feature id for the '<em><b>Tcp Listen Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HTTP_REP_GROUP__TCP_LISTEN_PORT = CONFIGURATION_NODE_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>HTTP Rep Group</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HTTP_REP_GROUP_FEATURE_COUNT = CONFIGURATION_NODE_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.RMIGroupImpl <em>RMI Group</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.RMIGroupImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getRMIGroup()
	 * @generated
	 */
    int RMI_GROUP = 35;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int RMI_GROUP__DESCRIPTION = CONFIGURATION_NODE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int RMI_GROUP__HOST = CONFIGURATION_NODE__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int RMI_GROUP__PORT = CONFIGURATION_NODE__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int RMI_GROUP__NAME = CONFIGURATION_NODE__NAME;

    /**
	 * The number of structural features of the '<em>RMI Group</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RMI_GROUP_FEATURE_COUNT = CONFIGURATION_NODE_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DbLinkImpl <em>Db Link</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DbLinkImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDbLink()
	 * @generated
	 */
    int DB_LINK = 36;

    /**
     * The feature id for the '<em><b>Source</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB_LINK__SOURCE = ICONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Target</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DB_LINK__TARGET = ICONNECTOR_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Db Link</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DB_LINK_FEATURE_COUNT = ICONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.RmiConnectorImpl <em>Rmi Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.RmiConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getRmiConnector()
	 * @generated
	 */
    int RMI_CONNECTOR = 38;

    /**
     * The feature id for the '<em><b>Source</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int RMI_CONNECTOR__SOURCE = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Target</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int RMI_CONNECTOR__TARGET = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Rmi Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RMI_CONNECTOR_FEATURE_COUNT = IJ_ON_AS_CONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.IWebConnector <em>IWeb Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.IWebConnector
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIWebConnector()
	 * @generated
	 */
    int IWEB_CONNECTOR = 43;

    /**
	 * The number of structural features of the '<em>IWeb Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IWEB_CONNECTOR_FEATURE_COUNT = 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.WebConnectorImpl <em>Web Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.WebConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getWebConnector()
	 * @generated
	 */
    int WEB_CONNECTOR = 39;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONNECTOR__DESCRIPTION = IWEB_CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONNECTOR__PORT = IWEB_CONNECTOR_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int WEB_CONNECTOR__NAME = IWEB_CONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Web Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEB_CONNECTOR_FEATURE_COUNT = IWEB_CONNECTOR_FEATURE_COUNT + 3;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.AJPImpl <em>AJP</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.AJPImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getAJP()
	 * @generated
	 */
    int AJP = 40;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int AJP__DESCRIPTION = WEB_CONNECTOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int AJP__PORT = WEB_CONNECTOR__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int AJP__NAME = WEB_CONNECTOR__NAME;

    /**
     * The number of structural features of the '<em>AJP</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int AJP_FEATURE_COUNT = WEB_CONNECTOR_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HTTPImpl <em>HTTP</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HTTPImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHTTP()
	 * @generated
	 */
    int HTTP = 41;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP__DESCRIPTION = WEB_CONNECTOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP__PORT = WEB_CONNECTOR__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP__NAME = WEB_CONNECTOR__NAME;

    /**
     * The number of structural features of the '<em>HTTP</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTP_FEATURE_COUNT = WEB_CONNECTOR_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HTTPSImpl <em>HTTPS</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HTTPSImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHTTPS()
	 * @generated
	 */
    int HTTPS = 42;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTPS__DESCRIPTION = WEB_CONNECTOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTPS__PORT = WEB_CONNECTOR__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTPS__NAME = WEB_CONNECTOR__NAME;

    /**
     * The number of structural features of the '<em>HTTPS</em>' class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int HTTPS_FEATURE_COUNT = WEB_CONNECTOR_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl <em>Jms Service</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJmsService()
	 * @generated
	 */
    int JMS_SERVICE = 44;

    /**
	 * The feature id for the '<em><b>Jmx Service URL</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JMS_SERVICE__JMX_SERVICE_URL = 0;

    /**
     * The feature id for the '<em><b>Jms Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JMS_SERVICE__JMS_PORT = 1;

    /**
	 * The feature id for the '<em><b>Jms Topics</b></em>' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JMS_SERVICE__JMS_TOPICS = 2;

    /**
	 * The feature id for the '<em><b>Jms Queues</b></em>' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JMS_SERVICE__JMS_QUEUES = 3;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JMS_SERVICE__NAME = 4;

    /**
	 * The number of structural features of the '<em>Jms Service</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JMS_SERVICE_FEATURE_COUNT = 5;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl <em>Discovery Service</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDiscoveryService()
	 * @generated
	 */
    int DISCOVERY_SERVICE = 45;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DISCOVERY_SERVICE__NAME = 0;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DISCOVERY_SERVICE__HOST = 1;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DISCOVERY_SERVICE__PORT = 2;

    /**
	 * The feature id for the '<em><b>Greeting Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DISCOVERY_SERVICE__GREETING_PORT = 3;

    /**
     * The feature id for the '<em><b>Source Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int DISCOVERY_SERVICE__SOURCE_PORT = 4;

    /**
	 * The number of structural features of the '<em>Discovery Service</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DISCOVERY_SERVICE_FEATURE_COUNT = 5;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApachePropertiesImpl <em>Apache Properties</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ApachePropertiesImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getApacheProperties()
	 * @generated
	 */
    int APACHE_PROPERTIES = 47;

    /**
	 * The number of structural features of the '<em>Apache Properties</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_PROPERTIES_FEATURE_COUNT = 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl <em>Apache Middleware Properties</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getApacheMiddlewareProperties()
	 * @generated
	 */
    int APACHE_MIDDLEWARE_PROPERTIES = 48;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_MIDDLEWARE_PROPERTIES__NAME = IMIDDLEWARE_PROPERTIES__NAME;

    /**
	 * The feature id for the '<em><b>Property File</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_MIDDLEWARE_PROPERTIES__PROPERTY_FILE = IMIDDLEWARE_PROPERTIES__PROPERTY_FILE;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_MIDDLEWARE_PROPERTIES__DESCRIPTION = IMIDDLEWARE_PROPERTIES__DESCRIPTION;

    /**
	 * The feature id for the '<em><b>Instance apache home</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME = IMIDDLEWARE_PROPERTIES_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Server listen adress</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS = IMIDDLEWARE_PROPERTIES_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Server listen port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT = IMIDDLEWARE_PROPERTIES_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Server user</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER = IMIDDLEWARE_PROPERTIES_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Server group</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP = IMIDDLEWARE_PROPERTIES_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Apache Middleware Properties</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int APACHE_MIDDLEWARE_PROPERTIES_FEATURE_COUNT = IMIDDLEWARE_PROPERTIES_FEATURE_COUNT + 5;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.ILocatable <em>ILocatable</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.ILocatable
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getILocatable()
	 * @generated
	 */
    int ILOCATABLE = 49;

    /**
	 * The number of structural features of the '<em>ILocatable</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ILOCATABLE_FEATURE_COUNT = 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl <em>JBoss AS</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossAS()
	 * @generated
	 */
    int JBOSS_AS = 50;

    /**
	 * The feature id for the '<em><b>Jasmine Node</b></em>' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__JASMINE_NODE = IJAVA_EE_SERVER__JASMINE_NODE;

    /**
	 * The feature id for the '<em><b>Middleware Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__MIDDLEWARE_PROPERTIES = IJAVA_EE_SERVER__MIDDLEWARE_PROPERTIES;

    /**
	 * The feature id for the '<em><b>Web Containers</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__WEB_CONTAINERS = IJAVA_EE_SERVER__WEB_CONTAINERS;

    /**
	 * The feature id for the '<em><b>Rmi Registries</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__RMI_REGISTRIES = IJAVA_EE_SERVER__RMI_REGISTRIES;

    /**
	 * The feature id for the '<em><b>Ejb Containers</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__EJB_CONTAINERS = IJAVA_EE_SERVER__EJB_CONTAINERS;

    /**
	 * The feature id for the '<em><b>Applications</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__APPLICATIONS = IJAVA_EE_SERVER__APPLICATIONS;

    /**
	 * The feature id for the '<em><b>Jms Services</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__JMS_SERVICES = IJAVA_EE_SERVER__JMS_SERVICES;

    /**
	 * The feature id for the '<em><b>Discovery Services</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__DISCOVERY_SERVICES = IJAVA_EE_SERVER__DISCOVERY_SERVICES;

    /**
	 * The feature id for the '<em><b>Http Servers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JBOSS_AS__HTTP_SERVERS = IJAVA_EE_SERVER__HTTP_SERVERS;

				/**
     * The feature id for the '<em><b>Home</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_AS__HOME = IJAVA_EE_SERVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Binding</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__BINDING = IJAVA_EE_SERVER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_AS__NAME = IJAVA_EE_SERVER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Webconnectors</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS__WEBCONNECTORS = IJAVA_EE_SERVER_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>JBoss AS</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_AS_FEATURE_COUNT = IJAVA_EE_SERVER_FEATURE_COUNT + 4;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl <em>JBoss Binding</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossBinding()
	 * @generated
	 */
    int JBOSS_BINDING = 51;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_BINDING__NAME = 0;

    /**
     * The feature id for the '<em><b>Naming Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_BINDING__NAMING_PORT = 1;

    /**
	 * The feature id for the '<em><b>Naming RMI Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__NAMING_RMI_PORT = 2;

    /**
	 * The feature id for the '<em><b>Webservice Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__WEBSERVICE_PORT = 3;

    /**
	 * The feature id for the '<em><b>Invoker RMI Object Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT = 4;

    /**
	 * The feature id for the '<em><b>Invoker Server Bind Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__INVOKER_SERVER_BIND_PORT = 5;

    /**
	 * The feature id for the '<em><b>Ha Naming Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__HA_NAMING_PORT = 6;

    /**
	 * The feature id for the '<em><b>Ha Naming RMI Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__HA_NAMING_RMI_PORT = 7;

    /**
	 * The feature id for the '<em><b>Ha Invoker RMI Object Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT = 8;

    /**
	 * The feature id for the '<em><b>Ha Invoker Server Bind Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT = 9;

    /**
	 * The feature id for the '<em><b>Corba Orb Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__CORBA_ORB_PORT = 10;

    /**
	 * The feature id for the '<em><b>Connector RMI Object Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT = 11;

    /**
	 * The feature id for the '<em><b>Snmp Trap Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__SNMP_TRAP_PORT = 12;

    /**
	 * The feature id for the '<em><b>Snmp Request Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__SNMP_REQUEST_PORT = 13;

    /**
	 * The feature id for the '<em><b>Jms Server Bind Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__JMS_SERVER_BIND_PORT = 14;

    /**
	 * The feature id for the '<em><b>Webserver Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__WEBSERVER_PORT = 15;

    /**
	 * The feature id for the '<em><b>Ejb3 Connector Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__EJB3_CONNECTOR_PORT = 16;

    /**
	 * The feature id for the '<em><b>Messaging Connector Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__MESSAGING_CONNECTOR_PORT = 17;

    /**
	 * The feature id for the '<em><b>Remoting Connector Port</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING__REMOTING_CONNECTOR_PORT = 18;

    /**
	 * The number of structural features of the '<em>JBoss Binding</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_BINDING_FEATURE_COUNT = 19;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IJBossConnectorImpl <em>IJ Boss Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IJBossConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJBossConnector()
	 * @generated
	 */
    int IJ_BOSS_CONNECTOR = 52;

    /**
	 * The number of structural features of the '<em>IJ Boss Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IJ_BOSS_CONNECTOR_FEATURE_COUNT = IJAVA_EE_CONNECTOR_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAConnectorImpl <em>JBoss HA Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossHAConnector()
	 * @generated
	 */
    int JBOSS_HA_CONNECTOR = 53;

    /**
     * The feature id for the '<em><b>Instance</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_CONNECTOR__INSTANCE = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Group</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_CONNECTOR__GROUP = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>JBoss HA Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_HA_CONNECTOR_FEATURE_COUNT = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHTTPRepConnectorImpl <em>JBoss HTTP Rep Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossHTTPRepConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossHTTPRepConnector()
	 * @generated
	 */
    int JBOSS_HTTP_REP_CONNECTOR = 54;

    /**
     * The feature id for the '<em><b>Instance</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HTTP_REP_CONNECTOR__INSTANCE = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Group</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HTTP_REP_CONNECTOR__GROUP = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>JBoss HTTP Rep Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_HTTP_REP_CONNECTOR_FEATURE_COUNT = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAGroupImpl <em>JBoss HA Group</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAGroupImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossHAGroup()
	 * @generated
	 */
    int JBOSS_HA_GROUP = 55;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_GROUP__DESCRIPTION = CONFIGURATION_NODE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>Host</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_GROUP__HOST = CONFIGURATION_NODE__HOST;

    /**
     * The feature id for the '<em><b>Port</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_GROUP__PORT = CONFIGURATION_NODE__PORT;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_GROUP__NAME = CONFIGURATION_NODE__NAME;

    /**
     * The feature id for the '<em><b>Lan Mode</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_GROUP__LAN_MODE = CONFIGURATION_NODE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Ping Hosts</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_HA_GROUP__PING_HOSTS = CONFIGURATION_NODE_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>JBoss HA Group</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_HA_GROUP_FEATURE_COUNT = CONFIGURATION_NODE_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossModJKConnectorImpl <em>JBoss Mod JK Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossModJKConnectorImpl
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossModJKConnector()
	 * @generated
	 */
    int JBOSS_MOD_JK_CONNECTOR = 56;

    /**
     * The feature id for the '<em><b>Jboss</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_MOD_JK_CONNECTOR__JBOSS = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Apache</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @generated
     * @ordered
     */
    int JBOSS_MOD_JK_CONNECTOR__APACHE = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>JBoss Mod JK Connector</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int JBOSS_MOD_JK_CONNECTOR_FEATURE_COUNT = IJ_BOSS_CONNECTOR_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation <em>Web Container Implementation</em>}' enum.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getWebContainerImplementation()
	 * @generated
	 */
    int WEB_CONTAINER_IMPLEMENTATION = 57;

    /**
	 * The meta object id for the '{@link org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider <em>Database Provider</em>}' enum.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDatabaseProvider()
	 * @generated
	 */
    int DATABASE_PROVIDER = 58;

    /**
     * The meta object id for the '<em>Inet Address</em>' data type. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @see java.net.InetAddress
     * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getInetAddress()
     * @generated
     */
    int INET_ADDRESS = 59;

    /**
     * The meta object id for the '<em>Port</em>' data type. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @see org.objectweb.jasmine.ui.jasminemodel.datatype.Port
     * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getPort()
     * @generated
     */
    int PORT = 60;

    /**
	 * The meta object id for the '<em>Deployment Exception</em>' data type.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.objectweb.jasmine.jade.service.deployer.DeploymentException
	 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDeploymentException()
	 * @generated
	 */
    int DEPLOYMENT_EXCEPTION = 61;

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINe <em>JASMI Ne</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JASMI Ne</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINe
	 * @generated
	 */
    EClass getJASMINe();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINe#getServerPool <em>Server Pool</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Server Pool</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINe#getServerPool()
	 * @see #getJASMINe()
	 * @generated
	 */
    EReference getJASMINe_ServerPool();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINe#getDomain <em>Domain</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Domain</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINe#getDomain()
	 * @see #getJASMINe()
	 * @generated
	 */
    EReference getJASMINe_Domain();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.ServerPool <em>Server Pool</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Server Pool</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ServerPool
	 * @generated
	 */
    EClass getServerPool();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.ServerPool#getServer <em>Server</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Server</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ServerPool#getServer()
	 * @see #getServerPool()
	 * @generated
	 */
    EReference getServerPool_Server();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.Server <em>Server</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Server</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Server
	 * @generated
	 */
    EClass getServer();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.Server#getJadeNode <em>Jade Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Jade Node</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Server#getJadeNode()
	 * @see #getServer()
	 * @generated
	 */
    EReference getServer_JadeNode();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode <em>JASMI Ne Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JASMI Ne Node</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode
	 * @generated
	 */
    EClass getJASMINeNode();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryHost <em>Discovery Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Discovery Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryHost()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_DiscoveryHost();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryPort <em>Discovery Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Discovery Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getDiscoveryPort()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_DiscoveryPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getHost <em>Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getHost()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_Host();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getUser <em>User</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>User</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getUser()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_User();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getPassword <em>Password</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Password</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getPassword()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_Password();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getSshKey <em>Ssh Key</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ssh Key</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getSshKey()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_SshKey();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getInstallDir <em>Install Dir</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Install Dir</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getInstallDir()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_InstallDir();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getJndiPort <em>Jndi Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jndi Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getJndiPort()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_JndiPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getFelixProfile <em>Felix Profile</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Felix Profile</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getFelixProfile()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_FelixProfile();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getNodeId <em>Node Id</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Node Id</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getNodeId()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_NodeId();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryHost <em>Registry Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Registry Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryHost()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_RegistryHost();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryPort <em>Registry Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Registry Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRegistryPort()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_RegistryPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRepositoryURL <em>Repository URL</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Repository URL</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getRepositoryURL()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_RepositoryURL();

    /**
	 * Returns the meta object for the reference list '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getMiddlewares <em>Middlewares</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Middlewares</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getMiddlewares()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EReference getJASMINeNode_Middlewares();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JASMINeNode#getName()
	 * @see #getJASMINeNode()
	 * @generated
	 */
    EAttribute getJASMINeNode_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.Domain <em>Domain</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Domain</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain
	 * @generated
	 */
    EClass getDomain();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getMiddlewareComponents <em>Middleware Components</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Middleware Components</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain#getMiddlewareComponents()
	 * @see #getDomain()
	 * @generated
	 */
    EReference getDomain_MiddlewareComponents();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getConnectors <em>Connectors</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connectors</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain#getConnectors()
	 * @see #getDomain()
	 * @generated
	 */
    EReference getDomain_Connectors();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getConfigurationNodes <em>Configuration Nodes</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Configuration Nodes</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain#getConfigurationNodes()
	 * @see #getDomain()
	 * @generated
	 */
    EReference getDomain_ConfigurationNodes();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getClusterContainers <em>Cluster Containers</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Cluster Containers</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain#getClusterContainers()
	 * @see #getDomain()
	 * @generated
	 */
    EReference getDomain_ClusterContainers();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getDb <em>Db</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Db</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain#getDb()
	 * @see #getDomain()
	 * @generated
	 */
    EReference getDomain_Db();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.Domain#getDblinks <em>Dblinks</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dblinks</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Domain#getDblinks()
	 * @see #getDomain()
	 * @generated
	 */
    EReference getDomain_Dblinks();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.Cluster <em>Cluster</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cluster</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Cluster
	 * @generated
	 */
    EClass getCluster();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.Cluster#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Cluster#getName()
	 * @see #getCluster()
	 * @generated
	 */
    EAttribute getCluster_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IConnector <em>IConnector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IConnector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IConnector
	 * @generated
	 */
    EClass getIConnector();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEConnector <em>IJava EE Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IJava EE Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEConnector
	 * @generated
	 */
    EClass getIJavaEEConnector();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector <em>IJ On AS Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IJ On AS Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector
	 * @generated
	 */
    EClass getIJOnASConnector();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.DB <em>DB</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>DB</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB
	 * @generated
	 */
    EClass getDB();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getProvider <em>Provider</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Provider</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getProvider()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_Provider();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getUser <em>User</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>User</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getUser()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_User();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getPassword <em>Password</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Password</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getPassword()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_Password();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getUrl <em>Url</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Url</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getUrl()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_Url();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getDriverName <em>Driver Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Driver Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getDriverName()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_DriverName();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJndiName <em>Jndi Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jndi Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getJndiName()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_JndiName();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJdbcDriverJarFile <em>Jdbc Driver Jar File</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jdbc Driver Jar File</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getJdbcDriverJarFile()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_JdbcDriverJarFile();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getMappernName <em>Mappern Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mappern Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getMappernName()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_MappernName();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getName()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_Name();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getPort()
	 * @see #getDB()
	 * @generated
	 */
    EAttribute getDB_Port();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.DB#getJasmineNode <em>Jasmine Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Jasmine Node</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DB#getJasmineNode()
	 * @see #getDB()
	 * @generated
	 */
    EReference getDB_JasmineNode();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent <em>IMiddleware Component</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IMiddleware Component</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent
	 * @generated
	 */
    EClass getIMiddlewareComponent();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent#getJasmineNode <em>Jasmine Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Jasmine Node</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent#getJasmineNode()
	 * @see #getIMiddlewareComponent()
	 * @generated
	 */
    EReference getIMiddlewareComponent_JasmineNode();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties <em>IMiddleware Properties</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IMiddleware Properties</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties
	 * @generated
	 */
    EClass getIMiddlewareProperties();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties#getName()
	 * @see #getIMiddlewareProperties()
	 * @generated
	 */
    EAttribute getIMiddlewareProperties_Name();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties#getPropertyFile <em>Property File</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Property File</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties#getPropertyFile()
	 * @see #getIMiddlewareProperties()
	 * @generated
	 */
    EAttribute getIMiddlewareProperties_PropertyFile();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties#getDescription()
	 * @see #getIMiddlewareProperties()
	 * @generated
	 */
    EAttribute getIMiddlewareProperties_Description();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS <em>JOn AS</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JOn AS</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS
	 * @generated
	 */
    EClass getJOnAS();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getName()
	 * @see #getJOnAS()
	 * @generated
	 */
    EAttribute getJOnAS_Name();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getInstanceName <em>Instance Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Instance Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getInstanceName()
	 * @see #getJOnAS()
	 * @generated
	 */
    EAttribute getJOnAS_InstanceName();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getWebconnectors <em>Webconnectors</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Webconnectors</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getWebconnectors()
	 * @see #getJOnAS()
	 * @generated
	 */
    EReference getJOnAS_Webconnectors();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasBase <em>Jonas Base</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jonas Base</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasBase()
	 * @see #getJOnAS()
	 * @generated
	 */
    EAttribute getJOnAS_JonasBase();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasRoot <em>Jonas Root</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jonas Root</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getJonasRoot()
	 * @see #getJOnAS()
	 * @generated
	 */
    EAttribute getJOnAS_JonasRoot();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getDomain <em>Domain</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Domain</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getDomain()
	 * @see #getJOnAS()
	 * @generated
	 */
    EAttribute getJOnAS_Domain();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#isMaster <em>Master</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Master</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#isMaster()
	 * @see #getJOnAS()
	 * @generated
	 */
    EAttribute getJOnAS_Master();

    /**
	 * Returns the meta object for the reference list '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getClusters <em>Clusters</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Clusters</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getClusters()
	 * @see #getJOnAS()
	 * @generated
	 */
    EReference getJOnAS_Clusters();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.JOnAS#getCmigroup <em>Cmigroup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cmigroup</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JOnAS#getCmigroup()
	 * @see #getJOnAS()
	 * @generated
	 */
	EReference getJOnAS_Cmigroup();

				/**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd <em>Apache HTT Pd</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Apache HTT Pd</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd
	 * @generated
	 */
    EClass getApache_HTTPd();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getName()
	 * @see #getApache_HTTPd()
	 * @generated
	 */
    EAttribute getApache_HTTPd_Name();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getModules <em>Modules</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Modules</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getModules()
	 * @see #getApache_HTTPd()
	 * @generated
	 */
    EReference getApache_HTTPd_Modules();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHome <em>Home</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Home</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHome()
	 * @see #getApache_HTTPd()
	 * @generated
	 */
    EAttribute getApache_HTTPd_Home();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHost <em>Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getHost()
	 * @see #getApache_HTTPd()
	 * @generated
	 */
    EAttribute getApache_HTTPd_Host();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getPort()
	 * @see #getApache_HTTPd()
	 * @generated
	 */
    EAttribute getApache_HTTPd_Port();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getUser <em>User</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>User</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getUser()
	 * @see #getApache_HTTPd()
	 * @generated
	 */
    EAttribute getApache_HTTPd_User();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getGroup <em>Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.Apache_HTTPd#getGroup()
	 * @see #getApache_HTTPd()
	 * @generated
	 */
    EAttribute getApache_HTTPd_Group();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IContainer <em>IContainer</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IContainer</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IContainer
	 * @generated
	 */
    EClass getIContainer();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IContainer#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IContainer#getDescription()
	 * @see #getIContainer()
	 * @generated
	 */
    EAttribute getIContainer_Description();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IContainer#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IContainer#getName()
	 * @see #getIContainer()
	 * @generated
	 */
    EAttribute getIContainer_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer <em>IJava EE Server</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IJava EE Server</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer
	 * @generated
	 */
    EClass getIJavaEEServer();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getWebContainers <em>Web Containers</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Web Containers</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getWebContainers()
	 * @see #getIJavaEEServer()
	 * @generated
	 */
    EReference getIJavaEEServer_WebContainers();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getRmiRegistries <em>Rmi Registries</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rmi Registries</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getRmiRegistries()
	 * @see #getIJavaEEServer()
	 * @generated
	 */
    EReference getIJavaEEServer_RmiRegistries();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getEjbContainers <em>Ejb Containers</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Ejb Containers</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getEjbContainers()
	 * @see #getIJavaEEServer()
	 * @generated
	 */
    EReference getIJavaEEServer_EjbContainers();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getApplications <em>Applications</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Applications</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getApplications()
	 * @see #getIJavaEEServer()
	 * @generated
	 */
    EReference getIJavaEEServer_Applications();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getJmsServices <em>Jms Services</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Jms Services</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getJmsServices()
	 * @see #getIJavaEEServer()
	 * @generated
	 */
    EReference getIJavaEEServer_JmsServices();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getDiscoveryServices <em>Discovery Services</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Discovery Services</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getDiscoveryServices()
	 * @see #getIJavaEEServer()
	 * @generated
	 */
    EReference getIJavaEEServer_DiscoveryServices();

    /**
	 * Returns the meta object for the reference list '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getHttpServers <em>Http Servers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Http Servers</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer#getHttpServers()
	 * @see #getIJavaEEServer()
	 * @generated
	 */
	EReference getIJavaEEServer_HttpServers();

				/**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer <em>IHTTP Server</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IHTTP Server</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IHTTPServer
	 * @generated
	 */
    EClass getIHTTPServer();

    /**
	 * Returns the meta object for the reference list '{@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer#getJavaeeServers <em>Javaee Servers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Javaee Servers</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IHTTPServer#getJavaeeServers()
	 * @see #getIHTTPServer()
	 * @generated
	 */
	EReference getIHTTPServer_JavaeeServers();

				/**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer <em>Web Container</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Web Container</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainer
	 * @generated
	 */
    EClass getWebContainer();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getType <em>Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainer#getType()
	 * @see #getWebContainer()
	 * @generated
	 */
    EAttribute getWebContainer_Type();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getJvmRoute <em>Jvm Route</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jvm Route</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainer#getJvmRoute()
	 * @see #getWebContainer()
	 * @generated
	 */
    EAttribute getWebContainer_JvmRoute();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainer#getHost <em>Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainer#getHost()
	 * @see #getWebContainer()
	 * @generated
	 */
    EAttribute getWebContainer_Host();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.EJBContainer <em>EJB Container</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>EJB Container</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.EJBContainer
	 * @generated
	 */
    EClass getEJBContainer();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.EJBContainer#isAutoGenic <em>Auto Genic</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Auto Genic</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.EJBContainer#isAutoGenic()
	 * @see #getEJBContainer()
	 * @generated
	 */
    EAttribute getEJBContainer_AutoGenic();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.EjbJar <em>Ejb Jar</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ejb Jar</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.EjbJar
	 * @generated
	 */
    EClass getEjbJar();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.EjbJar#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.EjbJar#getDescription()
	 * @see #getEjbJar()
	 * @generated
	 */
    EAttribute getEjbJar_Description();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.EjbJar#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.EjbJar#getName()
	 * @see #getEjbJar()
	 * @generated
	 */
    EAttribute getEjbJar_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IModule <em>IModule</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IModule</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IModule
	 * @generated
	 */
    EClass getIModule();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.ModJKModule <em>Mod JK Module</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mod JK Module</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ModJKModule
	 * @generated
	 */
    EClass getModJKModule();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ModJKModule#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ModJKModule#getDescription()
	 * @see #getModJKModule()
	 * @generated
	 */
    EAttribute getModJKModule_Description();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ModJKModule#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ModJKModule#getName()
	 * @see #getModJKModule()
	 * @generated
	 */
    EAttribute getModJKModule_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IApplication <em>IApplication</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IApplication</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IApplication
	 * @generated
	 */
    EClass getIApplication();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector <em>Rep HTTP Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rep HTTP Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector
	 * @generated
	 */
    EClass getRepHTTPConnector();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector#getSource()
	 * @see #getRepHTTPConnector()
	 * @generated
	 */
    EReference getRepHTTPConnector_Source();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RepHTTPConnector#getTarget()
	 * @see #getRepHTTPConnector()
	 * @generated
	 */
    EReference getRepHTTPConnector_Target();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.HAConnector <em>HA Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>HA Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HAConnector
	 * @generated
	 */
    EClass getHAConnector();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.HAConnector#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HAConnector#getSource()
	 * @see #getHAConnector()
	 * @generated
	 */
    EReference getHAConnector_Source();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.HAConnector#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HAConnector#getTarget()
	 * @see #getHAConnector()
	 * @generated
	 */
    EReference getHAConnector_Target();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry <em>IRMI Registry</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IRMI Registry</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry
	 * @generated
	 */
    EClass getIRMIRegistry();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry#getHost <em>Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry#getHost()
	 * @see #getIRMIRegistry()
	 * @generated
	 */
    EAttribute getIRMIRegistry_Host();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry#getPort()
	 * @see #getIRMIRegistry()
	 * @generated
	 */
    EAttribute getIRMIRegistry_Port();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IRMIRegistry#getName()
	 * @see #getIRMIRegistry()
	 * @generated
	 */
    EAttribute getIRMIRegistry_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IIOP <em>IIOP</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IIOP</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IIOP
	 * @generated
	 */
    EClass getIIOP();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JRMP <em>JRMP</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JRMP</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JRMP
	 * @generated
	 */
    EClass getJRMP();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.CMI <em>CMI</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>CMI</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.CMI
	 * @generated
	 */
    EClass getCMI();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IRMI <em>IRMI</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IRMI</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IRMI
	 * @generated
	 */
    EClass getIRMI();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup <em>Cmi Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cmi Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.CmiGroup
	 * @generated
	 */
    EClass getCmiGroup();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup#isLanMode <em>Lan Mode</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lan Mode</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.CmiGroup#isLanMode()
	 * @see #getCmiGroup()
	 * @generated
	 */
    EAttribute getCmiGroup_LanMode();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.CmiGroup#getTcpPingHost <em>Tcp Ping Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tcp Ping Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.CmiGroup#getTcpPingHost()
	 * @see #getCmiGroup()
	 * @generated
	 */
    EAttribute getCmiGroup_TcpPingHost();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode <em>Configuration Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Configuration Node</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode
	 * @generated
	 */
    EClass getConfigurationNode();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getDescription()
	 * @see #getConfigurationNode()
	 * @generated
	 */
    EAttribute getConfigurationNode_Description();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getHost <em>Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getHost()
	 * @see #getConfigurationNode()
	 * @generated
	 */
    EAttribute getConfigurationNode_Host();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getPort()
	 * @see #getConfigurationNode()
	 * @generated
	 */
    EAttribute getConfigurationNode_Port();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ConfigurationNode#getName()
	 * @see #getConfigurationNode()
	 * @generated
	 */
    EAttribute getConfigurationNode_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.HaGroup <em>Ha Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ha Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HaGroup
	 * @generated
	 */
    EClass getHaGroup();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.HaGroup#isLanMode <em>Lan Mode</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lan Mode</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HaGroup#isLanMode()
	 * @see #getHaGroup()
	 * @generated
	 */
    EAttribute getHaGroup_LanMode();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.HaGroup#getTcpPingHost <em>Tcp Ping Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tcp Ping Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HaGroup#getTcpPingHost()
	 * @see #getHaGroup()
	 * @generated
	 */
    EAttribute getHaGroup_TcpPingHost();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.ClusterContainer <em>Cluster Container</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cluster Container</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ClusterContainer
	 * @generated
	 */
    EClass getClusterContainer();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.ClusterContainer#getClusters <em>Clusters</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Clusters</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ClusterContainer#getClusters()
	 * @see #getClusterContainer()
	 * @generated
	 */
    EReference getClusterContainer_Clusters();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup <em>HTTP Rep Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>HTTP Rep Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup
	 * @generated
	 */
    EClass getHTTP_RepGroup();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup#getTcpListenPort <em>Tcp Listen Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tcp Listen Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HTTP_RepGroup#getTcpListenPort()
	 * @see #getHTTP_RepGroup()
	 * @generated
	 */
    EAttribute getHTTP_RepGroup_TcpListenPort();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.RMIGroup <em>RMI Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>RMI Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RMIGroup
	 * @generated
	 */
    EClass getRMIGroup();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.DbLink <em>Db Link</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Db Link</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DbLink
	 * @generated
	 */
    EClass getDbLink();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.DbLink#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DbLink#getSource()
	 * @see #getDbLink()
	 * @generated
	 */
    EReference getDbLink_Source();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.DbLink#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DbLink#getTarget()
	 * @see #getDbLink()
	 * @generated
	 */
    EReference getDbLink_Target();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode <em>IConfiguration Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IConfiguration Node</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode
	 * @generated
	 */
    EClass getIConfigurationNode();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.RmiConnector <em>Rmi Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rmi Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RmiConnector
	 * @generated
	 */
    EClass getRmiConnector();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.RmiConnector#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RmiConnector#getSource()
	 * @see #getRmiConnector()
	 * @generated
	 */
    EReference getRmiConnector_Source();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.RmiConnector#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.RmiConnector#getTarget()
	 * @see #getRmiConnector()
	 * @generated
	 */
    EReference getRmiConnector_Target();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.WebConnector <em>Web Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Web Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebConnector
	 * @generated
	 */
    EClass getWebConnector();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.WebConnector#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebConnector#getDescription()
	 * @see #getWebConnector()
	 * @generated
	 */
    EAttribute getWebConnector_Description();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.WebConnector#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebConnector#getPort()
	 * @see #getWebConnector()
	 * @generated
	 */
    EAttribute getWebConnector_Port();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.WebConnector#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebConnector#getName()
	 * @see #getWebConnector()
	 * @generated
	 */
    EAttribute getWebConnector_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.AJP <em>AJP</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>AJP</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.AJP
	 * @generated
	 */
    EClass getAJP();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.HTTP <em>HTTP</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>HTTP</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HTTP
	 * @generated
	 */
    EClass getHTTP();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.HTTPS <em>HTTPS</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>HTTPS</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.HTTPS
	 * @generated
	 */
    EClass getHTTPS();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IWebConnector <em>IWeb Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IWeb Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IWebConnector
	 * @generated
	 */
    EClass getIWebConnector();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService <em>Jms Service</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Jms Service</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JmsService
	 * @generated
	 */
    EClass getJmsService();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmxServiceURL <em>Jmx Service URL</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jmx Service URL</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmxServiceURL()
	 * @see #getJmsService()
	 * @generated
	 */
    EAttribute getJmsService_JmxServiceURL();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsPort <em>Jms Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jms Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsPort()
	 * @see #getJmsService()
	 * @generated
	 */
    EAttribute getJmsService_JmsPort();

    /**
	 * Returns the meta object for the attribute list '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsTopics <em>Jms Topics</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Jms Topics</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsTopics()
	 * @see #getJmsService()
	 * @generated
	 */
    EAttribute getJmsService_JmsTopics();

    /**
	 * Returns the meta object for the attribute list '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsQueues <em>Jms Queues</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Jms Queues</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JmsService#getJmsQueues()
	 * @see #getJmsService()
	 * @generated
	 */
    EAttribute getJmsService_JmsQueues();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JmsService#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JmsService#getName()
	 * @see #getJmsService()
	 * @generated
	 */
    EAttribute getJmsService_Name();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.DiscoveryService <em>Discovery Service</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Discovery Service</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DiscoveryService
	 * @generated
	 */
    EClass getDiscoveryService();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getName()
	 * @see #getDiscoveryService()
	 * @generated
	 */
    EAttribute getDiscoveryService_Name();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getHost <em>Host</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Host</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getHost()
	 * @see #getDiscoveryService()
	 * @generated
	 */
    EAttribute getDiscoveryService_Host();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getPort()
	 * @see #getDiscoveryService()
	 * @generated
	 */
    EAttribute getDiscoveryService_Port();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getGreetingPort <em>Greeting Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Greeting Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getGreetingPort()
	 * @see #getDiscoveryService()
	 * @generated
	 */
    EAttribute getDiscoveryService_GreetingPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getSourcePort <em>Source Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DiscoveryService#getSourcePort()
	 * @see #getDiscoveryService()
	 * @generated
	 */
    EAttribute getDiscoveryService_SourcePort();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent <em>Middleware Component</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Middleware Component</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent
	 * @generated
	 */
    EClass getMiddlewareComponent();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent#getMiddlewareProperties <em>Middleware Properties</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Middleware Properties</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.MiddlewareComponent#getMiddlewareProperties()
	 * @see #getMiddlewareComponent()
	 * @generated
	 */
    EReference getMiddlewareComponent_MiddlewareProperties();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheProperties <em>Apache Properties</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Apache Properties</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheProperties
	 * @generated
	 */
    EClass getApacheProperties();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties <em>Apache Middleware Properties</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Apache Middleware Properties</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties
	 * @generated
	 */
    EClass getApacheMiddlewareProperties();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getInstance_apache_home <em>Instance apache home</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Instance apache home</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getInstance_apache_home()
	 * @see #getApacheMiddlewareProperties()
	 * @generated
	 */
    EAttribute getApacheMiddlewareProperties_Instance_apache_home();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_adress <em>Server listen adress</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Server listen adress</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_adress()
	 * @see #getApacheMiddlewareProperties()
	 * @generated
	 */
    EAttribute getApacheMiddlewareProperties_Server_listen_adress();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_port <em>Server listen port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Server listen port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_listen_port()
	 * @see #getApacheMiddlewareProperties()
	 * @generated
	 */
    EAttribute getApacheMiddlewareProperties_Server_listen_port();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_user <em>Server user</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Server user</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_user()
	 * @see #getApacheMiddlewareProperties()
	 * @generated
	 */
    EAttribute getApacheMiddlewareProperties_Server_user();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_group <em>Server group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Server group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ApacheMiddlewareProperties#getServer_group()
	 * @see #getApacheMiddlewareProperties()
	 * @generated
	 */
    EAttribute getApacheMiddlewareProperties_Server_group();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.ILocatable <em>ILocatable</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>ILocatable</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.ILocatable
	 * @generated
	 */
    EClass getILocatable();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS <em>JBoss AS</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JBoss AS</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossAS
	 * @generated
	 */
    EClass getJBossAS();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getHome <em>Home</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Home</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossAS#getHome()
	 * @see #getJBossAS()
	 * @generated
	 */
    EAttribute getJBossAS_Home();

    /**
	 * Returns the meta object for the containment reference '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getBinding <em>Binding</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Binding</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossAS#getBinding()
	 * @see #getJBossAS()
	 * @generated
	 */
    EReference getJBossAS_Binding();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossAS#getName()
	 * @see #getJBossAS()
	 * @generated
	 */
    EAttribute getJBossAS_Name();

    /**
	 * Returns the meta object for the containment reference list '{@link org.objectweb.jasmine.ui.jasminemodel.JBossAS#getWebconnectors <em>Webconnectors</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Webconnectors</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossAS#getWebconnectors()
	 * @see #getJBossAS()
	 * @generated
	 */
    EReference getJBossAS_Webconnectors();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding <em>JBoss Binding</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JBoss Binding</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding
	 * @generated
	 */
    EClass getJBossBinding();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getName()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_Name();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingPort <em>Naming Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Naming Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_NamingPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingRMIPort <em>Naming RMI Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Naming RMI Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getNamingRMIPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_NamingRMIPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebservicePort <em>Webservice Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Webservice Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebservicePort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_WebservicePort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerRMIObjectPort <em>Invoker RMI Object Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Invoker RMI Object Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerRMIObjectPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_InvokerRMIObjectPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerServerBindPort <em>Invoker Server Bind Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Invoker Server Bind Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getInvokerServerBindPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_InvokerServerBindPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingPort <em>Ha Naming Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ha Naming Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_HaNamingPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingRMIPort <em>Ha Naming RMI Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ha Naming RMI Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaNamingRMIPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_HaNamingRMIPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerRMIObjectPort <em>Ha Invoker RMI Object Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ha Invoker RMI Object Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerRMIObjectPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_HaInvokerRMIObjectPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerServerBindPort <em>Ha Invoker Server Bind Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ha Invoker Server Bind Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getHaInvokerServerBindPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_HaInvokerServerBindPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getCorbaOrbPort <em>Corba Orb Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Corba Orb Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getCorbaOrbPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_CorbaOrbPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getConnectorRMIObjectPort <em>Connector RMI Object Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Connector RMI Object Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getConnectorRMIObjectPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_ConnectorRMIObjectPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpTrapPort <em>Snmp Trap Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Snmp Trap Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpTrapPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_SnmpTrapPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpRequestPort <em>Snmp Request Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Snmp Request Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getSnmpRequestPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_SnmpRequestPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getJmsServerBindPort <em>Jms Server Bind Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jms Server Bind Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getJmsServerBindPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_JmsServerBindPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebserverPort <em>Webserver Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Webserver Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getWebserverPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_WebserverPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getEjb3ConnectorPort <em>Ejb3 Connector Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ejb3 Connector Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getEjb3ConnectorPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_Ejb3ConnectorPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getMessagingConnectorPort <em>Messaging Connector Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Messaging Connector Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getMessagingConnectorPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_MessagingConnectorPort();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getRemotingConnectorPort <em>Remoting Connector Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Remoting Connector Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossBinding#getRemotingConnectorPort()
	 * @see #getJBossBinding()
	 * @generated
	 */
    EAttribute getJBossBinding_RemotingConnectorPort();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.IJBossConnector <em>IJ Boss Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>IJ Boss Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.IJBossConnector
	 * @generated
	 */
    EClass getIJBossConnector();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector <em>JBoss HA Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JBoss HA Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector
	 * @generated
	 */
    EClass getJBossHAConnector();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Instance</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector#getInstance()
	 * @see #getJBossHAConnector()
	 * @generated
	 */
    EReference getJBossHAConnector_Instance();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector#getGroup <em>Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAConnector#getGroup()
	 * @see #getJBossHAConnector()
	 * @generated
	 */
    EReference getJBossHAConnector_Group();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector <em>JBoss HTTP Rep Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JBoss HTTP Rep Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector
	 * @generated
	 */
    EClass getJBossHTTPRepConnector();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Instance</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector#getInstance()
	 * @see #getJBossHTTPRepConnector()
	 * @generated
	 */
    EReference getJBossHTTPRepConnector_Instance();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector#getGroup <em>Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHTTPRepConnector#getGroup()
	 * @see #getJBossHTTPRepConnector()
	 * @generated
	 */
    EReference getJBossHTTPRepConnector_Group();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup <em>JBoss HA Group</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JBoss HA Group</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup
	 * @generated
	 */
    EClass getJBossHAGroup();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup#getLanMode <em>Lan Mode</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lan Mode</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup#getLanMode()
	 * @see #getJBossHAGroup()
	 * @generated
	 */
    EAttribute getJBossHAGroup_LanMode();

    /**
	 * Returns the meta object for the attribute '{@link org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup#getPingHosts <em>Ping Hosts</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ping Hosts</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossHAGroup#getPingHosts()
	 * @see #getJBossHAGroup()
	 * @generated
	 */
    EAttribute getJBossHAGroup_PingHosts();

    /**
	 * Returns the meta object for class '{@link org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector <em>JBoss Mod JK Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>JBoss Mod JK Connector</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector
	 * @generated
	 */
    EClass getJBossModJKConnector();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector#getJboss <em>Jboss</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Jboss</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector#getJboss()
	 * @see #getJBossModJKConnector()
	 * @generated
	 */
    EReference getJBossModJKConnector_Jboss();

    /**
	 * Returns the meta object for the reference '{@link org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector#getApache <em>Apache</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Apache</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.JBossModJKConnector#getApache()
	 * @see #getJBossModJKConnector()
	 * @generated
	 */
    EReference getJBossModJKConnector_Apache();

    /**
	 * Returns the meta object for enum '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation <em>Web Container Implementation</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Web Container Implementation</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation
	 * @generated
	 */
    EEnum getWebContainerImplementation();

    /**
	 * Returns the meta object for enum '{@link org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider <em>Database Provider</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Database Provider</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider
	 * @generated
	 */
    EEnum getDatabaseProvider();

    /**
	 * Returns the meta object for data type '{@link java.net.InetAddress <em>Inet Address</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Inet Address</em>'.
	 * @see java.net.InetAddress
	 * @model instanceClass="java.net.InetAddress"
	 * @generated
	 */
    EDataType getInetAddress();

    /**
	 * Returns the meta object for data type '{@link org.objectweb.jasmine.ui.jasminemodel.datatype.Port <em>Port</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Port</em>'.
	 * @see org.objectweb.jasmine.ui.jasminemodel.datatype.Port
	 * @model instanceClass="org.objectweb.jasmine.ui.jasminemodel.datatype.Port"
	 * @generated
	 */
    EDataType getPort();

    /**
	 * Returns the meta object for data type '{@link org.objectweb.jasmine.jade.service.deployer.DeploymentException <em>Deployment Exception</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Deployment Exception</em>'.
	 * @see org.objectweb.jasmine.jade.service.deployer.DeploymentException
	 * @model instanceClass="org.objectweb.jasmine.jade.service.deployer.DeploymentException"
	 * @generated
	 */
    EDataType getDeploymentException();

    /**
     * Returns the factory that creates the instances of the model. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     *
     * @return the factory that creates the instances of the model.
     * @generated
     */
    JasminemodelFactory getJasminemodelFactory();

    /**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that
     * represent
     * <ul>
     * <li>each class,</li>
     * <li>each feature of each class,</li>
     * <li>each enum,</li>
     * <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
	 * @generated
	 */
    interface Literals {
        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeImpl <em>JASMI Ne</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJASMINe()
		 * @generated
		 */
        EClass JASMI_NE = eINSTANCE.getJASMINe();

        /**
		 * The meta object literal for the '<em><b>Server Pool</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference JASMI_NE__SERVER_POOL = eINSTANCE.getJASMINe_ServerPool();

        /**
		 * The meta object literal for the '<em><b>Domain</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference JASMI_NE__DOMAIN = eINSTANCE.getJASMINe_Domain();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ServerPoolImpl <em>Server Pool</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ServerPoolImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getServerPool()
		 * @generated
		 */
        EClass SERVER_POOL = eINSTANCE.getServerPool();

        /**
		 * The meta object literal for the '<em><b>Server</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference SERVER_POOL__SERVER = eINSTANCE.getServerPool_Server();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ServerImpl <em>Server</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ServerImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getServer()
		 * @generated
		 */
        EClass SERVER = eINSTANCE.getServer();

        /**
		 * The meta object literal for the '<em><b>Jade Node</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference SERVER__JADE_NODE = eINSTANCE.getServer_JadeNode();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl <em>JASMI Ne Node</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JASMINeNodeImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJASMINeNode()
		 * @generated
		 */
        EClass JASMI_NE_NODE = eINSTANCE.getJASMINeNode();

        /**
		 * The meta object literal for the '<em><b>Discovery Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__DISCOVERY_HOST = eINSTANCE.getJASMINeNode_DiscoveryHost();

        /**
		 * The meta object literal for the '<em><b>Discovery Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__DISCOVERY_PORT = eINSTANCE.getJASMINeNode_DiscoveryPort();

        /**
		 * The meta object literal for the '<em><b>Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__HOST = eINSTANCE.getJASMINeNode_Host();

        /**
		 * The meta object literal for the '<em><b>User</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__USER = eINSTANCE.getJASMINeNode_User();

        /**
		 * The meta object literal for the '<em><b>Password</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__PASSWORD = eINSTANCE.getJASMINeNode_Password();

        /**
		 * The meta object literal for the '<em><b>Ssh Key</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__SSH_KEY = eINSTANCE.getJASMINeNode_SshKey();

        /**
		 * The meta object literal for the '<em><b>Install Dir</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__INSTALL_DIR = eINSTANCE.getJASMINeNode_InstallDir();

        /**
		 * The meta object literal for the '<em><b>Jndi Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__JNDI_PORT = eINSTANCE.getJASMINeNode_JndiPort();

        /**
		 * The meta object literal for the '<em><b>Felix Profile</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__FELIX_PROFILE = eINSTANCE.getJASMINeNode_FelixProfile();

        /**
		 * The meta object literal for the '<em><b>Node Id</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__NODE_ID = eINSTANCE.getJASMINeNode_NodeId();

        /**
		 * The meta object literal for the '<em><b>Registry Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__REGISTRY_HOST = eINSTANCE.getJASMINeNode_RegistryHost();

        /**
		 * The meta object literal for the '<em><b>Registry Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__REGISTRY_PORT = eINSTANCE.getJASMINeNode_RegistryPort();

        /**
		 * The meta object literal for the '<em><b>Repository URL</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__REPOSITORY_URL = eINSTANCE.getJASMINeNode_RepositoryURL();

        /**
		 * The meta object literal for the '<em><b>Middlewares</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JASMI_NE_NODE__MIDDLEWARES = eINSTANCE.getJASMINeNode_Middlewares();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JASMI_NE_NODE__NAME = eINSTANCE.getJASMINeNode_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl <em>Domain</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DomainImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDomain()
		 * @generated
		 */
        EClass DOMAIN = eINSTANCE.getDomain();

        /**
		 * The meta object literal for the '<em><b>Middleware Components</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference DOMAIN__MIDDLEWARE_COMPONENTS = eINSTANCE.getDomain_MiddlewareComponents();

        /**
		 * The meta object literal for the '<em><b>Connectors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference DOMAIN__CONNECTORS = eINSTANCE.getDomain_Connectors();

        /**
		 * The meta object literal for the '<em><b>Configuration Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference DOMAIN__CONFIGURATION_NODES = eINSTANCE.getDomain_ConfigurationNodes();

        /**
		 * The meta object literal for the '<em><b>Cluster Containers</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference DOMAIN__CLUSTER_CONTAINERS = eINSTANCE.getDomain_ClusterContainers();

        /**
		 * The meta object literal for the '<em><b>Db</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference DOMAIN__DB = eINSTANCE.getDomain_Db();

        /**
		 * The meta object literal for the '<em><b>Dblinks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference DOMAIN__DBLINKS = eINSTANCE.getDomain_Dblinks();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ClusterImpl <em>Cluster</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ClusterImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getCluster()
		 * @generated
		 */
        EClass CLUSTER = eINSTANCE.getCluster();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute CLUSTER__NAME = eINSTANCE.getCluster_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IConnector <em>IConnector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IConnector
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIConnector()
		 * @generated
		 */
        EClass ICONNECTOR = eINSTANCE.getIConnector();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IJavaEEConnectorImpl <em>IJava EE Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IJavaEEConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJavaEEConnector()
		 * @generated
		 */
        EClass IJAVA_EE_CONNECTOR = eINSTANCE.getIJavaEEConnector();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector <em>IJ On AS Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IJOnASConnector
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJOnASConnector()
		 * @generated
		 */
        EClass IJ_ON_AS_CONNECTOR = eINSTANCE.getIJOnASConnector();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl <em>DB</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DBImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDB()
		 * @generated
		 */
        EClass DB = eINSTANCE.getDB();

        /**
		 * The meta object literal for the '<em><b>Provider</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__PROVIDER = eINSTANCE.getDB_Provider();

        /**
		 * The meta object literal for the '<em><b>User</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__USER = eINSTANCE.getDB_User();

        /**
		 * The meta object literal for the '<em><b>Password</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__PASSWORD = eINSTANCE.getDB_Password();

        /**
		 * The meta object literal for the '<em><b>Url</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__URL = eINSTANCE.getDB_Url();

        /**
		 * The meta object literal for the '<em><b>Driver Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__DRIVER_NAME = eINSTANCE.getDB_DriverName();

        /**
		 * The meta object literal for the '<em><b>Jndi Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__JNDI_NAME = eINSTANCE.getDB_JndiName();

        /**
		 * The meta object literal for the '<em><b>Jdbc Driver Jar File</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__JDBC_DRIVER_JAR_FILE = eINSTANCE.getDB_JdbcDriverJarFile();

        /**
		 * The meta object literal for the '<em><b>Mappern Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__MAPPERN_NAME = eINSTANCE.getDB_MappernName();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__NAME = eINSTANCE.getDB_Name();

        /**
		 * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DB__PORT = eINSTANCE.getDB_Port();

        /**
		 * The meta object literal for the '<em><b>Jasmine Node</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference DB__JASMINE_NODE = eINSTANCE.getDB_JasmineNode();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent <em>IMiddleware Component</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareComponent
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIMiddlewareComponent()
		 * @generated
		 */
        EClass IMIDDLEWARE_COMPONENT = eINSTANCE.getIMiddlewareComponent();

        /**
		 * The meta object literal for the '<em><b>Jasmine Node</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference IMIDDLEWARE_COMPONENT__JASMINE_NODE = eINSTANCE.getIMiddlewareComponent_JasmineNode();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties <em>IMiddleware Properties</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IMiddlewareProperties
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIMiddlewareProperties()
		 * @generated
		 */
        EClass IMIDDLEWARE_PROPERTIES = eINSTANCE.getIMiddlewareProperties();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute IMIDDLEWARE_PROPERTIES__NAME = eINSTANCE.getIMiddlewareProperties_Name();

        /**
		 * The meta object literal for the '<em><b>Property File</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute IMIDDLEWARE_PROPERTIES__PROPERTY_FILE = eINSTANCE.getIMiddlewareProperties_PropertyFile();

        /**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute IMIDDLEWARE_PROPERTIES__DESCRIPTION = eINSTANCE.getIMiddlewareProperties_Description();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl <em>JOn AS</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JOnASImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJOnAS()
		 * @generated
		 */
        EClass JON_AS = eINSTANCE.getJOnAS();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JON_AS__NAME = eINSTANCE.getJOnAS_Name();

        /**
		 * The meta object literal for the '<em><b>Instance Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JON_AS__INSTANCE_NAME = eINSTANCE.getJOnAS_InstanceName();

        /**
		 * The meta object literal for the '<em><b>Webconnectors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference JON_AS__WEBCONNECTORS = eINSTANCE.getJOnAS_Webconnectors();

        /**
		 * The meta object literal for the '<em><b>Jonas Base</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JON_AS__JONAS_BASE = eINSTANCE.getJOnAS_JonasBase();

        /**
		 * The meta object literal for the '<em><b>Jonas Root</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JON_AS__JONAS_ROOT = eINSTANCE.getJOnAS_JonasRoot();

        /**
		 * The meta object literal for the '<em><b>Domain</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JON_AS__DOMAIN = eINSTANCE.getJOnAS_Domain();

        /**
		 * The meta object literal for the '<em><b>Master</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JON_AS__MASTER = eINSTANCE.getJOnAS_Master();

        /**
		 * The meta object literal for the '<em><b>Clusters</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JON_AS__CLUSTERS = eINSTANCE.getJOnAS_Clusters();

        /**
		 * The meta object literal for the '<em><b>Cmigroup</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference JON_AS__CMIGROUP = eINSTANCE.getJOnAS_Cmigroup();

								/**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl <em>Apache HTT Pd</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.Apache_HTTPdImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getApache_HTTPd()
		 * @generated
		 */
        EClass APACHE_HTT_PD = eINSTANCE.getApache_HTTPd();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_HTT_PD__NAME = eINSTANCE.getApache_HTTPd_Name();

        /**
		 * The meta object literal for the '<em><b>Modules</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference APACHE_HTT_PD__MODULES = eINSTANCE.getApache_HTTPd_Modules();

        /**
		 * The meta object literal for the '<em><b>Home</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_HTT_PD__HOME = eINSTANCE.getApache_HTTPd_Home();

        /**
		 * The meta object literal for the '<em><b>Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_HTT_PD__HOST = eINSTANCE.getApache_HTTPd_Host();

        /**
		 * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_HTT_PD__PORT = eINSTANCE.getApache_HTTPd_Port();

        /**
		 * The meta object literal for the '<em><b>User</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_HTT_PD__USER = eINSTANCE.getApache_HTTPd_User();

        /**
		 * The meta object literal for the '<em><b>Group</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_HTT_PD__GROUP = eINSTANCE.getApache_HTTPd_Group();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IContainerImpl <em>IContainer</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IContainerImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIContainer()
		 * @generated
		 */
        EClass ICONTAINER = eINSTANCE.getIContainer();

        /**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute ICONTAINER__DESCRIPTION = eINSTANCE.getIContainer_Description();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute ICONTAINER__NAME = eINSTANCE.getIContainer_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer <em>IJava EE Server</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IJavaEEServer
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJavaEEServer()
		 * @generated
		 */
        EClass IJAVA_EE_SERVER = eINSTANCE.getIJavaEEServer();

        /**
		 * The meta object literal for the '<em><b>Web Containers</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference IJAVA_EE_SERVER__WEB_CONTAINERS = eINSTANCE.getIJavaEEServer_WebContainers();

        /**
		 * The meta object literal for the '<em><b>Rmi Registries</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference IJAVA_EE_SERVER__RMI_REGISTRIES = eINSTANCE.getIJavaEEServer_RmiRegistries();

        /**
		 * The meta object literal for the '<em><b>Ejb Containers</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference IJAVA_EE_SERVER__EJB_CONTAINERS = eINSTANCE.getIJavaEEServer_EjbContainers();

        /**
		 * The meta object literal for the '<em><b>Applications</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference IJAVA_EE_SERVER__APPLICATIONS = eINSTANCE.getIJavaEEServer_Applications();

        /**
		 * The meta object literal for the '<em><b>Jms Services</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference IJAVA_EE_SERVER__JMS_SERVICES = eINSTANCE.getIJavaEEServer_JmsServices();

        /**
		 * The meta object literal for the '<em><b>Discovery Services</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference IJAVA_EE_SERVER__DISCOVERY_SERVICES = eINSTANCE.getIJavaEEServer_DiscoveryServices();

        /**
		 * The meta object literal for the '<em><b>Http Servers</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IJAVA_EE_SERVER__HTTP_SERVERS = eINSTANCE.getIJavaEEServer_HttpServers();

								/**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IHTTPServer <em>IHTTP Server</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IHTTPServer
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIHTTPServer()
		 * @generated
		 */
        EClass IHTTP_SERVER = eINSTANCE.getIHTTPServer();

        /**
		 * The meta object literal for the '<em><b>Javaee Servers</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IHTTP_SERVER__JAVAEE_SERVERS = eINSTANCE.getIHTTPServer_JavaeeServers();

								/**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.WebContainerImpl <em>Web Container</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.WebContainerImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getWebContainer()
		 * @generated
		 */
        EClass WEB_CONTAINER = eINSTANCE.getWebContainer();

        /**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEB_CONTAINER__TYPE = eINSTANCE.getWebContainer_Type();

        /**
		 * The meta object literal for the '<em><b>Jvm Route</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEB_CONTAINER__JVM_ROUTE = eINSTANCE.getWebContainer_JvmRoute();

        /**
		 * The meta object literal for the '<em><b>Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEB_CONTAINER__HOST = eINSTANCE.getWebContainer_Host();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.EJBContainerImpl <em>EJB Container</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.EJBContainerImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getEJBContainer()
		 * @generated
		 */
        EClass EJB_CONTAINER = eINSTANCE.getEJBContainer();

        /**
		 * The meta object literal for the '<em><b>Auto Genic</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute EJB_CONTAINER__AUTO_GENIC = eINSTANCE.getEJBContainer_AutoGenic();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.EjbJarImpl <em>Ejb Jar</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.EjbJarImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getEjbJar()
		 * @generated
		 */
        EClass EJB_JAR = eINSTANCE.getEjbJar();

        /**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute EJB_JAR__DESCRIPTION = eINSTANCE.getEjbJar_Description();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute EJB_JAR__NAME = eINSTANCE.getEjbJar_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IModuleImpl <em>IModule</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IModuleImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIModule()
		 * @generated
		 */
        EClass IMODULE = eINSTANCE.getIModule();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ModJKModuleImpl <em>Mod JK Module</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ModJKModuleImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getModJKModule()
		 * @generated
		 */
        EClass MOD_JK_MODULE = eINSTANCE.getModJKModule();

        /**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute MOD_JK_MODULE__DESCRIPTION = eINSTANCE.getModJKModule_Description();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute MOD_JK_MODULE__NAME = eINSTANCE.getModJKModule_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IApplication <em>IApplication</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IApplication
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIApplication()
		 * @generated
		 */
        EClass IAPPLICATION = eINSTANCE.getIApplication();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.RepHTTPConnectorImpl <em>Rep HTTP Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.RepHTTPConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getRepHTTPConnector()
		 * @generated
		 */
        EClass REP_HTTP_CONNECTOR = eINSTANCE.getRepHTTPConnector();

        /**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference REP_HTTP_CONNECTOR__SOURCE = eINSTANCE.getRepHTTPConnector_Source();

        /**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference REP_HTTP_CONNECTOR__TARGET = eINSTANCE.getRepHTTPConnector_Target();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HAConnectorImpl <em>HA Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HAConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHAConnector()
		 * @generated
		 */
        EClass HA_CONNECTOR = eINSTANCE.getHAConnector();

        /**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference HA_CONNECTOR__SOURCE = eINSTANCE.getHAConnector_Source();

        /**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference HA_CONNECTOR__TARGET = eINSTANCE.getHAConnector_Target();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IRMIRegistryImpl <em>IRMI Registry</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IRMIRegistryImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIRMIRegistry()
		 * @generated
		 */
        EClass IRMI_REGISTRY = eINSTANCE.getIRMIRegistry();

        /**
		 * The meta object literal for the '<em><b>Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute IRMI_REGISTRY__HOST = eINSTANCE.getIRMIRegistry_Host();

        /**
		 * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute IRMI_REGISTRY__PORT = eINSTANCE.getIRMIRegistry_Port();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute IRMI_REGISTRY__NAME = eINSTANCE.getIRMIRegistry_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IIOPImpl <em>IIOP</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IIOPImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIIOP()
		 * @generated
		 */
        EClass IIOP = eINSTANCE.getIIOP();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JRMPImpl <em>JRMP</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JRMPImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJRMP()
		 * @generated
		 */
        EClass JRMP = eINSTANCE.getJRMP();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.CMIImpl <em>CMI</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.CMIImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getCMI()
		 * @generated
		 */
        EClass CMI = eINSTANCE.getCMI();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IRMIImpl <em>IRMI</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IRMIImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIRMI()
		 * @generated
		 */
        EClass IRMI = eINSTANCE.getIRMI();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.CmiGroupImpl <em>Cmi Group</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.CmiGroupImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getCmiGroup()
		 * @generated
		 */
        EClass CMI_GROUP = eINSTANCE.getCmiGroup();

        /**
		 * The meta object literal for the '<em><b>Lan Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute CMI_GROUP__LAN_MODE = eINSTANCE.getCmiGroup_LanMode();

        /**
		 * The meta object literal for the '<em><b>Tcp Ping Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute CMI_GROUP__TCP_PING_HOST = eINSTANCE.getCmiGroup_TcpPingHost();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ConfigurationNodeImpl <em>Configuration Node</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ConfigurationNodeImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getConfigurationNode()
		 * @generated
		 */
        EClass CONFIGURATION_NODE = eINSTANCE.getConfigurationNode();

        /**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute CONFIGURATION_NODE__DESCRIPTION = eINSTANCE.getConfigurationNode_Description();

        /**
		 * The meta object literal for the '<em><b>Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute CONFIGURATION_NODE__HOST = eINSTANCE.getConfigurationNode_Host();

        /**
		 * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute CONFIGURATION_NODE__PORT = eINSTANCE.getConfigurationNode_Port();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute CONFIGURATION_NODE__NAME = eINSTANCE.getConfigurationNode_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HaGroupImpl <em>Ha Group</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HaGroupImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHaGroup()
		 * @generated
		 */
        EClass HA_GROUP = eINSTANCE.getHaGroup();

        /**
		 * The meta object literal for the '<em><b>Lan Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute HA_GROUP__LAN_MODE = eINSTANCE.getHaGroup_LanMode();

        /**
		 * The meta object literal for the '<em><b>Tcp Ping Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute HA_GROUP__TCP_PING_HOST = eINSTANCE.getHaGroup_TcpPingHost();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ClusterContainerImpl <em>Cluster Container</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ClusterContainerImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getClusterContainer()
		 * @generated
		 */
        EClass CLUSTER_CONTAINER = eINSTANCE.getClusterContainer();

        /**
		 * The meta object literal for the '<em><b>Clusters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference CLUSTER_CONTAINER__CLUSTERS = eINSTANCE.getClusterContainer_Clusters();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HTTP_RepGroupImpl <em>HTTP Rep Group</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HTTP_RepGroupImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHTTP_RepGroup()
		 * @generated
		 */
        EClass HTTP_REP_GROUP = eINSTANCE.getHTTP_RepGroup();

        /**
		 * The meta object literal for the '<em><b>Tcp Listen Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute HTTP_REP_GROUP__TCP_LISTEN_PORT = eINSTANCE.getHTTP_RepGroup_TcpListenPort();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.RMIGroupImpl <em>RMI Group</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.RMIGroupImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getRMIGroup()
		 * @generated
		 */
        EClass RMI_GROUP = eINSTANCE.getRMIGroup();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DbLinkImpl <em>Db Link</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DbLinkImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDbLink()
		 * @generated
		 */
        EClass DB_LINK = eINSTANCE.getDbLink();

        /**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference DB_LINK__SOURCE = eINSTANCE.getDbLink_Source();

        /**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference DB_LINK__TARGET = eINSTANCE.getDbLink_Target();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode <em>IConfiguration Node</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IConfigurationNode
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIConfigurationNode()
		 * @generated
		 */
        EClass ICONFIGURATION_NODE = eINSTANCE.getIConfigurationNode();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.RmiConnectorImpl <em>Rmi Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.RmiConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getRmiConnector()
		 * @generated
		 */
        EClass RMI_CONNECTOR = eINSTANCE.getRmiConnector();

        /**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference RMI_CONNECTOR__SOURCE = eINSTANCE.getRmiConnector_Source();

        /**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference RMI_CONNECTOR__TARGET = eINSTANCE.getRmiConnector_Target();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.WebConnectorImpl <em>Web Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.WebConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getWebConnector()
		 * @generated
		 */
        EClass WEB_CONNECTOR = eINSTANCE.getWebConnector();

        /**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEB_CONNECTOR__DESCRIPTION = eINSTANCE.getWebConnector_Description();

        /**
		 * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEB_CONNECTOR__PORT = eINSTANCE.getWebConnector_Port();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEB_CONNECTOR__NAME = eINSTANCE.getWebConnector_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.AJPImpl <em>AJP</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.AJPImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getAJP()
		 * @generated
		 */
        EClass AJP = eINSTANCE.getAJP();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HTTPImpl <em>HTTP</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HTTPImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHTTP()
		 * @generated
		 */
        EClass HTTP = eINSTANCE.getHTTP();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.HTTPSImpl <em>HTTPS</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.HTTPSImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getHTTPS()
		 * @generated
		 */
        EClass HTTPS = eINSTANCE.getHTTPS();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.IWebConnector <em>IWeb Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.IWebConnector
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIWebConnector()
		 * @generated
		 */
        EClass IWEB_CONNECTOR = eINSTANCE.getIWebConnector();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl <em>Jms Service</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JmsServiceImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJmsService()
		 * @generated
		 */
        EClass JMS_SERVICE = eINSTANCE.getJmsService();

        /**
		 * The meta object literal for the '<em><b>Jmx Service URL</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JMS_SERVICE__JMX_SERVICE_URL = eINSTANCE.getJmsService_JmxServiceURL();

        /**
		 * The meta object literal for the '<em><b>Jms Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JMS_SERVICE__JMS_PORT = eINSTANCE.getJmsService_JmsPort();

        /**
		 * The meta object literal for the '<em><b>Jms Topics</b></em>' attribute list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JMS_SERVICE__JMS_TOPICS = eINSTANCE.getJmsService_JmsTopics();

        /**
		 * The meta object literal for the '<em><b>Jms Queues</b></em>' attribute list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JMS_SERVICE__JMS_QUEUES = eINSTANCE.getJmsService_JmsQueues();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JMS_SERVICE__NAME = eINSTANCE.getJmsService_Name();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl <em>Discovery Service</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.DiscoveryServiceImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDiscoveryService()
		 * @generated
		 */
        EClass DISCOVERY_SERVICE = eINSTANCE.getDiscoveryService();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DISCOVERY_SERVICE__NAME = eINSTANCE.getDiscoveryService_Name();

        /**
		 * The meta object literal for the '<em><b>Host</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DISCOVERY_SERVICE__HOST = eINSTANCE.getDiscoveryService_Host();

        /**
		 * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DISCOVERY_SERVICE__PORT = eINSTANCE.getDiscoveryService_Port();

        /**
		 * The meta object literal for the '<em><b>Greeting Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DISCOVERY_SERVICE__GREETING_PORT = eINSTANCE.getDiscoveryService_GreetingPort();

        /**
		 * The meta object literal for the '<em><b>Source Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DISCOVERY_SERVICE__SOURCE_PORT = eINSTANCE.getDiscoveryService_SourcePort();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.MiddlewareComponentImpl <em>Middleware Component</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.MiddlewareComponentImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getMiddlewareComponent()
		 * @generated
		 */
        EClass MIDDLEWARE_COMPONENT = eINSTANCE.getMiddlewareComponent();

        /**
		 * The meta object literal for the '<em><b>Middleware Properties</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference MIDDLEWARE_COMPONENT__MIDDLEWARE_PROPERTIES = eINSTANCE.getMiddlewareComponent_MiddlewareProperties();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApachePropertiesImpl <em>Apache Properties</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ApachePropertiesImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getApacheProperties()
		 * @generated
		 */
        EClass APACHE_PROPERTIES = eINSTANCE.getApacheProperties();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl <em>Apache Middleware Properties</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.ApacheMiddlewarePropertiesImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getApacheMiddlewareProperties()
		 * @generated
		 */
        EClass APACHE_MIDDLEWARE_PROPERTIES = eINSTANCE.getApacheMiddlewareProperties();

        /**
		 * The meta object literal for the '<em><b>Instance apache home</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_MIDDLEWARE_PROPERTIES__INSTANCE_APACHE_HOME = eINSTANCE.getApacheMiddlewareProperties_Instance_apache_home();

        /**
		 * The meta object literal for the '<em><b>Server listen adress</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_ADRESS = eINSTANCE.getApacheMiddlewareProperties_Server_listen_adress();

        /**
		 * The meta object literal for the '<em><b>Server listen port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_MIDDLEWARE_PROPERTIES__SERVER_LISTEN_PORT = eINSTANCE.getApacheMiddlewareProperties_Server_listen_port();

        /**
		 * The meta object literal for the '<em><b>Server user</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_MIDDLEWARE_PROPERTIES__SERVER_USER = eINSTANCE.getApacheMiddlewareProperties_Server_user();

        /**
		 * The meta object literal for the '<em><b>Server group</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute APACHE_MIDDLEWARE_PROPERTIES__SERVER_GROUP = eINSTANCE.getApacheMiddlewareProperties_Server_group();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.ILocatable <em>ILocatable</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.ILocatable
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getILocatable()
		 * @generated
		 */
        EClass ILOCATABLE = eINSTANCE.getILocatable();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl <em>JBoss AS</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossASImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossAS()
		 * @generated
		 */
        EClass JBOSS_AS = eINSTANCE.getJBossAS();

        /**
		 * The meta object literal for the '<em><b>Home</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_AS__HOME = eINSTANCE.getJBossAS_Home();

        /**
		 * The meta object literal for the '<em><b>Binding</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_AS__BINDING = eINSTANCE.getJBossAS_Binding();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_AS__NAME = eINSTANCE.getJBossAS_Name();

        /**
		 * The meta object literal for the '<em><b>Webconnectors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
         * end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_AS__WEBCONNECTORS = eINSTANCE.getJBossAS_Webconnectors();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl <em>JBoss Binding</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossBindingImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossBinding()
		 * @generated
		 */
        EClass JBOSS_BINDING = eINSTANCE.getJBossBinding();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__NAME = eINSTANCE.getJBossBinding_Name();

        /**
		 * The meta object literal for the '<em><b>Naming Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__NAMING_PORT = eINSTANCE.getJBossBinding_NamingPort();

        /**
		 * The meta object literal for the '<em><b>Naming RMI Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__NAMING_RMI_PORT = eINSTANCE.getJBossBinding_NamingRMIPort();

        /**
		 * The meta object literal for the '<em><b>Webservice Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__WEBSERVICE_PORT = eINSTANCE.getJBossBinding_WebservicePort();

        /**
		 * The meta object literal for the '<em><b>Invoker RMI Object Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__INVOKER_RMI_OBJECT_PORT = eINSTANCE.getJBossBinding_InvokerRMIObjectPort();

        /**
		 * The meta object literal for the '<em><b>Invoker Server Bind Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__INVOKER_SERVER_BIND_PORT = eINSTANCE.getJBossBinding_InvokerServerBindPort();

        /**
		 * The meta object literal for the '<em><b>Ha Naming Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__HA_NAMING_PORT = eINSTANCE.getJBossBinding_HaNamingPort();

        /**
		 * The meta object literal for the '<em><b>Ha Naming RMI Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__HA_NAMING_RMI_PORT = eINSTANCE.getJBossBinding_HaNamingRMIPort();

        /**
		 * The meta object literal for the '<em><b>Ha Invoker RMI Object Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__HA_INVOKER_RMI_OBJECT_PORT = eINSTANCE.getJBossBinding_HaInvokerRMIObjectPort();

        /**
		 * The meta object literal for the '<em><b>Ha Invoker Server Bind Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__HA_INVOKER_SERVER_BIND_PORT = eINSTANCE.getJBossBinding_HaInvokerServerBindPort();

        /**
		 * The meta object literal for the '<em><b>Corba Orb Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__CORBA_ORB_PORT = eINSTANCE.getJBossBinding_CorbaOrbPort();

        /**
		 * The meta object literal for the '<em><b>Connector RMI Object Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__CONNECTOR_RMI_OBJECT_PORT = eINSTANCE.getJBossBinding_ConnectorRMIObjectPort();

        /**
		 * The meta object literal for the '<em><b>Snmp Trap Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__SNMP_TRAP_PORT = eINSTANCE.getJBossBinding_SnmpTrapPort();

        /**
		 * The meta object literal for the '<em><b>Snmp Request Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__SNMP_REQUEST_PORT = eINSTANCE.getJBossBinding_SnmpRequestPort();

        /**
		 * The meta object literal for the '<em><b>Jms Server Bind Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__JMS_SERVER_BIND_PORT = eINSTANCE.getJBossBinding_JmsServerBindPort();

        /**
		 * The meta object literal for the '<em><b>Webserver Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__WEBSERVER_PORT = eINSTANCE.getJBossBinding_WebserverPort();

        /**
		 * The meta object literal for the '<em><b>Ejb3 Connector Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__EJB3_CONNECTOR_PORT = eINSTANCE.getJBossBinding_Ejb3ConnectorPort();

        /**
		 * The meta object literal for the '<em><b>Messaging Connector Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__MESSAGING_CONNECTOR_PORT = eINSTANCE.getJBossBinding_MessagingConnectorPort();

        /**
		 * The meta object literal for the '<em><b>Remoting Connector Port</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_BINDING__REMOTING_CONNECTOR_PORT = eINSTANCE.getJBossBinding_RemotingConnectorPort();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.IJBossConnectorImpl <em>IJ Boss Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.IJBossConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getIJBossConnector()
		 * @generated
		 */
        EClass IJ_BOSS_CONNECTOR = eINSTANCE.getIJBossConnector();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAConnectorImpl <em>JBoss HA Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossHAConnector()
		 * @generated
		 */
        EClass JBOSS_HA_CONNECTOR = eINSTANCE.getJBossHAConnector();

        /**
		 * The meta object literal for the '<em><b>Instance</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_HA_CONNECTOR__INSTANCE = eINSTANCE.getJBossHAConnector_Instance();

        /**
		 * The meta object literal for the '<em><b>Group</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_HA_CONNECTOR__GROUP = eINSTANCE.getJBossHAConnector_Group();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHTTPRepConnectorImpl <em>JBoss HTTP Rep Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossHTTPRepConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossHTTPRepConnector()
		 * @generated
		 */
        EClass JBOSS_HTTP_REP_CONNECTOR = eINSTANCE.getJBossHTTPRepConnector();

        /**
		 * The meta object literal for the '<em><b>Instance</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_HTTP_REP_CONNECTOR__INSTANCE = eINSTANCE.getJBossHTTPRepConnector_Instance();

        /**
		 * The meta object literal for the '<em><b>Group</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_HTTP_REP_CONNECTOR__GROUP = eINSTANCE.getJBossHTTPRepConnector_Group();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAGroupImpl <em>JBoss HA Group</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossHAGroupImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossHAGroup()
		 * @generated
		 */
        EClass JBOSS_HA_GROUP = eINSTANCE.getJBossHAGroup();

        /**
		 * The meta object literal for the '<em><b>Lan Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_HA_GROUP__LAN_MODE = eINSTANCE.getJBossHAGroup_LanMode();

        /**
		 * The meta object literal for the '<em><b>Ping Hosts</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute JBOSS_HA_GROUP__PING_HOSTS = eINSTANCE.getJBossHAGroup_PingHosts();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.impl.JBossModJKConnectorImpl <em>JBoss Mod JK Connector</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JBossModJKConnectorImpl
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getJBossModJKConnector()
		 * @generated
		 */
        EClass JBOSS_MOD_JK_CONNECTOR = eINSTANCE.getJBossModJKConnector();

        /**
		 * The meta object literal for the '<em><b>Jboss</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_MOD_JK_CONNECTOR__JBOSS = eINSTANCE.getJBossModJKConnector_Jboss();

        /**
		 * The meta object literal for the '<em><b>Apache</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
        EReference JBOSS_MOD_JK_CONNECTOR__APACHE = eINSTANCE.getJBossModJKConnector_Apache();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation <em>Web Container Implementation</em>}' enum.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.WebContainerImplementation
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getWebContainerImplementation()
		 * @generated
		 */
        EEnum WEB_CONTAINER_IMPLEMENTATION = eINSTANCE.getWebContainerImplementation();

        /**
		 * The meta object literal for the '{@link org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider <em>Database Provider</em>}' enum.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.ui.jasminemodel.DatabaseProvider
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDatabaseProvider()
		 * @generated
		 */
        EEnum DATABASE_PROVIDER = eINSTANCE.getDatabaseProvider();

        /**
		 * The meta object literal for the '<em>Inet Address</em>' data type.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see java.net.InetAddress
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getInetAddress()
		 * @generated
		 */
        EDataType INET_ADDRESS = eINSTANCE.getInetAddress();

        /**
         * The meta object literal for the '<em>Port</em>' data type. <!--
         * begin-user-doc --> <!-- end-user-doc -->
         *
         * @see org.objectweb.jasmine.ui.jasminemodel.datatype.Port
         * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getPort()
         * @generated
         */
        EDataType PORT = eINSTANCE.getPort();

        /**
		 * The meta object literal for the '<em>Deployment Exception</em>' data type.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see org.objectweb.jasmine.jade.service.deployer.DeploymentException
		 * @see org.objectweb.jasmine.ui.jasminemodel.impl.JasminemodelPackageImpl#getDeploymentException()
		 * @generated
		 */
        EDataType DEPLOYMENT_EXCEPTION = eINSTANCE.getDeploymentException();

    }

} // JasminemodelPackage
